#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int a[20][20];
int ca[20][20];
int b[20][20];

int color[20];

vector<int> elm[20];

set<int> maskset;

char board[111][222][111];
int bx = 1;
int by = 1;
int bz = 1;

int masks[111];

int maskcolor[11111];


int comp[22];
int cs = 0;
int n;

void dfs(int v)
{
	color[v] = 1;
	for (int j = 0; j < n; j++)
	{
		if (!color[j] && a[v][j])
			dfs(j);
	}
}

void dfscomp(int v)
{
	color[v] = 1;
	elm[cs].push_back(v);
	for (int j = 0; j < n; j++)
	{
		if (!color[j] && ca[v][j])
			dfscomp(j);
	}
}

vector<int> tsortlist;

void topsort(int mask)
{
	maskcolor[mask] = 1;
	for (auto m : maskset)
	{
		if ((m&mask) == m && !maskcolor[m])
			topsort(m);
	}
	tsortlist.push_back(mask);
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	scanf("%i", &n);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			scanf("%i", &a[i][j]);
			ca[i][j] |= a[i][j];
			ca[j][i] |= a[i][j];
		}
	}
	memset(board, '#', sizeof(board));
	for (int i = 0; i < n; i++)
	{
		if (!color[i])
		{
			comp[cs] = i;
			dfscomp(i);
			cs++;
		}
	}
	for (int i = 0; i < n; i++)
	{
		memset(color, 0, sizeof(color));
		dfs(i);
		memcpy(b[i], color, sizeof(color));
	}
	for (int i = 0; i < cs; i++)
	{
		int mx = 0;
		maskset.clear();
		for (auto x : elm[i])
		{
			int msk = 0;
			for (int j = 0; j < n; j++)
				if (b[x][j])
					msk |= 1 << j;
			masks[x] = msk;
			mx |= msk;
			maskset.insert(msk);
		}
		memset(maskcolor, 0, sizeof(maskcolor));
		tsortlist.clear();
		topsort(mx);
		reverse(tsortlist.begin(), tsortlist.end());
		int x = i * 3;
		int m = tsortlist.size();
		
		if (x+1 >= bx)
			bx = x+1 + 1;
		for (int j = 0; j < m; j++)
		{
			int z = j * 2;
			if (z >= bz)
				bz = z+1;
			for (int y = 0; y < 220; y++)
				board[x][y][z] = '.';
			int nn = 0;
			if (nn+1 >= by)
				by = nn+1 + 1;
			for (auto xx : elm[i])
			{
				if (masks[xx] == tsortlist[j])
					board[x][nn++][z] = '1'+xx;
			}
		}
		int y = 0;
		for (int j = 0; j < m-1; j++)
		{
			int m1 = tsortlist[j];
			for (int k = j + 1; k < m; k++)
			{
				int m2 = tsortlist[k];
				if ((m2&m1) != m2)
					continue;
				int tx = x + 1;
				int tz1 = j * 2;
				int tz2 = k * 2;
				for (int z = tz1; z <= tz2; z++)
				{
					board[tx][y][z] = '.';
				}
				if (y+1 >= by)
					by = y+1 + 1;
				y += 2;
			}
		}
	}
	printf("%i %i %i\n", bx, by, bz);
	for (int z = 0; z < bz; z++)
	{
		for (int y = 0; y < by; y++)
		{
			for (int x = 0; x < bx; x++)
			{
				printf("%c", board[x][y][z]);
			}
			printf("\n");
		}
		printf("\n");
	}
}