#pragma warning (disable : 4996)

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

bool check_3_0(int a, int b) {
	a -= 75;
	if (a < 0) {
		return false;
	}
	int counts[3][2];
	for (int i = 0; i < 3; i++) {
		counts[i][0] = 25;
		counts[i][1] = 0;
	}

	for (int i = 0; i < 3; i++) {
		while (counts[i][1] <23 && b != 0) {
			counts[i][1]++;
			b--;
			if (a == b) {
				if (counts[0][1] < 23) {
					return false;
				}
				else {
					cout << "3:0" << endl;
					counts[0][0] += a;
					counts[0][1] += b;
					for (int j = 0; j < 3; j++) {
						cout << counts[j][0] << ":" << counts[j][1] << " ";
					}
					return true;
				}
			}
		}
	}
}

struct Scores {
	int cur_score;
	int max_score;
	int opponent_score;
	Scores() {
		cur_score = 0;
		opponent_score = 25;
		max_score = 23;
	}
};

bool add_check_can_tower(vector<Scores>& winned_a, vector<Scores>& winned_b, int val) {
	for (int i = 0; i < winned_a.size(); i++) {
		if (winned_a[i].cur_score >= winned_a[i].max_score) {
			winned_a[i].opponent_score += val;
			winned_a[i].cur_score += val;
			return true;
		}
	}
	for (int i = 0; i < winned_b.size(); i++) {
		if (winned_b[i].cur_score >= winned_b[i].max_score) {
			winned_b[i].opponent_score += val;
			winned_b[i].cur_score += val;
			return true;
		}
	}
	return false;
}

bool add_check_can_1(vector<Scores>& winned) {
	for (int i = 0; i < winned.size(); i++) {
		if (winned[i].cur_score < winned[i].max_score) {
			winned[i].cur_score++;
			return true;
		}
	}
	return false;
}

void output_result(vector<Scores> winned_a, vector<Scores> winned_b, int wins_a, int wins_b) {
	cout << winned_a.size() << ":" << winned_b.size() << endl;
	bool swapped = false;
	if (wins_a > wins_b) {
		swap(winned_a, winned_b);
		swapped = true;
	}
	reverse(winned_a.begin(), winned_a.end());
	reverse(winned_b.begin(), winned_b.end());
	for (int i = 0; i < winned_a.size(); i++) {
		if (swapped) {
			swap(winned_a[i].cur_score, winned_a[i].opponent_score);
		}
		cout << winned_a[i].opponent_score << ":" << winned_a[i].cur_score << " ";
	}
	for (int i = 0; i < winned_b.size(); i++) {
		if (swapped) {
			swap(winned_b[i].cur_score, winned_b[i].opponent_score);
		}
		cout << winned_b[i].cur_score << ":" << winned_b[i].opponent_score << " ";
	}
	cout << endl;
}
bool check(int a, int b, int wins_a, int wins_b) {
	vector<Scores> winned_a(wins_a);
	vector<Scores> winned_b(wins_b);
	if (wins_a == 3 && wins_b == 2) {
		winned_a[0].opponent_score = 15;
		winned_a[0].max_score = 13;
		a += 10;
	}
	if (wins_b == 3 && wins_a == 2) {
		winned_b[0].opponent_score = 15;
		winned_b[0].max_score = 13;
		b += 10;
	}
	a -= wins_a * 25;
	b -= wins_b * 25;

	if (a < 0 || b < 0) {
		return false;
	}
	if (a == 0 && b == 0) {
		output_result(winned_a, winned_b, wins_a, wins_b);
		return true;
	}

	while (1) {
		if (a == b) {
			if (add_check_can_tower(winned_a, winned_b, a)) {
				output_result(winned_a, winned_b, wins_a,wins_b);
				return true;
			}
		}
		if (a >= b) {
			a--;
			if ((a<0) || (!add_check_can_1(winned_b))) {
				return false;
			}
		}
		else {
			b--;
			if ((b<0) || (!add_check_can_1(winned_a))) {
				return false;
			}
		}
	}
	return false;
}

void solve() {
	int a, b;
	cin >> a >> b;
	bool res = check(a, b, 3, 0);
	if (res) return;
	res = check(a, b, 3, 1);
	if (res) return;
	res = check(a, b, 3, 2);
	if (res) return;
	res = check(a, b, 2, 3);
	if (res) return;
	res = check(a, b, 1, 3);
	if (res) return;
	res = check(a, b, 0, 3);
	if (res) return;
	cout << "Impossible" << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef MANO
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		solve();
	}

	return 0;
}