#pragma warning (disable : 4996)

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<ll> divs;
vector<ll> ps;
vector<ll> res;
ll N;
ll cur_sum = 0;

bool f(int step) {
	if (step == int(divs.size()) - 1) {
		ll cut = N - 1 - cur_sum;
		if (cut % (N / divs[step]) != 0) {
			return false;
		}
		res.push_back(cut / (N / divs[step]));
		return true;
	}
	for (ll cur = 0; cur < ps[step]; ++cur) {
		ll cut = cur * (N / divs[step]);
		if (cur_sum + cut > N - 1) break;
		cur_sum += cut;
		res.push_back(cur);
		if (f(step + 1)) {
			return true;
		}
		cur_sum -= cut;
		res.pop_back();
	}
	return false;
}

void ansno() {
	cout << "NO";
	exit(0);
}

void solve() {
	ll n;
	cin >> n;
	N = n;
	for (ll d = 2; d * d <= N; ++d) {
		if (N == d) {
			cout << "NO";
			return;
		}
		if (n % d == 0) {
			ll cur = d;
			while (n % d == 0) {
				n /= d;
				if (N != cur) {
					divs.push_back(cur);
					ps.push_back(d);
				}
				cur *= d;
			}
		}
	}
	if (divs.empty()) {
		cout << "NO";
		return;
	}
	if (n > 1) {
		divs.push_back(n);
		ps.push_back(n);
	}

	bool ans = f(0);
	if (!ans) {
		cout << "NO";
		return;
	}

	vector<pair<ll, ll>> vans;
	for (int i = 0; i < res.size(); ++i) {
		if (res[i]) {
			vans.emplace_back(res[i], divs[i]);
		}
	}

	cout << "YES\n";
	cout << vans.size() << '\n';
	for (auto p : vans) {
		cout << p.first << ' ' << p.second << '\n';
	}
}

void gen() {
	for (int i = 0; i < 10000; ++i) {
		cout << i + 3 << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef MANO
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	//gen(); return 0;
	solve();

/*	for (int i = 0; i < 1000; ++i) {
	cur_sum = 0;
	res.clear();
	divs.clear();
	ps.clear();
	cout << i + 3 << ' ';
	solve();
	cout << endl;
	}*/

	return 0;
}