#pragma warning (disable : 4996)

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const int NUM = 12;
int g[NUM][NUM];
int g1[NUM][NUM];
int N;

bool visit[NUM];
int comp[NUM];
vector<int> que, component;
vector<vector<int>> cmpnts;
int last_comp_id;

const int A = 5;
const int B = 244;
const int C = 20;
char fld[A][B][C];

void dfs_fwd(int v) {
	visit[v] = true;
	for (int i = 0; i < N; ++i) {
		if (visit[i] || !g[v][i]) continue;
		dfs_fwd(i);
	}
	que.push_back(v);
}

void dfs_rev(int v) {
	visit[v] = true;
	for (int i = 0; i < N; ++i) {
		if (visit[i] || !g[i][v]) continue;
		dfs_rev(i);
	}
	component.push_back(v);
}

void tarjan() {
	fill(visit, visit + N, false);
	que.clear();
	for (int v = 0; v < N; ++v) {
		if (!visit[v]) dfs_fwd(v);
	}
	reverse(que.begin(), que.end());
	fill(visit, visit + N, false);
	for (int v : que) {
		if (!visit[v]) {
			component.clear();
			dfs_rev(v);
			for (int u : component) {
				comp[u] = last_comp_id;
			}
			cmpnts.emplace_back(component);
			last_comp_id++;
		}
	}
}

void dfs_comp(int v) {
	visit[v] = true;
	//que.push_back(v);
	for (int i = 0; i < last_comp_id; ++i) {
		if (visit[i] || !g1[v][i]) {
			continue;
		}
		dfs_comp(i);
	}
	que.push_back(v);
}

/*void top_sort(int v) {
	visit[v] = true;
	//que.push_back(v);
	for (int i = 0; i < last_comp_id; ++i) {
		if (visit[i] || !g1[v][i]) {
			continue;
		}
		dfs_comp(i);
	}
	que.push_back(v);
}*/

int LAY[NUM];

void solve() {
	int n;
	cin >> n;
	N = n;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> g[i][j];
		}
	}
	tarjan();
	/*for (int i = 0; i < N; ++i) {
		cout << comp[i] << ' ';
	}*/
	for (auto cmp : cmpnts) {
		for (int v : cmp) {
			for (int i = 0; i < N; ++i) {
				if (comp[i] == comp[v] || !g[v][i]) continue;
				g1[comp[v]][comp[i]] = 1;
			}
		}
	}
	que.clear();
	fill(visit, visit + n, false);
	for (int v = 0; v < last_comp_id; ++v) {
		if (visit[v]) continue;
		dfs_comp(v);
	}
	//cout << endl;

	for (int i = 0; i < A; i++) {
		for (int j = 0; j < B; j++) {
			for (int k = 0; k < C; k++) {
				fld[i][j][k] = '.';
			}
		}
	}
	for (int i = 0; i < que.size(); ++i) {
		int id_comp = que[i];
		LAY[id_comp] = 2*i;
		for (int v : cmpnts[id_comp]) {
			fld[0][v][2 * i] = (char)(v + '1');
		}
	}

	for (int i = 0; i < que.size(); ++i) {
		for (int j = 0; j < A; ++j) {
			for (int k = 0; k < B; ++k) {
				fld[j][k][2 * i + 1] = '#';
			}
		}
	}

	for (int i = 0; i < que.size(); ++i) {
		for (int j = 1; j < A; ++j) {
			for (int k = 0; k < B; ++k) {
				fld[j][k][2 * i] = '#';
			}
		}
	}

	int edge_id = 0;
	for (int i = 0; i < last_comp_id; i++) {
		for (int j = 0; j < last_comp_id; j++) {
			if (!g1[i][j]) {
				continue;
			}
			int lay2 = LAY[i];
			int lay1 = LAY[j];
			//assert(lay1 < lay2);
			int edge_id = i*last_comp_id + j;
			for (int i = lay1; i <= lay2; i++) {
				fld[2][2 * edge_id][i] = '.';
			}
			fld[1][2 * edge_id][lay1] = '.';
			fld[1][2 * edge_id][lay2] = '.';
		}
	}

	cout << B << " " << A << " " << C << endl;
	for (int i = C-1; i >=0; i--) {
		for (int j = 0; j < A; j++) {
			for (int k = 0; k < B; k++) {
				cout << fld[j][k][i];
			}
			cout << endl;
		}
		cout << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef MANO
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}