import java.util.*;

public class TaskM {

    private static LL[] edges, reverse;
    private static boolean[] used;
    private static ArrayList<Integer> order = new ArrayList<>();
    private static int[] comp;

    private static int component = 1;

    private static String[] template = new String[] {
            ".xxxxxxxxx",
            ".#########",
            "xxxxxxxxx.",
            "#########."
    };

    public static HS[] graph;
    public static AL[] compVertices;

    public static void main(String[] args) throws Exception {
        Scanner in = new Scanner(System.in);

        int n = in.nextInt();

        edges = new LL[n];
        reverse = new LL[n];
        for(int i = 0; i < n; i++) reverse[i] = new LL();

        for(int i = 0; i < n; i++) {
            edges[i] = new LL();
            for(int j = 0; j < n; j++)
                if(in.nextInt() == 1) {
                    edges[i].add(j);
                    reverse[j].add(i);
                }
        }

        used = new boolean[n];
        comp = new int[n];

        for(int i = 0; i < n; i++) {
            if(!used[i]) dfs1(i);
        }

        for(int i = 0; i < n; i++) {
            int v = order.get(n - i - 1);
            if(comp[v] == 0) dfs2(v, component++);
        }

        compVertices = new AL[component - 1];
        for(int i = 0; i < compVertices.length; i++) compVertices[i] = new AL();

        for(int i = 0; i < n; i++) compVertices[comp[i] - 1].add(i + 1);

        graph = new HS[component - 1];
        for(int i = 0; i < graph.length; i++) graph[i] = new HS();

        HS[] reverseGraph = new HS[component - 1];
        for(int i = 0; i < graph.length; i++) reverseGraph[i] = new HS();

        for(int i = 0; i < n; i++)
            for(int to : reverse[i]) {
                if(comp[i] == comp[to]) continue;
                graph[comp[i] - 1].add(comp[to] - 1);
                reverseGraph[comp[to] - 1].add(comp[i] - 1);
            }

        int start = component - 2;

        ArrayList<ArrayList<Integer>> layers = new ArrayList<>();
        for(int i = 0; i < 9; i++) layers.add(new ArrayList<>());

        Queue<Integer> queue = new LinkedList<>();
        queue.add(start);

        ArrayList<Integer> tmp = new ArrayList<>();
        tmp.add(comp[start] - 1);
        layers.set(0, tmp);

        int[] aaa = new int[n];
        aaa[start] = 0;

        while(!queue.isEmpty()) {
            int cur = queue.poll();

            for(int to : graph[cur]) {
                int l = aaa[cur] + 1;
                aaa[to] = l;
                layers.get(l).add(to);
                queue.add(to);
            }
        }

        maxDepth = 0;
        for(int i = 0; i < layers.size(); i++)
            if(!layers.get(i).isEmpty()) maxDepth = i;


        canvas = new char[(maxDepth + 1) * 2 + 2][1000];

        localUsed = new boolean[component];
        int offset = 0;
        for(int i = 0; i < component - 1; i++)
            if(!localUsed[i] && reverseGraph[i].isEmpty())
                offset = generate(i, 0, false, offset);

        String str = new String(canvas[0]).trim();
        System.out.println(str.length() + " 1 " + ((maxDepth + 1) * 2));

        for(int i = canvas.length - 4; i >= 0; i-=2) {
            System.out.println(new String(canvas[i]).trim() + "\n");
            System.out.println(new String(canvas[i + 1]).trim() + "\n");
        }
    }

    public static int maxDepth;
    public static char[][] canvas;
    public static boolean[] localUsed;

    public static int generate(int c, int deep, boolean fake, int offset) {
        //if(deep == maxDepth) return offset;
        if(fake) {
            for(int i = 0; i < 11; i++) {
                canvas[deep * 2][offset + i] = '#';
                canvas[deep * 2 + 1][offset + i] = '#';
            }
            return offset + 11;
        }

        int off = offset;
        for(int u : graph[c])
            off = generate(u, deep + 1, false, off);

        if(graph[c].isEmpty())
            off = generate(0, deep + 1, true, off);

        int ptr = 0;
        if(deep % 2 == 1) {
            canvas[deep * 2][offset] = '.';
            for(int i = offset + 1; i < off - 1; i++) {
                char cc = ptr < compVertices[c].size() ? (char)('0' + compVertices[c].get(ptr)) : '.';
                ptr++;
                canvas[deep * 2][i] = cc;
            }
            canvas[deep * 2][off - 1] = '#';

            canvas[deep * 2 + 1][offset] = '.';
            for(int i = offset + 1; i < off; i++) canvas[deep * 2 + 1][i] = '#';
        } else {
            canvas[deep * 2][off - 2] = '.';
            for(int i = offset; i < off - 2; i++) {
                char cc = ptr < compVertices[c].size() ? (char)('0' + compVertices[c].get(ptr)) : '.';
                ptr++;
                canvas[deep * 2][i] = cc;
            }
            canvas[deep * 2][off - 1] = '#';

            canvas[deep * 2 + 1][off - 2] = '.';
            for(int i = offset; i < off - 2; i++) canvas[deep * 2 + 1][i] = '#';
            canvas[deep * 2 + 1][off - 1] = '#';
        }

        return off;
    }

    public static void dfs1(int v) {
        used[v] = true;
        for(int u : edges[v])
            if(!used[u]) dfs1(u);
        order.add(v);
    }

    public static void dfs2(int v, int current) {
        comp[v] = current;
        for(int u : reverse[v])
            if(comp[u] == 0) dfs2(u, current);
    }

    public static class LL extends LinkedList<Integer> { }

    public static class AL extends ArrayList<Integer> { }

    public static class HS extends HashSet<Integer> { }

}
