#include <iostream>
#include <vector>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <functional>
#include <cstdlib>

std::vector<long long> own_divisors(long long n)
{
    std::vector<long long> result;
    long long d;
    for (d = 2; d*d < n; d++) {
        if (n % d != 0) continue;
        result.push_back(d);
        result.push_back(n / d);
    }
    if (d*d == n) result.push_back(d);
    return result;
}

std::vector<long long> prime_divisors(long long n)
{
    std::vector<long long> result;
    for (long long d = 2; d*d <= n; d++) {
        if (n % d != 0) continue;
        result.push_back(d);
        while (n % d == 0) n /= d;
    }
    if (n != 1) result.push_back(n);
    return result;
}

std::vector<long long> own_prime_divisors(long long n)
{
    std::vector<long long> result;
    long long m = n;
    for (long long d = 2; d*d <= n; d++) {
        if (m % d != 0) continue;
        result.push_back(d);
        while (m % d == 0) m /= d;
    }
    if (m != n && m != 1) result.push_back(m);
    return result;
}

std::vector<long long> own_quasidivisors(long long n)
{
    std::vector<long long> result;
    long long m = n;
    for (long long d = 2; d*d <= n; d++) {
        if (m % d != 0) continue;
        for (int i = 1; i <= n / d && i <= 7000; i++) {
            result.push_back(i * d);
        }
        while (m % d == 0) m /= d;
    }
    if (m != n && m != 1) result.push_back(m);
    return result;
}

std::unordered_set<long long> pbeen;
std::unordered_set<long long> been;
bool wdfs(long long k, long long cw,
          const std::vector<long long> &ws,
          std::vector<std::pair<long long, long long>> &result)
{
    if (k > 100000) return false;
    if (been.find(cw) != been.end()) return false;
    if (cw == 0) return true;
    been.insert(cw);
    for (int i = 0; i < ws.size(); i++) {
        /*
        long long alpha = cw / ws[i];
        if (alpha == 0) continue;
        result.push_back({ws[i], alpha});
        if (wdfs(k+1, cw - alpha*ws[i], ws, result)) return true;
        result.pop_back();
        */
        long long yyy;
        long long alpha1;
        for (alpha1 = cw / ws[i], yyy = 0; alpha1 >= 1 && yyy < (cw < 1000000 ? 200 : 400); alpha1--, yyy++) {
            result.push_back({ws[i], alpha1});
            if (wdfs(k+1, cw - alpha1*ws[i], ws, result)) return true;
            result.pop_back();
        }
        /*
        long long alpha2;
        for (long long alpha2 = 1, yyy = 0; alpha2 <= alpha1 && yyy < 20; alpha2++, yyy++) {
            result.push_back({ws[i], alpha2});
            if (wdfs(k+1, cw - alpha2*ws[i], ws, result)) return true;
            result.pop_back();
        }
        */
        /*
        if (cw / ws[i] == 0) continue;
        for (long long yyy = 0; yyy < 100; yyy++) {
            long long alpha = std::rand() % (cw / ws[i]) + 1;
            result.push_back({ws[i], alpha});
            if (wdfs(k+1, cw - alpha*ws[i], ws, result)) return true;
            result.pop_back();
        }
        */
    }
    return false;
}

int main()
{
    std::srand(117);

    long long n; std::cin >> n;
    std::vector<long long> ws = own_divisors(n);
    std::sort(ws.begin(), ws.end(), std::greater<long long>());
    //std::random_shuffle(ws.begin(), ws.end());

    /*
    for (const auto &w: ws) std::cout << w << ' ';
    std::cout << std::endl;
    */

    if (ws.empty()) {
        std::cout << "NO" << std::endl;
        return 0;
    }

    std::vector<std::pair<long long, long long>> result;
    if (!wdfs(0, n-1, ws, result)) {
        std::cout << "NO" << std::endl;
        return 0;
    }

    std::cout << "YES" << std::endl;
    std::cout << result.size() << std::endl;
    for (int i = 0; i < result.size(); i++) {
        std::cout << result[i].second << ' ' << n/result[i].first << std::endl;
    }

    return 0;
}
