#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

bool visited[8][8];

pair<int, int> next_step(const pair<int, int> &now, int dir) {
    int found = -1;
    if (dir == 1) {
        for (int x = now.first; x < 8; ++x) {
            if (!visited[x][now.second]) {
                found = x;
            }
        }
    } else {
        for (int x = now.first; x >= 0; --x) {
            if (!visited[x][now.second]) {
                found = x;
            }
        }
    }
    if (found == -1) {
        return {now.first, now.second + 1};
    } else {
        return {found, now.second};
    }
}

string convert(const pair<int, int> &p) {
    char c = 'a' + p.first;
    char str[2];
    str[0] = c;
    str[1] = 0;
    return string(str) + to_string(p.second + 1);
}

void ext1(pair<int, int> &now, int &n) {
    now.second = 7;
    visited[now.first][now.second] = true;
    --n;
    cout << convert(now) << ' ';
}

void ext2(pair<int, int> &now, int &n) {
    now.second = 6;
    visited[now.first][now.second] = true;
    --n;
    cout << convert(now) << ' ';
}

void ext3(pair<int, int> &now, int &n) {
    now.second = 7;
    visited[now.first][now.second] = true;
    --n;
    cout << convert(now) << ' ';
    now.first = 6;
    visited[now.first][now.second] = true;
    --n;
    cout << convert(now) << ' ';
}


int main() {
    int n = 0;
    cin >> n;
    cout << "a1 ";
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            visited[i][j] = false;
        }
    }
    visited[0][0] = true;
    visited[7][7] = true;
    pair<int, int> now{0, 0};
    int dir = 1;
    while (n != 1) {
        if (n == 3 && now.first == 3 && now.second == 6) {
            ext3(now, n);
            continue;
        }
        if (n == 2 && now.second != 7) {
            if (now.first == 7) {
                ext2(now, n);
                continue;
            }
            ext1(now, n);
            continue;
        }
        now = next_step(now, dir);
        visited[now.first][now.second] = true;
        cout << convert(now) << ' ';
        dir *= -1;
        --n;
    }
    cout << "h8";
    return 0;
}