#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <math.h>
#include <set>
#include <deque>

using namespace std;

int main() {
    int64_t n = 0;
    cin >> n;
    if (n == 2) {
        cout << "NO";
        return 0;
    }
    int64_t d = n - 1;
    int64_t up_lim = n / 2 + 1;
    set<int64_t> divs;
    for (int64_t i = 2; i <= up_lim; ++i) {
        if (n % i == 0) {
            divs.insert(i);
        }
    }
    if (divs.empty()) {
        cout << "NO";
        return 0;
    }
    deque<pair<int64_t, vector<int64_t>>> q;
    q.push_back({n - 1, vector<int64_t>()});
    set<int64_t> visited;
    visited.insert(n - 1);
    while (!q.empty()) {
        int64_t now = q.front().first;
        vector<int64_t> path = q.front().second;
        if (now == 0) {
            cout << "YES\n" << path.size() << '\n';
            for (const auto &v : path) {
                cout << "1 " << v << '\n';
            }
            return 0;
        }
        q.pop_front();
        for (const auto &v : divs) {
            int64_t tmp = now * v - n;
            if (tmp >= 0 && visited.find(tmp / v) == visited.cend()) {
                vector<int64_t> np = path;
                np.push_back(v);
                q.push_back({tmp / v, np});
                visited.insert(tmp / v);
            }
        }
    }
    cout << "NO";
    return 0;
}