#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <deque>
#include <stack>
#include <queue>
#include <utility>
#include <algorithm>
#include <ctime>
#include <random>
#include <string>
#include <cstring>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long int64;
typedef pair<int, int> pii;

const int INF = 1e9 + 1e6;
const int64 LINF = 4e18;
const double EPS = 1e-9;

#define ll long long

void solve();

int main()
{
#ifdef _MY_DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif // _MY_DEBUG

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	solve();
}

int64 n;
int64 gcd(int64 a, int64 b);

void solve()
{
	cin >> n;

	set<int64> del;

	vector<bool> prime(3e5, true);
	prime[0] = prime[1] = false;
	for (int64 i = 2; i <= 1e5; ++i) {
		if (prime[i]) {
			if (i*i*1ll <= 1e5) {
				for (int j = i*i; j <= 1e5; j += i) {
					prime[j] = false;
				}
			}
		}
	}

	for (int64 i = 2; i <= sqrt(n); ++i) {
		if (n%i == 0) {
			if (prime[i]) {
				del.insert(i);
			}
			if (prime[n / i]) {
				del.insert(n / i);
			}
		}
	}

	int64 fg = (n - 1);
	int64 df = n;

	vector<pair<int64, int64>> ans;

	vector<int64> del1;
	for (auto fghj : del) {
		del1.push_back(fghj);
	}

	reverse(del1.begin(), del1.end());

	for (auto as : del1) {
		int64 kt = as;

		int64 ddf = fg / kt;
		ddf = min(ddf, n/as - 1ll);

		if (ddf > 0) {
			int64 gcds = gcd(ddf*as, n);
			ans.push_back({ ddf*as / gcds,n / gcds });
			fg -= ddf*kt;
		}

		if (fg == 0) {
			break;
		}
	}

	if (!fg) {
		cout << "YES" << endl << ans.size() << endl;
		for (auto we : ans) {
			cout << we.first << " " << we.second << endl;
		}
	}
	else {
		cout << "NO";
	}
}

int64 gcd(int64 a, int64 b)
{
	if (b == 0) return a;
	else return gcd(b, a%b);
}