#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <deque>
#include <stack>
#include <queue>
#include <utility>
#include <algorithm>
#include <ctime>
#include <random>
#include <string>
#include <cstring>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long int64;
typedef pair<int, int> pii;

const int INF = 1e9 + 1e6;
const int64 LINF = 4e18;
const double EPS = 1e-9;

#define ll long long

void solve();

int main()
{
#ifdef _MY_DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif // _MY_DEBUG

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	solve();
}

int64 n;
int64 gcd(int64 a, int64 b);

map<int64, bool> used;
map<int64, int64> path;

vector<int64> del1;

void bfs(int64 s);

void solve()
{
	cin >> n;

	set<int64> del;

	vector<bool> prime(3e7, true);
	prime[0] = prime[1] = false;
	for (int64 i = 2; i <= 1e7; ++i) {
		if (prime[i]) {
			if (i*i*1ll <= 1e7) {
				for (int j = i*i; j <= 1e7; j += i) {
					prime[j] = false;
				}
			}
		}
	}

	for (int64 i = 2; i <= sqrt(n); ++i) {
		if (n%i == 0) {
			if (prime[i]) {
				del.insert(i);
			}
			if (prime[n / i]) {
				del.insert(n / i);
			}
		}
	}

	int64 fg = (n - 1);
	int64 df = n;

	vector<pair<int64, int64>> ans;

	for (auto fghj : del) {
		del1.push_back(fghj);
	}

	reverse(del1.begin(), del1.end());

	bfs(0);

	if (!used[n - 1]) {
		cout << "NO";
		return;
	}

	cout << "YES" << endl;

	map<int64, int64> aas;
	int64 qwe = n - 1;
	while (true) {
		if (path[qwe] == -1)
			break;

		aas[qwe - path[qwe]]++;
		qwe = path[qwe];
	}

	cout << aas.size() << endl;
	for (auto ver : aas) {
		int64 gc = gcd(ver.first*ver.second, n);
		cout << ver.first*ver.second / gc << " " << n / gc << endl;
	}
}

int64 gcd(int64 a, int64 b)
{
	if (b == 0) return a;
	else return gcd(b, a%b);
}

void bfs(int64 s) {
	used[s] = true;
	path[s] = - 1;

	queue<int64> q;
	q.push(0);

	while (!q.empty()) {
		int64 ptr = q.front();
		q.pop();

		for (auto sdf : del1) {
			if (ptr + sdf > n - 1ll) {
				continue;
			}

			if (!used[ptr + sdf]) {
				used[ptr + sdf] = true;
				path[ptr + sdf] = ptr;
				q.push(ptr + sdf);

				if (ptr + sdf == n - 1ll) {
					break;
				}

			}
		}

		if (used[n - 1ll]) {
			break;
		}
	}
}