#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define FILE "filename"
#define LOC 1
#define len(x) int(x.size())

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;

const double EPS = 1e-9;
const int ITER = 300;
const int INF = 1e9+100;
const ll LINF = 1e18+100;

const int MAXN = 230;

int n;
int adj[MAXN][MAXN];
int adjr[MAXN][MAXN];

int dx[8] = {-1, -1, -1,  0, 0,  1, 1, 1};
int dy[8] = {-1,  0,  1, -1, 1, -1, 0, 1};

int parent[MAXN];
int rnk[MAXN];
void make_set(int v) {
    parent[v] = v;
    rnk[v] = 1;
}

int find_parent(int a) {
    if(parent[a] == a)
        return a;
    return (parent[a] = find_parent(parent[a]));
}

void union_set(int a, int b) {
    a = find_parent(a);
    b = find_parent(b);
    if(a == b)
        return;
    if(rnk[a] < rnk[b])
        swap(a, b);
    parent[b] = a;
    if(rnk[a] == rnk[b])
        ++rnk[a];
}


bool more(int a, int b) {
    if(adj[a][b])
        return true;
    deque<int> q;
    vector<int> used(n, 0);
    q.pb(a);
    used[a] = true;
    while(!q.empty()) {
        int v = q.front();
        q.pop_front();
        for(int i = 0; i < n; ++i) {
            if(adj[v][i] && !used[i]) {
                q.pb(i);
                used[i] = true;
            }
        }
    }
    if(used[b])
        return true;
    return false;
}

bool can_get(int a, int b) {
    return more(a, b) && more(b, a);
}


char ans[MAXN][50000][10];

bool cmp(int a, int b) {
    return more(a, b);
}

void solve() {
    cin >> n;
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < n; ++j)
            cin >> adj[i][j];
    for(int i = 0; i < n; ++i)
        make_set(i);
    for(int i = 0; i < n; ++i) {
        for(int j = i+1; j < n; ++j) {
            if(can_get(i, j))
                union_set(i, j);
        }
    }
    set<int> all;
    for(int i = 0; i < n; ++i)
        all.insert(find_parent(i));
    int layers = all.size()*2;
    int x = 4000;
    int y = 10;

    for(int layer = 0; layer < layers; ++layer) {
        if(layer%2 == 0) {
            for(int i = 0; i < x; ++i)
                for(int j = 0; j < y; ++j)
                    ans[layer][i][j] = '.';
        }
        else {
            for(int i = 0; i < x; ++i)
                for(int j = 0; j < y; ++j)
                    ans[layer][i][j] = '#';
        }
    }


    vector<int> comps;
    for(auto i = all.begin(); i != all.end(); ++i)
        comps.pb(*i);
    sort(comps.begin(), comps.end(), &cmp);

    for(int layer = 0; layer < layers; ++layer) {
        if(layer %2)
            continue;
        int cur = 0;
        for(int i = 0; i < n; ++i) {
            if(find_parent(i) == comps[layer/2])
                ans[layer][0][cur++] = '1' + i;
        }
    }


//  for(int layer = 0; layer < layers; ++layer) {
//        if(layer%2 == 0) {
//
//        }
//  }

    int chanx = 3;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            if(adj[i][j] == 0)
                continue;
            if(find_parent(i) == find_parent(j))
                continue;
            if(more(i, j)) {

                int ii = find_parent(i);
                int jj = find_parent(j);
                for(int k = 0; k < len(comps); ++k) {
                    if(comps[k] == ii) {
                        ii = k;
                        break;
                    }
                }
                for(int k = 0; k < len(comps); ++k) {
                    if(comps[k] == jj) {
                        jj = k;
                        break;
                    }
                }
//              cerr << "#YAY: " << ii << ' ' << jj << endl;
                for(int layer = min(jj*2, ii*2); layer <= max(ii*2, jj*2); ++layer) {
                    ans[layer][chanx][5] = '.';
                    if(layer != ii*2 && layer != jj*2) {
                        for(int disp = 0; disp < 8; ++disp)
                            ans[layer][chanx+dx[disp]][5+dy[disp]] = '#';
                    }
                }
                chanx += 5;
            }
        }
    }
    cout << y << ' ' << x << ' ' << layers << "\n";
    for(int layer = 0; layer < layers; ++layer) {
        for(int i = 0; i < x; ++i) {
            for(int j = 0; j < y; ++j) {
                cout << ans[layer][i][j];
            }
            cout << "\n";
        }
        cout << "\n";
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//  cin >> t;
    for(int cs = 0; cs < t; ++cs) {
        solve();
    }
    return 0;
}
