#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

#define F first
#define S second

#define en end()
#define bg begin()

#define rev reverse
#define mp make_pair
#define pb push_back

#define y1 y1234567890
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()
#define len(x) (int)strlen(x)

#define sqr(x) ((x + 0ll) * (x))
#define sqrd(x) ((x + 0.0) * (x))

#define forn(i, n) for (int i = 1; i <= n; i++)

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const int N = 300500;

struct node {
	int key, pr, val;
	ll sum, mx;
	node *l, *r;
	node(){};
	node(int x, int y) {
		key = x;
		val = y;
		sum = y;
		mx = x + y;
		pr = sqr(rand());
		l = r = NULL;
	}
};

node *root = NULL;

typedef pair < node*, node* > pnn;

inline ll getsum(node *v) {
	return (v ? v->sum : 0);
}

inline ll getmx(node *v) {
	return (v ? v->mx : 0);
}

inline void upd(node *v) {
	if (!v)
		return;
	v->sum = getsum(v->l) + getsum(v->r) + v->val;
	v->mx = max({getmx(v->l) + v->val + getsum(v->r), v->key + v->val + getsum(v->r), getmx(v->r)});
}

pnn split(node *v, int x) {
	if (!v) return {v, v};
	pnn res;
	if (v->key <= x) {
		res = split(v->r, x);
		v->r = res.F;
		res.F = v;
	}
	else {
		res = split(v->l, x);
		v->l = res.S;
		res.S = v;
	}
	upd(res.F);
	upd(res.S);
	return res;
}

node* merge(node *a, node *b) {
	if (!a) return b;
	if (!b) return a;
	if (a->pr > b->pr) {
		a->r = merge(a->r, b);
		upd(a);
		return a;
	}
	else {
		b->l = merge(a, b->l);
		upd(b);
		return b;
	}
}

void dfs(node *v) {
	if (!v) return;
	dfs(v->l);
	cerr << v->key << " ";
	dfs(v->r);
}

inline void add(int x, int y) {
	pnn p = split(root, x);
	node *u = new node(x, y);
	p.F = merge(p.F, u);
	root = merge(p.F, p.S);
}

inline void del(int x) {
	pnn p = split(root, x);
	pnn p1 = split(p.F, x - 1);
	root = merge(p1.F, p.S);
}

inline void query(int x) {
	pnn p = split(root, x);
	printf("%lld\n", (p.F ? max(0ll, p.F->mx - x) : 0));
	root = merge(p.F, p.S);
}

int q, x[N], y[N];

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	srand(time(NULL));

	//cin.tie(NULL);
	//cout.tie(NULL);
	//ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	scanf("%d", &q);

	for (int i = 1; i <= q; i++) {
		char tp[5];
		scanf("%s %d", tp, &x[i]);
		if (tp[0] == '+') {
			scanf("%d", &y[i]);
			add(x[i], y[i]);
		}
		else if (tp[0] == '-') {
			int pos = x[i];
			del(x[pos]);
		}
		else {
			query(x[i]);
		}
		/*cerr << "dfs : ";
		dfs(root);
		cerr << endl;*/
	}
	
	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;
	
	return 0;
}
