#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 gen(713);
struct treap {
    treap *L, *R;
    int x, y, len;
    ll lft, last, spare;

    treap(int _x, int _len) : L(nullptr), R(nullptr), x(_x), y(gen()), len(_len),
        lft(_x), last(_x + _len), spare(0) { }
};

ll lft0, last0, spare0;
void combine(ll lft1, ll last1, ll spare1, ll lft2, ll last2, ll spare2) {
    lft0 = min(lft1, lft2);
    if (last1 <= lft2) {
        spare0 = spare1 + spare2;
        last0 = last2;
    } else {
        ll delta = last1 - lft2;
        if (delta <= spare2) {
            last0 = last2;
            spare0 = spare1 + spare2 - delta;
        } else {
            last0 = last2 + delta - spare2;
            spare0 = spare1;
        }
    }
}

inline void recalc(treap *t) {
    if (t) {
        t->lft = t->x;
        t->last = t->x + t->len;
        t->spare = 0;
        if (t->L) {
            combine(t->L->lft, t->L->last, t->L->spare, t->lft, t->last, t->spare);
            t->lft = lft0;
            t->last = last0;
            t->spare = spare0;
        }
        if (t->R) {
            combine(t->lft, t->last, t->spare, t->R->lft, t->R->last, t->R->spare);
            t->lft = lft0;
            t->last = last0;
            t->spare = spare0;
        }
    }
}

void merge(treap *& t, treap *L, treap *R) {
    if (!L) t = R;
    else if (!R) t = L;
    else if (L->y > R->y)
        merge(L->R, L->R, R), t = L;
    else
        merge(R->L, L, R->L), t = R;
    recalc(t);
}

void split(treap *t, treap *& L, treap *& R, int x) {
    if (!t) {
        L = R = nullptr;
        return;
    }
    if (t->x <= x)
        split(t->R, t->R, R, x), L = t;
    else
        split(t->L, L, t->L, x), R = t;
    recalc(L);
    recalc(R);
}

treap *t;

ll query(int x) {
    treap *t1, *t2;
    split(t, t1, t2, x);
    ll ans = 0;
    if (t1) {
        ans = t1->last;
    } else {
        ans = x;
    }
    merge(t, t1, t2);
    return ans;
}

int visit_time[300105];

void add(int x, int len, int i) {
    visit_time[i] = x;
    treap *t1;
    split(t, t, t1, x);
    merge(t, t, new treap(x, len));
    merge(t, t, t1);
}

void del(int i) {
    if (!visit_time[i])
        return;
    treap *t1, *t2;
    split(t, t, t2, visit_time[i]);
    split(t, t, t1, visit_time[i] - 1);
    if (t1) delete t1;
    merge(t, t, t2);
}

int main() {
    ios_base::sync_with_stdio(false);
    //freopen("K.txt", "r", stdin);

    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        char c;
        int x, y;
        cin >> c >> x;
        if (c == '?') {
            ll ans = query(x);
            cout << max<ll>(ans, x) - x << "\n";
        } else if (c == '+') {
            cin >> y;
            add(x, y, i);
        } else {
            del(x - 1);
        }
    }
}
