#include <iostream>
#include <queue>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <set>
#include <map>
#include <assert.h>
#include <string>
using namespace std;

void stress();
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	stress();
	return 0;
}


#define int long long

vector<int> div(int n)
{
	vector<int> ans;
	for (int i = 2; i*i <= n; i++)
	{
		if (n%i == 0)
		{
			ans.push_back(i);
			if (n / i != i)
				ans.push_back(n / i);
		}
	}
	sort(ans.begin(), ans.end());
	return ans;
}

vector<int> primes;
const int MAXN = 1e5;
int p[MAXN];
void sieve()
{
	for (int i = 2; i < MAXN; i++)
	{
		if (!p[i])
		{
			if (i*i <= 1e9)
				primes.push_back(i);
			for (int j = i*i; j < MAXN; j += i)
			{
				p[j] = 1;
			}
		}
	}
}
set<int> bad;
vector<int> divs;
map<int, int> ans;
map<int, bool> was;
bool f(int x)
{
	if (x == 0)
		return 1;
	if (was.count(x))
		return was[x];
	was[x] = false;
	for (int i = divs.size() - 1; i >= 0; i--)
	{
		int it = divs[i];
		if (it > x)
			continue;
		if (x%it == 0)
		{
			was[x] = true;
			ans[it] += x / it;
			return true;
		}
		ans[it]++;
		if (f(x - it))
		{
			was[x] = true;
			return was[x];
		}
		ans[it]--;
		if (!ans[it])
			ans.erase(it);
	}
	return false;

}
void solveF(int n)
{


	divs = div(n);
	if (!divs.size())
	{
		cout << "NO" << endl;
		return;
	}
	ans.clear();
	was.clear();
	if (!f(n - 1))
	{

		cout << "NO" << endl;
		return;
	}

	vector<pair<int, int>> res;

	for (auto it : ans)
	{
		
		int first = it.second;
		if (!first)
			continue;
		int second = n / it.first;
		
		res.push_back({ first,second });
		if (first >= second)
		{
			cout << "NO";
			return;
		}
	}
	if (res.size() == 0)
	{
		cout << "NO";
		return;
	}
		cout << "YES" << endl;
	cout << res.size() << endl;
	for (auto it : res)
		cout << it.first << " " << it.second << endl;
}
//int const N = 205;
//int const M = 5;
//tuple<int, int, int, int> dp[N][N][M][M];
//
//void solveA()
//{
//
//	for (int i = 0; i < N; i++)
//	{
//		for (int j = 0; j < N; j++)
//		{
//			for (int z = 0; z < M; z++)
//			{
//				for (int x = 0; x < M; x++)
//				{
//					dp[i][j][z][x] = { -1, -1, -1, -1 };
//				}
//			}
//		}
//	}
//
//	dp[0][0][0][0] = { 0, 0, 0, 0 };
//
//	queue<tuple<int, int, int, int>> q;
//	q.push({ 0, 0, 0, 0 });
//
//	while (!q.empty())
//	{
//		int cur_a, cur_b, w1, w2;
//		tie(cur_a, cur_b, w1, w2) = q.front();
//		q.pop();
//
//
//		int plus = (w1 + w2 == 4 ? 15 : 25);
//
//		int nxt_a, nxt_b;
//		nxt_a = cur_a + plus;
//		for (nxt_b = 0; nxt_b <= plus - 2; nxt_b++)
//		{
//			if (nxt_a <= 200 && nxt_b <= 200)
//			{
//				dp[nxt_a][nxt_b][w1 + 1][w2] = { cur_a, cur_b, w1, w2 };
//			}
//		}
//		for (nxt_a = cur_a + plus + 1; nxt_a <= 200; nxt_a++)
//		{
//			nxt_b = nxt_a - 2;
//			if (nxt_a <= 200 && nxt_b <= 200)
//			{
//				dp[nxt_a][nxt_b][w1 + 1][w2] = { cur_a, cur_b, w1, w2 };
//			}
//		}
//
//		nxt_b = cur_b + plus;
//		for (nxt_a = 0; nxt_a <= plus - 2; nxt_a++)
//		{
//			if (nxt_a <= 200 && nxt_b <= 200)
//			{
//				dp[nxt_a][nxt_b][w1][w2] = { cur_a, cur_b, w1, w2 };
//			}
//		}
//		for (nxt_a = cur_a + plus + 1; nxt_a <= 200; nxt_a++)
//		{
//			nxt_b = nxt_a - 2;
//			if (nxt_a <= 200 && nxt_b <= 200)
//			{
//				dp[nxt_a][nxt_b][w1 + 1][1] = { cur_a, cur_b, w1, w2 };
//			}
//		}
//
//	}
//
//
//	int tests;
//	cin >> tests;
//	while (tests--)
//	{
//
//	}
//}

void stress()
{
	sieve();
	for (int i = 0; i < primes.size(); i++)
	{
		int cur = primes[i] * primes[i];
		while (cur <= 1e9)
		{
			bad.insert(cur);
			cur *= primes[i];
		}
	}
	int n;
	cin >> n;
	solveF(n);
	//for (int n = 2; n < 20; n++)

	//{
	//	cout << n << ": ";
	//	solveF(n);
	//	cout << endl;
	//}
}