#include <iostream>
#include <queue>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <set>
#include <map>
#include <assert.h>
#include <string>
using namespace std;

void stress();
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	stress();
    return 0;
}


#define int long long

vector<int> div(int n)
{
	vector<int> ans;
	for (int i = 2; i*i <= n; i++)
	{
		if (n%i == 0)
		{
			ans.push_back(i);
			if (n / i != i)
				ans.push_back(n / i);
		}
	}
	sort(ans.begin(), ans.end());
	return ans;
}

vector<int> primes;
const int MAXN = 1e5;
int p[MAXN];
void sieve()
{
	for (int i = 2; i < MAXN; i++)
	{
		if (!p[i])
		{
			if (i*i <= 1e9)
				primes.push_back(i);
			for (int j = i*i; j < MAXN; j += i)
			{
				p[j] = 1;
			}
		}
	}
}
set<int> bad;
vector<int> divs;
map<int, int> ans;
map<int, bool> was;
bool f(int x)
{
	if (x == 0)
		return 1;
	if (was.count(x))
		return was[x];
	was[x] = false;
	for (int i = divs.size()-1; i>=0; i--)
	{
		int it = divs[i];
		if (it > x)
			continue;
		if (x%it == 0)
		{
			was[x] = true;
			ans[it] += x / it;
			return true;
		}
		ans[it]++;
		if (f(x - it))
		{
			was[x] = true;
			return was[x];
		}
		ans[it]--;
		if (!ans[it])
			ans.erase(it);
	}
	return false;

}
void solveF(int n)
{
#ifdef _DEBUG
	ofstream cout("output.txt");
#endif // DEBUG

	divs = div(n);
	if (!divs.size()|| bad.count(n))
	{
		cout << "NO" << endl;
		return;
	}
	ans.clear();
	was.clear();
	if (!f(n - 1))
	{
		
		cout << "NO" << endl;
		return;
	}
	else
		cout << "YES" << endl;
	vector<pair<int,int>> res;
	
	for (auto it : ans)
	{
		int first = it.second;
		int second = n / it.first;
		while (first >= second)
		{
			res.push_back({ second - 1,first });
			second -= first - 1;
		}
		res.push_back({ first,second});

	}
	assert(res.size() <= 100000);
	cout << res.size() << endl;
	for (auto it : res)
		cout << it.first << " " << it.second << endl;
}
void stress()
{
	sieve();
	for (int i = 0; i < primes.size(); i++)
	{
		int cur = primes[i] * primes[i];
		while (cur <= 1e9)
		{
			bad.insert(cur);
			cur *= primes[i];
		}
	}
	int n;
	cin >> n;
	solveF(n);
}

