#include <iostream>
#include <queue>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <set>
#include <map>
using namespace std;

void stress();
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	stress();
    return 0;
}


#define int long long
const int MAXN = 64;
int d[8][8][64];
pair<int, int> from[8][8][64];
int n = 8;
int di[] = { 0,0,-1,1 };
int dj[] = { 1,-1,0,0 };
bool check(int i, int j)
{
	return i >= 0 && j >= 0 && i < n && j < n;
}
void solveE()
{
	#ifdef _DEBUG
		ifstream cin("input.txt");
		ofstream cout("output.txt");
	#endif // DEBUG
	int m;
	cin >> m;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			for (int k = 0; k < MAXN; k++)
				from[i][j][k] = { -1,-1 };
	queue<pair<pair<int, int>, int>> q;
	q.push({ { 0,0 },0 });
	while (!q.empty())
	{
		auto u = q.front();
		int i = u.first.first;
		int j = u.first.second;
		int cnt = u.second;
		if (cnt == 63)
			break;
		q.pop();
		for (int k = 0; k < 4; k++)
		{
			for (int t = 1; t < n; t++)
			{
				int nj = j + t*dj[k], ni = i + t*di[k];
				if (check(ni, nj) && from[ni][nj][cnt + 1].second == -1)
				{
					q.push({ { ni,nj },cnt + 1 });
					from[ni][nj][cnt + 1] = { i,j };
				}
			}
		}
	}
	vector<pair<int, int>> ans;
	int lasti = 7, lastj = 7;
	while (true)
	{
		ans.push_back({ lasti,lastj });
		auto u = from[lasti][lastj][m];
		lasti = u.first, lastj = u.second;
		m--;
		if (m == 0)
			break;
	}
	reverse(ans.begin(), ans.end());
	for (auto it : ans)
		//	cout << it.first << " " << it.second + 1 << endl;
				cout << char('a' + it.first) << it.second + 1 << " ";

}
void solveL()
{
#ifdef _DEBUG
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif // DEBUG
	int n, m;
	cin >> n >> m;
	set<int> todo;
	for (int i = 1; i <= m; i++)
		todo.insert(i);
	vector<int> a(n), b(n);
	map<int, vector<int>> mp;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		mp[a[i]].push_back(b[i]);
	}
	vector<int> canchange;
	for (auto it : mp)
	{
		todo.erase(it.first);
		sort(it.second.begin(), it.second.end());
		if (!it.second.size())
			continue;
		for (int i = 0; i < it.second.size() - 1; i++)
			canchange.push_back(it.second[i]);
	}
	sort(canchange.begin(), canchange.end());
	int ans = 0;
	for (int i = 0; i < todo.size(); i++)
		ans += canchange[i];
	cout << ans;
}
void stress()
{
	solveL();
}

