#include "bits/stdc++.h"
using namespace std;

#define vec vector
//typedef vector<T> vec<T>;

void dfs_top_sort(int v, vec<int>& used, vec<int>& t, vec< vec<int> >& g) {
    int n = g.size();
    used[v] = 1;

    for (int to = 0; to < n; ++to) {
        if (g[v][to] == 1 && used[to] == 0) {
            dfs_top_sort(to, used, t, g);
        }
    }

    t.push_back(v);
}


void dfs_fill_component(int v, vec<int>& used, vec< vec<int> >& g, vec<int>& colors, int color) {
    int n = g.size();
    used[v] = 1;
    colors[v] = color;

    for (int to = 0; to < n; ++to) {
        if (g[v][to] == 1 && used[to] == 0) {
            dfs_fill_component(to, used, g, colors, color);
        }
    }
}


int main()
{
//     freopen("input.txt", "r", stdin);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    /// input
    int n;
    cin >> n;

    vec< vec<int> > g(n, vec<int>(n));
    vec< vec<int> > gt(n, vec<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> g[i][j];
            gt[j][i] = g[i][j];
        }
    }

    // calc
//    vec< vec<int> > mat(n);
//    for (int source = 0; source < n; ++source) {
//        vec<int> used(n, 0);
//        dfs(source, g, used);
//
//        mat[source] = used;
//    }

    // calc top sort
    vec<int> t, used(n, 0);
    for (int source = 0; source < n; ++source) {
        if (used[source] == 0) {
            dfs_top_sort(source, used, t, g);
        }
    }
    reverse(t.begin(), t.end());
//    return 0;

    int color = 0;
    used.assign(n, 0);
    vec<int> colors(n, -1);
    for (int i = 0; i < n; ++i) {
        int v = t[i];
        if (used[v] == 0) {
            dfs_fill_component(v, used, gt, colors, color);
            color++;
        }
    }

    // build condence graph
    vec< vec<int> > gc(color, vec<int>(color, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (g[i][j] == 1) {
                gc[colors[i]][colors[j]] = 1;
            }
        }
    }

//    for (int i = 0; i < n; ++i) {
//        cout << colors[i] << " ";
//    }
//    cout << endl;
//    cout << endl;

//    for (int i = 0; i < color; ++i) {
//        for (int j = 0; j < color; ++j) {
//            cout << gc
//        }
//    }

    // build ten
    int a, b, h;
    a = 3; // depth
    b = 3 * color * color + n; // length
    h = 2 * color; // height
    vec< vec< vec<int> > > ten(h, vec< vec<int> >(a, vec<int>(b, -2)));

    for (int u = 0; u < color; ++u) {
        // floor
        int cur_height = 2 * (color - 1 - u);

        // bridge
        for (int i = 0; i < b; ++i) {
            ten[cur_height][0][i] = -1;
            ten[cur_height][1][i] = -1;
            ten[cur_height][2][i] = -1;
        }

        // walls
        for (int i = 0; i < b; ++i) {
            ten[cur_height + 1][1][i] = -1;
            ten[cur_height + 1][2][i] = -1;
        }

        // holes
        for (int i = 0; i < color * color; ++i) {
            int pos = 3 * i + 1;
            ten[cur_height][2][pos] = -2;
            ten[cur_height + 1][2][pos] = -2;
        }

        // mark num
        for (int i = 0; i < n; ++i) {
            int num_id = b - 1 - i;
            if (colors[i] == u) {
                ten[cur_height + 1][0][num_id] = i + 1;
            }
        }
    }

    for (int u = 0; u < color; ++u) {
        for (int v = u + 1; v < color; ++v) {
            if (gc[u][v] == 0) {
                continue;
            }

            int u_h = 2 * (color - 1 - u);
            int v_h = 2 * (color - 1 - v);

            int id = u * color + v;
            int pos = 3 * id + 1;

            ten[u_h + 1][1][pos] = -2;

            ten[v_h][2][pos] = -1;
            ten[v_h + 1][1][pos] = -2;
        }
    }

    // output
    cout << b << " " << a << " " << h << endl;
    for (int i = h - 1; i >= 0; --i) {
        for (int j = 0; j < a; ++j) {
            for (int k = 0; k < b; ++k) {
                if (ten[i][j][k] == -1) {
                    cout << "#";
                } else if (ten[i][j][k] == -2) {
                    cout << ".";
                } else {
                    cout << ten[i][j][k];
                }
            }
            cout << endl;
        }
        cout << endl;
    }

    return 0;
}
