#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <functional>
#include <random>
#include <math.h>
#include <ctime>
#include <iomanip>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define fore(i, l, r) for (int i = int(l); i < (int)(r); i++)
#define all(a) (a).begin(), a.end()
#define x first
#define y second
#define vec vector
#define pb push_back
#define mp make_pair

typedef pair<int, int> pt;
typedef long long li;
typedef long double ld;

mt19937 rnd(time(NULL));

const ld PI = acos(-1);
const ld EPS = 1e-9;
const int INF = 1e9;
const li INF64 = 1e18;

const int N = 9;

bool used[N];
int comp[N];
vec<int> order;
vec<vec<int>> g;
vec<vec<int>> gb;
vec<vec<int>> ng;
vec<int> tops;

void comp1(int v) {
	used[v] = true;

	for (int u : g[v]) {
		if (!used[u]) {
			comp1(u);
		}
	}
	order.push_back(v);
}

void comp2(int v, int color) {
	comp[v] = color;
	used[v] = true;

	for (int u : gb[v]) {
		if (!used[u]) {
			comp2(u, color);
		}
	}
}

void top(int v) {
	used[v] = true;
	for (int u : ng[v]) {
		if (!used[u]) {
			top(u);
		}
	}

	tops.push_back(v);
}

void dfs(int v) {
	used[v] = true;
	for (int u : ng[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}
}

int dx[] = { -1, -1, -1, 0, 0, 1, 1, 1 };
int dy[] = { -1, 0, 1, -1, 1, -1, 0, 1 };

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(15);

	int n;
	cin >> n;

	g = vec<vec<int>>(n, vec<int>());
	gb = vec<vec<int>>(n, vec<int>());

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			int c;
			cin >> c;
			if (c) {
				g[i].push_back(j);
				gb[j].push_back(i);
			}
		}
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			comp1(i);
		}
	}

	memset(used, false, sizeof(used));
	reverse(all(order));

	int color = 0;
	for (int i : order) {
		if (!used[i]) {
			comp2(i, color++);
		}
	}

	ng = vec<vec<int>> (color, vec<int>());

	for (int i = 0; i < n; i++) {
		for (int v : g[i]) {
			if (comp[i] != comp[v]) {
				ng[comp[i]].push_back(comp[v]);
			}
		}
	}
	memset(used, false, sizeof(used));

	for (int i = 0; i < color; i++) {
		if (!used[i]) {
			top(i);
		}
	}

	reverse(all(tops));

	int Z = 40;
	int K = 100;
	vec<vec<vec<char>>> field(Z, vec<vec<char>>(K, vec<char>(K, '#')));
	for (int l = 0; l < Z; l += 2) {
		forn(i, K) {
			forn(j, K) {
				field[l][i][j] = '.';
			}
		}
	}
	for (int i = 0; i < tops.size(); i++) {
		vec<int> vs;
		for (int j = 0; j < n; j++) {
			if (tops[i] == comp[j]) {
				vs.push_back(j);
			}
		}

		set<int> to_comps;
		memset(used, false, sizeof(used));
		dfs(tops[i]);
		for (int j = 0; j < color; j++) {
			if (used[j] && j != tops[i]) {
				to_comps.insert(j);
			}
		}

		int h = i * 2;
		for (int v : vs) {
			field[h][K - 1][v] = '1' + v;
		}

		for (int to : to_comps) {
			int lvl = 0;
			for (int j = 0; j < color; j++) {
				if (tops[j] == to) {
					lvl = j;
					break;
				}
			}

			int t = lvl * 2;
			for (int l = h + 1; l < t; l++) {
				int x = i * 3 + 1;
				int y = lvl * 3 + 1;
				field[l][x][y] = '.';
				for (int d = 0; d < 8; d++) {
					int nx = x + dx[d];
					int ny = y + dy[d];

					field[l][nx][ny] = '#';
				}
			}
		}
	}

	cout << K << " " << K << " " << Z << endl;
	for (int z = 0; z < Z; z++) {
		forn(i, K) {
			forn(j, K) {
				cout << field[z][i][j];
			}
			cout << endl;
		}
		cout << endl;
	}
}