#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <cstdint>
#include <queue>
#include <functional>
#include <iterator>
#include <set>
#include <string>
#include <cstring>
#include <numeric>
#include <cmath>
#include <list>
#include <cstdlib>
#include <random>
#include <cstdio>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using vl = vector<ll>;
using mll = map<ll, ll>;

#define fi(n) for(int i = 0; i < int (n); i++)
#define fj(n) for(int j = 0; j < int (n); j++)
#define fk(n) for(int k = 0; k < int (n); k++)
#define f1(n) for(auto &i1 : n)
#define f2(n) for(auto &i2 : n)
#define f3(n) for(auto &i3 : n)
#define all(n) n.begin(), n.end()



class cartesian {
public:
	struct node {
		node(unsigned b, ll v) : buben(b), value(v), mn(v),
			subsize(1), l(nullptr), r(nullptr) {}
		ll value;
		ll mn;
		unsigned buben;
		int subsize;
		node *l, *r;
	};
	using pnode = node *;
	cartesian() : root(nullptr), rng(0xDEADBEEF) {}

	void insert(int idx, ll value) {
		pnode v = new node(rng(), value);
		pnode t1, t2;
		split(root, idx, t1, t2);
		merge(t1, t1, v);
		merge(root, t1, t2);
	}

	pnode at(int idx) {
		pnode cur = root;
		int add = 0;
		while (cur) {
			int cur_idx = add + subsize(cur->l);
			if (idx == cur_idx)
				return cur;
			else if (idx < cur_idx)
				cur = cur->l;
			else { cur = cur->r; add = cur_idx + 1; }
		}
	}

	int subsize(pnode n) { return n ? n->subsize : 0; }
	ll value(pnode n) { return n ? n->value : 0; }
	ll getmin(pnode n) { return n ? n->mn : ll(1e9); }

	void upd_node(pnode t) {
		if (!t) return;
		t->subsize = 1 + subsize(t->l) + subsize(t->r);
		t->value = value(t->l) + value(t->r);
		t->mn = min(getmin(t->l), getmin(t->r));
	}

	void split(pnode t, int idx, pnode &l, pnode &r, int add = 0) {
		if (!t) return void(l = r = nullptr);
		int cur_idx = add + subsize(t->l);
		if (idx <= cur_idx) {
			split(t->l, idx, l, t->l, add);
			r = t;
		}
		else {
			split(t->r, idx, t->r, r, cur_idx + 1);
			l = t;
		}
		upd_node(t);
	}

	void merge(pnode &t, pnode l, pnode r) {
		if (!l || !r) t = l ? l : r;
		else if (l->buben > r->buben) {
			merge(l->r, l->r, r);
			t = l;
		}
		else {
			merge(r->l, l, r->l);
			t = r;
		}
		upd_node(t);
	}

	int leftz(pnode p, int add = 0) {
		if (!p) return -1;
		int cur_idx = add + subsize(p->l);
		if (p->l && p->l->mn == 0)
			return leftz(p->l, add);
		if (p->value == 0)
			return cur_idx;
		return leftz(p->r, cur_idx + 1);
	}

	pnode root;
	mt19937 rng;
};


cartesian tree;

vector<pair<int, int> > qs;

void join(int t, int d) {
	cartesian::pnode t0, t1, t2;
	tree.split(tree.root, t, t0, t1);
	tree.split(t1, d, t1, t2);

	t1->value++;
	t1->mn++;

	tree.merge(t1, t1, t2);
	tree.merge(tree.root, t0, t1);
}

void cancel(int id) {
	int t = qs[id].first;
	int d = qs[id].second;

	cartesian::pnode t0, t1, t2;
	tree.split(tree.root, t, t0, t1);
	tree.split(t1, d, t1, t2);

	t1->value--;

	tree.merge(t1, t1, t2);
	tree.merge(tree.root, t0, t1);
}

ll query(int t) {
	cartesian::pnode t0, t1, t2;
	tree.split(tree.root, t, t0, t1);
	int z = tree.leftz(t1);
	tree.split(t1, z, t1, t2);
	ll ans = t1->value;
	tree.merge(t1, t1, t2);
	tree.merge(tree.root, t0, t1);
	return ans;
}

char buf[16];

/*vector<vector<int> > g;

ll ans;

ll dfs(int v, vector<vector<int> > &g, int par = -1) {
	ll subsize = 0;
	for (int to : g[v]) {
		if (to == par)
			continue;
		subsize += dfs(to, g, v);
	}
}*/

int main() {
#ifdef OFFLINE_JUDGE
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cin.sync_with_stdio(false);
	cout.sync_with_stdio(false);
	cin.tie(nullptr);

	/*int n, m; cin >> n >> m;
	g.resize(n);
	fi(m) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].emplace_back(v);
		g[v].emplace_back(u);
	}
	vector<int> roots;
	fi(n) {
		if (g[i].size() >= 3)
			roots.emplace_back(i);
	}*/

	fi(2000000)
		tree.insert(i, 0);

	int q;
	cin >> q;
	while (q--) {
		cin >> buf;
		if (buf[0] == '+') {
			int t, d; cin >> t >> d;
			join(t, d);
			qs.emplace_back(t, d);
		}
		else if (buf[0] == '-') {
			int id; cin >> id;
			id--;
			cancel(id);
		}
		else { // '?'
			int t; cin >> t;
			cout << query(t) << endl;
		}
	}

	return 0;
}