#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <cstdint>
#include <queue>
#include <functional>
#include <iterator>
#include <set>
#include <string>
#include <cstring>
#include <numeric>
#include <cmath>
#include <list>
#include <cstdlib>
#include <cstdio>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using vl = vector<ll>;
using mll = map<ll, ll>;

#define fi(n) for(int i = 0; i < int (n); i++)
#define fj(n) for(int j = 0; j < int (n); j++)
#define fk(n) for(int k = 0; k < int (n); k++)
#define f1(n) for(auto &i1 : n)
#define f2(n) for(auto &i2 : n)
#define f3(n) for(auto &i3 : n)
#define all(n) n.begin(), n.end()

int mtx[9][9];
vector<vector<int> > g, gr;

vector<char> used;
vector<int> tps;

void dfs1(int v) {
	if (used[v])
		return;
	used[v] = 1;
	for (int to : g[v])
		dfs1(to);
	tps.emplace_back(v);
}

int next_comp;
vector<int> mycomp;

void dfs2(int v) {
	if (used[v])
		return;
	used[v] = 1;
	mycomp[v] = next_comp;
	for (int from : gr[v])
		dfs2(from);
}

vector<vector<int> > comps;

void dfs3(int v) {
	if (used[v])
		return;
	used[v] = 1;
	for (int to : comps[v])
		dfs3(to);
	tps.emplace_back(v);
}

int main() {
#ifdef OFFLINE_JUDGE
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cin.sync_with_stdio(false);
	cout.sync_with_stdio(false);
	cin.tie(nullptr);

	int n; cin >> n;
	g.resize(n);
	gr.resize(n);
	fi(n)fj(n) {
		cin >> mtx[i][j];
		if (mtx[i][j]) {
			g[i].emplace_back(j);
			gr[j].emplace_back(i);
		}
	}
	used.assign(n, 0);
	fi(n) dfs1(i);
	used.assign(n, 0);
	mycomp.resize(n);
	reverse(all(tps));
	fi(n) {
		if (used[tps[i]])
			continue;
		dfs2(tps[i]);
		next_comp++;
	}
	comps.resize(next_comp);
	fi(n) {
		for (int to : g[i]) {
			if (mycomp[i] != mycomp[to])
				comps[mycomp[i]].emplace_back(mycomp[to]);
		}
	}
	tps.clear();
	used.assign(next_comp, 0);
	fi(next_comp) {
		dfs3(i);
	}
	reverse(all(tps));
	vector<int> h(next_comp);
	int next_h = 0;
	fi(next_comp) {
		h[tps[i]] = next_h;
		next_h += 2;
	}
	int H = next_comp * 2;
	int D = 150;
	int W = 3;
	vector<vector<vector<char> > > ans(H, vector<vector<char> >(D, vector<char>(W)));
	fi(H)fj(D)fk(W) ans[i][j][k] = '#';
	fi(next_comp)fj(D) ans[i*2][j][0] = '.';
	vector<int> last_idx(next_comp);
	fi(n) {
		int myh = h[mycomp[i]];
		ans[myh][last_idx[mycomp[i]]][0] = char(i + '1');
		last_idx[mycomp[i]]++;
	}
	int next_lift = 0;
	fi(next_comp) {
		for (int to : comps[i]) {
			int h1 = h[i];
			int h2 = h[to];
			ans[h1][next_lift][1] = '.';
			ans[h2][next_lift][1] = '.';
			for (int h = h1; h <= h2; h++)
				ans[h][next_lift][2] = '.';
			next_lift += 2;
		}
	}

	cout << D << ' ' << W << ' ' << H << endl;
	fi(H) {
		fj(W) {
			fk(D) {
				cout << ans[i][k][j];
			}
			cout << endl;
		}
		cout << endl;
	}

	return 0;
}