#include <set>
#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <queue>
#include <string>

using namespace std;

vector<int> ban;

vector<vector<int> > g;
vector<int> ans;
vector<int> sts;
int ub;

int C = 0;

int count_sts(int v, int col)
{
	if (ban[v] || sts[v] == col)
		return 0;
	sts[v] = col;
	int ret = 1;
	for (int u : g[v])
		if (ans[u] == ans[v] + 1)
			ret += count_sts(u, col);
	return ret;
}

void bfs(int v)
{
	int n = g.size();
	fill(ans.begin(), ans.end(), -1);
	ans[v] = 0;
	queue<int> q;
	q.push(v);
	while (q.size())
	{
		int v = q.front();
		q.pop();
		for (int u : g[v]) if (!ban[u] && ans[u] == -1)
		{
			ans[u] = ans[v] + 1;
			q.push(u);
		}
	}
}

int get_sz(int v)
{
	bfs(v);
	int kek = 0;
	for (int u : g[v])
		kek = max(kek, count_sts(u, C++));
	return kek;
}

void unban(int v, int col)
{
	if (ban[v] != col)
		return;
	ub++;
	ban[v] = 0;
	for (int u : g[v])
		if (ans[u] == ans[v] + 1)
			unban(u, col);
}


bool check(int v)
{
	int n = g.size();
	cout << v + 1 << endl;
	string s;
	cin >> s;
	if (s == "FOUND")
		return 1;
	int x;
	cin >> x;
	bfs(v);
	ub = 0;
	for (int i = 0; i < n; i++)
		if (!ban[i])
			ban[i] = v + 1;
	unban(x - 1, v + 1);
	return 0;
}


int main()
{
	int n, m;
	cin >> n >> m;
	g.resize(n);
	ban.resize(n);
	ans.resize(n);
	sts.resize(n);
	for (int i = 0; i < m; i++)
	{
		int kek;
		cin >> kek;
		int prev;
		cin >> prev;
		--prev;
		for (int i = 1; i < kek; i++)
		{
			int x;
			cin >> x;
			--x;
			g[x].push_back(prev);
			g[prev].push_back(x);
			prev = x;
		}
	}
	for (int i = 0; i < n; i++)
	{
		ub = n;
		fill(ban.begin(), ban.end(), 0);
		vector<int> sz(n);
		do
		{
			for (int i = 0; i < n; i++)
				if (ban[i])
					sz[i] = n + 1;
				else
					sz[i] = get_sz(i);

		} while (!check(min_element(sz.begin(), sz.end()) - sz.begin()));
	}
	return 0;
}