#include <set>
#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <queue>
#include <string>

using namespace std;

const int maxn = 505;

int n;
vector<int> g[maxn];
int ans[maxn];
int sts[maxn];
int ban[maxn];
int ub;

int C = 0;

int count_sts(int v, int col)
{
	if (ban[v] || sts[v] == col)
		return 0;
	sts[v] = col;
	int ret = 1;
	for (int u : g[v])
		if (ans[u] == ans[v] + 1)
			ret += count_sts(u, col);
	return ret;
}

inline void bfs(int v)
{
	fill(ans, ans + n, -1);
	ans[v] = 0;
	queue<int> q;
	q.push(v);
	while (q.size())
	{
		int v = q.front();
		q.pop();
		for (int u : g[v]) if (!ban[u] && ans[u] == -1)
		{
			ans[u] = ans[v] + 1;
			q.push(u);
		}
	}
}

int get_sz(int v)
{
	bfs(v);
	int kek = 0;
	for (int u : g[v])
		kek = max(kek, count_sts(u, C++));
	return kek;
}

void unban(int v, int col)
{
	if (ban[v] != col)
		return;
	ub++;
	ban[v] = 0;
	for (int u : g[v])
		if (ans[u] == ans[v] + 1)
			unban(u, col);
}


inline bool check(int v)
{
	cout << v + 1 << endl;
	string s;
	cin >> s;
	if (s == "FOUND")
		return 1;
	int x;
	cin >> x;
	bfs(v);
	ub = 0;
	for (int i = 0; i < n; i++)
		if (!ban[i])
			ban[i] = v + 1;
	unban(x - 1, v + 1);
	return 0;
}


int main()
{
	int m;
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		int kek;
		cin >> kek;
		int prev;
		cin >> prev;
		--prev;
		for (int i = 1; i < kek; i++)
		{
			int x;
			cin >> x;
			--x;
			g[x].push_back(prev);
			g[prev].push_back(x);
			prev = x;
		}
	}
	for (int i = 0; i < n; i++)
	{
		ub = n;
		fill(ban, ban + n, 0);
		vector<int> sz(n);
		int uhh = -1;
		do
		{
			uhh = -1;
			int bub = ub;
			for (int i = 0; i < n; i++)
				if (ban[i])
					sz[i] = n + 1;
				else
				{
					sz[i] = get_sz(i);
					if (sz[i] <= bub / 2)
					{
						uhh = i;
						break;
					}
				}
			if (uhh == -1)
				uhh = min_element(sz.begin(), sz.end()) - sz.begin();
		} while (!check(min_element(sz.begin(), sz.end()) - sz.begin()));
	}
	return 0;
}