#include <iostream>
#include <vector>
#include <stdio.h>

using namespace std;

typedef long long ll;

const int inf = 1e9;

int rnd(int x = inf){
    return (rand() << 15 | rand()) % x;
}

struct Node{
    int b;
   // int kek;
    int st, d;
    int y;
    ll T, t;
    Node* left = nullptr;
    Node* right = nullptr;
    Node(int b, int d) : b(b), y(rnd()), T(b + d), t(0), left(nullptr), right(nullptr) {
        this -> st = b;
        this -> d = d;
       // this -> kek = rnd();
    }
};

pair<ll, ll> lolich(int b1, ll T1, ll t1, int b2, ll T2, ll t2){
    ll T, t;
    if (T1 <= b2){
        T = T2;
        t = t1 + t2 + b2 - T1;
    }
    else{
        T = T2 + max(0LL, T1 - b2 - t2);
        t = t1 + t2 - min(t2, T1 - b2);
    }
    return {T, t};
}

void update(Node* &v){
    if (v == nullptr)
        return;
    v -> b = v -> st;
    v -> T = v -> st + v -> d;
    v -> t = 0;
    if (v -> left != nullptr){
        pair<ll, ll> u = lolich(v -> left -> b, v -> left -> T, v -> left -> t, v -> b, v -> T, v -> t);
        v -> b = v -> left -> b;
        v -> T = u.first;
        v -> t = u.second;
    }
    if (v -> right != nullptr){
        pair<ll, ll> u = lolich(v -> b, v -> T, v -> t, v -> right -> b, v -> right -> T, v -> right -> t);
        v -> T = u.first;
        v -> t = u.second;
    }
}

Node* merge(Node* a, Node* b){
    if (a == nullptr)
        return b;
    if (b == nullptr)
        return a;
    if (a -> y < b -> y){
        a -> right = merge(a -> right, b);
        update(a);
        return a;
    }
    else{
        b -> left = merge(a, b -> left);
        update(b);
        return b;
    }
}

pair<Node*, Node*> split(Node* v, int x){
    if (v == nullptr)
        return {v, v};
    pair<Node*, Node*> s;
    if (v -> st >= x){
        s = split(v -> left, x);
        v -> left = s.second;
        update(v);
        return {s.first, v};
    }
    else{
        s = split(v -> right, x);
        v -> right = s.first;
        update(v);
        return {v, s.second};
    }
}

void print(Node* v){
    if (v == nullptr)
        return;
    print(v -> left);
    cout << v -> st << endl;
    print(v -> right);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
   // freopen("test.in", "r", stdin);
    int q;
    cin >> q;
    Node* root = nullptr;
    pair<Node*, Node*> v, u;
    vector<int> kek(q);
    int now = -1;
    while (q-- > 0){
        char c;
        cin >> c;
        now++;
        if (c == '+'){
            int a, b;
            cin >> a >> b;
            v = split(root, a);
            v.second = merge(new Node(a, b), v.second);
            root = merge(v.first, v.second);
            kek[now] = a;
            continue;
        }
        if (c == '-'){
            int a;
            cin >> a;
            //print(root);
            v = split(root, kek[a - 1]);
            u = split(v.second, kek[a - 1] + 1);
            root = merge(v.first, u.second);
            //print(root);
            continue;
        }
        int a;
        cin >> a;
        //print(root);
        v = split(root, a + 1);
        if (v.first == nullptr || v.first -> T <= a)
            cout << 0 << "\n";
        else
            cout << v.first -> T - a << "\n";
        root = merge(v.first, v.second);
    }
    return 0;
}
