#include <bits/stdc++.h>
using namespace std;

#ifdef mypity
#define debug(...) fprintf(stderr, __VA_ARGS__);
#define cdebug(...) cerr << __VA_ARGS__;
#else
#define debug(...) do {} while(false)
#define cdebug(...) do {} while(false)
#endif

using i64 = int64_t;
#define WHOLE(v) v.begin(),v.end()

int wins, losses;

int getsize(int mask) {
  wins = 0, losses = 0;
  for (int i = 0; i < 5; ++i) {
    if (mask & (1<<i)) {
      ++wins;
    } else {
      ++losses;
    }
    if (max(wins, losses) == 3) {
      return i + 1;
    }
  }
  return 5;
}

vector<pair<int, int>> ans;

bool check(int a, int b, int mask, int sz, int most) {
  auto setsize = [](int id) {
    return id == 4 ? 15 : 25;
  };

  ans.assign(sz, make_pair(0, 0));

  for (int i = 0; i < sz; ++i) {
    if (mask & (1<<i)) {
      a -= setsize(i);
      ans[i].first += setsize(i);
    } else {
      ans[i].second += setsize(i);
      b -= setsize(i);
    }
  }
  if (a < 0 || b < 0) {
    return false;
  }

  int& lastlose = (mask & (1<<(most))) ? b : a;
  int& cool = (mask & (1<<(most))) ? ans[most].second: ans[most].first;
  int delta1 = min(lastlose, setsize(most) - 2);
  lastlose -= delta1;
  cool += delta1;

  auto mi = min(a, b);
  a -= mi;
  b -= mi;
  ans[most].first += mi;
  ans[most].second += mi;

  for (int i = 0; i < sz; ++i) {
    if (i == most) continue;
    if (mask & (1<<i)) {
      int delta = min(b, setsize(i) - 2);
      b -= delta;
      ans[i].second += delta;
    } else {
      auto delta = min(a, setsize(i) - 2);
      a -= delta;
      ans[i].first += delta;
    }
  }
  return a == 0 && b == 0;
}

void solve() {
  int a, b;
  cin >> a >> b;

  int best = -123123, bestmask = -1, bestmost = -1;

  for (int mask = 0; mask < (1<<5); ++mask) {
    auto sz = getsize(mask);
    auto score = wins - losses;
    for (int most = 0; most < sz; ++most) {
      if (score > best && check(a, b, mask, sz, most)) {
        best = score;
        bestmask = mask;
        bestmost = most;
      }
    }
  }
  if (bestmask == -1) {
    printf("Impossible\n");
    return;
  }
  check(a, b, bestmask, getsize(bestmask), bestmost);
  int sa = 0, sb = 0;
  printf("%d:%d\n", wins, losses);
  for (auto pa : ans) {
    sa += pa.first;
    sb += pa.second;
    printf("%d:%d ", pa.first, pa.second);
  }
  if (sa != a || sb != b) {
    exit(1);
  }
  printf("\n");
}

int main() {
#ifdef mypity
  freopen("A.in", "r", stdin);
#endif
  cin.sync_with_stdio(false);
  cin.tie(nullptr);

  int t;
  cin >> t;
  for (int i = 0; i < t; ++i) {
    solve();
  }
}