#include <bits/stdc++.h>
using namespace std;

#ifdef mypity
#define debug(...) fprintf(stderr, __VA_ARGS__);
#define cdebug(...) cerr << __VA_ARGS__;
#else
#define debug(...) do {} while(false)
#define cdebug(...) do {} while(false)
#endif

using i64 = int64_t;
#define WHOLE(v) v.begin(),v.end()

int n;
vector<vector<int>> direct;

vector<bool> used;
vector<int> topOrder;
void topTraverse(int v) {
  used[v] = true;
  for (int u = 0; u < n; ++u) {
    if (direct[v][u] && !used[u]) {
      topTraverse(u);
    }
  }
  topOrder.push_back(v);
}

vector<vector<int>> comp;
vector<int> compid;
int comps;
void colorize(int v, int color) {
  comp.back().push_back(v);
  compid[v] = color;
  used[v] = true;
//  for (int u : gr[v]) {
  for (int u = 0; u < n; ++u) {
    if (direct[u][v] && !used[u]) {
      colorize(u, color);
    }
  }
}

vector<vector<int>> scced;

void getscc() {
  used.assign(n, false);
  for (int i = 0; i < n; ++i) {
    if (!used[i]) {
      topTraverse(i);
    }
  }
  reverse(WHOLE(topOrder));

  used.assign(n, false);
  compid.resize(n);
  comps = 0;
  for (int i = 0; i < n; ++i) {
    if (!used[topOrder[i]]) {
      comp.emplace_back();
      colorize(topOrder[i], comps++);
    }
  }

  scced.resize(comp.size(), vector<int>(comp.size(), 0));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      if (direct[i][j] && compid[i] != compid[j]) {
        scced[compid[i]][compid[j]] = 1;
      }
      assert(compid[i] <= compid[j] || !direct[i][j]);
    }
  }
}

int main() {
#ifdef mypity
  freopen("M.in", "r", stdin);
#endif
  cin.sync_with_stdio(false);
  cin.tie(nullptr);

  cin >> n;
  direct.resize(n, vector<int>(n));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      cin >> direct[i][j];
    }
  }

  getscc();

  vector<vector<string>> ans(50, vector<string>(50, string(50, '.')));

  for (int i = 1; i <= comps; ++i) {
    // ans[4 * i][3 * i][3 * i]
    for (int j = 0; j <= 4 * i; ++j) {
      ans[4 * i][j][3 * i] = '#';
    }
    for (int j = 3 * i; j < 50; ++j) {
      ans[4 * i][4 * i][j] = '#';
    }
  }
  for (int i = 1; i <= comps; ++i) {
    for (int j = 1; j <= comps; ++j) {
      assert(!scced[i-1][j-1] || i < j);
      if (i < j && !scced[i-1][j-1]) {
        for (int d : {-1, 1}) {
          ans[4 * i][4 * i + d][3 * j] = '#';
          ans[4 * i - 1][4 * i + d][3 * j] = '#';
          ans[4 * i - 2][4 * i + d][3 * j] = '#';
        }
      }
    }
  }
  for (int i = 1; i <= comps; ++i) {
    for (int v : comp[i-1]) {
      ans[4 * i - 1][4 * i][40 + v] = char('1' + v);
    }
  }

  cout << ans[0][0].size() << ' ' << ans[0].size() << ' ' << ans.size() << '\n';
  for (const auto& plane : ans) {
    for (const auto& row : plane) {
      cout << row << '\n';
    }
    cout << '\n';
  }
}