#include <iostream>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define ff first
#define ss second

int endd[] = { 25, 25, 25, 25, 15 };

pii get_score(int mask, int len)
{
	int a = 0;
	for (int i = 0; i < len; ++i)
		a += (bool)(mask & (1 << i));
	return { a, len - a };
}

bool is_ok(ll a, ll b, ll x, ll y, int beta, int len)
{
	if (a < 0 || b < 0)
		return false;
	if (beta == len)
		return x >= a && y >= b;
	return ((a - x - b) * (a - b + y) <= 0);
}

void sub(int& a, int& b, int& y, int i, int beta)
{
	a -= endd[i];
	if (beta == i)
	{
		b -= endd[i] - 2;
	}
	else
	{
		y += endd[i] - 2;
	}
}

pii prepare(int& a, int& b, int mask, int len, int beta)
{
	int x = 0, y = 0;
	for (int i = 0; i < len; ++i)
	{
		if (mask & (1 << i))
		{
			sub(a, b, y, i, beta);
		}
		else
		{
			sub(b, a, x, i, beta);
		}
	}
	return { x, y };
}

bool is_possible(int a, int b, int mask, int len, int beta)
{
	auto pa = prepare(a, b, mask, len, beta);
	int x = pa.ff;
	int y = pa.ss;
	return is_ok(a, b, x, y, beta, len);
}

bool cmp(pii a, pii b)
{
	return a.ff - a.ss > b.ff - b.ss;
}

bool is_correct(int mask, int len)
{
	int a = 0;
	int b = 0;
	for (int i = 0; i < len; ++i)
	{
		if (a == 3 || b == 3)
			return false;
		if (mask & (1 << i))
		{
			a += 1;
		}
		else
		{
			b += 1;
		}
	}
	return a == 3 || b == 3;
}

int main()
{
	int n;
	cin >> n;
	vector<pii> ans;
	for (int k = 0; k < n; ++k)
	{
		pii best = { -1, 1000};
		int best_mask;
		int best_len;
		int best_beta;
		int a, b;
		cin >> a >> b;
		for (int len = 3; len <= 5; ++len)
		{
			for (int i = 0; i < (1 << len); ++i)
			{
				if (!is_correct(i, len))
					continue;
				for (int beta = 0; beta <= len; ++beta)
				{
					if (is_possible(a, b, i, len, beta))
					{
						pii score = get_score(i, len);
						if (cmp(score, best))
						{
							best = score;
							best_mask = i;
							best_len = len;
							best_beta = beta;
						}
					}
				}
			}
		}
		if (best == pii(-1, 1000))
		{
			cout << "Impossible\n";
		}
		else
		{
			int mask = best_mask;
			int len = best_len;
			int beta = best_beta;
			auto pa = prepare(a, b, mask, len, beta);
			int x = pa.ff;
			int y = pa.ss;
			vector<pii> ans;
			for (int i = 0; i < len; ++i)
			{
				if (i == beta)
				{
					if (mask & (1 << i))
					{
						ans.emplace_back(endd[i], endd[i] - 2);
					}
					else
					{
						ans.emplace_back(endd[i] - 2, endd[i]);
					}
					continue;
				}
				if (mask & (1 << i))
				{
					for (int j = 0; j <= endd[i] - 2; ++j)
					{
						if (is_ok(a, b - j, x, y - endd[i] + 2, beta, len))
						{
							ans.push_back({ endd[i], j }), b -= j, y -= endd[i] - 2;
							break;
						}
					}
				}
				else
				{
					for (int j = 0; j <= endd[i] - 2; ++j)
					{
						if (is_ok(a - j, b, x - endd[i] + 2, y, beta, len))
						{
							ans.push_back({ j, endd[i] }), a -= j, x -= endd[i] - 2;
							break;
						}
					}
				}
			}
			if (a != b)
			{
				throw exception();
			}
			if (beta >= ans.size() && a != 0)
			{
				throw exception();
			}
			if (beta < ans.size())
			{
				ans[beta].ff += a;
				ans[beta].ss += a;
			}
			cout << best.ff << ':' << best.ss << '\n';
			for (auto pa : ans)
			{
				cout << pa.ff << ':' << pa.ss << ' ';
			}
			cout << '\n';
		}
	}
	return 0;
}

/*
6
75 0
90 90
20 0
0 75
78 50
80 100

6
75 0
3:0
25:0 25:0 25:0
90 90
3:1
40:38 25:4 0:25 25:23
20 0
Impossible
0 75
0:3
0:25 0:25 0:25
78 50
3:0
28:26 25:1 25:23
80 100
3:2
40:38 25:0 0:25 0:25 15:12
*/