#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <queue>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define ff first
#define ss second

const int MAXN = 510;

vector<int> g[MAXN];
int dist[MAXN];
int pre[MAXN];
int n, m;

vector<int> get_path(int start, int finish)
{
	vector<int> path;
	path.push_back(finish);
	while (pre[finish] != start)
	{
		finish = pre[finish];
		path.push_back(finish);
	}
	path.push_back(start);
	return path;
}

int ask(int v)
{
	cout << v + 1 << endl;
	string ans;
	cin >> ans;
	int go = -1;
	if (ans != "FOUND")
	{
		cin >> go;
	}
	return go - 1;
}

void bfs(int start)
{
	fill(dist, dist + n, -1);
	dist[start] = 0;
	queue<int> q;
	q.push(start);
	while (!q.empty())
	{
		int cur = q.front();
		q.pop();
		for (auto to : g[cur])
		{
			if (dist[to] == -1)
			{
				dist[to] = dist[cur] + 1;
				pre[to] = cur;
				q.push(to);
			}
		}
	}
}

int v_floyd[MAXN][MAXN];
int dist_floyd[MAXN][MAXN];

void calc_floyd()
{
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			dist_floyd[i][j] = 1e9;
	for (int i = 0; i < n; ++i)
		for (auto to : g[i])
			dist_floyd[i][to] = 1, v_floyd[i][to] = to;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			for (int k = 0; k < n; ++k)
			{
				if (dist_floyd[i][k] + dist_floyd[k][j] < dist_floyd[i][j])
				{
					dist_floyd[i][j] = dist_floyd[i][k] + dist_floyd[k][j];
					v_floyd[i][j] = v_floyd[i][k];
				}
			}
}

int main()
{
	cin >> n >> m;
	for (int i = 0; i < m; ++i)
	{
		int len;
		cin >> len;
		vector<int> v;
		for (int j = 0; j < len; ++j)
		{
			int x;
			cin >> x;
			--x;
			v.push_back(x);
		}
		for (int j = 0; j < len - 1; ++j)
		{
			int x = v[j];
			int y = v[j + 1];
			g[x].push_back(y);
			g[y].push_back(x);
		}
	}
	calc_floyd();
	int cur = 1;
	for (int i = 0; i < n; ++i)
	{
		unordered_set<int> bad;
		while (true)
		{
			int a[MAXN];
			int best = 0;
			for (int j = 0; j < n; ++j)
			{
				if (bad.count(j))
					continue;
				fill(a, a + MAXN, 0);
				bool flag = false;
				for (int k = 0; k < n; ++k)
				{
					if (bad.count(k))
						continue;
					int cur = v_floyd[j][k];
					a[cur]++;
					if (a[cur] > (n - bad.size()) / 2 + 1)
					{
						flag = true;
						break;
					}
				}
				if (!flag)
				{
					best = j;
				}
			}
			int go = ask(best);
			if (go == -2)
				break;
			bad.insert(best);
			for (int j = 0; j < n; ++j)
			{
				if (v_floyd[best][j] != go)
					bad.insert(j);
			}
		}
	}
	return 0;
}

/*
5 2
5 1 2 3 4 5
2 1 3

*/