#include <iostream>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

ll gcd(ll a, ll b)
{
	return (b != 0) ? gcd(b, a % b) : a;
}

ll gcd_wide(ll a, ll b, ll &x, ll &y)
{
	if (a == 0) {
		x = 0;
		y = 1;
		return b;
	}
	ll x1, y1;
	ll d = gcd_wide(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

int main()
{
	ll n;
	cin >> n;
	vector<ll> divisors;
	for (int i = 2; i < sqrt(n) + 1; ++i)
	{
		if (n % i == 0)
			divisors.push_back(i), divisors.push_back(n / i);
	}
	ll a = -1, b = -1;
	for (auto div1 : divisors)
		for (auto div2 : divisors)
		{
			if (div1 == 1 || div2 == 1)
				continue;
			if (gcd(div1, div2) == 1)
			{
				a = div1;
				b = div2;
			}
		}
	if (a == -1)
	{
		cout << "NO";
		return 0;
	}
	else
	{
		cout << "YES\n";
		ll c, d;
		gcd_wide(a, b, c, d);
		c *= (n - 1);
		d *= (n - 1);
		ll mod_c = n / a;
		ll mod_d = n / b;
		c = (c % mod_c + mod_c) % mod_c;
		d = (d % mod_d + mod_d) % mod_d;
		cout << 2 << '\n';
		cout << c << ' ' << n / a << '\n';
		cout << d << ' ' << n / b << '\n';
	}
	return 0;
}

/*

*/