#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <cstring>
#include <algorithm>

using namespace std;

typedef long long lld;
typedef unsigned long long llu;
typedef unsigned int uint;
typedef pair<lld, lld> pii;

#define forn(i, n) for(int (i) = 0; (i) < (n); (i)++)
#define formn(i, m, n) for(int (i) = (m); (i) < (n); (i)++)
#define foreach(x, c) for(auto (x) : (c))

const int MAXN = 2e5;

vector<vector<int>> g, gr;
vector<char> used;
vector<int> order;
vector<vector<int>> components;
vector<vector<int>> gmat;
vector<vector<int>> comp_graph;
vector<int> comp_by_vert;
vector<int> comp_used;
vector<int> comp_order;

void dfs1(int v) {
	used[v] = true;
	forn(i, g[v].size()) {
		if (!used[g[v][i]]) {
			dfs1(g[v][i]);
		}
	}
	order.push_back(v);
}

void dfs2(int v, int comp) {
	used[v] = true;
	components[comp].push_back(v);
	comp_by_vert[v] = comp;
	forn(i, gr[v].size()) {
		if (!used[gr[v][i]]) {
			dfs2(gr[v][i], comp);
		}
	}
}

void comp_dfs_order(int v) {
	comp_used[v] = true;
	foreach(u, comp_graph[v]) {
		if (!comp_used[u]) {
			comp_dfs_order(u);
		}
	}
	comp_order.push_back(v);
}

int main() {
	int n;
	scanf("%d", &n);
	gmat.resize(n);
	g.resize(n);
	gr.resize(n);
	comp_by_vert.resize(n);
	forn(i, n) {
		gmat[i].assign(n, 0);
		forn(j, n) {
			int t;
			scanf("%d", &t);
			if (t) {
				g[i].push_back(j);
				gr[j].push_back(i);
				gmat[i][j] = 1;
			}
		}
	}

	used.assign(n, false);
	forn(i, n) {
		if (!used[i]) {
			dfs1(i);
		}
	}
	used.assign(n, false);
	int comp_num = 0;
	forn(i, n) {
		int v = order[n - 1 - i];
		if (!used[v]) {
			components.push_back(vector<int>());
			dfs2(v, comp_num++);
		}
	}
	comp_graph.resize(comp_num);
	forn(i, comp_num) {
		foreach(u, components[i]) {
			comp_graph[i].push_back(comp_by_vert[u]);
		}
	}

	comp_used.assign(comp_num, 0);
	forn(i, comp_num) {
		if (!comp_used[i]) {
			comp_dfs_order(i);
		}
	}

	//  ?

	vector<vector<int>> A(comp_num);
	forn(i, comp_num) {
		A[i].resize(comp_num);
		foreach(j, components[i]) {
			foreach(u, g[j]) {
				A[i][comp_by_vert[u]] = 1;
			}
		}
	}
	forn(i, comp_num) {
		A[i][i] = 0;
	}

	printf("%lld 3 %lld\n", (lld)(comp_num)* comp_num * 2 + 9, (lld)(comp_num) * 2);

	forn(zz, comp_num) {
		int z = comp_order[zz];


		forn(j, comp_num * comp_num) {
			printf(".#");
		}
		printf("#########");
		printf("\n");

		forn(x, comp_num * comp_num) {
			int f = x / comp_num;
			int s = x % comp_num;
			if ((z == f || z == s) && A[f][s] == 1) {
				printf(".");
			}
			else {
				printf("#");
			}
			printf("#");
		}
		printf("#########");
		printf("\n");

		foreach(cn, components[z]) {
			printf("%d", cn + 1);
		}
		forn(j, comp_num * comp_num * 2 - components[z].size() + 9) {
			printf(".");
		}
		printf("\n\n");


		forn(x, comp_num * comp_num) {
			int f = x / comp_num;
			int s = x % comp_num;
			if (s == z) {
				printf("#");
			}
			else {
				printf(".");
			}
			printf("#");
		}
		printf("#########");
		printf("\n");
		forn(x, 2 * comp_num * comp_num + 9) {
			printf("#");
		}
		printf("\n");
		forn(j, comp_num * comp_num * 2 + 9) {
			printf("#");
		}
		printf("\n\n");

	}
}

/*
4
0 1 0 1
0 0 1 0
0 1 0 0
1 0 0 0
8 3 4
##.##############
03...............
##.###.##########
#################
#################

.#.#.#.##########
##.##############
12...............
.###.############
#################
#################

.#.#.#.##########



9
0 0 0 0 0 0 0 0 0
0 0 1 0 0 0 0 0 0
0 0 0 1 0 0 0 0 1
0 1 0 0 1 1 0 0 0
0 0 0 0 0 1 0 0 0
0 0 0 0 1 0 1 0 0
0 0 0 0 0 0 0 0 0
0 0 0 0 0 0 1 0 0
0 0 0 0 0 0 0 1 0
*/