#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define sz(a) int((a).size())
#define sqr(a)) (a) * (a)
#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define fore(i, l, r) for (int i = int(l); i < int(r); ++i)
#define all(a) (a).begin(), (a).end()

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<li, li> pll;

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, vector<A> &a) {
	out << "[";
	forn(i, sz(a)) {
		if (i) out << ", ";
		out << a[i];
	}
	return out << "]";
}

mt19937 rnd(time(NULL));
mt19937 rnd64(time(NULL));

const ld PI = acosl(-1.0);
const ld EPS = 1e-9;
const int INF = 1e9;
const li INF64 = 1e18;
const int MOD = 1e9 + 7;

const int N = 1000 * 1000 + 13;

int n;
pair<int, pt> q[N];

bool read() {
	if (scanf("%d", &n) != 1)
		return false;
	static char buf[5];
	forn(i, n){
		scanf("%s", buf);
		if (buf[0] == '+'){
			q[i].x = 0;
			scanf("%d%d", &q[i].y.x, &q[i].y.y);
			--q[i].y.x;
		}
		else if (buf[0] == '-'){
			q[i].x = 1;
			scanf("%d", &q[i].y.x);
			--q[i].y.x;
		}
		else{
			q[i].x = 2;
			scanf("%d", &q[i].y.x);
			--q[i].y.x;
		}
	}
	return true;
}

pll t[4 * N];

pll unite(pll l, pll r){
	pll v;
	v.x = min(INF64, l.x + max(0ll, r.x - l.y));
	v.y = r.y + l.y - min(l.y, r.x);
	return v;
}

void build(int v, int l, int r){
	if (l == r - 1){
		t[v] = mp(1ll, 0ll);
		return;
	}
	
	int m = (l + r) / 2;
	
	build(v * 2, l, m);
	build(v * 2 + 1, m, r);
	
	t[v] = unite(t[v * 2], t[v * 2 + 1]);
}

void upd(int v, int l, int r, int pos, pll val){
	if (l == r - 1){
		t[v] = val;
		return;
	}
	
	int m = (l + r) / 2;
	
	if (pos < m)
		upd(v * 2, l, m, pos, val);
	else
		upd(v * 2 + 1, m, r, pos, val);
	
	t[v] = unite(t[v * 2], t[v * 2 + 1]);
}

pll get(int v, int l, int r, int L, int R){
	if (l == L && r == R)
		return t[v];
	
	int m = (l + r) / 2;
	
	if (m >= R)
		return get(v * 2, l, m, L, R);
	else if (m < L)
		return get(v * 2 + 1, m, r, L, R);
	
	auto t1 = get(v * 2, l, m, L, min(m, R));
	auto t2 = get(v * 2 + 1, m, r, max(m, L), R);
	
	return unite(t1, t2);
}

li used[N];

void solve() {
	memset(used, -1, sizeof(used));
	
	build(1, 0, N);
	forn(i, n){
		int tp = q[i].x;
		if (tp == 0){
			upd(1, 0, N, q[i].y.x, mp(0ll, q[i].y.y - 1));
			used[q[i].y.x] = q[i].y.y;
		}
		else if (tp == 1){
			upd(1, 0, N, q[q[i].y.x].y.x, mp(1ll, 0ll));
			used[q[q[i].y.x].y.x] = -1;
		}
		else{
			pll val = get(1, 0, N, 0, q[i].y.x);
			if (used[q[i].y.x] != -1)
				val = unite(val, {0, used[q[i].y.x]});
			printf("%lld\n", val.y);
		}
	}
}

int main() {
	cout << fixed << setprecision(10);
	cerr << fixed << setprecision(5);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	int tt = clock();
#endif

	while (read()) {
		solve();
#ifdef _DEBUG
		cerr << "TIME = " << clock() - tt << endl;
		tt = clock();
#endif
	}
}