#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
#define mp(a, b) make_pair((a), (b))
#define ft first
#define sd second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
int maxn = 100005;

vector<pii> d;
vector<int> dp;
vector<int> pr;
vector<int> suf;
int sol = -1;

void brute(int cnt, int pos) {
	if (cnt < maxn) {
		if (dp[cnt] != -1)
			sol = cnt;
		return;
	}

	for (int i = pos; i < sz(d); i++) {
		if (d[i].sd > cnt)
			continue;
		//if (d[i].sd < 1000)
		//	return;
		suf.push_back(d[i].sd);
		brute(cnt - d[i].sd, i);
		if (sol != -1)
			return;
		suf.pop_back();
	}
}

void solve()
{
	int n;
	scanf("%d", &n);
	for (int i = 2; i * i <= n; i++) {
		if (n % i == 0) {
			int v1 = i, v2 = n / i;
			d.push_back(mp(v1, v2));
			d.push_back(mp(v2, v1));
		}
	}

	//prime
	if (sz(d) == 0) {
		printf("NO");
		return;
	}
	sort(all(d));

	dp.resize(maxn, -1);
	pr.resize(maxn, -1);
	dp[0] = 0;
	for (int i = 0; i < sz(d); i++) {
		for (int j = d[i].sd; j < maxn; j++) {
			if (dp[j - d[i].sd] == -1)
				continue;
			dp[j] = 1;
			pr[j] = d[i].sd;
		}
	}

	brute(n - 1, 0);
	if (sol == -1) {
		printf("NO");
		return;
	}

	vector<pii> ans;
	map<int, int> msuf;
	for (auto m : suf) {
		msuf[n / m]++;
	}
	for (auto pr : msuf) {
		int b = n / pr.ft;
		int val = pr.sd;
		while (val > 0) {
			int mn = min(b - 1, val);
			val -= mn;
			ans.push_back(mp(mn, b));
		}
	}

	map<int, int> mapa;
	while (sol != 0) {
		mapa[pr[sol]]++;
		sol -= pr[sol];
	}
	for (auto pr : mapa) {
		int b = n / pr.ft;
		int val = pr.sd;
		while (val > 0) {
			int mn = min(b - 1, val);
			val -= mn;
			ans.push_back(mp(mn, b));
		}
	}

	printf("YES\n%d\n", sz(ans));
	for (auto f : ans) {
		printf("%d %d\n", f.ft, f.sd);
	}
}

int main()
{
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
#endif
	solve();
	return 0;
}