#include <bits/stdc++.h>

using namespace std;

const int MAXN = 505;
const int INF = (int) 1e9;

int n, m;
int d[MAXN][MAXN];
vector<pair<int, int> > edges;
vector<int> g[MAXN];
bool alive[MAXN], tmp[MAXN];
int q[MAXN], lq, rq;

void init() {
    memset(alive, 1, sizeof alive);
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    for (auto &e : edges) {
        g[e.first].push_back(e.second);
        g[e.second].push_back(e.first);
    }
}

void rebuild_graph(int u, int w) {
    // cerr << u << ' ' << w << '\n';
    memcpy(tmp, alive, sizeof alive);
    for (int v = 0; v < n; v++) {
        if (!alive[v]) {
            continue;
        }
        if (d[u][v] <= d[w][v]) {
            tmp[v] = 0;
        }
    }
    memcpy(alive, tmp, sizeof tmp);

    for (int v = 0; v < n; v++) {
        g[v].clear();
    }
    for (auto& e : edges) {
        if (alive[e.first] && alive[e.second]) {
            g[e.first].push_back(e.second);
            g[e.second].push_back(e.first);
        }
    }
}

void bfs(int v) {
    for (int i = 0; i < n; i++) {
        d[v][i] = INF;
    }
    d[v][v] = 0;

    memset(tmp, 0, sizeof tmp);
    lq = 0, rq = 0;
    q[rq++] = v;
    tmp[v] = 1;

    while (lq < rq) {
        int u = q[lq++];
        for (int to : g[u]) {
            if (!tmp[to]) {
                d[v][to] = d[v][u] + 1;
                tmp[to] = 1;
                q[rq++] = to;
            }
        }
    }
}

void count_distances() {
    for (int v = 0; v < n; v++) {
        if (alive[v]) {
            bfs(v);
        }
    }
}

int verteces_to_remove(int u, int w) {
    int cnt = 0;
    for (int v = 0; v < n; v++) {
        if (!alive[v]) {
            continue;
        }
        if (d[u][v] <= d[w][v]) {
            cnt++;
        }
    }
    return cnt;
}

int find_opt() {
    int opt_v = -1, opt_c = 0;
    for (int v = 0; v < n; v++) {
        if (!alive[v]) {
            continue;
        }
        int c = INF;
        for (int u : g[v]) {
            c = min(c, verteces_to_remove(v, u));
        }
        if (c > opt_c) {
            opt_c = c;
            opt_v = v;
        }
    }
    return opt_v;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int k, v, u;
        cin >> k >> v;
        v--;

        for (int j = 1; j < k; j++) {
            cin >> u;
            u--;
            edges.emplace_back(u, v);
            v = u;
        }
    }

    for (int T = 0; T < n; T++) {
        init();
        while (true) {
            count_distances();

//            for (int i = 0; i < n; i++) {
//                cerr << alive[i] << ' ';
//            }
//            cerr << "\n\n";
//            for (int i = 0; i < n; i++) {
//                for (int j = 0; j < n; j++) {
//                    cerr << d[i][j] << ' ';
//                }
//                cerr << '\n';
//            }
//            cerr << '\n';

            int v = find_opt();
            cout << v + 1 << endl;
            string feedback;
            cin >> feedback;
            if (feedback == "FOUND") {
                break;
            }
            int w;
            cin >> w;
            rebuild_graph(v, --w);
        }
    }

    return 0;
}

/*
 5 2
 5 1 2 3 4 5
 2 1 3
 */