#include <bits/stdc++.h>

using namespace std;

const int MAXN = 300005;
const int SQRT = 1005;



int q;
int64_t D[SQRT][SQRT];
int query_t[MAXN];
int query_d[SQRT][SQRT];

void add(int T, int64_t d) {
    int b = T / 1000;
    int t = T % 1000;
    query_d[b][t] = d;

    d = 0;
    int cnt0 = 0;
    for (int j = 0; j < 1000; j++) {
        d += query_d[b][j];
        if (d == 0) {
            cnt0++;
        } else {
            d--;
        }
    }
    D[b][0] = d;
    for (int j = 1; j <= cnt0; j++) {
        D[b][j] = D[b][0];
    }
    for (int j = cnt0 + 1; j <= 1000; j++) {
        D[b][j] = D[b][0] + j - cnt0;
    }
}

void remove(int T) {
    int b = T / 1000;
    int t = T % 1000;
    query_d[b][t] = 0;

    int64_t d = 0;
    int cnt0 = 0;
    for (int j = 0; j < 1000; j++) {
        d += query_d[b][j];
        if (d == 0) {
            cnt0++;
        } else {
            d--;
        }
    }
    D[b][0] = d;
    for (int j = 1; j <= cnt0; j++) {
        D[b][j] = D[b][0];
    }
    for (int j = cnt0 + 1; j <= 1000; j++) {
        D[b][j] = D[b][0] + j - cnt0;
    }
}

int64_t ask(int T) {
    int64_t d = 0;
    for (int i = 0; (i + 1) * 1000 <= T; i++) {
        int64_t _d = min(d, 1000ll);
        d = max(0ll, d - 1000ll) + D[i][_d];
    }

    int b = T / 1000;
    int t = T % 1000;
    for (int i = 0; i <= t; i++) {
        d += query_d[b][i];
        if (d > 0 && i < t) {
            d--;
        }
    }

    return d;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> q;
    for (int i = 0; i < q; i++) {
        char type;
        int j;
        cin >> type >> j;
        if (type == '?') {
            query_t[i] = j;
            cout << ask(query_t[i]) << '\n';
            continue;
        }
        if (type == '+') {
            int d;
            cin >> d;
            query_t[i] = j;
            add(query_t[i], d);
            continue;
        }
        if (type == '-') {
            remove(query_t[--j]);
            continue;
        }
    }

    return 0;
}


/*
 19
 ? 3
 + 2 2
 ? 3
 ? 4
 + 5 2
 ? 5
 ? 6
 + 1 2
 ? 2
 ? 3
 ? 4
 ? 5
 ? 6
 ? 7
 ? 9
 - 8
 ? 2
 ? 3
 ? 6
 */