#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

void distribute(int &from, int &to, int lim) {
    lim = min(lim, from);
    to += lim;
    from -= lim;
}

bool can32(int a, int b, vector<vector<int>> &res) {
    if (a < 65 || b < 50)
        return false;
    vector<vector<int>> scores = {{25, 0},{25, 0},{0,25},{0,25},{15,0}};
    a -= 65;
    b -= 50;
    int freeA = a - 46, freeB = b - 23 * 2 - 13;
    if (freeA <= 0 && freeB <= 0){
        distribute(b, scores[0][1], 23);
        distribute(b, scores[1][1], 23);
        distribute(a, scores[2][0], 23);
        distribute(a, scores[3][0], 23);
        distribute(b, scores[4][1], 13);
        res = scores;
        return true;
    }
    if (freeA > freeB) {
        if (freeA > b + 13)
            return false;
        distribute(a, scores[4][0], freeA);
        distribute(b, scores[4][1], freeA + 13);

        distribute(b, scores[0][1], 23);
        distribute(b, scores[1][1], 23);
        distribute(a, scores[2][0], 23);
        distribute(a, scores[3][0], 23);
        res = scores;
        return true;
    } else {
        if (a < freeB)
            return false;
        distribute(a, scores[4][0], freeB);
        distribute(b, scores[4][1], freeB + 13);

        distribute(b, scores[0][1], 23);
        distribute(b, scores[1][1], 23);
        distribute(a, scores[2][0], 23);
        distribute(a, scores[3][0], 23);
        res = scores;
        return true;
    }
}

bool can30(int a, int b, vector<vector<int>> &res) {
    if (a < 75)
        return false;
    vector<vector<int>> scores = {{25, 0},{25, 0},{25,0}};
    a -= 75;
    if (a > b + 23)
        return false;
    if (b > a + 23 * 3)
        return false;
    distribute(b, scores[0][1], 23 + a);
    distribute(a, scores[0][0], a);
    distribute(b, scores[1][1], 23);
    distribute(b, scores[2][1], 23);
    res = scores;
    return true;
}

bool can31(int a, int b, vector<vector<int>> &res) {
    if (a < 75 || b < 25)
        return false;
    vector<vector<int>> scores = {{25, 0},{25, 0},{0,25},{25,0}};
    a -= 75;
    b -= 25;
    int freeA = a - 23, freeB = b - 23 * 3;
    if (freeA <= 0 && freeB <= 0){
        distribute(b, scores[0][1], 23);
        distribute(b, scores[1][1], 23);
        distribute(a, scores[2][0], 23);
        distribute(b, scores[3][1], 23);
        res = scores;
        return true;
    }
    if (freeA > freeB) {
        if (freeA > b + 23)
            return false;
        distribute(a, scores[0][0], freeA);
        distribute(b, scores[0][1], freeA + 23);

        distribute(b, scores[1][1], 23);
        distribute(a, scores[2][0], 23);
        distribute(b, scores[3][1], 23);
        res = scores;
        return true;
    } else {
        if (a < freeB)
            return false;
        distribute(a, scores[4][0], freeB);
        distribute(b, scores[4][1], freeB + 23);

        distribute(b, scores[1][1], 23);
        distribute(a, scores[2][0], 23);
        distribute(b, scores[3][1], 23);
        res = scores;
        return true;
    }
}

void print(vector<vector<int>> &res, bool rev = 0) {
    for (auto i : res)
        cout << i[0 ^ rev] << ':' << i[1 ^ rev] << ' ';
    cout << '\n';
}

void solve() {
    int a, b;
    cin >> a >> b;
    vector<vector<int>> res;
    if (can30(a, b, res)) {
        cout << "3:0\n";
        print(res);
        return;
    }
    if (can31(a, b, res)) {
        cout << "3:1\n";
        print(res);
        return;
    }
    if (can32(a, b, res)) {
        cout << "3:2\n";
        print(res);
        return;
    }
    if (can32(b, a, res)) {
        cout << "2:3\n";
        print(res, 1);
        return;
    }
    if (can31(b, a, res)) {
        cout << "1:3\n";
        print(res, 1);
        return;
    }
    if (can30(b, a, res)) {
        cout << "0:3\n";
        print(res, 1);
        return;
    }
    cout << "Impossible\n";
}

int main() {
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
}
/*
6
75 0
90 90
20 0
0 75
78 50
80 100
 */