#include <iostream>
#include <cmath>

using namespace std;

pair<int, int> egcd(int a, int b) {
    int r[2][2] = {{1, 0}, {0, 1}};
    while (b > 0) {
        int k = a / b;
        a -= b * k;//a = a % b
        r[0][0] -= r[1][0] * k;
        r[0][1] -= r[1][1] * k;
        swap(a, b);
        swap(r[0][0], r[1][0]);
        swap(r[0][1], r[1][1]);
    }
    return {r[0][0], r[0][1]};
}

pair<int, int> diaf(int a, int b) {
    auto egcd1 = egcd(a, b);
    egcd1.first *= -1;
    egcd1.second *= -1;
    egcd1.first += b;
    while (egcd1.first < 0) {
        egcd1.first += b;
        egcd1.second -= a;
    }
    while (egcd1.second < 0) {
        egcd1.first -= b;
        egcd1.second += a;
    }
    if (egcd1.first < 0 || egcd1.second < 0 || egcd1.first * a + egcd1.second * b != a * b - 1)
        cerr << "ERRR";
    return egcd1;
}

pair<int, int> split(int n) {
    int k =2;
    pair<int, int> res;
    while (k <= sqrt(n) + 10 && k < n && n % k != 0) {
        ++k;
    }
    //cerr <<  n << " " << k << endl;
    if (n % k != 0 || n == k) {
        return {1, n};
    }
    res.first = 1;
    while (n != 0 && n % k == 0) {
        n /= k;
        res.first *= k;
    }
    res.second = n;
    if (res.first == 1 || res.second == 1) {
        return {1, n};
    }
    return res;
}

int main() {
    int n;
    cin >> n;
    auto p = split(n);
    if (p.first == 1) {
        cout << "NO\n";
        return 0;
    }

    auto sol = diaf(p.first, p.second);
    cout << "YES\n";
    cout << "2\n";
    cout << sol.first << " " << p.second << "\n";
    cout << sol.second << " " << p.first << "\n";


    return 0;
}