//
// Created by neerc on 02.12.2018.
//
#include <algorithm>
#include <iostream>
#include <queue>
#include <set>
#include <vector>

using namespace std;

using layer = vector<string>;

vector<vector<int>> g;

struct A {
    vector<vector<int>> &g;

    A(vector<vector<int>> &g) : g(g) {}

    vector<int> color;
    vector<int> used;
    int colors = 0;

    void dfs(int v) {
        used[v] |= 1;
        for (int i = 0; i < g[v].size(); ++i)
            if (g[v][i] && !(used[i] & 1)) {
                dfs(i);
            }
    }

    void rdfs(int v) {
        used[v] |= 2;
        for (int i = 0; i < g[v].size(); ++i)
            if (g[i][v] && !(used[i] & 2)) {
                rdfs(i);
            }
    }

    A &Paint() {
        color.assign(g.size(), -1);
        for (int i = 0; i < g.size(); ++i) {
            if (color[i] == -1) {
                used.assign(g.size(), 0);
                dfs(i);
                rdfs(i);
                for (int j = 0; j < g.size(); ++j)
                    if (used[j] == 3) {
                        color[j] = colors;
                    }
                ++colors;
            }
        }
        return *this;
    }
};

struct B {

    vector<vector<int>> &g;

    B(vector<vector<int>> &g) : g(g), used(g.size()) {
        for (int i = 0; i < g.size(); ++i)
            if (!used[i]) {
                dfs(i);
            }
        reverse(out.begin(), out.end());
    }

    vector<int> out, used;

    void dfs(int v) {
        used[v] = 1;
        for (int i = 0; i < g[v].size(); ++i) {
            if (g[v][i] && !used[i])
                dfs(i);
        }
        out.push_back(v);
    }
};

int main() {
    int n;
    cin >> n;

    g.assign(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> g[i][j];
        }
    }
    /*for (int t = 0; t < g.size(); ++t)
        for (int i = 0; i < g.size(); ++i)
            for (int j = 0; j < g.size(); ++j)
                for (int k = 0; k < g.size(); ++k)
                    g[i][j] |= g[i][k] & g[k][j];*/
    A painter(g);
    painter.Paint();
    vector<vector<int>> shrinked(painter.colors, vector<int>(painter.colors));
    for (int i = 0; i < g.size(); ++i) {
        for (int j = 0; j < g.size(); ++j)
            if (g[i][j])
                shrinked[painter.color[i]][painter.color[j]] = 1;
    }
    auto layers = B(shrinked).out;
    vector<pair<int, int>> edges;
    for (int i = 0; i < shrinked.size(); ++i) {
        for (int j = 0; j < shrinked.size(); ++j) {
            if (i != j && shrinked[i][j]) {
                edges.push_back({layers[i], layers[j]});
            }
        }
    }
    vector<layer> map;
    int width = max((size_t) 10, edges.size() * 2);
    for (int l = 0; l < layers.size(); ++l) {
        map.emplace_back();
        map.back().emplace_back();
        for (int i = 0; i < n; i++) {
            if (painter.color[i] == layers[l]) {
                map.back().back().push_back('1' + i);
            }
        }
        map.back().back().resize(width, '.');
        map.back().push_back(string(width, '.'));
        map.back().push_back(string(width, '#'));
        map.back().push_back(string(width, '#'));
        //FLOOR
        map.emplace_back();
        map.back().push_back(string(width, '#'));
        map.back().push_back(string(width, '#'));
        map.back().push_back(string(width, '#'));
        map.back().push_back(string(width, '#'));
    }
    for (int i = 0; i < edges.size(); ++i) {
        map[edges[i].first * 2][2][i * 2] = '.';
        map[edges[i].second * 2][2][i * 2] = '.';
        for (int j = edges[i].first * 2; j <= edges[i].second * 2; ++j)
            map[j][3][i * 2] = '.';

    }
    cout << width << " 4 " << map.size() << endl;
    for (const auto &l : map) {
        for (const string &s : l)
            cout << s << '\n';
        cout << '\n';
    }
}

/*
4 0 1 0 1 0 0 1 0 0 1 0 0 1 0 0 0
 */