#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <map>
#include <queue>
#include <functional>
#include <string>

#include <ctime>


#define remax(x,y)  x = std::max(x, y)


using namespace std;


template<class T>
using minheap = priority_queue<T, vector<T>, greater<T>>;


struct game
{
    pair<int, int> score;
    vector<pair<int, int>> val;

    game (int x = 0) : score (x, x)
    {}

    bool operator< (const game &g) const
    {
        if (score.first == g.score.first)
            return score.second > g.score.second;
        return score.first < g.score.first;
    }

    game add (int a, int b) const
    {
        game ret;

        if (score.first < 0)
        {
            ret.score = { -10, -10 };

            return ret;
        }

        ret.score = score;
        if (a > b)
            ret.score.first++;
        else
            ret.score.second++;
        ret.val = val;
        ret.val.emplace_back (a, b);

        return ret;
    }
};


game bad (-10);


game foo (int a, int b, int ra = 0, int rb = 0)
{
    static vector<game> dp (201 * 201 * 7, bad);
    static vector<bool> used (201 * 201 * 7);

    if (a < 0 || b < 0 || ((ra == 3 || rb == 3) && (a != 0 || b != 0)))
        return bad;
    if (a == 0 && b == 0 && (ra == 3 || rb == 3))
        return game ();

    const int sh = 201 * 7 * a + 7 * b + 3 * ra + rb;

    if (!used[sh])
    {
        used[sh] = true;

        int to = (ra == 2 && rb == 2) ? 15 : 25;

        for (int i = 0; i <= to - 2; i++)
        {
            remax (dp[sh], foo (a - to, b - i, ra + 1, rb).add (to, i));
            remax (dp[sh], foo (a - i, b - to, ra, rb + 1).add (i, to));
        }

        for (int i = to; i <= min (a, b) + 2; i++)
        {
            remax (dp[sh], foo (a - i, b - (i - 2), ra + 1, rb).add (i, i - 2));
            remax (dp[sh], foo (a - (i - 2), b - i, ra, rb + 1).add (i - 2, i));
        }
    }

    return dp[sh];
}


void solve (istream &cin = std::cin, ostream &cout = std::cout)
{
    int t;

    cin >> t;

    for (int i = 0; i < t; i++)
    {
        int a, b;

        cin >> a >> b;

        auto ans = foo (a, b);

        if (ans.score.first < 0)
        {
            cout << "Impossible" << endl;
        }
        else
        {
            cout << ans.score.first << ':' << ans.score.second << endl;

            reverse (ans.val.begin (), ans.val.end ());

            for (auto it : ans.val)
                cout << it.first << ':' << it.second << ' ';
            cout << endl;
        }
    }
}


int main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);

#ifdef LOCAL
    ifstream fin ("input.txt");

    solve (fin);

    cout << "clock: " << clock () / (double)CLOCKS_PER_SEC << endl;
#else
    solve ();
#endif // LOCAL

    return 0;
}
