#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <functional>
#include <string>

#include <ctime>
#include <cassert>

using namespace std;

#define remax(x,y) x = std::max(x,(y));


template<class T>
using minheap = priority_queue<T, vector<T>, greater<T>>;


unordered_set<char> word;


void token_parse (const string &prog, const vector<string> &reserved, vector<string> &tok, int st = 0)
{
    for (int l = st, r = st; l < prog.size (); l = r)
    {
        while (l < prog.size () && isspace (prog[l]))
            l++;

        if (l == prog.size ())
            break;

        int tr = l;

        for (const auto &it : reserved)
            if (prog.substr (l, it.size ()) == it)
            {
                remax (r, l + (int)it.size ());

                break;
            }

        if ('0' <= prog[l] && prog[l] <= '9')
        {
            for (tr = l + 1; tr < prog.size () && '0' <= prog[tr] && prog[tr] <= '9'; tr++);

            remax (r, tr);
        }
        else if (word.count (prog[tr]))
        {
            for (tr = l + 1; tr < prog.size () && word.count (prog[tr]); tr++);

            remax (r, tr);
        }

        tok.push_back (prog.substr (l, r - l));
    }
}


void solve (istream &cin = std::cin, ostream &cout = std::cout)
{
    for (char c = 'a'; c <= 'z'; c++)
        word.insert (c);
    for (char c = 'A'; c <= 'Z'; c++)
        word.insert (c);
    for (char c = '0'; c <= '9'; c++)
        word.insert (c);
    word.insert ('_');
    word.insert ('$');

    int n;

    cin >> n;

    vector<string> reserved (n);

    for (auto &it : reserved)
        cin >> it;

    auto cmp = [](const string &a, const string &b) {
        return a.size () == b.size () ? a < b : a.size () > b.size ();
    };

    sort (reserved.begin (), reserved.end (), cmp);

    cin >> n;

    string prog;

    getline (cin, prog);

    prog.clear ();

    for (int i = 0; i < n; i++)
    {
        string tmp;

        getline (cin, tmp);

        auto wh = tmp.find ('#');

        if (wh != tmp.npos)
            tmp = tmp.substr (0, wh);

        prog += " " + tmp;
    }

    vector<string> tok;

    token_parse (prog, reserved, tok);

    unordered_map<string, int> cnt;

    vector<pair<int, string>> qw;

    for (auto it : tok)
        if (!('0' <= it.front () && it.front () <= '9') && !binary_search (reserved.begin (), reserved.end (), it, cmp))
        {
            if (cnt[it] == 0)
                qw.emplace_back (0, it);
            cnt[it]++;
        }

    //sort (qw.begin (), qw.end (), greater<pair<int, string>> ());

    vector<string> repl;

    for (int i = 0; repl.size () < qw.size (); i++)
    {
        int t = i;

        string add;

        while (t > 0)
        {
            add += 'a' + (t % 26);
            t /= 26;
        }

        reverse (add.begin (), add.end ());

        if (add.empty ())
            add = 'a';

        if (!binary_search (reserved.begin (), reserved.end (), add))
            repl.push_back (add);
    }

    unordered_map<string, string> mapper;

    for (int i = 0; i < qw.size (); i++)
        mapper[qw[i].second] = repl[i];

    for (auto &it : tok)
        if (mapper.count (it))
            it = mapper[it];

    string ans;

    const auto to = tok;

    vector<int> del;

    ans.clear ();

    for (auto it : to)
    {
        ans += it;

        del.push_back ((del.empty () ? 0 : del.back ()) + it.size ());
    }

    int sh = 0;

    bool loop = true;

    while (loop)
    {
        loop = false;

        tok.clear ();

        token_parse (ans, reserved, tok);

        for (int i = 0; !loop && i < min (to.size (), tok.size ()); i++)
            if (to[i] != tok[i])
            {
                ans.insert (ans.begin () + del[i] + sh, ' ');
                sh++;
                loop = true;
            }
    }

    cout << ans << endl;
}


int main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);

#ifdef LOCAL
    ifstream fin ("input.txt");
    ofstream fout ("output.txt");

    solve (fin, fout);

    cout << endl;
    cout << "clock: " << clock () / (double)CLOCKS_PER_SEC << endl;
#else
    solve ();
#endif // LOCAL

    return 0;
}
