#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <functional>

#include <ctime>

using namespace std;


template<class T>
using minheap = priority_queue<T, vector<T>, greater<T>>;


void solve (istream &cin = std::cin, ostream &cout = std::cout)
{
    int n, k;

    cin >> n >> k;

    vector<int> a (n), b (n);

    for (auto &it : a)
    {
        cin >> it;
        it--;
    }

    for (auto &it : b)
        cin >> it;

    vector<pair<int, int>> save (k);

    for (int i = 0; i < n; i++)
        save[a[i]] = max (save[a[i]], make_pair (b[i], i));

    minheap<int> pq;

    set<int> diff (a.begin (), a.end ());

    int cnt = k - diff.size ();

    for (int i = 0; i < n; i++)
        if (save[a[i]].second != i)
            pq.push (b[i]);

    long long sum = 0;

    for (int i = 0; i < cnt; i++)
    {
        sum += pq.top ();
        pq.pop ();
    }

    cout << sum << endl;
}


int main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);

#ifdef LOCAL
    ifstream fin ("input.txt");

    solve (fin);

    cout << "clock: " << clock () / (double)CLOCKS_PER_SEC << endl;
#else
    solve ();
#endif // LOCAL

    return 0;
}
