#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <memory>
#include <functional>
#include <cassert>
using namespace std;
typedef long long ll;

int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }
int n;

void print_ans(vector<pair<int, int>> v)
{
	cout << "YES\n";
	cout << v.size() << "\n";
	ll nom = 0;
	for (auto p : v) {
		nom += p.first * (n / p.second);
		cout << p.first << " " << p.second << "\n";
	}

	assert(nom == n - 1);
	exit(0);
}

void solve()
{
	cin >> n;
	vector<int> divs;
	for (int i = 2; i * i <= n; ++i) {
		if (n % i == 0) divs.push_back(i);
		if (i * i < n) divs.push_back(n / i);
	}

	if (n % 2 == 0) {
		for (int d : divs) {
			if (d % 2 == 0) {
				int c = n / d;
				if (c % 2 == 1) {
					int nom = n - c - 1;
					int denom = n;
					int g = gcd(nom, denom);

					print_ans({ { 1, d },{ nom / g, denom / g } });
				}
			}
		}
	}
	else {
		for (int d : divs) {
			int c = n / d;
			if (c == d) continue;
			int g = gcd(n - c, n);
			if (g != 1) {
				print_ans({ { 1, d },{ (n - c) / d, n / d } });
			}
		}
	}

	cout << "NO";
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	solve();
}