#undef NDEBUG
#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using li = long long;
using ld = long double;

void solve(bool read);

using namespace std;

int main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#else
    //cin.tie(nullptr);
    //ios_base::sync_with_stdio(false);
#endif

    solve(true);

#ifdef LOCAL
    cerr << endl << endl << clock() / (double)CLOCKS_PER_SEC << endl;
#endif

    return 0;
}

int makeTurn(int v);

struct Graph {
    int n;
    vector<vector<int>> e;
    vector<char> exists;

    void read() {
        int nPaths;
        cin >> n >> nPaths;
        e.resize(n);
        exists.assign(n, false);

        //cout << "read " << n << " " << nPaths << endl;

        for (int i = 0; i < nPaths; ++i) {
            int sz;
            cin >> sz;

            vector<int> path(sz);
            for (int j = 0; j < sz; ++j) {
                cin >> path[j];
                --path[j];
            }
            for (int j = 0; j + 1 < sz; ++j) {
                e[path[j]].push_back(path[j + 1]);
                e[path[j + 1]].push_back(path[j]);
            }
        }
    }
    //vector<int> p;

    vector<int> doBfsSlow(int v) {
        //p.assign(n, -1);
        vector<int> d;
        d.assign(n, -1);

        vector<int> q;
        d[v] = 0;
        q.push_back(v);
        int pos = 0;

        while (pos < q.size()) {
            int v = q[pos];
            ++pos;

            for (int u : e[v]) {
                if (!exists[u]) continue;

                if (d[u] == -1) {
                    d[u] = d[v] + 1;
                    //p[u] = v;
                    q.push_back(u);
                }
            }
        }

        return d;
    }

    int epoch = 0;
    vector<int> fastd;
    vector<int> fastq;
    vector<vector<int>> faste;

    void doBfsFast(int v) {
        //p.assign(n, -1);
        //vector<int> d;
        //d.assign(n, -1);

        ++epoch;

        //vector<int> q;
        //d[v] = 0;
        int limit = epoch * n;
        fastd[v] = limit;
        fastq.clear();
        fastq.push_back(v);
        int pos = 0;

        while (pos < fastq.size()) {
            int v = fastq[pos];
            ++pos;

            for (int u : faste[v]) {
                if (!exists[u]) continue;

                if (fastd[u] < limit) {
                    fastd[u] = fastd[v] + 1;
                    //p[u] = v;
                    fastq.push_back(u);
                }
            }
        }
    }

    /*vector<char> getRemain(int u, int v) {
        vector<char> remain = exists;

    }*/

    vector<char> getRemain(const vector<int>& dv, const vector<int>& du) {
        vector<char> can(du.size());
        for (int i = 0; i < du.size(); ++i) {
            can[i] = (exists[i] && (du[i] + 1 == dv[i])) ? 1 : 0;
        }
        return can;
    }

    void reset() {
        exists.assign(n, true);
    }

    static constexpr int maxN = 505;
    int dist[maxN][maxN];

    bool doTurn() {
        fastd.assign(n, -1);
        epoch = 0;

        faste.resize(n);
        for (int i = 0; i < n; ++i) {
            if (!exists[i]) continue;
            faste[i].clear();

            for (int u : e[i]) {
                if (!exists[u]) continue;

                faste[i].push_back(u);
            }
        }

        int bestTurn = -1;
        int minCount = 1e9;

        int numExists = count(all(exists), 1);
        if (numExists == 1) {
            for (int v = 0; v < n; ++v) {
                if (exists[v]) {
                    int res = makeTurn(v);
                    assert(res == -1);
                    return false;
                }
            }
            abort();
        }

        vector<int> existing;
        for (int v = 0; v < n; ++v) {
            if (exists[v]) {
                existing.push_back(v);
            }
        }

        for (int v : existing) {
            int limit = n * epoch;
            doBfsFast(v);
            for (int u : existing) {
                dist[v][u] = fastd[u] - limit;
            }
        }

        //vector<int> vDist(n);

        for (int v = 0; v < n; ++v) {
            if (!exists[v]) continue;

            //auto a = doBfsSlow(v);
            /*++epoch;
            int limit = n * epoch;
            doBfsFast(v);
            for (int u : existing) {
                vDist[u] = fastd[u] - limit;
            }*/

            int worstCase = 0;

            for (int u : e[v]) {
                if (!exists[u]) {
                    continue;
                }

                int canCount = 0;
                if (true) {
                    //++epoch;
                    //doBfsFast(u);

                    //limit = n * epoch;
                    for (int t : existing) {
                        if (dist[u][t] + 1 == dist[v][t]) {
                            ++canCount;
                        }
                    }
                } else {
                    //auto b = doBfsSlow(u);
                    //auto can = getRemain(a, b);
                    //canCount = count(all(can), 1);
                }

                worstCase = max(worstCase, canCount);
            }

            assert(worstCase > 0);
            if (worstCase < minCount) {
                minCount = worstCase;
                bestTurn = v;
            }
        }

        assert(bestTurn != -1);
        int w = makeTurn(bestTurn);
        if (w == -1) {
            return false;
        }

        auto can = getRemain(doBfsSlow(bestTurn), doBfsSlow(w));
        for (int i = 0; i < n; ++i) {
            exists[i] = exists[i] && can[i];
        }

        return true;
    }

    int secretVertex = -1;
    int turnsMade = 0;

    int makeTurnImpl(int v) {
        assert(secretVertex != -1);

        if (secretVertex == -2) {
            cout << v + 1 << endl;
            string ans;
            cin >> ans;

            if (ans == "FOUND") {
                return -1;
            } else {
                assert(ans == "GO");
                int w;
                cin >> w;
                --w;
                return w;
            }
        } else {
            ++turnsMade;
            assert(turnsMade <= 10);

            bool print = false;

            if (print)
                cout << "Turn " << v + 1 << endl;

            if (v == secretVertex) {
                if (print)
                    cout << "Guessed!" << endl << endl;
                return -1;
            } else {
                auto d = doBfsSlow(secretVertex);

                vector<int> cands;
                for (int u : e[v]) {
                    if (d[u] < d[v]) {
                        cands.push_back(u);
                    }
                }
                assert(!cands.empty());
                int w = cands[rand() % cands.size()];
                if (print)
                    cout << "Not guessed, go " << w + 1 << endl;
                return w;
            }
        }
    }
};

Graph generate() {
    Graph g;
    g.n = 500;
    g.e.resize(g.n);

    auto addEdge = [&](int u, int v) {
        g.e[u].push_back(v);
        g.e[v].push_back(u);
    };

    for (int i = 1; i < g.n; ++i) {
        addEdge(i, rand() % i);
    }

    cout << "Generated graph " << g.n << " " << g.n << endl;
    for (int i = 0; i < g.n; ++i) {
        for (int u : g.e[i]) {
            assert(u != i);
            if (u > i) {
                cout << "2  " << i + 1 << " " << u + 1 << endl;
            }
        }
    }

    return g;
    //int nLoops =
    //vector<int> loopSizes;
}

Graph secret;
Graph g;

int makeTurn(int v) {
    return secret.makeTurnImpl(v);
}

void solve(bool __attribute__((unused)) read) {
    read = true;


    if (read) {
        g.read();
    } else {
        g = generate();
    }
    secret = g;
    secret.reset();

    for (int i = 0; i < g.n; ++i) {
        secret.turnsMade = 0;
        if (!read) {
            cout << "Playing game with secret vertex " << i + 1 << endl;
            secret.secretVertex = i;
        } else {
            secret.secretVertex = -2;
        }

        g.reset();
        auto t0 = clock();
        while (g.doTurn()) {
            auto t1 = clock();
            //cout << fixed << setprecision(6) << "turn in " << (t1 - t0) / CLOCKS_PER_SEC << endl;
            t0 = clock();
        }
        //break;
    }
}