#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using li = long long;
using ld = long double;

void solve(bool read);

using namespace std;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif

    solve(true);

#ifdef LOCAL
    cerr << endl << endl << clock() / (double)CLOCKS_PER_SEC << endl;
#endif

    return 0;
}

inline int inv(int a, int b) {
    return a == 1 ? 1 : b - 1ll * inv(b % a, a) * b / a % b;
}

pair<li, li> euc(int a, int b) {
    li x = inv(a, b);
    li y = (1 - a * x) / b;
    return {x, y};
}

void solve(bool __attribute__((unused)) read) {
    int n;
    cin >> n;
    int nn = n;
    vector<int> ps;
    for (int i = 2; i * i <= n; ++i) {
        if (n % i) continue;
        ps.push_back(i);
        while (n % i == 0) n /= i;
    }
    if (n > 1) {
        ps.push_back(n);
    }

    if ((int)ps.size() == 1) {
        cout << "NO\n";
        return;
    }
    n = nn;

    // just in case
    for (int i = 0; i < (int)ps.size(); ++i) {
        for (int j = 0; j < i; ++j) {
            int p = ps[j], q = ps[i];
            auto pr = euc(p, q);
            li a = -pr.first, b = -pr.second;
            if (a < 0) {
                a += n / p;
            } else {
                b += n / q;
            }

            if (a < 0) {
                li k = (abs(a) + q - 1) / q;
                a += k * q;
                b -= k * p;
            } else if (b < 0) {
                li k = (abs(b) + p - 1) / p;
                a -= k * q;
                b += k * p;
            }

            if (a >= 0 && b >= 0) {
                cout << "YES\n";
                vector<li> ans;
                if (a > 0) {
                    ans.push_back(a * p);
                }
                if (b > 0) {
                    ans.push_back(b * q);
                }
                cout << ans.size() << "\n";
                for (auto x : ans) {
                    li g = __gcd(x, (li)n);
                    cout << x / g << " " << n / g << "\n";
                }
                return;
            }
        }
    }
    cout << "NO\n";
}