#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using li = long long;
using ld = long double;

void solve(bool read);

using namespace std;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif

    solve(true);

#ifdef LOCAL
    cerr << endl << endl << clock() / (double)CLOCKS_PER_SEC << endl;
#endif

    return 0;
}

enum {
    WORD_T, RES_T, NUM_T
};

const int MX_PW = 11;
const int MX_LEN = 3333;

int target_len = 1;
int target_ptr = 0;

int n, m;
int pw26[MX_PW];
string reserved[44];
int pre_nxt_word[MX_LEN], pre_nxt_num[MX_LEN];
vector <int> pre_res[MX_LEN];
map <string, string> word_map;
int pos[MX_LEN], d[MX_LEN];

bool is_digit(char c) {
    return '0' <= c && c <= '9';
}

bool is_word_char(char c) {
    return is_digit(c) || ('a' <= c && c <= 'z') ||
            ('A' <= c && c <= 'Z') || c == '$' || c == '_';
}

string next_target_word() {
    pw26[0] = 1;
    for (int i = 1; i < MX_PW; ++i) {
        pw26[i] = pw26[i - 1] * 26;
    }
    if (pw26[target_len] == target_ptr) {
        target_ptr = 0;
        ++target_len;
    }
    string t = "";
    for (int i = 0; i < target_len; ++i) {
        t += char('a' + target_ptr %
                pw26[target_len - i] / pw26[target_len - i - 1]);
    }
    ++target_ptr;
    for (int k = 0; k < n; ++k) {
        if (reserved[k] == t)
            return next_target_word();
    }
    return t;
}

void precalc(string& s) {
    for (int i = 0; i < (int)s.size(); ++i) {
        if (s[i] == ' ')
            continue;
        pre_res[i].clear();
        for (int j = i; j < min((int)s.size(), i + 22); ++j) {
            for (int k = 0; k < n; ++k) {
                if (s.substr(i, j - i + 1) == reserved[k]) {
                    pre_res[i].push_back(j + 1);
                }
            }
        }
        int mx_word = 0;
        if (!is_digit(s[i])) {
            mx_word = (int)s.size();
            for (int j = i; j < (int) s.size(); ++j) {
                if (!is_word_char(s[j])) {
                    mx_word = j;
                    break;
                }
            }
            if (mx_word == i)
                mx_word = 0;
        }
        pre_nxt_word[i] = mx_word;
        int mx_num = (int)s.size();
        for (int j = i; j < (int)s.size(); ++j) {
            if (!is_digit(s[j])) {
                mx_num = j;
                break;
            }
        }
        if (mx_num == i)
            mx_num = 0;
        pre_nxt_num[i] = mx_num;
    }
}

int getnext(int p, int& type) {
    int j = 0;
    for (int i: pre_res[p]) {
        j = max(j, i);
    }
    type = RES_T;
    if (pre_nxt_num[p] > j) {
        j = pre_nxt_num[p];
        type = NUM_T;
    }
    if (pre_nxt_word[p] > j) {
        j = pre_nxt_word[p];
        type = WORD_T;
    }
    return j;
}

void solve(bool __attribute__((unused)) read) {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> reserved[i];
    }
    cin >> m;
    string s = "";
    for (int i = 0; i < m + 1; ++i) {
        string st;
        getline(cin, st);
        for (int j = 0; j < (int)st.size(); ++j) {
            if (st[j] == '#') {
                st.resize(j);
                break;
            }
        }
        s += st;
        s += " ";
    }
//    cout << "start_string = " << s << endl;
    precalc(s);
    vector <string> tokens;
    for (int i = 0; i < (int)s.size(); ) {
        if (s[i] == ' ') {
            ++i;
            continue;
        }
        int type;
        int j = getnext(i, type);
        if (type == WORD_T) {
            string t = s.substr(i, j - i);
            if (!word_map.count(t)) {
                word_map[t] = next_target_word();
            }
            tokens.push_back(word_map[t]);
        } else {
            tokens.push_back(s.substr(i, j - i));
        }
        i = j;
    }
#ifdef LOCAL
    cout << "tokens = ";
    for (int i = 0; i < (int)tokens.size(); ++i) {
        cout << tokens[i] << " ";
    }
    cout << "\n";
#endif

    s = "";
    for (int i = 0; i < (int)tokens.size(); ++i) {
        pos[i] = s.size();
        s += tokens[i];
    }
    pos[tokens.size()] = s.size();
    precalc(s);
    d[0] = 0;
    for (int i = 1; i < (int)tokens.size(); ++i) {
        d[i] = d[i - 1];
        for (int j = 0; j < i; ++j) {
            for (int p = pos[j]; p <= pos[j]; ++p) {
//                cout << i << " " << j << " " << k << " " << type << endl;
                for (int k: pre_res[p]) {
                    if (pos[i] + 1 <= k && k <= pos[i + 1] + 1) {
                        d[i] = max(d[i], j + 1);
                    }
                }
                if (i == 16) {
//                    cout << "pre_nxt_word = " << j << " " << pre_nxt_word[p] << endl;
                }
                if (pre_nxt_num[p] >= pos[i] + 1 ||
                        pre_nxt_word[p] >= pos[i] + 1) {
                    d[i] = max(d[i], j + 1);
                }
            }
        }
//        cout << i << " " << d[i] << endl;
    }
    int x = (int)tokens.size() - 1;
    vector <string> ans;
    while (x != -1) {
        for (int i = x; i >= d[x]; --i) {
            ans.push_back(tokens[i]);
        }
        ans.push_back(" ");
        x = d[x] - 1;
    }
    ans.pop_back();
    reverse(all(ans));
    for (auto s: ans) {
        cout << s;
    }
    cout << '\n';
}