#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using li = long long;
using ld = long double;

void solve(bool read);

using namespace std;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif

    solve(true);

#ifdef LOCAL
    cerr << endl << endl << clock() / (double)CLOCKS_PER_SEC << endl;
#endif

    return 0;
}

vector<vector<int>> e, re;
vector<char> used;
vector<int> order;

void dfs(int v) {
    used[v] = true;
    for (int u: e[v]) {
        if (used[u]) {
            continue;
        }

        dfs(u);
    }

    order.push_back(v);
}

//vector<int> comp;
int curColor;
vector<int> compColor;
vector<vector<int>> newEdges;

void rdfs(int v) {
    compColor[v] = curColor;
    used[v] = true;

    //cout << v + 1 << " is in comp " << curColor + 1 << endl;

    for (int u : re[v]) {
        if (used[u]) {
            continue;
        }

        rdfs(u);
    }
}

const int SZ = 100;
vector<vector<string>> ans;

pair<int, int> getTube(int i, int j) {
    return make_pair(4 + 4 * i, 4 + 4 * j);
}

void solve(bool __attribute__((unused)) read) {
    int n;
    cin >> n;

    e.resize(n);
    re.resize(n);

    ans.resize(2 * n);
    for (int i = 0; i < ans.size(); ++i) {
        ans[i].assign(4 * (n + 2), string(4 * (n + 2), i % 2 == 0 ? '#' : '.'));
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int x;
            cin >> x;
            if (x == 1) {
                e[i].push_back(j);
                re[j].push_back(i);
            }
        }
    }

    used.assign(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }

    used.assign(n, false);

    compColor.assign(n, -1);
    reverse(all(order));
    curColor = 0;
    for (int v : order) {
        if (!used[v]) {
            rdfs(v);
            ++curColor;
        }
    }

    //cout << "got " << curColor << " comps" << endl;
    //assert(curColor > 0);

    newEdges.resize(curColor);
    for (int v = 0; v < n; ++v) {
        assert(compColor[v] != -1);

        for (int u : e[v]) {
            if (compColor[u] != compColor[v]) {
                newEdges[compColor[v]].push_back(compColor[u]);
            }
        }
    }

    for (int i = 0; i < curColor; ++i) {
        for (int j = 0; j < curColor; ++j) {
            auto p = getTube(i, j);
            for (int z = 1; z < ans.size(); z += 2) {
                for (int dx = -1; dx <= 1; ++dx) {
                    for (int dy = -1; dy <= 1; ++dy) {
                        if (dx == 0 && dy == 0) continue;

                        ans[z][p.first + dx][p.second + dy] = '#';
                    }
                }
            }
        }
    }

    auto getBase = [&](int v) {
        assert(v >= 0 && v < curColor);
        return (curColor - 1 - v) * 2;
    };

    for (int i = 0; i < curColor; ++i) {
        sort(all(newEdges[i]));
        newEdges[i].erase(unique(all(newEdges[i])), newEdges[i].end());

        for (int u : newEdges[i]) {
            //cout << "NEW EDGE " << u << " " << i << endl;

            auto p = getTube(i, u);
            int zi = getBase(i);
            int zu = getBase(u);
            assert(zu < zi);

            for (int z : { zi, zu }) {
                for (int dx = -1; dx <= 1; ++dx) {
                    for (int dy = -1; dy <= 1; ++dy) {
                        if (dx == 0 && dy == 0) continue;

                        char &c = ans[z + 1][p.first + dx][p.second + dy];
                        assert(c == '#');
                        c = '.';
                    }
                }
            }
            char& c = ans[zi][p.first][p.second];
            assert(c == '#');
            c = '.';
        }
    }

    for (int i = 0; i < n; ++i) {
        int comp = compColor[i];

        int z = getBase(comp);
        ans[z + 1][0][i] = '0' + (i + 1);
    }

    reverse(all(ans));
    cout << ans[0][0].size() << " " << ans[0].size() << " " << ans.size() << "\n";
    for (auto& it : ans) {
        for (auto& s : it) {
            cout << s << "\n";
        }
        cout << "\n";
    }
}