#include <bits/stdc++.h>

using namespace std;

#define int int64_t

const int MAXT = 2e6 + 1;

struct Query {
    char c;
    int x, y;
    Query(char c = 0, int x = 0, int y = -1):
        c(c), x(x), y(y) {}
};

struct TreeMax {
    int n;
    vector <int> d, add;
    TreeMax(int n = 0): n(n) {
        d.resize(4 * n, 0);
        add.resize(4 * n, 0);
    }

    void push(int i, int l, int r) {
        d[i] += add[i];
        if (2 * i + 1 < (int)add.size()) {
            add[2 * i] += add[i];
            add[2 * i + 1] += add[i];
        }
        add[i] = 0;
    }

    void tr_add(int i, int l, int r, int ql, int qr, int val) {
        push(i, l, r);
        if (l > qr || r < ql)
            return;
        if (ql <= l && r <= qr) {
            add[i] += val;
            push(i, l, r);
            return;
        }
        int m = (l + r) / 2;
        tr_add(2 * i, l, m, ql, qr, val);
        tr_add(2 * i + 1, m + 1, r, ql, qr, val);
        d[i] = max(d[2 * i], d[2 * i + 1]);
    }

    int tr_get(int i, int l, int r, int ql, int qr) {
        push(i, l, r);
        if (l > qr || r < ql)
            return 0;
        if (ql <= l && r <= qr)
            return d[i];
        int m = (l + r) / 2;
        return max(tr_get(2 * i, l, m, ql, qr), tr_get(2 * i + 1, m + 1, r, ql, qr));
    }

    void add_(int l, int r, int val) {
        tr_add(1, 0, n - 1, l, r, val);
    }

    int get(int l, int r) {
        return tr_get(1, 0, n - 1, l, r);
    }

} val;

struct TreeSum {
    int n;
    vector <int> d;
    TreeSum(int n = 0): n(n) {
        d.resize(4 * n, 0);
    }

    void tr_add(int i, int l, int r, int pos, int val) {
        if (l > pos || r < pos)
            return;
        if (l == r) {
            d[i] += val;
            return;
        }
        int m = (l + r) / 2;
        tr_add(2 * i, l, m, pos, val);
        tr_add(2 * i + 1, m + 1, r, pos, val);
        d[i] = d[2 * i] + d[2 * i + 1];
    }

    int tr_get(int i, int l, int r, int ql, int qr) {
        if (l > qr || r < ql)
            return 0;
        if (ql <= l && r <= qr)
            return d[i];
        int m = (l + r) / 2;
        return tr_get(2 * i, l, m, ql, qr) + tr_get(2 * i + 1, m + 1, r, ql, qr);
    }

    void add_(int pos, int val) {
        tr_add(1, 0, n - 1, pos, val);
    }

    int get(int l, int r) {
        return tr_get(1, 0, n - 1, l, r);
    }

} sum;

vector <Query> q;
set <int> all;

int32_t main() {
    //freopen("input.txt", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int kek; cin >> kek;
    for (int i = 0; i < kek; i++) {
        char c; cin >> c;
        int x, y = -1;
        if (c == '+')
            cin >> x >> y;
        else
            cin >> x;
        q.push_back(Query(c, x, y));
    }

    val = TreeMax(MAXT);
    sum = TreeSum(MAXT);

    for (int i = 0; i < MAXT; i++)
        val.add_(i, i, i);

    for (int i = 0; i < (int)q.size(); i++) {
        if (q[i].c == '+') {
            val.add_(0, q[i].x, q[i].y);
            sum.add_(q[i].x, q[i].y);
            all.insert(q[i].x);
        } else if (q[i].c == '-') {
            int tm = q[q[i].x - 1].x;
            sum.add_(q[q[i].x - 1].x, -q[q[i].x - 1].y);
            val.add_(0, tm, -q[q[i].x - 1].y);
            all.erase(q[i].x);
        } else if (q[i].c == '?') {
            int tm = q[i].x;
            auto tmp = all.upper_bound(tm);
            if (tmp == all.begin()) {
                cout << 0 << endl;
            } else {
                tmp--;
                int tm1 = (*tmp);
                /*cout << "tm1 = " << tm1 << endl;
                for (int i = 0; i < 10; i++)
                    cout << "val.d[" << i << "] = " << val.d[i] << endl;
                cout << "val.get = " << val.get(0, tm) << endl;*/
                int res = val.get(0, tm1) - sum.get(tm1 + 1, MAXT - 1);
                cout << max(0ll, res - tm) << endl;
            }
        }
    }

    return 0;
}
