#define _SCL_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS

#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

char _inf[] =
#ifdef HER
"input.txt"
#else
""
#endif
;

char _ouf[] =
#ifdef HER
""
#else
""
#endif
;

#ifndef HER
#define endl '\n'
#endif

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using ll = long long;
using ld = long double;

ll n;
ll nn;
vector<ll> arr;

ll pw(ll x, ll n, ll p) {
	ll ans = 1;
	while (n) {
		if (n & 1) ans = (ans * x) % p;
		x = (x * x) % p;
		n >>= 1;
	}

	return ans;
}

ll inv(ll x, ll p) {
	return pw(x, p - 2, p);
}

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

void _solve() {
	cin >> n;
	nn = n;

	for (ll i = 2; i * i <= n; ++i) {
		if (n % i == 0) {
			arr.push_back(i);
			while (n % i == 0) {
				n /= i;
			}
		}
	}

	if (n != 1) {
		arr.push_back(n);
		n = 1;
	}

	n = nn;

	if (arr.size() == 1) {
		printf("NO\n");
		return;
	}

	ll p = arr[0];
	ll q = arr[1];
	ll c = (n / p) / q;

	ll a = q - inv(p, q);
	ll b = (p * q - 1 - a * p) / q;

	printf("YES\n");
	vector<pair<ll, ll>> ans;

	ans.push_back({ a, q * c });
	ans.push_back({ b, p * c });
	if (c > 1) {
		ans.push_back({ c - 1, c });
	}

	printf("%d\n", (int)ans.size());
	for (int i = 0; i < (int)ans.size(); ++i) {
		ll gc = gcd(ans[i].first, ans[i].second);
		ans[i].first /= gc;
		ans[i].second /= gc;
		printf("%lld %lld\n", ans[i].first, ans[i].second);
	}
}

int main() {
	if(_inf[0])
		freopen(_inf, "r", stdin);
	if (_ouf[0])
		freopen(_ouf, "w", stdout);
	
	cin.tie(nullptr);
	ios_base::sync_with_stdio(false);
	
	_solve();

#ifdef HER
	cout << "\n\nTIME = " << clock() / (ld)CLOCKS_PER_SEC << endl;
	while (1);
#endif
}
