#define _SCL_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")

#define first x
#define second y

#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

char _inf[] =
#ifdef HER
"input.txt"
#else
""
#endif
;

char _ouf[] =
#ifdef HER
""
#else
""
#endif
;

#ifndef HER
#define endl '\n'
#endif

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using ll = long long;
using ld = long double;

const int N = 100 * 1000 + 228;
char typ[N];
pair<int, int> p[N];

int sgn(int a) {
	if (a < 0) {
		return -1;
	}
	else if (a > 0) {
		return 1;
	}
	else {
		assert(false);
	}
}

vector<int> g[2 * N];
vector<int> rg[2 * N];
bool used[2 * N];
vector<int> order;
int cp[2 * N];

int n, m;

int get(int x) {
	if (x > 0) {
		return 2 * x - 1;
	}
	else {
		return -2 * x - 2;
	}
}

int gg(int x) {
	return x ^ 1;
}

void dfs(int v) {
	used[v] = true;
	for (int i = 0; i < (int)g[v].size(); ++i) {
		int to = g[v][i];

		if (!used[to]) {
			dfs(to);
		}
	}

	order.push_back(v);
}

void dfs_r(int v, int c) {
	used[v] = true;
	cp[v] = c;
	for (int i = 0; i < (int)rg[v].size(); ++i) {
		int to = rg[v][i];

		if (!used[to]) {
			dfs_r(to, c);
		}
	}
}

bool sl(vector<pair<int, int>> ff) {
	for (int i = 0; i <= 2 * n; ++i) {
		g[i].clear();
		rg[i].clear();
		used[i] = false;
	}
	order.clear();

	for (int i = 0; i < (int)ff.size(); ++i) {
		int v1 = get(ff[i].first);
		int v2 = get(ff[i].second);

		g[gg(v1)].push_back(v2);
		rg[gg(v2)].push_back(v1);
	}

	for (int i = 0; i < 2 * n; ++i) {
		if (!used[i]) {
			dfs(i);
		}
	}

	for (int i = 0; i < 2 * n; ++i) {
		used[i] = false;
	}

	int c = 0;
	reverse(order.begin(), order.end());
	for (int i = 0; i < 2 * n; ++i) {
		int v = order[i];
		if (!used[v]) {
			dfs_r(v, c++);
		}
	}

	for (int i = 1; i < 2 * n; i += 2) {
		if (cp[i] == cp[i - 1]) {
			return false;
		}
	}

	return true;
}

void solve() {

	cin >> n >> m;

	for (int i = 1; i <= n; ++i) {
		cin >> typ[i];
	}

	set<int> q;
	vector<vector<int>> cl(n + 1);

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;

		cl[abs(a)].push_back(i);
		cl[abs(b)].push_back(i);

		if (abs(a) > abs(b)) {
			swap(a, b);
		}

		p[i] = { a, b };

		if (typ[abs(a)] == 'A' || typ[abs(b)] == 'A') {
			q.insert(i);
		}
	}

	while (!q.empty()) {
		int i = *q.begin();
		q.erase(q.begin());

		if (typ[abs(p[i].x)] == 'A' && typ[abs(p[i].y)] == 'A') {
			if (p[i].x == -p[i].y) {
				continue;
			}

			cout << "FALSE" << endl;
			return;
		}

		if (typ[abs(p[i].x)] == 'E' && typ[abs(p[i].y)] == 'A') {
			cout << "FALSE" << endl;
			return;
		}

		assert(typ[abs(p[i].x)] == 'A' && typ[abs(p[i].y)] == 'E');
		int new_var;
		if ((p[i].x > 0) == (p[i].y > 0)) {
			new_var = -abs(p[i].x);
		}
		else {
			new_var = abs(p[i].x);
		}

		for (int j : cl[abs(p[i].y)]) {
			if (abs(p[j].x) == abs(p[i].y)) {
				p[j].x = sgn(p[j].x) * new_var;
			}
			if (abs(p[j].y) == abs(p[i].y)) {
				p[j].y = sgn(p[j].y) * new_var;
			}

			q.insert(j);
			if (abs(p[j].x) > abs(p[j].y)) {
				swap(p[j].x, p[j].y);
			}
		}
	}

	vector<pair<int, int>> egor;
	for (int i = 0; i < m; ++i) {
		if (typ[abs(p[i].x)] == 'E' && typ[abs(p[i].y)] == 'E') {
			egor.push_back({ p[i].x, p[i].y });
		}
		else {
			assert(typ[abs(p[i].x)] == 'A' && typ[abs(p[i].y)] == 'A');
		}
	}

	// egor

	if (sl(egor)) {
		cout << "TRUE\n";
	}
	else {
		cout << "FALSE\n";
	}
	
}

void _solve() {
	int t;
	cin >> t;

	for (int i = 0; i < t; ++i) {
		solve();
	}
}

int main() {
	if (_inf[0])
		freopen(_inf, "r", stdin);
	if (_ouf[0])
		freopen(_ouf, "w", stdout);

	cin.tie(nullptr);
	ios_base::sync_with_stdio(false);

	_solve();

#ifdef HER
	cout << "\n\nTIME = " << clock() / (ld)CLOCKS_PER_SEC << endl;
	while (1);
#endif
}
