#define _SCL_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")

#define first x
#define second y

#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

char _inf[] =
#ifdef HER
"input.txt"
#else
""
#endif
;

char _ouf[] =
#ifdef HER
""
#else
""
#endif
;

#ifndef HER
#define endl '\n'
#endif

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using ll = long long;
using ld = long double;


const int MAX_N = 15;

int n;
vector<int> g[MAX_N];
vector<int> rg[MAX_N];
vector<int> order;
vector<int> ngg[MAX_N];
vector<int> on_f[MAX_N];
bool mt[MAX_N][MAX_N];
bool used[MAX_N];
int cp[MAX_N];
const int SZ_N = 10;
const int SZ_H = 3 * 10 + 5;
const int SZ_M = 1000 * 1000 / SZ_N / SZ_H;
vector<int> lvl_ptr;

char ans[SZ_H][SZ_N][SZ_M + 1];

void dfs(int v) {
	used[v] = true;
	for (int i = 0; i < (int)g[v].size(); ++i) {
		int to = g[v][i];

		if (!used[to]) {
			dfs(to);
		}
	}

	order.push_back(v);
}

void dfs_r(int v, int c) {
	used[v] = true;
	cp[v] = c;
	for (int i = 0; i < (int)rg[v].size(); ++i) {
		int to = rg[v][i];

		if (!used[to]) {
			dfs_r(to, c);
		}
	}
}

int edge_ptr = 1;

void add_edge(int v, int u) {
	v = lvl_ptr[v];
	u = lvl_ptr[u];

	int j = edge_ptr;

	int ff = v;
	ans[ff][1][j - 1] = '.';
	ans[ff][1][j + 1] = '.';
	ans[ff][0][j] = '.';
	ans[ff][2][j] = '.';

	ff = u;
	ans[ff][1][j - 1] = '.';
	ans[ff][1][j + 1] = '.';
	ans[ff][0][j] = '.';
	ans[ff][2][j] = '.';

	if (ff != 0) {
		ans[ff - 1][1][j] = '#';
	}
	edge_ptr += 3;
}

void _solve() {
	
	scanf("%d", &n);

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			int x;
			scanf("%d", &x);
			if (x) {
				g[i].push_back(j);
				rg[j].push_back(i);
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
		}
	}

	memset(used, 0, sizeof(used));
	reverse(order.begin(), order.end());
	int c = 0;
	for (int i = 0; i < n; ++i) {
		int v = order[i];

		if (!used[v]) {
			dfs_r(v, c++);
		}
	}

	for (int i = 0; i < n; ++i) {
		cp[i] = c - 1 - cp[i];
	}

	for (int i = 0; i < n; ++i) {
		on_f[cp[i]].push_back(i);
		for (int j = 0; j < (int)g[i].size(); ++j) {
			mt[cp[i]][cp[g[i][j]]] = true;
		}
	}
	
	for (int i = 0; i < SZ_H; ++i) {
		for (int j = 0; j < SZ_N; ++j) {
			for (int k = 0; k < SZ_M; ++k) {
				ans[i][j][k] = '.';
			}
		}
	}

	lvl_ptr.push_back(0);
	for (int i = 2; i < SZ_H; i += 3) {
		lvl_ptr.push_back(i + 1);
		for (int j = 0; j < SZ_N; ++j) {
			for (int k = 0; k < SZ_M; ++k) {
				ans[i][j][k] = '#';
			}
		}
	}

	for (int i = 0; i < c; ++i) {
		int cur = lvl_ptr[i];
		int now = 0;
		int ck = SZ_M - 1;

		for (int k = 0; k < (int)on_f[i].size(); ++k) {
			ans[cur][k][ck] = '1' + on_f[i][k];
		}
	}

	int cur = 81;
	for (int i = 0; i < SZ_H; ++i) {
		int cnt = 0;
		for (int j = 1; j < SZ_M && cnt < cur; j += 3, ++cnt) {
			ans[i][1][j - 1] = '#';
			ans[i][1][j + 1] = '#';
			ans[i][1][j] = '.';
			ans[i][0][j] = '#';
			ans[i][2][j] = '#';
		}
		assert(cnt == cur);
	}



	for (int i = 0; i < c; ++i) {
		for (int j = i + 1; j < c; ++j) {
			if (i == j) {
				continue;
			}

			if (mt[j][i]) {
				add_edge(j, i);
			}
		}
	}


	assert(SZ_M * SZ_N * SZ_H <= 1000 * 1000);
	printf("%d %d %d\n", SZ_M, SZ_N, SZ_H);

	for (int i = SZ_H - 1; i >= 0; --i) {
		for (int j = 0; j < SZ_N; ++j) {
			ans[i][j][SZ_M] = '\0';
			printf("%s\n", ans[i][j]);
		}
		printf("\n");
	}
}

int main() {
	if(_inf[0])
		freopen(_inf, "r", stdin);
	if (_ouf[0])
		freopen(_ouf, "w", stdout);
	
	cin.tie(nullptr);
	ios_base::sync_with_stdio(false);
	
	_solve();

#ifdef HER
	cout << "\n\nTIME = " << clock() / (ld)CLOCKS_PER_SEC << endl;
	while (1);
#endif
}
