#include <iostream>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <math.h>

using namespace std;

typedef vector<int> vi;
typedef long long ll;

const double eps = 1e-11;

ll gcd(ll a, ll b, ll &x, ll &y)
{
    if (b == 0) {
        x = 1;
        y = 0;
        return a;
    }

    ll x1, y1;
    ll d = gcd(b, a % b, x1, y1);

    x = y1;
    y = x1 - (a / b)*y1;
    return d;
}

vi getdel(int n)
{
    vi ans;

    for (int i = 2; 1LL*i*i <= n; i++) {
        if (n % i == 0) {
            int x = i;
            int y = n / i;

            ans.push_back(x);
            if (y != x)
                ans.push_back(y);
        }
    }

    return ans;
}


int main()
{
#ifdef _DEBUG
    freopen("input.txt", "rt", stdin);
    freopen("output.txt", "wt", stdout);
#endif

    int n;
    cin >> n;

    vi del = getdel(n);

    for (int b2 : del) {
        for (int b1 : del) {
            ll a = 1ll*b2*n;
            ll b = 1ll*b1*n;
            ll c = 1LL*(n-1)*b1*b2;

            ll x, y, d;

            d = gcd(a, b, x, y);

            if (c % d != 0)
                continue;

            ll x0 = x*c / d;
            ll y0 = y*c / d;

            double l0 = -1.0*x0*d / b + eps;
            double r0 = 1.0*(b1 - x0)*d / b - eps;

            double l1 = 1.0*(y0 - b2)*d / a + eps;
            double r1 = 1.0*y0*d / a - eps;

            double l = max(l0, l1);
            double r = min(r0, r1);

            if (floor(r) - floor(l) > 0) {
                ll t = (ll)floor(r);

                ll ansX = x0 + b/d*t;
                ll ansY = y0 - a/d*t;

                cout << "YES\n2\n";
                cout << ansX << ' ' << b1 << '\n';
                cout << ansY << ' ' << b2 << '\n';
                return 0;
            }
        }
    }

    cout << "NO";

    return 0;
}