import java.io.*;
import java.util.Arrays;
import java.util.Comparator;

public class TaskL {

    public static void main(String[] args) throws IOException {
        new TaskL().run();
    }

    StreamTokenizer st = new StreamTokenizer(new BufferedReader(new InputStreamReader(System.in)));
    PrintWriter pw = new PrintWriter(System.out);

    private int nextInt() throws IOException {
        st.nextToken();
        return (int) st.nval;
    }

    static class Person {
        int job;
        int value;

        public Person(int job, int value) {
            this.job = job;
            this.value = value;
        }
    }

    private void run() throws IOException {
        int n = nextInt();
        int k = nextInt();
        long sum = 0;

        int[] jobs = new int[k];
        int[] a = new int[n];
        Person[] b = new Person[n];
        int badJobs = k;

        for (int i = 0; i < n; i++) {
            int c = nextInt() - 1;
            a[i] = c;
            if (jobs[c] == 0) {
                badJobs--;
            }
            jobs[c]++;
        }

        for (int i = 0; i < n; i++) {
            b[i] = new Person(a[i], nextInt());
        }
        Arrays.sort(b, new Comparator<Person>() {
            @Override
            public int compare(Person o1, Person o2) {
                return o1.value - o2.value;
            }
        });

        for (Person p : b) {
            if (jobs[p.job] > 1) {
                sum += p.value;
                jobs[p.job]--;
                badJobs--;
                if (badJobs == 0) {
                    break;
                }
            }
        }


        pw.println(sum);
        pw.close();
    }

}
