#ifndef DEBUG
#include <iostream>

const int MAX_SCORE = 201;
const int MAX_SET_NUM = 6;
const int MAX_DELTA = 4;
#else
#include <fstream>
std::ifstream cin{ "input.txt" };
std::ofstream cout{ "output.txt" };

const int MAX_SCORE = 201;
const int MAX_SET_NUM = 6;
const int MAX_DELTA = 4;
#endif

#include <vector>
#include <iomanip>
#include <algorithm>
#include <map>
#include <set>
#include <string>

using namespace std;

pair<int, int> answers[MAX_SCORE][MAX_SCORE][MAX_SET_NUM][MAX_DELTA];

pair<int, int> def_pair = { -1, -1 };
pair<int, int> null_pair = { 0, 0 };

bool more_than(int cnt)
{
	return cnt >= MAX_SCORE;
}

void init()
{
	for (int i = 0; i < MAX_SCORE; i++)
	{
		for (int j = 0; j < MAX_SCORE; j++)
		{
			for (int st = 0; st < MAX_SET_NUM; st++)
			{
				for (int delta = 0; delta < MAX_DELTA; delta++)
					answers[i][j][st][delta] = def_pair;
			}
		}
	}
	answers[0][0][0][0] = null_pair;

	for (int st = 0; st < MAX_SET_NUM - 1; st++)
	{
		for (int delta = 0; delta < MAX_DELTA; delta++)
		{
			if (delta == 3 || st - delta == 3)
				continue;
			for (int i = 0; i < MAX_SCORE; i++)
			{
				for (int j = 0; j < MAX_SCORE; j++)
				{
					if (answers[i][j][st][delta] == def_pair)
						continue;
					int border = ((st < 4) ? 25 : 15);
					for (int xt = 0; xt + 1 < border; xt++)
					{
						if (!more_than(xt + j) && !more_than(border + i))
							answers[i + border][xt + j][st + 1][delta + 1] = { border, xt };
						if (!more_than(border + j) && !more_than(xt + i))
							answers[i + xt][border + j][st + 1][delta] = { xt, border };
					}
					for (int xt = border + 1; xt <= MAX_SCORE; xt++)
					{
						if (!more_than(xt + j) && !more_than(xt - 2 + i))
							answers[i + xt - 2][xt + j][st + 1][delta] = { xt - 2, xt };
						if (!more_than(xt - 2 + j) && !more_than(xt + i))
							answers[i + xt][xt - 2 + j][st + 1][delta + 1] = { xt, xt - 2};
					}
				}
			}
		}
	}
}

void check_zeros()
{

	for (int st = 0; st < MAX_SET_NUM; st++)
	{
		for (int delta = 0; delta < MAX_DELTA; delta++)
		{
			for (int i = 0; i < MAX_SCORE; i++)
			{
				for (int j = 0; j < MAX_SET_NUM; j++)
				{
					if (answers[i][j][st][delta] == null_pair)
					{
						bool f = true;
					}
				}
			}
		}
	}
}

bool restore_answer(int x, int y, int st, int delta)
{
	//check_zeros();
	if (answers[x][y][st][delta] == def_pair)
		return false;
	string score = to_string(delta) + ":" + to_string(st - delta);
	vector<pair<int, int>>answer_list;
	while (answers[x][y][st][delta] != null_pair)
	{
		auto pair_now = answers[x][y][st][delta];
		answer_list.push_back(pair_now);
		x -= pair_now.first;
		y -= pair_now.second;
		st--;
		delta -= pair_now.first > pair_now.second;
	}
	reverse(answer_list.begin(), answer_list.end());
	cout << score << "\n";
	for (auto &i : answer_list)
		cout << i.first << ":" << i.second << " ";
	cout << "\n";
	return true;
}

void solve(int x, int y)
{
	vector<pair<int, int>>zapr{ {3, 3}, {4, 3 } };

	for (int delta = 3; delta >= 0; delta--)
	{
		for (int st = delta; st < MAX_SET_NUM; st++)
		{
			if (delta != 3 && st - delta != 3)
				continue;
			if (restore_answer(x, y, st, delta))
				return;

		}
	}
	cout << "Impossible" << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	init();

	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		int left, right;
		cin >> left >> right;
		solve(left, right);
	}
	/**/
}