
#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <queue>

using namespace std;

const int magic_const = 1e8;

int n, m;
vector<vector<int>>distances;
vector<vector<int>>edges;

void BFS(int beg, vector<int>&v)
{
	v[beg] = 0;
	queue<int> q;
	q.push(beg);
	while (!q.empty())
	{
		int now = q.front();
		q.pop();
		for (auto edge : edges[now])
		{
			if (v[edge] > v[now] + 1)
			{
				v[edge] = v[now] + 1;
				q.push(edge);
			}
		}
	}
}

int get_best_vertex(vector<bool> &active)
{
	int bestv = -1;
	int bestsize = magic_const;
	for (int i = 0; i < active.size(); i++)
	{
		
		int distancenow = 0;
		for (int j = 0; j < active.size(); j++)
		{
			if (active[j])
				distancenow = max(distancenow, distances[i][j]);
		}
		if (distancenow < bestsize)
		{
			bestsize = distancenow;
			bestv = i;
		}
	}
	return bestv;
}

void solve_now()
{
	string s;
	vector<bool> active(n, true);
	while (true)
	{
		int now = get_best_vertex(active);
		cout << now + 1 << endl;
		cin >> s;
		if (s == "GO")
		{
			int cur;
			cin >> cur;
			cur--;
			for (int i = 0; i < n; i++)
			{
				active[i] = active[i] & (distances[now][i] > distances[cur][i]);
			}
		}
		else
			return;
	}
}

void solve()
{
	cin >> n >> m;
	edges.resize(n);
	distances.resize(n, vector<int>(n, magic_const));
	for (int i = 0; i < m; i++)
	{ 
		int k;
		cin >> k;
		int prev;
		cin >> prev;
		prev--;
		for (int j = 1; j < k; j++)
		{
			int now;
			cin >> now;
			now--;
			edges[prev].push_back(now);
			edges[now].push_back(prev);
			prev = now;
		}
	}
	for (int i = 0; i < n; i++)
	{
		BFS(i, distances[i]);
	}

	for (int i = 0; i < n; i++)
		solve_now();
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();
}