#ifndef DEBUG
#include <iostream>
#else
#include <fstream>
std::ifstream cin{ "input.txt" };
std::ofstream cout{ "output.txt" };
#endif

#include <vector>
#include <iomanip>
#include <algorithm>
#include <map>
#include <set>
#include <string>

using namespace std;

vector<pair<int, int>>v;
vector<int> order{ 0, 1, 2, 3, 4, 7, 6, 5};
vector<int> normorder{ 0, 1, 2, 3, 4, 5 , 6, 7 };
vector<bool> used;

using ll = long long;

vector<ll> factorize(ll num)
{
	vector<ll> answer;
	ll ogr = num;
	for (ll i = 2; i * i <= min(ogr, num * num); i++)
	{
		while (num % i == 0)
		{
			num /= i;
			answer.push_back(i);
		}
	}
	if (num > 1)
		answer.push_back(num);
	return answer;
}

ll gcd(ll a, ll b, ll&x, ll& y)
{
	if (a == 0)
	{
		x = 0;
		y = 1;
		return b;
	}
	ll x1, y1;
	ll d = gcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

void solve()
{
	ll n;
	cin >> n;
	auto fact = factorize(n);
	ll left = 1, right = 1;
	int last = 1;
	left = fact[0];
	while (last < fact.size() && fact[last] == fact[last - 1])
	{
		left *= fact[last];
		last++;
	}
	if (last >= fact.size())
	{
		cout << "NO" << "\n";
		return;
	}
	while (last < fact.size())
	{
		right *= fact[last];
		last++;
	}
	ll x, y;
	gcd(left, right, x, y);
	x *= n - 1;
	y *= n - 1;
	auto lcm = n;
	if (x < 1)
	{
		swap(x, y);
		swap(left, right);
	}
	auto lb = -1ll;
	auto rb = n + 1;
	while (rb - lb > 1)
	{
		auto mid = (lb + rb) / 2;
		auto ynow = y + mid * left;
		if (ynow >= 1ll)
			rb = mid;
		else
			lb = mid;
	}
	x -= rb * right;
	y += rb * left;
	if (x >= 1 && y >= 1)
	{
		cout << "YES" << "\n" << 2 << "\n";
		cout << x << " " << right << "\n";
		cout << y << " " << left << "\n";
	}
	else
	{
		cout << "NO" << "\n";
		return;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();
	
	/**/
}