#include <bits/stdc++.h>
#ifdef SIR
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif
typedef long long ll;

using namespace std;

int cur_best;

struct Fl {
    vector<vector<char> > E;
    vector<int> Ix, Iy;
    int n, m;
    Fl(vector<vector<char> > &E) : E(E) {
        n = E.size();
        if (E.size()) {
            m = E[0].size();
        }
        for (int i = 0; i < n; i++) Ix.push_back(i);
        for (int i = 0; i < m; i++) Iy.push_back(i);
    }

    char get(int x, int y) {
        return E[Ix[x]][Iy[y]];
    }
    int del_x(int i) {
        int t = Ix[i];
        Ix.erase(Ix.begin() + i);
        return t;
    }
    int del_y(int i) {
        int t = Iy[i];
        Iy.erase(Iy.begin() + i);
        return t;
    }
    int N() {
        return Ix.size();
    }
    int M() {
        return Iy.size();
    }
    void ins_x(int p, int x) {
        Ix.insert(Ix.begin() + p, x);
    }
    void ins_y(int p, int x) {
        Iy.insert(Iy.begin() + p, x);
    }
};
struct solver {
    struct edge {
        int to, c, f, back;
    };

    vector<vector<edge>> E;
    vector<int> used;
    int sz;

    void add(int a, int b, int c) {
        int ia = (int)E[b].size();
        int ib = (int)E[a].size();
        E[a].push_back({ b, c, 0, ia });
        E[b].push_back({ a, 0, 0, ib });
    }


    int dfs(int v, int t, int cmin) {
        if (v == t) return cmin;
        used[v] = 1;
        for (auto &e : E[v]) {
            if (e.f < e.c && !used[e.to]) {
                int df = dfs(e.to, t, min(cmin, e.c - e.f));
                if (df > 0) {
                    e.f += df;
                    E[e.to][e.back].f -= df;
                    return df;
                }
            }
        }
        return 0;
    }

    int flow(int s, int t) {
        int fl = 0;
        while (1) {
            used.assign(sz, 0);
            int df = dfs(s, t, (int)1e9);
            if (df == 0) break;
            fl += df;
        }
        return fl;
    }

    int solve(Fl &F) {

        int n = (int)F.N();
        int m = (int)F.M();

        int S = n + m;
        int T = n + m + 1;

        sz = n + m + 2;
        E.clear();
        E.resize(sz);

        for (int i = 0; i < n; i++) {
            add(S, i, 2);
        }
        for (int i = 0; i < m; i++) {
            add(i + n, T, 1);
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (F.get(i, j)) {
                    add(i, j + n, 1);
                }
            }
        }
        return flow(S, T) / 2;
    }
} Q;

int est_best_ans(Fl &E) {
    return Q.solve(E);
}

double Lim;
double LLim;

bool EX;
bool AN;

void brut(Fl &E, int cur_ans) {
    static int IT = 0;
    IT++;
    if (AN || EX || (IT % 100 == 0 && clock() * 1.0 / CLOCKS_PER_SEC > LLim) ) {
        EX = 1;
        return;
    }
    if (cur_ans >= cur_best) {
        AN = 1;
        return;
    }
    int n = E.N();
    if (n == 0) return;
    int m = E.M();
    if (m == 0) return;
    //cerr << n << ' ' << m << endl;
    if (cur_best >= cur_ans + est_best_ans(E)) {
        return;
    }
    vector<int> B(m);
    vector<vector<int> > A(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (E.get(i, j)) A[i].push_back(j);
            B[j] += E.get(i, j);
        }
    }
    for (int i = 0; i < n; i++) {
        if (A[i].size() == 2) {
            if (B[A[i][0]] + B[A[i][1]] <= 1) {
                auto t1 = E.del_x(i);
                auto t2 = E.del_y(A[i][0]);
                auto t3 = E.del_y(A[i][1]);
                brut(E, cur_ans + 1);
                E.ins_y(A[i][1], t3);
                E.ins_y(A[i][0], t2);
                E.ins_x(i, t1);
                return;
            }
        }
        if (A[i].size() < 2) {
            int t1 = E.del_x(i);
            brut(E, cur_ans);
            E.ins_x(i, t1);
            return;
        }
    }
    for (int j = 0; j < m; j++) {
        if (B[j] == 0) {
            int t1 = E.del_y(j);
            brut(E, cur_ans);
            E.ins_y(j, t1);
            return;
        }
    }

    int mx = -1;
    int C, L1, L2;
    vector<int> F(m);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (E.get(i, j)) {
                F[j] += A[i].size();
            }
        }
    }
    for (int i = 0; i < n; i++) {
        vector<pair<int, int> > E;
        for (int j : A[i]) E.push_back({-F[j], j});
        sort(E.begin(), E.end());
        int v = A[i].size() * A[i].size() - E[0].first - E[1].first;
        if (mx < v) {
            mx = v;
            C = i;
            L1 = E[0].second;
            L2 = E[1].second;
        }
    }
    if (L1 < L2) swap(L1, L2);
    if (mx >= 0) {
        auto t1 = E.del_x(C);
        auto t2 = E.del_y(L1);
        auto t3 = E.del_y(L2);
        brut(E, cur_ans + 1);
        E.ins_y(L2, t3);
        E.ins_y(L1, t2);
        E.ins_x(C, t1);


        E.E[E.Ix[C]][E.Iy[L1]] = 0;
        brut(E, cur_ans);
        E.E[E.Ix[C]][E.Iy[L1]] = 1;
        E.E[E.Ix[C]][E.Iy[L2]] = 0;
        brut(E, cur_ans);
        E.E[E.Ix[C]][E.Iy[L2]] = 1;
    }
}

void solve() {
    int t; cin >> t;
    Lim = 1.9 / t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<char> > P(n, vector<char>(m));
        for (int i = 0; i < n; i++) {
            string s; cin >> s;
            for (int j = 0; j < m; j++) {
                P[i][j] = s[j] == '1';
            }
        }
        cur_best = 0;
        EX = 0;
        Fl t(P);
        for (cur_best = 1; ; cur_best++) {
            AN = 0;
            brut(t, 0);
            if (AN == 0) {
                break;
            }
        }
        cout << cur_best << '\n';
        LLim += Lim;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef SIR
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}