#include <bits/stdc++.h>
#ifdef SIR
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif
typedef long long ll;

using namespace std;

struct node {
    ll L = 0, R = 0;
};

#define EMPTY node{ -1, -1 }

node merge(node F, node G) {
    node H;

    if (F.L == -1) return G;
    if (G.L == -1) return F;

    if (F.R <= G.L) {
        H = { F.L + (G.L - F.R), G.R };
    } else {
        H = { F.L, G.R + (F.R - G.L) };
    }
    return H;
}

const int dd = (int)1e6 + 7;

struct SegmentTree {
    node T[4 * dd];

    SegmentTree() {
        for (int i = 0; i < 4 * dd; i++) {
            T[i] = EMPTY;
        }
    }

    void upd(int v, int tl, int tr, int pos, node cur) {
        if (tl == tr) {
            T[v] = cur;
        } else {
            int tm = (tl + tr) / 2;
            if (pos <= tm) upd(v * 2, tl, tm, pos, cur);
            else upd(v * 2 + 1, tm + 1, tr, pos, cur);
            T[v] = merge(T[v * 2], T[v * 2 + 1]);
        }
    }

    node get(int v, int tl, int tr, int l, int r) {
        if (tl == l && tr == r) return T[v];
        int tm = (tl + tr) / 2;

        if (r <= tm) return get(v * 2, tl, tm, l, r);
        if (l > tm) return get(v * 2 + 1, tm + 1, tr, l, r);

        auto t1 = get(v * 2, tl, tm, l, tm);
        auto t2 = get(v * 2 + 1, tm + 1, tr, tm + 1, r);
        return merge(t1, t2);
    }
} T;

void solve() {
    int q; cin >> q;

    vector<ll> op(q);

    for (int it = 0; it < q; it++) {
        char c; cin >> c;

        if (c == '?') {
            ll t; cin >> t;
            auto p = T.get(1, 0, dd - 1, 0, t);
            cout << max(0ll, p.R - t) << "\n";
        } else if (c == '+') {
            ll t, d;
            cin >> t >> d;

            //auto p = T.get(1, 0, dd - 1, 0, t);
            T.upd(1, 0, dd - 1, t, { t, t + d });
            op[it] = t;
        } else {
            int i; cin >> i;
            i--;
            T.upd(1, 0, dd - 1, op[i], EMPTY);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef SIR
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}