#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <utility>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <stack>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
const int N = 1e5 + 5;

ll gcd(ll a, ll b, ll & x, ll & y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	ll x1, y1;
	ll d = gcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

bool find_any_solution(ll a, ll b, ll c, ll & x0, ll & y0, ll & g) {
	g = gcd(abs(a), abs(b), x0, y0);
	if (c % g) {
		return false;
	}
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0) x0 *= -1;
	if (b < 0) y0 *= -1;
	return true;
}

void shift_solution(ll & x, ll & y, ll a, ll b, ll cnt) {
	x += cnt * b;
	y -= cnt * a;
}


void solve() {
	ll n;
	cin >> n;
	for (ll i = 2; i * i <= n; ++i) {
		if (n % i) continue;
		ll a = i;
		ll b = n / i;
		ll c = n - 1;
		ll x = -1, y = -1, g = -1;
		if (!find_any_solution(a, b, c, x, y, g))
			continue;
		if (x < 0 || y >= a) {
			ll cnt = max((abs(x) + b - 1) / b, (y  - 1) / a);
			shift_solution(x, y, a, b, cnt);
		}
		if (x == 0 || y == a)
			shift_solution(x, y, a, b, 1);
		if (y < 0 || x >= b) {
			ll cnt = max((abs(y) + a - 1) / a, (x  - 1) / b);
			shift_solution(x, y, a, b, -cnt);
		}
		if (y == 0 || x == b)
			shift_solution(x, y, a, b, -1);
		if (x <= 0 || y <= 0 || x >= b || y >= a) continue;
		cout << "YES" << endl;
		cout << 2 << endl;
		cout << min(x, b) << ' ' << max(x, b) << endl;
		cout << min(a, y) << ' ' << max(a, y) << endl;
		return;
	}
	cout << "NO" << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

#endif
	solve();
	return 0;
}