#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <utility>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <stack>
#include <deque>



#if _DEBUG
#define de if(1)
#else
#define de if(0)
#endif

#define ho(x) #x << " = " << x << " | "

using namespace std;

int __intend = 0;

void nint() {
	__intend++;
}
void pint() {
	__intend--;
}

string gint() {
	string s;
	for (int i = 0; i < __intend; ++i)
		s += '\t';
	return s;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
const int N = 3e5 + 5;

struct Treap {
	ll x, y, d;
	Treap * l, *r, *p;
	ll mxt, mnt, len;
	Treap(ll t, ll d) :x(t), y(rand()), d(d) {
		de cout << gint() << "Create Treap " << ho(t) << ho(d) << endl;
		mxt = t + d;
		mnt = t + d;
		len = d;
		l = r = nullptr;
	}
};

using pTreap = Treap *;
using ptt = pair<pTreap, pTreap>;

pTreap Update(pTreap root) {
	if (!root) return nullptr;
	de cout << gint() << "Update " << ho(ll(root)) << endl;
	ll tl = 0;
	root->mnt = root->x;
	if (root->l) {
		root->mnt = root->l->mnt;
		root->mxt = root->l->mxt;
		root->len = root->l->len;
		root->l->p = root;
		tl = root->len;
	}
	else {
		root->mxt = 0;
		root->len = 0;
	}
	if (root->mxt > root->x) {
		root->mxt += root->d;
	}
	else {
		root->mxt = root->x + root->d;
	}
	root->len += root->d;
	if (root->r) {
		root->r->p = root;
		if (root->mxt > root->r->mxt - root->r->len) {
			root->mxt += root->r->len;
		}
		root->len += root->r->len;
	}
	de cout << gint() << ho(root->len) << ho(root->mxt) << endl;
	return root;
}

pTreap Merge(pTreap L, pTreap R) {
	de cout << gint() << "Merge " << ho(ll(L)) << ho(ll(R)) << endl;
	if (!L) return R;
	if (!R) return L;
	de cout << gint() << ho(L->y) << ho(R->y) << endl;
	if (L->y > R->y) {
		L->r = Merge(L->r, R);
		L->p = nullptr;
		return Update(L);
	}
	else {
		R->l = Merge(L, R->l);

		R->p = nullptr;
		return Update(R);
	}
}

ptt SplitL(pTreap root, int x) {
	de cout << gint() << "SplitL " << ho(ll(root)) << ho(x) << endl;
	if (!root) return { nullptr, nullptr };
	root->p = nullptr;
	de cout << gint() << ho(root->x) << ho(root->l) << ho(root->r) << endl;
	if (root->x > x) {
		ptt t = SplitL(root->l, x);
		root->l = t.second;
		return { t.first, Update(root) };
	}
	else {
		ptt t = SplitL(root->r, x);
		root->r = t.first;
		return { Update(root), t.second };
	}
}

pTreap Lift(pTreap root) {
	if (!root) 
	de cout << gint() << "Lift " << ho(root) << endl;
	if (!root) throw;
	Update(root);
	if (root->p) return Lift(root->p);
	return  root;
}

pTreap Erase(pTreap node) {
	de cout << gint() << "Erase " << ho(ll(node)) << endl;
	pTreap newnode = Merge(node->l, node->r);
	if (!node->p) return newnode;
	if (newnode == nullptr) return Lift(node->p);
	newnode->p = node->p;
	if (node->p->l == node) {
		node->p->l = newnode;
	}
	else {
		node->p->r = newnode;
	}
	return Lift(newnode);
}

pTreap Add(pTreap & root, ll t, ll d) {
	de cout << gint() << "Add  " << ho(ll(root)) << ho(t) << ho(d) << endl;
	auto n = new Treap(t, d);
	ptt p = SplitL(root, t);
	p.first = Merge(p.first, n);
	root = Merge(p.first, p.second);
	return n;
}

ll Late(pTreap node, ll nx, ll cx = 0) {
	de cout << gint() << "Late " << ho(ll(node)) << ho(cx) << endl;
	if (!node) return cx;
	pTreap l = node->l, r = node->r;
	if (l && l->mxt > nx) {
		return Late(l, nx, cx);
	}
	else if (l) cx = max(cx + l->len, l->mxt);
	if (nx < node->x) return nx;
	cx = max(cx + node->d, node->d + node->x);
	if (r) {
		ll rmxt = max(cx + r->len, r->mxt);
		if (nx < rmxt) return Late(r, nx, cx);
		cx = rmxt;
	}
	return cx;
}

ll GetMXT(pTreap node) {
	if (!node) return 0;
	return node->mxt;
}

pTreap knights[N];

void solve() {
	int q;
	scanf("%d\n", &q);
	pTreap root = nullptr;
	for (int i = 1; i <= q; ++i) {
		char t;
		scanf("%c", &t);
		de cout << t << ' ';
		if (t == '?') {
			ll x;
			scanf("%lld\n", &x);
			de cout << x << endl;
			printf("%lld\n", max(0ll, Late(root, x) - x));
		}
		if (t == '+') {
			ll kt, kd;
			scanf("%lld%lld\n", &kt, &kd);
			de cout << kt << ' ' << kd << endl;
			knights[i] = Add(root, kt, kd);
		}
		if (t == '-') {
			int j;
			scanf("%d\n", &j);
			de cout << j << endl;
			root = Erase(knights[j]);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}