#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <utility>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <stack>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

const int N = 9;

int n;
int mat[N][N];
int gr[N][N];
vector<vector<int>> cmps;

namespace Smt {
	int used[N];
	int color[N];
	vector<int> topsort;
	void dfs1(int v) {
		used[v] = true;
		for (int i = 0; i < n; ++i) {
			if (!mat[v][i])
				continue;
			if (!used[i]) {
				dfs1(i);
			}
		}
		topsort.push_back(v);
	}
	void dfs2(int v, vector<int> &cmp) {
		used[v] = true;
		cmp.push_back(v);
		for (int to = 0; to < n; ++to) {
			if (!mat[to][v])
				continue;
			if (!used[to]) {
				dfs2(to, cmp);
			}
		}
	}
	void init() {
		for (int v = 0; v < n; ++v) {
			if (!used[v]) {
				dfs1(v);
			}
		}

		reverse(topsort.begin(), topsort.end());

		for (int v = 0; v < n; ++v)
			used[v] = false;

		for (int v : topsort) {
			if (!used[v]) {
				vector<int> cmp;
				dfs2(v, cmp);
				cmps.push_back(cmp);
			}
		}

		reverse(cmps.begin(), cmps.end());
		for (int c = 0; c < cmps.size(); ++c) {
			for (int v : cmps[c]) {
				color[v] = c;
			}
		}


		int cmp_sz = cmps.size();
		for (int c1 = 0; c1 < cmp_sz; ++c1) {
			for (int v : cmps[c1]) {
				for (int to = 0; to < n; ++to) {
					if (mat[v][to]) {
						gr[c1][color[to]] = true;
					}
				}
			}
		}
	}
}

const int M = 100;

char mp[M][M][M];

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> mat[i][j];
		}
	}
	Smt::init();
	for (int i = 0; i < M; ++i) {
		for (int j = 0; j < M; ++j) {
			for (int k = 0; k < M; ++k)
				mp[i][j][k] = '.';
		}
	}

	int grsz = cmps.size();
	int h = 3 * grsz + 1;
	for (int i = 0; i < grsz; ++i) {
		for (int j = 0; j <= grsz; ++j) {
			for (int k = 0; k < 5; ++k) {
				for (int l = 0; l < 5; ++l)
					mp[3 * i][5 * j + k][l] = '#';
			}
			if (j != grsz) mp[3 * i][5 * j + 2][2] = '.';
		}
		mp[3 * i][5 * i + 2][2] = '#';
		for (int j = 0; j < grsz; ++j) {
			if (gr[i][j] || i == j) continue;
			for (int h = 1; h <= 2; ++h) {
				for (int k = -1; k <= 1; ++k) {
					for (int l = -1; l <= 1; ++l) {
						if (!k && !l) continue;
						mp[3 * i + h][5 * j + 2 + k][2 + l] = '#';
					}
				}
			}
		}
		for (int j = 0; j < cmps[i].size(); ++j) {
			mp[3 * i + 1][5 * grsz + j % 5][j / 5] = '0' + cmps[i][j] + 1;
		}
	}
	cout << 5 << ' ' << grsz * 5 + 5 << ' ' << 3 * grsz << endl;
	for (int i = 3 * grsz - 1; i >= 0; --i) {
		for (int j = 0; j < grsz * 5 + 5; ++j) {
			for (int k = 0; k < 5; ++k) {
				cout << mp[i][j][k];
			}
			cout << endl;
		}
		cout << endl;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}