#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(x) (x).begin(), (x).end()

vector<vector<int> > g, gr;
vector<char> used;
vector<int> order, component;

void dfs1(int v) {
    used[v] = true;
    for (auto &i : g[v]) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    order.push_back(v);
}
void dfs2(int v) {
    used[v] = true;
    component.push_back(v);
    for (auto &i : gr[v]) {
        if (!used[i]) {
            dfs2(i);
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    g.resize(n);
    gr.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int tmp;
            cin >> tmp;
            if (tmp){
                g[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
    used.assign(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    used.assign(n, false);

    vector<vector<int>> comps;
    int compNum[9] = {};

    for (int i = 0; i < n; ++i) {
        int v = order[n - i - 1];
        if (!used[v]) {
            dfs2(v);
            for (auto &i : component) {
                compNum[i] = comps.size();
            }
            comps.push_back(component);
            component.clear();
        }
    }

    int gg[9][9] = {{}};
    int cntIn[9] = {};
    for (int i = 0; i < comps.size(); i++) {
        for (int j : g[i]) {
            if (compNum[i] == compNum[j]) continue;
            gg[compNum[i]][compNum[j]] = 1;
            cntIn[compNum[j]]++;
        }
    }

    vector<int> topsort;
    queue<int> q;
    for (int i = 0; i < comps.size(); i++) {
        if (cntIn[i] == 0) {
            q.push(i);
        }
    }

    while (!q.empty()) {
        int cur = q.front();
        q.pop();
        topsort.push_back(cur);
        for (int i = 0; i < 9; i++) {
            if (gg[cur][i] == 0) continue;
            cntIn[i]--;
            if (cntIn[i] == 0) {
                q.push(i);
            }
        }
    }

    vector<string> lvl = {
        "#.#.#.#.#.#.#.#.#.",
        "##################",
        "##################"
    };

    vector<string> bl = {
        "#.#.#.#.#.#.#.#.#.",
        "##################",
        ".................."
    };

    vector<vector<string>> ans;

    ans.push_back(lvl);
    for (int i = 0; i < comps[topsort[0]].size(); i++) {
        ans.back()[2][i] = '0' + comps[topsort[0]][i] + 1;
    }

    for (int i = 1; i < topsort.size(); i++) {
        int curCompNum = topsort[i];
        auto sp = bl;
        auto fl = lvl;
        for (int j = 0; j <= i; j++) {
            fl[0][2 * j + 1] = '#';
        }

        for (int j = 0; j < comps.size(); j++) {
            if (!gg[curCompNum][j]) continue;
            sp[1][2 * j + 1] = '.';
        }

        ans.push_back(sp);
        ans.push_back(fl);

        for (int j = 0; j < comps[topsort[i]].size(); j++) {
            ans.back()[2][j] = '0' + comps[topsort[i]][j] + 1;
        }
    }

    cout << "18 3 " << ans.size() << endl;
    for (auto &v : ans) {
        for (auto &s : v) {
            cout << s << endl;
        }
        cout << endl;
    }
}
/*
4
0 1 0 1
0 0 1 0
0 1 0 0
1 0 0 0
*/
