#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <fstream>
#include <map>
#include <string>
#include <queue>


using namespace std;

typedef long long lol;
#define fi(i, n, k) for (int (i) = (k); (i) < (n); (i)++)

const lol INF = 2e9;

vector<int> primes;
int cnts[10]; int n;
bool done = false;

void rec(int i)
{	
	int rem = n - 1;
	for (int j = 1; j < i; j++)
	{
		rem -= cnts[j] * primes[j];
	}


	if (rem % primes[0] == 0)
	{
		cnts[0] = rem / primes[0];
		done = true;
	}

	if (i >= primes.size() || done)
		return;

	for (int x = 0; x <= primes[i]; x++)
	{
		bool ok = true;
		for (int j = 0; j < i && ok; j++)
		{
			if (x % primes[j] == 0)
				ok = false;
		}

		if (!ok)
			continue;

		cnts[i] = x;

		rec(i + 1);
		if (done)
			break;
	}
}

lol gcd(lol a, lol b)
{
	if (b == 0)
		return a;
	return gcd(b, a%b);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG

	cin.sync_with_stdio(0);
	cin.tie(0);


	cin >> n;

	int nn = n;
	for (int x = 2; x * x <= nn; x++)
	{
		if (nn % x == 0)
		{
			primes.push_back(x);
		}

		while (nn % x == 0) nn /= x;
	}
	if (nn > 1)
		primes.push_back(nn);

	sort(primes.begin(), primes.end());

	
	rec(1);
	
	if (done)
	{
		cout << "YES\n";
		vector<pair<int, int >> ans;
		for (int j = 0; j < primes.size(); j++)
		{
			if (cnts[j] > 0)
				ans.push_back({ cnts[j], n / primes[j] });
		}

		sort(ans.begin(), ans.end());
		cout << ans.size() << "\n";

		for (auto it : ans)
		{
			cout << it.first << " " << it.second << "\n";
		}
	}
	else
	{
		cout << "NO";
	}

	return (0);
}