#include <bits/stdc++.h>
using namespace std;

struct Trie {
    bool term;
    int to[256];
} T[100005];
void Insert(string& s) {
    int cur = 1;
    static int nxt = 2;
    for (int i = 0; i < (int)s.size(); i++) {
        if (T[cur].to[(int)s[i]] == 0) {
            T[cur].to[(int)s[i]] = nxt++;
        }
        cur = T[cur].to[(int)s[i]];
    }
    T[cur].term = true;
}
bool Reserved(string s) {
    int cur = 1;
    for (int i = 0; i < (int)s.size(); i++) {
        if (T[cur].to[(int)s[i]] == 0) return false;
        cur = T[cur].to[(int)s[i]];
    }
    return T[cur].term;
}

bool Number(string s) {
    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] < '0' || s[i] > '9') return false;
    }
    return true;
}

bool valid_char(char c) {
    if (c >= 'a' && c <= 'z') return true;
    if (c >= 'A' && c <= 'Z') return true;
    if (c >= '0' && c <= '9') return true;
    if (c == '_') return true;
    if (c == '$') return true;
    return false;
}
bool Word(string s) {
    if (s[0] >= '0' && s[0] <= '9') return false;
    for (int i = 0; i < (int)s.size(); i++) {
        if (!valid_char(s[i])) return false;
    }
    return true;
}

enum {
    RESERVED = 0,
    NUMBER,
    WORD
};

struct Token {
    int type;
    string s;
};

vector<Token> ParseLine(string line)
{
    //cout << endl;
    //cout << "Parsing line: " << line << endl;

    vector<Token> ans;

    int L = 0;
    while (L < (int)line.size()) {
        if (line[L] == ' ') {
            L++;
            continue;
        }

        int R = line.size() - 1;

        while (R >= L) {
            string tmp = line.substr(L, R - L + 1);

            if (Reserved(tmp)) {
                //cout << "Reserved:" << tmp << endl;
                ans.push_back({RESERVED, tmp});

                break;
            }
            else if (Word(tmp)) {
                //cout << "Word:" << tmp << endl;
                ans.push_back({WORD, tmp});

                break;
            }
            else if (Number(tmp)) {
                //cout << "Number:" << tmp << endl;
                ans.push_back({NUMBER, tmp});

                break;
            }
            else {
                R--;
                continue;
            }
        }

        L = R + 1;
    }

    return ans;
}

string NXT = "a";
void Inc() {
    for (int i = (int)NXT.size() - 1; i >= 0; i--) {
        if (NXT[i] != 'z') {
            NXT[i]++;
            for (int j = i + 1; j < (int)NXT.size(); j++) {
                NXT[j] = 'a';
            }
            return;
        }
    }

    int c = NXT.size() + 1;
    NXT = "";
    for (int i = 0; i < c; i++) {
        NXT += "a";
    }
}
map<string, string> MP;

string S[1000][1000];
int dp[1000][1000];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    {
        int n;
        cin >> n;
        while (n--) {
            string s;
            cin >> s;
            Insert(s);
        }
    }

    string line;
    getline(cin, line);

    vector<Token> real;

    {
        int M;
        cin >> M;
        getline(cin, line);

        while (M--) {
            getline(cin, line);
            //cout << line << endl;
            int len = 0;
            while (len < (int)line.size() && line[len] != '#') len++;

            vector<Token> tmp = ParseLine(line.substr(0, len));
            for (auto& t : tmp) {
                real.push_back(t);
            }
        }
    }

    for (auto& t : real)
    {
        if (t.type == WORD) {
            if (MP.count(t.s) == 0) {
                while (Reserved(NXT)) Inc();
                MP[t.s] = NXT;
                Inc();
            }
            t.s = MP[t.s];
        }
    }

    //for (auto& t : real) {
    //    cout << t.s << " ";
    //} cout << endl;

    for (int i = 0; i < (int)real.size(); i++) {
        for (int c = 0; c <= i; c++) {
            if (i > 0 && dp[i][c] == 0) continue;

            if (dp[i + 1][c + 1] == 0 || dp[i + 1][c + 1] > dp[i][c] + (int)real[i].s.size()) {
                NXT = "a";
                MP.clear();
                vector<Token> tmp = ParseLine(S[i][c] + real[i].s);

                /*
                if (i == 1 && c == 1) {
                    cout << "OK" << endl;
                    for (auto t : tmp) {
                        cout << t.type << " " << t.s << endl;
                    }
                }
                */

                bool ok = true;
                if ((int)tmp.size() != i + 1) ok = false;
                for (int j = 0; j <= i && ok; j++) {
                    if (real[j].type != tmp[j].type) ok = false;
                    if (real[j].s != tmp[j].s) ok = false;
                }
                if (ok) {
                    dp[i + 1][c + 1] = dp[i][c] + real[i].s.size();
                    S[i + 1][c + 1] = S[i][c] + real[i].s;
                }
            }
            if (dp[i + 1][1] == 0 || dp[i + 1][1] > dp[i][c] + real[i].s.size() + 1) {
                dp[i + 1][1] = dp[i][c] + real[i].s.size() + 1;
                S[i + 1][1] = S[i][c] + " " + real[i].s;
            }
        }
    }

    string ans;

    for (int x = 0; x <= real.size(); x++) {
        if (ans.empty() || (!S[real.size()][x].empty() && S[real.size()][x].size() < ans.size())) {
            ans = S[real.size()][x];
        }
    }

    cout << ans << endl;

    return 0;
}
