#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MX = 1e6 + 100;

namespace Treap {

    const int MT = MX;

    struct Node {
        int LSon, RSon;
        int pr;
        int t, d;
        ll add, value, maxValue, summaD;
    };

    Node T[MT];
    int tt = 0;

    int NewNode(int t, int d, ll val) {
        tt++;
        T[tt].pr = rand();
        T[tt].t = t;
        T[tt].d = d;
        T[tt].value = val;
        T[tt].maxValue = val;
        T[tt].summaD = d;
        return tt;
    }

    void Apply(int v, int d) {
        if (v == 0) return;
        T[v].add += d;
        T[v].maxValue += d;
    }

    void Update(int v) {

        T[v].maxValue = T[v].value;

        T[v].maxValue = max(T[v].maxValue, T[T[v].LSon].maxValue);
        T[v].maxValue = max(T[v].maxValue, T[T[v].RSon].maxValue);

        T[v].maxValue += T[v].add;

        T[v].summaD = T[v].d + T[T[v].LSon].summaD + T[T[v].RSon].summaD;
    }

    void Push(int v) {

        ll delta = T[v].add;
        if (delta == 0) return;

        T[v].value += delta;
        Apply(T[v].LSon, delta);
        Apply(T[v].RSon, delta);

        T[v].add = 0;
    }

    int Merge(int a, int b) {
        if (a == 0 || b == 0) return (a + b);
        int v;

        if (T[a].pr > T[b].pr) {
            Push(a);
            T[a].RSon = Merge(T[a].RSon, b);
            v = a;
        }
        else {
            Push(b);
            T[b].LSon = Merge(a, T[b].LSon);
            v = b;
        }

        Update(v);
        return v;
    }

    void Split(int v, int& a, int& b, int key) {
        a = b = 0;
        if (v == 0) return;

        Push(v);

        if (T[v].t > key) {
            Split(T[v].LSon, a, T[v].LSon, key);
            b = v;
        }
        else {
            Split(T[v].RSon, T[v].RSon, b, key);
            a = v;
        }
        Update(v);
    }

    void Debug(int v) {
        if (v == 0) return;
        Debug(T[v].LSon);
        cout << "{" << T[v].t << ":" << T[v].d << "}";
        Debug(T[v].RSon);
    }


    ll Ask(int& root, int t) {
        int left, right;

        Split(root, left, right, t);

        int res = 0;


        ll summaD = 0;
        if (right > 0)
            summaD = T[right].summaD;

        if (left > 0)
            res = max(T[left].maxValue - summaD, (ll)t) - t;

        root = Merge(left, right);

        return res;
    }

    int Insert(int root, int t, int d) {
        int left, right;
        Split(root, left, right, t);

        Apply(left, d);

        ll val = t + d;
        if (right > 0)
            val += T[right].summaD;

        return Merge(left, Merge(NewNode(t, d, val), right) );
    }

    int Delete(int root, int t) {
        int left, right, med;

        Split(root, left, right, t - 1);
        Split(right, med, right, t);

        Apply(left, -T[med].d);

        return Merge(left, right);
    }




}
int input_t[MX];


int main() {
    char s[10];
    srand(37284);

    int q;
    ignore = scanf("%d", &q);

    int root = 0;

    for (int i = 1; i <= q; i++) {
        ignore = scanf("%s", s);
        if (s[0] == '?') {
            int x;
            ignore = scanf("%d", &x);
            printf("%lld\n", Treap::Ask(root, x));
        }
        else if (s[0] == '+') {
            int t, d;
            ignore = scanf("%d %d", &t, &d);
            root = Treap::Insert(root, t, d);
            input_t[i] = t;
        }
        else if (s[0] == '-') {
            int t;
            ignore = scanf("%d", &t);
            t = input_t[t];
            root = Treap::Delete(root, t);
        }
    }


    return 0;
}
