#include <bits/stdc++.h>
using namespace std;

string to_string(bool x) {
	return x ? "true" : "false";
}

string to_string(char x) {
	return string(1, x);
}

string to_string(string s) {
	return '"' + s + '"';
}

string to_string(const char *s) {
	return to_string((string) s);
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
	return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A>
string to_string(A v) {
	bool first = true;
	string res = "{";
	for (const auto &x : v) {
		if (!first) {
			res += ", ";
		}
		first = false;
		res += to_string(x);
	}
	res += "}";
	return res;
}

void debug_out() {
	cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
	cerr << " " << to_string(H);
	debug_out(T...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 1
#endif

#define all(x) (x).begin(), (x).end()
#define sz(a) (int) (a).size()
#define pb push_back
#define fi first
#define se second
#define two(a) (1LL << (a))
#define has(mask, i) (((mask) >> (i)) & 1)

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;
using vvi = vector<vi>;
using vpii = vector<pii>;
using ld = long double;
using vs = vector<string>;

mt19937_64 rnd((unsigned long) chrono::high_resolution_clock::now().time_since_epoch().count());

const int MAXN = 6;
const int MAXW = 4;
const int MAXP = 202;

int dp[MAXN][MAXW][MAXP][MAXP];

int go(int n, int w, int a, int b) {
	auto &res = dp[n][w][a][b];
	if (res != -1)
		return res;
	if (n == 0) {
		res = (w == 0 && a == 0 && b == 0 ? 1 : 0);
		return res;
	}
	int maxp = (n == 5) ? 15 : 25;
	res = 0;
	for (int ca = maxp; ca <= a; ca++) {
		int ql = (ca == maxp ? 0 : ca - 2);
		int qr = (ca == maxp ? maxp - 2 : ca - 2);
		for (int cb = ql; cb <= qr; cb++) {
			if (a - ca < 0 || b - cb < 0 || w - 1 < 0)
				continue;
			res = max(res, go(n - 1, w - 1, a - ca, b - cb));
		}
	}
	for (int cb = maxp; cb <= b; cb++) {
		int ql = (cb == maxp ? 0 : cb - 2);
		int qr = (cb == maxp ? maxp - 2 : cb - 2);
		for (int ca = ql; ca <= qr; ca++) {
			if (a - ca < 0 || b - cb < 0)
				continue;
			res = max(res, go(n - 1, w, a - ca, b - cb));
		}
	}
	return res;
}

vpii rr;

void recovery(int n, int w, int a, int b) {
	if (n == 0)
		return;
	int maxp = (n == 5) ? 15 : 25;
	for (int ca = maxp; ca <= a; ca++) {
		int ql = (ca == maxp ? 0 : ca - 2);
		int qr = (ca == maxp ? maxp - 2 : ca - 2);
		for (int cb = ql; cb <= qr; cb++) {
			if (a - ca < 0 || b - cb < 0 || w - 1 < 0)
				continue;
			auto to = go(n - 1, w - 1, a - ca, b - cb);	
			if (to) {
				rr.pb({ ca, cb });
				recovery(n - 1, w - 1, a - ca, b - cb);
				return;
			}
		}
	}
	for (int cb = maxp; cb <= b; cb++) {
		int ql = (cb == maxp ? 0 : cb - 2);
		int qr = (cb == maxp ? maxp - 2 : cb - 2);
		for (int ca = ql; ca <= qr; ca++) {
			if (a - ca < 0 || b - cb < 0)
				continue;
			auto to = go(n - 1, w, a - ca, b - cb);
			if (to) {
				rr.pb({ ca, cb });
				recovery(n - 1, w, a - ca, b - cb);
				return;
			}
		}
	}
}

pii find_ans(int a, int b) {
	int ba, bb, minn = INT_MAX;
	ba = -7;
	bb = -1;
	for (int n = 0; n < MAXN; n++) {
		for (int w = 0; w < MAXW; w++) {
			int wa = w;
			int wb = n - w;
			if (wa < 3 && wb < 3)
				continue;
			if (wa >= 3 && wb >= 3)
				continue;
			bool better_diff = (wa - wb > ba - bb);
			bool better = better_diff || ((wa - wb >= ba - bb) && minn > n);
			debug(n, w, a, b, go(n, w, a, b));
			if (go(n, w, a, b) == 1 && better) {
				ba = wa;
				bb = wb;
				minn = n;
			}
		}
	}
	return { ba, bb };
}

void solve() {
	memset(dp, -1, sizeof(dp));
	int Q;
	cin >> Q;
	for (int q = 0; q < Q; q++) {
		int a, b;
		cin >> a >> b;
		pii ans = find_ans(a, b);
		//debug(min(ans.fi, ans.se) <= -1);
		if (min(ans.fi, ans.se) <= -1)
			cout << "Impossible\n";
		else { 
			int n, wa, wb;
			wa = ans.fi;
			wb = ans.se;
			n = wa + wb;
			cout << wa << ":" << wb << "\n";
			rr.clear();
			recovery(n, wa, a, b);
			int rsz = (int)rr.size();
			reverse(all(rr));
			//debug(rr);
			if (rsz == 5)
				swap(rr[0], rr[rsz - 2]);
			for (auto r : rr)
				cout << r.fi << ":" << r.se << " ";
			cout << "\n";
		}
	}
}

int main() {
#ifdef LOCAL
	freopen("xxx.in", "r", stdin);
	freopen("xxx.out", "w", stdout);
	auto start_time = clock();
#else
	
#endif

	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.setf(ios::fixed | ios::showpoint);
	cerr.setf(ios::fixed | ios::showpoint);
	cout.precision(12);
	cerr.precision(4);

	solve();

#ifdef LOCAL
	auto end_time = clock();
	cerr << "time: " << (end_time - start_time) * 1.0 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}