#include <bits/stdc++.h>
using namespace std;

string to_string(bool x) {
	return x ? "true" : "false";
}

string to_string(char x) {
	return string(1, x);
}

string to_string(string s) {
	return '"' + s + '"';
}

string to_string(const char *s) {
	return to_string((string) s);
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
	return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A>
string to_string(A v) {
	bool first = true;
	string res = "{";
	for (const auto &x : v) {
		if (!first) {
			res += ", ";
		}
		first = false;
		res += to_string(x);
	}
	res += "}";
	return res;
}

void debug_out() {
	cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
	cerr << " " << to_string(H);
	debug_out(T...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 1
#endif

#define all(x) (x).begin(), (x).end()
#define sz(a) (int) (a).size()
#define pb push_back
#define fi first
#define se second
#define two(a) (1LL << (a))
#define has(mask, i) (((mask) >> (i)) & 1)

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;
using vvi = vector<vi>;
using vpii = vector<pii>;
using ld = long double;
using vs = vector<string>;

mt19937_64 rnd((unsigned long) chrono::high_resolution_clock::now().time_since_epoch().count());

struct fraq_t {
	ll p, q;
         
    fraq_t() {
    	p = 0; q = 1;
    }

    fraq_t(ll a, ll b) {
    	ll t = __gcd(a, b);
    	p = a / t;
    	q = b / t;
    }

    fraq_t operator + (fraq_t const& f) const {
    	return fraq_t(p * f.q + f.p * q, q * f.q);
    }

    bool operator == (fraq_t const& f) const {
    	return p * f.q == f.p * q;
    }
};

void solve() {
    ll n; cin >> n;
	for(ll i = 2; i * i <= n; i++) {
		if(n % i == 0) {
			ll a = i, b = n / i;
			for(ll c1 = 1; c1 < i; c1++) {
				ll sum = n - 1 - c1 * b;
				if(sum <= 0 || sum % a != 0) continue;
				ll c2 = sum / a;

				cout << "YES\n2\n";
				cout << c1 << ' ' << a << endl;
				cout << c2 << ' ' << b << endl;
				return;
			}
		}
	}
	cout << "NO\n";
}

int main() {
#ifdef LOCAL
	freopen("xxx.in", "r", stdin);
	freopen("xxx.out", "w", stdout);
	auto start_time = clock();
#else
	
#endif

	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.setf(ios::fixed | ios::showpoint);
	cerr.setf(ios::fixed | ios::showpoint);
	cout.precision(12);
	cerr.precision(4);

	solve();

#ifdef LOCAL
	auto end_time = clock();
	cerr << "time: " << (end_time - start_time) * 1.0 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}