#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    assert(freopen("in.txt", "r", stdin));
//    assert(freopen("out.txt", "w", stdout));
#endif
    run();
}

const int N = (int) 3e5 + 123;
const int K = 500;
const int BLOCKS = N / K + 1;

int n, q;
int l[BLOCKS], r[BLOCKS], len[BLOCKS];

vector<int> X;
struct Q {
    char tp;
    int t, d;
    int i;
};

Q qu[N];

int get_ind(int x) {
    return lower_bound(X.begin(), X.end(), x) - X.begin();
}

int state[2 * N];

int advance(int block, int t) {
    if (len[block] == 0) {
        return t;
    }
    if (t <= r[block] - len[block]) {
        return r[block];
    } else {
        return t + len[block];
    }
}

int ask(int t) {
    int p = (int) (upper_bound(X.begin(), X.end(), t) - X.begin());
    int cur_t = 0;
    for (int i = 0; i < p; i++) {
        if (i + K - 1 < p) {
            cur_t = advance(i / K, cur_t);
            continue;
        }
        if (state[i] > 0) {
            if (cur_t <= X[i]) {
                cur_t = X[i] + state[i];
            } else {
                cur_t = cur_t + state[i];
            }
        }
    }
    return max(0, cur_t - t);
}

void recalc(int block) {
    r[block] = 0;
    len[block] = 0;
    int L = K * block;
    int R = L + K;
    int t = 0;
    for (int i = L; i < R; i++) {
        if (state[i] == 0) {
            continue;
        }
        len[i] += state[i];
        if (t <= X[i]) {
            t = X[i] + state[i];
        } else {
            t = t + state[i];
        }
    }
    r[block] = t;
}

void run() {
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> qu[i].tp;
        if (qu[i].tp == '+') {
            cin >> qu[i].t >> qu[i].d;
            n++;
            X.push_back(qu[i].t);
        } else if (qu[i].tp == '-') {
            cin >> qu[i].i;
            qu[i].i--;
        } else {
            cin >> qu[i].t;
        }
    }
    sort(X.begin(), X.end());
    X.resize(unique(X.begin(), X.end()) - X.begin());

    for (int i = 0;i < q; i++) {
        if (qu[i].tp == '+') {
            int p = get_ind(qu[i].t);
            state[p] = qu[i].d;
            recalc(p / K);
        } else if (qu[i].tp == '-') {
            int p = get_ind(qu[i].t);
            state[p] = 0;
            recalc(p / K);
        } else {
            cout << ask(qu[i].t) << "\n";
        }
    }
}
