


#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define en '\n'
#define sp ' '
#define ALL(x) begin(x), end(x)
#define ww(x) #x << " = " << x

using ll = long long;
using pii = pair <int, int>;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

template <class K, class T>
using poc_ht = __gnu_pbds::cc_hash_table<K, T>;

template <class T1, class T2>
T1 eqMin (T1 & a, const T2 & b) {
    if (a > (T1) b) {
        return a = (T1) b;
    }
    return a;
}

template <class T1, class T2>
T1 eqMax (T1 & a, const T2 & b) {
    if (a < (T1) b) {
        return a = (T1) b;
    }
    return a;
}

template<class It>
ostream& _out(ostream& os, It b, It e) {
    if(b == e) return os << "{}";
    os << "{" << *b;
    for(; ++b != e; os << ", " << *b);
    return os << "}\n";
}

template<class C>
auto operator << (ostream& os, C const& c)
-> decltype( begin(c), end(c), c.size(), declval<ostream&>()) {
    return _out(os, begin(c), end(c));
}

ostream& operator << (ostream& os, string const& s) {
    return os << s.data();
}

template<class X,class Y>
ostream& operator << (ostream& os, pair<X, Y> const& p) {
    return os << "[" << p.first << ", " << p.second << "]";
}

template <class T>
using row = vector<T>;
template <class T>
using mat = row<row<T>>;

template <class T>
auto make_mat(size_t n, size_t m, T const& val) {
    return mat<T>(n, row<T>(m, val));
}

const int MOD = (int) 1e9 + 7;
const int INF = (int) 2e9;
const ll LINF = (ll) 2e17;
const int MAXN = (int) 1e5+9;

bool dp[6][6][401][401];
pii back[6][6][401][401];
vector <pii> edgesWin, edgesLose;
vector <pii> edgesWinLast, edgesLoseLast;

void precalc () {
    for (int i = 0; i <= 23; i++) {
        edgesWin.emplace_back(25, i);
        edgesLose.emplace_back(i, 25);
    }
    for (int i = 24; i + 2 <= 200; i++) {
        edgesWin.emplace_back(i + 2, i);
        edgesLose.emplace_back(i, i + 2);
    }

    for (int i = 0; i <= 13; i++) {
        edgesWinLast.emplace_back(15, i);
        edgesLoseLast.emplace_back(i, 15);
    }
    for (int i = 14; i + 2 <= 200; i++) {
        edgesWinLast.emplace_back(i + 2, i);
        edgesLoseLast.emplace_back(i, i + 2);
    }

    dp[0][0][0][0] = true;
    for (int l = 0; l < 6; l++) {
        for (int r = 0; r < 6; r++) {
            if (l + r > 4) {
                continue;
            }
            if (l > 2 || r > 2) {
                continue;
            }

            for (int x = 0; x <= 200; x++) {
                for (int y = 0; y <= 200; y++) {
                    if (!dp[l][r][x][y]) {
                        continue;
                    }
                    if (l + r == 4) {
                        for (auto edge : edgesWinLast) {
                            if (!dp[l + 1][r][x + edge.first][y + edge.second])
                                back[l + 1][r][x + edge.first][y + edge.second] = edge;
                            dp[l + 1][r][x + edge.first][y + edge.second] = true;
                        }
                        for (auto edge : edgesLoseLast) {
                            if (!dp[l][r + 1][x + edge.first][y + edge.second])
                                back[l][r + 1][x + edge.first][y + edge.second] = edge;
                            dp[l][r + 1][x + edge.first][y + edge.second] = true;
                        }
                    }
                    for (auto edge : edgesWin) {
                        if (!dp[l + 1][r][x + edge.first][y + edge.second])
                            back[l + 1][r][x + edge.first][y + edge.second] = edge;
                        dp[l + 1][r][x + edge.first][y + edge.second] = true;
                    }
                    for (auto edge : edgesLose) {
                        if (!dp[l][r + 1][x + edge.first][y + edge.second])
                            back[l][r + 1][x + edge.first][y + edge.second] = edge;
                        dp[l][r + 1][x + edge.first][y + edge.second] = true;
                    }
                }
            }
        }
    }
}

void solve () {
    int n;
    cin >> n;
    while (n--) {
        int x, y;
        cin >> x >> y;
        int bestDif = -100500, l, r;
        for (int i = 0; i <= 5; i++) {
            for (int j = 0; j <= 5; j++) {
                if ((i < 3 && j < 3) || i + j > 5) {
                    continue;
                }
                if (!dp[i][j][x][y]) {
                    continue;
                }

                if (i - j > bestDif) {
                    bestDif = i - j, l = i, r = j;
                }
            }
        }
        if (bestDif == -100500) {
            cout << "Impossible\n";
            continue;
        }


        cout << l << ":" << r << endl;
        vector <pii> ans;
        while (x || y) {
            int bx = back[l][r][x][y].first, by = back[l][r][x][y].second;
            ans.emplace_back(bx, by);
            x -= bx, y -= by;
            if (bx > by) {
                l--;
            } else {
                r--;
            }
        }
        reverse(ALL(ans));
        for (auto game : ans) {
            cout << game.first << ':' << game.second << ' ';
        }
        cout << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    precalc();
    solve();
}

