#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define mp make_pair
#define pb push_back
#define f first
#define s second

const int maxn = 100;
const int inf = 2e9;

vector<int> edge[maxn];
vector<int> redge[maxn];
vector<int> order;
int used[maxn];
int component_num;
int component[maxn];
vector<int> g[maxn];
vector <int> level;
char field[maxn][maxn][maxn];
vector <vector <int>> levels_ver(10);

void dfs(int v) {
    used[v] = true;
    for (auto to : edge[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    order.pb(v);
}

void dfs_rev(int v) {
    used[v] = true;
    component[v] = component_num;
    for (auto to : redge[v]) {
        if (!used[to]) {
            dfs_rev(to);
        }
    }
}


void dfs1(int v) {
    used[v] = 1;
    int lvl = 0;
    for (int i = 0; i < g[v].size(); ++i) {
        lvl = max(lvl, level[g[v][i]] + 1);
        if (!used[g[v][i]]) {
            dfs1(g[v][i]);
            lvl = max(level[g[v][i]] + 1, lvl);
        }
    }
    level[v] = lvl;
}



void preprocess() {
    for (int i = 0; i < 100; ++i) {
        for (int j = 0; j < 100; ++j) {
            for (int k = 0; k < 100; ++k) {
                field[i][j][k] = '.';
            }
        }
    }
    for (int z = 0; z < 100; z += 5) {
        for (int x = 0; x < 100; ++x) {
            for (int y = 0; y < 100; ++y) {
                field[x][y][z] = '#';
            }
        }
        if (z % 2 == 0) {
            for (int x = 10; x < 100; x += 10) {
                for (int y = 0; y < 100; ++y) {
                    for (int i = 1; i < 3; ++i) {
                        field[x][y][z + i] = '#';
                    }
                }
            }
        } else {
            for (int y = 10; y < 100; y += 10) {
                for (int x = 0; x < 100; ++x) {
                    for (int i = 1; i < 3; ++i) {
                        field[x][y][z + i] = '#';
                    }
                }
            }
        }
    }
}




int main()
{
    //freopen("input.txt", "r", stdin);
//    ifstream cin("input.txt");
//    ofstream cout("output.txt");
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j) {
            int x;
            cin >> x;
            if (x) {
                edge[i].pb(j);
                redge[j].pb(i);
            }
        }

    for (int i = 1; i <= n; ++i)
        if (!used[i])
            dfs(i);
    reverse(order.begin(), order.end());
    for (int i = 0; i < maxn; ++i)
        used[i] = 0;
    for (auto v : order) {
        if (!used[v]) {
            ++component_num;
            dfs_rev(v);
        }
    }

    for (int i = 1; i <= n; ++i) {
        for (auto to : edge[i]) {
            if (component[i] != component[to]) {
                g[component[i]].pb(component[to]);
            }
        }
    }
    level.assign(maxn, -inf);
    for (int i = 0; i < maxn; ++i) {
        used[i] = 0;
    }
    for (int i = 1; i <= component_num; ++i) {
        if (!used[i]) dfs1(i);
    }
    for (int i = 1; i <= component_num; ++i) {
        levels_ver[level[i]].pb(i);
    }
    preprocess();
    for (int lvl = 0; lvl < 10; ++lvl) {
        for (int i = 0; i < levels_ver[lvl].size(); ++i) {
            int idx = 1;
            for (int ver = 1; ver <= n; ++ver) {
                if (component[ver] == levels_ver[lvl][i]) {
                    if (lvl % 2 == 0) {
                        field[10*i + idx][0][5 * lvl + 1] = ver + '0';
                    } else {
                        field[0][10*i + idx][5 * lvl + 1] = ver + '0';
                    }
                    ++idx;
                }
            }

            for (int ver : g[levels_ver[lvl][i]]) {
                assert(lvl >= 1);
                idx = -1;
                for (int k = 0; k < levels_ver[lvl - 1].size(); ++k) {
                    if(levels_ver[lvl - 1][k] == ver) {
                        idx = k;
                        break;
                    }
                }
                if (lvl % 2 == 0) {
                    field[0][10*idx + 1][5 * lvl] = '.';
                } else {
                    field[10*idx + 1][0][5 * lvl] = '.';
                }
            }
        }
    }
    cout << "100 100 100\n";
    for (int z = 99; z >= 0; --z) {
        for (int x = 0; x < 100; ++x) {
            for (int y = 0; y < 100; ++y) {
                cout << field[x][y][z];
            }
            cout << '\n';
        }
        cout << "\n\n";
    }
    return 0;
}
