#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define mp make_pair
#define pb push_back
#define f first
#define s second

const int maxn = 100;
const int inf = 2e9;

vector<int> edge[maxn];
vector<int> redge[maxn];
vector<int> order;
int used[maxn];
int component_num;
int component[maxn];
vector<int> g[maxn];

//vector <int> level;
//char field[maxn][maxn][maxn];
//vector <vector <int>> levels_ver(10);

const int max_x = 50;
const int max_y = 500;
const int max_z = 3;

char field[max_x][max_y][max_z];

void dfs(int v) {
    used[v] = true;
    for (auto to : edge[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    order.pb(v);
}

void dfs_rev(int v) {
    used[v] = true;
    component[v] = component_num;
    for (auto to : redge[v]) {
        if (!used[to]) {
            dfs_rev(to);
        }
    }
}


void dfs1(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to])
            dfs1(to);
    }
    order.pb(v);
}


int main()
{
//    freopen("input.txt", "r", stdin);
//    ifstream cin("input.txt");
//    ofstream cout("output.txt");
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j) {
            int x;
            cin >> x;
            if (x) {
                edge[i].pb(j);
                redge[j].pb(i);
            }
        }

    for (int i = 1; i <= n; ++i)
        if (!used[i])
            dfs(i);
    reverse(order.begin(), order.end());
    for (int i = 0; i < maxn; ++i)
        used[i] = 0;
    for (auto v : order) {
        if (!used[v]) {
            ++component_num;
            dfs_rev(v);
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (auto to : edge[i]) {
            if (component[i] != component[to]) {
                g[component[i]].pb(component[to]);
            }
        }
    }

    order.clear();
    for (int i = 0; i < maxn; ++i) {
        used[i] = 0;
    }
    for (int i = 1; i <= component_num; ++i) {
        if (!used[i]) {
            dfs1(i);
        }
    }

    for (int i = 0; i < max_x; ++i)
        for (int j = 0; j < max_y; ++j)
            field[i][j][1] = '#';

    for (int i = 48; i >= 0; i -= 2) {
        for (int j = 0; j < max_y; ++j)
            field[i][j][0] = '#';
    }
    reverse(order.begin(), order.end());
    int x = 49;
    for (auto v : order) {
        int y = 0;
        for (int i = 1; i <=n; ++i)
            if (component[i] == v) {
                field[x][y++][0] = i + '0';
            }
        x -= 2;
    }
    int empty_y = 0;
    for (auto v : order) {
        for (auto to : g[v]) {
            int layer1, layer2;
            for (int i = 0; i < order.size(); ++i)
                if (order[i] == v) {
                    layer1 = 49 - i * 2;
                }
            for (int i = 0; i < order.size(); ++i)
                if (order[i] == to) {
                    layer2 = 49 - i * 2;
                }
            field[layer1][empty_y][1] = '.';

            field[layer2][empty_y][1] = '.';
            field[layer2 - 1][empty_y][2] = '#';
            empty_y += 3;
        }
    }

    for (int i = max_x - 1; i >= 0; --i) {
        for (int j = 0; j < max_y; ++j) {
            for (int k = 0; k < max_z; ++k) {
                if (field[i][j][k] == 0)
                    cout << '.';
                else
                    cout << field[i][j][k];
            }
            cout << endl;
        }
        cout << endl;
    }

//    for (int i = 1; i <= n; ++i) {
//        for (auto to : edge[i]) {
//            if (component[i] != component[to]) {
//                g[component[i]].pb(component[to]);
//            }
//        }
//    }
//    level.assign(maxn, -inf);
//    for (int i = 0; i < maxn; ++i) {
//        used[i] = 0;
//    }
//    for (int i = 1; i <= component_num; ++i) {
//        if (!used[i]) dfs1(i);
//    }
//    for (int i = 1; i <= component_num; ++i) {
//        levels_ver[level[i]].pb(i);
//    }
//    preprocess();
//    for (int lvl = 0; lvl < 10; ++lvl) {
//        for (int i = 0; i < levels_ver[lvl].size(); ++i) {
//            int idx = 1;
//            for (int ver = 1; ver <= n; ++ver) {
//                if (component[ver] == levels_ver[lvl][i]) {
//                    if (lvl % 2 == 0) {
//                        field[10*i + idx][0][5 * lvl + 1] = ver + '0';
//                    } else {
//                        field[0][10*i + idx][5 * lvl + 1] = ver + '0';
//                    }
//                    ++idx;
//                }
//            }
//
//            for (int ver : g[levels_ver[lvl][i]]) {
//                assert(lvl >= 1);
//                idx = -1;
//                for (int k = 0; k < levels_ver[lvl - 1].size(); ++k) {
//                    if(levels_ver[lvl - 1][k] == ver) {
//                        idx = k;
//                        break;
//                    }
//                }
//                if (lvl % 2 == 0) {
//                    field[0][10*idx + 1][5 * lvl] = '.';
//                } else {
//                    field[10*idx + 1][0][5 * lvl] = '.';
//                }
//            }
//        }
//    }
//    cout << "100 100 100\n";
//    for (int z = 99; z >= 0; --z) {
//        for (int x = 0; x < 100; ++x) {
//            for (int y = 0; y < 100; ++y) {
//                cout << field[x][y][z];
//            }
//            cout << '\n';
//        }
//        cout << "\n\n";
//    }
//    return 0;
}
