#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

#define ll long long

const int maxn = 510;
vector <int> ed[maxn];
int dst[maxn][maxn];

int n;

void bfs(int v) {
    for (int i = 1; i <= n; i++) {
        dst[v][i] = -1;
    }

    dst[v][v] = 0;

    queue <int> q;

    q.push(v);

    while (!q.empty()) {
        int u = q.front();
        q.pop();

        for (int i = 0; i < (int)ed[u].size(); i++) {
            int to = ed[u][i];

            if (dst[v][to] == -1) {
                dst[v][to] = dst[v][u] + 1;
                q.push(to);
            }
        }
    }
}

int val[maxn];

void go(vector <int> al, int num) {
    if (al.empty()) {
        exit(0);
    }

    if (num == 10) {
        throw 1;
    }

    for (int i = 1; i <= n; i++) {
        val[i] = 0;
        for (int j = 0; j < (int)ed[i].size(); j++) {
            int u = ed[i][j];

            int cur = 0;

            for (int k = 0; k < (int)al.size(); k++) {
                int v = al[k];

                if (dst[v][u] < dst[v][i]) {
                    cur++;
                }
            }

            val[i] = max(val[i], cur);
        }
    }

    int best = 1;

    for (int i = 2; i <= n; i++) {
        if (val[i] < val[best]) {
            best = i;
        }
    }

    cout << best << endl;

    string s;

    cin >> s;

    if (s[0] == 'F') {
        return;
    }

    int x;

    cin >> x;

    vector <int> nal;

    for (int i = 0; i < (int)al.size(); i++) {
        int v = al[i];

        if (dst[v][x] < dst[v][best]) {
            nal.push_back(v);
        }
    }

    go(nal, num + 1);
}

int main() {
    int m;

    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int k;

        scanf("%d", &k);

        int prev = -1;

        for (int j = 0; j < k; j++) {
            int x;

            scanf("%d", &x);

            if (j != 0) {
                ed[prev].push_back(x);
                ed[x].push_back(prev);
            }

            prev = x;
        }
    }

    for (int i = 1; i <= n; i++) {
        bfs(i);
    }

    vector <int> al;

    for (int i = 1; i <= n; i++) {
        al.push_back(i);
    }

    for (int i = 1; i <= n; i++) {
        go(al, 0);
    }

    return 0;
}
