#include <iostream>
#include <vector>
#include <set>
#include <fstream>
#include <cassert>
#include <memory.h>
#include <queue>
#include <map>
#include <algorithm>

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

ll ans = 0;
const int inf = 1e9;

void compressLeaves(vector<vector<int> >& g, vector<int>& a) {
    int n = sz(g);
    vector<int> deg(n);
    for (int i = 0; i < n; ++i) {
        deg[i] = sz(g[i]);
    }
    queue<int> q;
    vector<bool> alive(n, true);
    vector<bool> used(n, false);
    for (int i = 0; i < n; ++i) {
        if (deg[i] <= 1) {
            q.push(i);
            used[i] = true;
        }
    }
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        int u = -1;
        for (int to : g[v]) {
            if (alive[to]) {
                u = to;
            }
        }
        if (u == -1) {
            continue;
        }
        --deg[u];
        if (deg[u] <= 1 && !used[u]) {
            q.push(u);
        }
        ans += ll(a[v]) * (n - a[v]);
        alive[v] = false;
        a[u] += a[v];
    }
    vector<int> newId(n);
    int cc = 0;
    for (int i = 0; i < n; ++i) {
        if (alive[i]) {
            newId[i] = cc++;
        } else {
            newId[i] = -1;
        }
    }
    vector<vector<int> > h(cc);
    vector<int> b(cc);
    for (int i = 0; i < n; ++i) {
        if (!alive[i]) {
            continue;
        }
        for (int to : g[i]) {
            if (alive[to]) {
                h[newId[i]].pb(newId[to]);
            }
        }
        b[newId[i]] = a[i];
    }
    g.swap(h);
    a.swap(b);
}

struct datum {
    int from, to;
    vector<int> vct;
};

ll solve(vector<ll> d, vector<ll> a) {
    int n = sz(a);
    int cntL, cntR;
    ll sumL, sumR;
    ll valL, valR;
    ll lenL = 0, lenR = 0;
    for (int i = 0; i < n; ++i) {
        lenR += d[i];
    }
    int pos = 0;
    while (lenL + d[pos] <= lenR - d[pos]) {
        lenL += d[pos];
        lenR -= d[pos];
        ++pos;
    }
    cntL = pos;
    cntR = n - pos - 1;
    sumL = 0, valL = 0;
    for (int i = 1; i <= pos; ++i) {
        sumL += a[i];
        valL += a[i] * i;
    }
    sumR = 0, valR = 0;
    for (int i = n - 1, zz = 1; i > pos; --i, ++zz) {
        sumR += a[i];
        valR += a[i] * zz;
    }
    ll ans = a[0] * (sumL + sumR);

    for (int i = 1; i < n; ++i) {
        lenL -= d[i - 1];
        lenR += d[i - 1];
        valL -= sumL;
        --cntL;
        ++cntR;
        sumL -= a[i] * d[i - 1];
        valR += sumR;
        valR += a[i - 1] * d[i - 1];
        sumR += a[i - 1] * d[i - 1];
        while (lenL + d[pos] <= lenR - d[pos]) {
            lenL += d[pos];
            lenR -= d[pos];
            ++pos;
            if (pos == n) {
                pos = 0;
            }
            ++cntL;
            sumL += a[pos] * d[pos];
            valL += a[pos] * cntL * d[pos];
            sumR -= a[pos] * d[pos];
            valR -= a[pos] * cntR * d[pos];
            --cntR;
        }
        ans += a[i] * (sumL + sumR);
    }
    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //ifstream cin("input.txt");
    //ofstream cout("output.txt");

    int n, m;
    cin >> n >> m;

    vector<vector<int> > g(n);
    vector<int> a(n, 1);

    while (m--) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].pb(v);
        g[v].pb(u);
    }

    compressLeaves(g, a);
    n = sz(g);
    /*cout << ans << "\n";
    for (int v = 0; v < n; ++v) {
        for (int to : g[v]) {
            cout << v << " " << to << "\n";
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << a[i] << " ";
    }*/

    if (n == 1) {
        cout << ans << "\n";
        return 0;
    }

    vector<int> id(n, -1);
    int b = 0;
    for (int i = 0; i < n; ++i) {
        if (sz(g[i]) > 2) {
            id[i] = b++;
        }
    }

    if (b == 0) {
        vector<int> order;
        vector<bool> used(n, false);
        used[0] = true;
        order.pb(0);
        int curr = 0;
        for (int i = 0; i < n - 1; ++i) {
            int nx = -1;
            for (int to : g[curr]) {
                if (used[to]) {
                    continue;
                }
                nx = to;
            }
            assert(nx != -1);
            order.pb(nx);
            used[nx] = true;
            curr = nx;
        }
        vector<int> pref(n);
        vector<int> vct(n);
        for (int i = 0; i < n; ++i) {
            vct[i] = a[order[i]];
        }
        a.swap(vct);

        ll sum = 0;
        ll val = 0;
        for (int i = 1; i <= n / 2; ++i) {
            sum += a[i];
            val += ll(i) * a[i];
        }
        ans += val * a[0];
        int j = n / 2;
        for (int i = 1; i < n; ++i) {
            val -= sum;
            ++j;
            if (j == n) {
                j = 0;
            }
            sum -= a[i];
            sum += a[j];
            val += ll(n / 2) * a[j];
            ans += val * a[i];
        }
        if (n % 2 == 0) {
            for (int i = 0; i + n / 2 < n; ++i) {
                ans -= ll(n / 2) * a[i] * a[i + n / 2];
            }
        }
        cout << ans << "\n";
        return 0;
    }

    vector<vector<int> > dist(b, vector<int>(b, inf));
    vector<int> edge(n);
    vector<int> edgePos(n);
    vector<datum> data;
    for (int i = 0; i < n; ++i) {
        edge[i] = -1;
    }
    int ptr = 0;

    for (int i = 0; i < n; ++i) {
        if (id[i] != -1 || edge[i] != -1) {
            continue;
        }
        vector<int> vis;
        vector<int> goal;
        queue<int> q;
        q.push(i);
        edge[i] = ptr;
        int lst;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int to : g[v]) {
                if (edge[to] != -1) {
                    continue;
                }
                if (id[to] != -1) {
                    goal.pb(to);
                    lst = v;
                } else {
                    vis.pb(to);
                    q.push(to);
                    edge[to] = ptr;
                }
            }
        }
        ++ptr;
        assert(sz(goal) == 2);
        swap(goal[0], goal[1]);
        vector<int> ord;
        int curr = lst;
        int pr = goal[0];
        ord.pb(curr);
        edgePos[curr] = 0;
        while (true) {
            int nx = -1;
            for (int to : g[curr]) {
                if (to == pr) {
                    continue;
                }
                nx = to;
            }
            if (nx == goal[1]) {
                break;
            }
            pr = curr;
            curr = nx;
            ord.pb(curr);
            edgePos[curr] = sz(ord) - 1;
        }
        data.pb({goal[0], goal[1], ord});
    }

    /*for (int i = 0; i < n; ++i) {
        cout << edge[i] << "\n";
    }*/

    /*for (int i = 0; i < sz(data); ++i) {
        cout << data[i].from +1<< " " << data[i].to +1<< "\n";
        for (int v : data[i].vct) {
            cout << v+1 << " ";
        }
        cout << "\n";
    }*/

    for (int i = 0; i < sz(data); ++i) {
        int u = id[data[i].from], v = id[data[i].to];
        int len = sz(data[i].vct) + 1;
        dist[u][v] = min(dist[u][v], len);
        dist[v][u] = min(dist[v][u], len);
    }

    for (int k = 0; k < b; ++k) {
        for (int i = 0; i < b; ++i) {
            for (int j = 0; j < b; ++j) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }

    vector<vector<ll> > sum(sz(data) * 2);
    vector<vector<ll> > val(sz(data) * 2);
    for (int i = 0; i < sz(data); ++i) {
        sum[i * 2].resize(sz(data[i].vct));
        val[i * 2].resize(sz(data[i].vct));
        sum[i * 2][0] = a[data[i].vct[0]];
        val[i * 2][0] = a[data[i].vct[0]];
        for (int j = 1; j < sz(data[i].vct); ++j) {
            sum[i * 2][j] = sum[i * 2][j - 1] + a[data[i].vct[j]];
            val[i * 2][j] = val[i * 2][j - 1] + ll(j + 1) * a[data[i].vct[j]];
        }

        reverse(all(data[i].vct));
        sum[i * 2 + 1].resize(sz(data[i].vct));
        val[i * 2 + 1].resize(sz(data[i].vct));
        sum[i * 2 + 1][0] = a[data[i].vct[0]];
        val[i * 2 + 1][0] = a[data[i].vct[0]];
        for (int j = 1; j < sz(data[i].vct); ++j) {
            sum[i * 2 + 1][j] = sum[i * 2 + 1][j - 1] + a[data[i].vct[j]];
            val[i * 2 + 1][j] = val[i * 2 + 1][j - 1] + ll(j + 1) * a[data[i].vct[j]];
        }
        reverse(all(data[i].vct));
    }

    ll got = 0;
    for (int i = 0; i < n; ++i) {
        if (id[i] != -1) {
            continue;
        }
        for (int e = 0; e < sz(data); ++e) {
            if (e == edge[i]) {
                continue;
            }
            int u1 = id[data[edge[i]].from];
            int v1 = id[data[edge[i]].to];
            int u2 = id[data[e].from];
            int v2 = id[data[e].to];
            int du = min(edgePos[i] + 1 + dist[u1][u2],
                         sz(data[edge[i]].vct) - edgePos[i] + dist[v1][u2]);
            int dv = min(edgePos[i] + 1 + dist[u1][v2],
                         sz(data[edge[i]].vct) - edgePos[i] + dist[v1][v2]);
            int s = sz(data[e].vct);
            //cout << du << " " << dv << endl;
            if (dv + s - du - 1 < 0) {
                got += sum[e * 2 + 1].back() * dv * a[i] + val[e * 2 + 1].back() * a[i];
                //cout << "Z" << got << endl;
            } else {
                int k = (dv + s - du - 1) / 2;
                if (k >= s) {
                    got += sum[e * 2].back() * dv * a[i] + val[e * 2].back() * a[i];
                } else {
                    got += sum[e * 2][k] * du * a[i] + val[e * 2][k] * a[i];
                    if (s - k - 2 >= 0) {
                        got += sum[e * 2 + 1][s - k - 2] * dv * a[i] + val[e * 2 + 1][s - k - 2] * a[i];
                        //cout << "!" << got << endl;
                    }
                }

            }
        }
    }

    ans += got / 2;
    got = 0;

    for (int i = 0; i < n; ++i) {
        if (id[i] == -1) {
            continue;
        }
        for (int e = 0; e < sz(data); ++e) {
            int w = id[i];
            int u2 = id[data[e].from];
            int v2 = id[data[e].to];
            int du = dist[w][u2];
            int dv = dist[w][v2];
            int s = sz(data[e].vct);
            if (dv + s - du - 1 < 0) {
                got += sum[e * 2 + 1].back() * dv * a[i] + val[e * 2 + 1].back() * a[i];
            } else {
                int k = (dv + s - du - 1) / 2;

                if (k >= s) {
                    got += sum[e * 2].back() * dv * a[i] + val[e * 2].back() * a[i];
                } else {
                    got += sum[e * 2][k] * du * a[i] + val[e * 2][k] * a[i];
                    if (s - k - 2 >= 0) {
                        got += sum[e * 2 + 1][s - k - 2] * dv * a[i] + val[e * 2 + 1][s - k - 2] * a[i];
                        //cout << "!" << got << endl;
                    }
                }
            }
        }
    }

    ans += got;

    vector<int> cc;
    for (int i = 0; i < n; ++i) {
        if (id[i] != -1) {
            cc.pb(i);
        }
    }

    for (int i = 0; i < b; ++i) {
        for (int j = i + 1; j < b; ++j) {
            ans += dist[i][j] * a[cc[i]] * a[cc[j]];
        }
    }

    for (int i = 0; i < sz(data); ++i) {
        int u = id[data[i].from];
        int v = id[data[i].to];
        vector<ll> aa = {0};
        for (int j : data[i].vct) {
            aa.pb(a[j]);
        }
        aa.pb(0);
        vector<ll> dd;
        for (int i = 0; i < sz(aa) - 1; ++i) {
            dd.pb(1);
        }
        dd.pb(1 + dist[u][v]);
        ans += solve(dd, aa) / 2;
        //cout << "!" << solve(dd, aa) << endl;
    }

    cout << ans << "\n";

}
