#include <iostream>
#include <vector>
#include <set>
#include <fstream>
#include <cassert>
#include <memory.h>
#include <map>
#include <algorithm>

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int MAXN = 410;

int p;
int fact[MAXN];

int ans[MAXN][MAXN];
int f[MAXN][MAXN];

void mul(int &a, int b) {
    ll c = (ll) a * b;
    c %= p;
    a = c;
}

void add(int &a, int b) {
    a += b;
    if (a >= p) {
        a -= p;
    }
}

void sub(int &a, int b) {
    a -= b;
    if (a < 0) {
        a += p;
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    // ifstream cin("input.txt");
    // ofstream cout("output.txt");

    int tests;
    cin >> tests >> p;


    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        fact[i] = fact[i - 1];
        mul(fact[i], i);
    }

    f[0][0] = 1;
    for (int i = 0; i < MAXN - 1; ++i) {
        for (int j = 0; j <= i; ++j) {
            for (int k = 1; i + k < MAXN; ++k) {
                int cur = fact[k];
                mul(cur, f[i][j]);
                add(f[i + k][j + 1], cur);
            }
        }
    }

    for (int i = 1; i < MAXN; ++i) {
        for (int j = 2; j < i; ++j) {
            ans[i][j] = f[i][j];
            mul(ans[i][j], ans[j][j]);
        }
        ans[i][i] = fact[i];
        for (int j = 2; j < i; ++j) {
            sub(ans[i][i], ans[i][j]);
        }
    }

    /*for (int i = 1; i <= 2; ++i) {
        for (int j = 0; j <= i; ++j) {
            cout << i << " " << j << " " << f[i][j] << endl;
        }
    }*/

    for (int i = 2; i < MAXN; ++i) {
        if (i % 2 == 0) {
            sub(ans[i][i], 2);
        } else {
            add(ans[i][i], 2);
        }
    }

    for (int i = 0; i < tests; ++i) {
        int k;
        cin >> k;

        cout << ans[k][k] << endl;
    }



}
