#include <iostream>
#include <vector>
#include <set>
#include <fstream>
#include <cassert>
#include <memory.h>
#include <map>
#include <algorithm>

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int sigma = 256;

struct node {
    int to[sigma];
    bool term;
    node() {
        memset(to, -1, sizeof(to));
        term = false;
    }
};

vector<node> t;

void add(const string& s) {
    int v = 0;
    for (int i = 0; i < sz(s); ++i) {
        if (t[v].to[s[i]] == -1) {
            t[v].to[s[i]] = sz(t);
            t.pb(node());
        }
        v = t[v].to[s[i]];
    }
    t[v].term = true;
}

bool valid(char c) {
    if (isalpha(c)) {
        return true;
    }
    if (isdigit(c)) {
        return true;
    }
    return (c == '_' || c == '$');
}

int getMaxWord(const string& s) {
    int pos = 0;
    while (pos < sz(s) && valid(s[pos])) {
        ++pos;
    }
    if (isdigit(s[0])) {
        return 0;
    }
    return pos;
}

int getMaxDigit(const string& s) {
    int pos = 0;
    while (pos < sz(s) && isdigit(s[pos])) {
        ++pos;
    }
    return pos;
}

int getMaxRes(const string& s) {
    int ans = 0;
    int v = 0;
    for (int i = 0; i < sz(s); ++i) {
        if (t[v].to[s[i]] == -1) {
            return ans;
        }
        v = t[v].to[s[i]];
        if (t[v].term) {
            ans = i + 1;
        }
    }
    return ans;
}

set<string> setik;

void inc(string& s) {
    int f = -1;
    for (int j = sz(s) - 1; j >= 0; --j) {
        if (s[j] != 'z') {
            f = j;
            break;
        }
    }
    if (f == -1) {
        int k = sz(s);
        string ans = "";
        for (int i = 0; i <= k; ++i) {
            ans += "a";
        }
        s = ans;
        if (setik.count(s)) {
            inc(s);
        }
        return;
    }
    ++s[f];
    for (int j = f + 1; j < sz(s); ++j) {
        s[j] = 'a';
    }
    if (setik.count(s)) {
        inc(s);
    }
}

const int nmax = 80 * 40 + 10;

bool dp[nmax][nmax];
int llenw[nmax];
int llend[nmax];
int llenr[nmax];
int ttot[nmax];
int vv[nmax];
int pref[nmax];
int p[nmax];

const int inf = 1e9;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //ifstream cin("input.txt");
    //ofstream cout("output.txt");

    int n;
    cin >> n;

    t.pb(node());

    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        add(s);
        setik.insert(s);
    }

    int q;
    cin >> q;

    string s;
    getline(cin, s);

    vector<string> tokens;
    map<string, string> mapa;
    string curr = "a";

    while (q--) {
        getline(cin, s);
        while (s != "") {
            if (s[0] == ' ') {
                s = s.substr(1, sz(s) - 1);
                continue;
            }
            if (s[0] == '#') {
                break;
            }
            int lenw = getMaxWord(s);
            int lend = getMaxDigit(s);
            int lenr = getMaxRes(s);
            int x = max({lenw, lend, lenr});
            //cerr << s << endl;

            string t = s.substr(0, x);
            if (!setik.count(t) && !isdigit(t[0])) {
                if (mapa.count(t)) {
                    tokens.pb(mapa[t]);
                } else {
                    mapa[t] = curr;
                    tokens.pb(curr);
                    inc(curr);
                }
            } else {
                tokens.pb(t);
            }
            s = s.substr(x, sz(s) - x);
        }
    }

    /*for (int i = 0; i < sz(tokens); ++i) {
        cout << tokens[i] << "\n";
    }*/

    for (int i = 0; i < sz(tokens); ++i) {
        dp[i][i] = true;
        int lenw = 0;
        while (lenw < sz(tokens[i]) && valid(tokens[i][lenw])) {
            ++lenw;
        }
        if (isdigit(tokens[i][0])) {
            lenw = 0;
        }
        int lend = 0;
        while (lend < sz(tokens[i]) && isdigit(tokens[i][lend])) {
            ++lend;
        }
        int v = 0;
        int lenr = 0;
        int tot = 0;
        for (int j = 0; j < sz(tokens[i]); ++j) {
            ++tot;
            if (t[v].to[tokens[i][j]] == -1) {
                v = -1;
                break;
            }
            v = t[v].to[tokens[i][j]];
            if (t[v].term) {
                lenr = tot;
            }
        }
        tot = sz(tokens[i]);
        llenw[i] = lenw;
        llend[i] = lend;
        llenr[i] = lenr;
        ttot[i] = tot;
        vv[i] = v;
    }

    for (int len = 2; len <= sz(tokens); ++len) {
        for (int i = 0; i + len - 1 < sz(tokens); ++i) {
            int j = i + len - 1;
            int lenw = llenw[i];
            int lend = llend[i];
            int lenr = llenr[i];
            int tot = ttot[i];
            int v = vv[i];
            {
                if (lenw == tot) {
                    while (lenw - tot < sz(tokens[j]) && valid(tokens[j][lenw - tot])) {
                        ++lenw;
                    }
                }
                if (lend == tot) {
                    while (lend - tot < sz(tokens[j]) && isdigit(tokens[j][lend - tot])) {
                        ++lend;
                    }
                }
                int z = tot;
                if (v != -1) {
                    for (int u = 0; u < sz(tokens[j]); ++u) {
                        if (t[v].to[tokens[j][u]] == -1) {
                            v = -1;
                            break;
                        }
                        v = t[v].to[tokens[j][u]];
                        ++tot;
                        if (t[v].term) {
                            lenr = tot;
                        }
                    }
                }
                tot = z + sz(tokens[j]);
                /*if (i == 1 && j == 3) {
                    cout << lenw << " " << lenr << " " << lend << endl;
                }*/
                int x = max({lenw, lenr, lend});
                //cout << x << " " << tokens[i] << endl;
                if (x == sz(tokens[i]) && dp[i + 1][j]) {
                    dp[i][j] = true;
                } else {
                    dp[i][j] = false;
                }
            }

            llenw[i] = lenw;
            llend[i] = lend;
            llenr[i] = lenr;
            ttot[i] = tot;
            vv[i] = v;
        }
    }

    /*for (int j = 2; j < sz(tokens); ++j) {
        if (dp[1][j]) {
            cout << "!" << j << endl;
        }
    }*/

    pref[0] = 0;
    for (int i = 1; i < sz(tokens); ++i) {
        pref[i] = inf;
        for (int j = i; j >= 0; --j) {
            if (dp[j][i]) {
                int val = 0;
                if (j) {
                    val = pref[j - 1] + 1;
                }
                if (val < pref[i]) {
                    pref[i] = val;
                    p[i] = j;
                }
            }
        }
    }

    vector<string> ans;
    int i = sz(tokens) - 1;
    while (i >= 0) {
        int j = p[i];
        s = "";
        for (int u = j; u <= i; ++u) {
            s += tokens[u];
        }
        i = j - 1;
        ans.pb(s);
    }

    reverse(all(ans));
    for (int i = 0; i < sz(ans); ++i) {
        cout << ans[i];
        if (i != sz(ans) - 1) {
            cout << ' ';
        }
    }
    cout << "\n";

}
