#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

#define ll long long

struct vt {
    int t;
    int y;
    int d;
    ll sumd;
    ll val;
    ll ch;
    ll maxx;
    int l, r;

    vt() {

    }

    vt(int t, int d): t(t), y(rand()), d(d), sumd(d), val(t + d), ch(0), maxx(t + d), l(-1), r(-1) {

    }
};

const int maxn = (int)3e5 + 10;

vt mas[maxn];
int posit = 0;

int my_new(int t, int d) {
    mas[posit] = vt(t, d);
    return posit++;
}

void sets(int t, ll x) {
    if (t != -1) {
        mas[t].val += x;
        mas[t].ch += x;
        mas[t].maxx += x;
    }
}

void push(int t) {
    if (mas[t].ch != 0) {
        sets(mas[t].l, mas[t].ch);
        sets(mas[t].r, mas[t].ch);
        mas[t].ch = 0;
    }
}

ll sumd(int t) {
    return (t == -1 ? 0 : mas[t].sumd);
}

ll maxx(int t) {
    return (t == -1 ? 0 : mas[t].maxx);
}

void recalc(int t) {
    mas[t].sumd = mas[t].d + sumd(mas[t].l) + sumd(mas[t].r);
    mas[t].maxx = max(max(maxx(mas[t].l), maxx(mas[t].r)), mas[t].val);
}

int merge(int l, int r) {
    if (l == -1) {
        return r;
    }

    if (r == -1) {
        return l;
    }

    if (mas[l].y > mas[r].y) {
        push(l);
        mas[l].r = merge(mas[l].r, r);
        recalc(l);
        return l;
    } else {
        push(r);
        mas[r].l = merge(l, mas[r].l);
        recalc(r);
        return r;
    }
}

void split(int t, int tm, int &l, int &r) {
    if (t == -1) {
        l = -1;
        r = -1;
    } else if (mas[t].t > tm) {
        push(t);
        split(mas[t].l, tm, l, mas[t].l);
        recalc(t);
        r = t;
    } else {
        push(t);
        split(mas[t].r, tm, mas[t].r, r);
        recalc(t);
        l = t;
    }
}

void add(int &t, int tm, int d) {
    int l, r;

    split(t, tm, l, r);

    sets(l, d);
    int m = my_new(tm, d);
    mas[m].val += sumd(r);
    mas[m].maxx += sumd(r);
    t = merge(merge(l, m), r);
}

void del(int &t, int tm, int d) {
    int l, m, r;

    split(t, tm - 1, l, r);

    split(r, tm, m, r);

    sets(l, -d);

    t = merge(l, r);
}

ll query(int &t, int tm) {
    int l, r;

    split(t, tm, l, r);

    ll ans = maxx(l) - sumd(r);

    t = merge(l, r);

    return ans;
}

int tm[maxn], d[maxn];

int main() {
    //freopen("input.txt", "r", stdin);
    int t = -1;

    int q;

    cin >> q;

    for (int i = 1; i <= q; i++) {
        char c;

        scanf(" %c", &c);

        if (c == '+') {
            int tt, dd;

            scanf("%d %d", &tt, &dd);

            add(t, tt, dd);

            tm[i] = tt;
            d[i] = dd;
        } else if (c == '-') {
            int pos;

            scanf("%d", &pos);

            del(t, tm[pos], d[pos]);
        } else {
            int tt;

            scanf("%d", &tt);

            ll prev = query(t, tt);

            if (prev < tt) {
                printf("0\n");
            } else {
                printf("%lld\n", prev - tt);
            }
        }
    }

    return 0;
}
