#include <iostream>
#include <vector>
#include <set>
#include <fstream>
#include <cassert>
#include <algorithm>

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int nmax = 15;

int g[nmax][nmax];
int n;

vector<int> order;
vector<bool> used;

void dfs1(int v) {
    used[v] = true;
    for (int to = 0; to < n; ++to) {
        if (g[v][to] && !used[to]) {
            dfs1(to);
        }
    }
    order.pb(v);
}

vector<int> compId;
vector<vector<int> > comps;

void dfs2(int v, int x) {
    compId[v] = x;
    comps.back().pb(v);
    for (int to = 0; to < n; ++to) {
        if (g[to][v] && compId[to] == -1) {
            dfs2(to, x);
        }
    }
}

int h[nmax][nmax];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //ifstream cin("input.txt");
    //ofstream cout("output.txt");

    cin >> n;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> g[i][j];
        }
    }

    used.assign(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i);
        }
    }

    reverse(all(order));
    compId.assign(n, -1);
    int cc = 0;
    for (int v : order) {
        if (compId[v] != -1) {
            continue;
        }
        comps.pb(vector<int>());
        dfs2(v, cc);
        ++cc;
    }

    string de = "";
    for (int i = 0; i < n * cc; ++i) {
        de += "#";
    }
    vector<string> occ;
    for (int i = 0; i < 2 * cc - 1; ++i) {
        occ.pb(de);
    }

    vector<vector<string> > vct;
    vector<string> c;

    for (int i = 0; i < 2 * cc - 1; ++i) {
        string s = "";
        for (int j = 0; j < n * cc; ++j) {
            s += "#";
        }
        if (i % 2 == 0) {
            for (int j = n * (i / 2); j < n * (i / 2) + n; ++j) {
                s[j] = '.';
            }
            int pos = 0;
            for (int j = n * (i / 2); pos < sz(comps[i / 2]); ++j, ++pos) {
                s[j] = char(comps[i / 2][pos] + '0');
            }
        }
        c.pb(s);
    }

    /*for (int i = 0; i < sz(c); ++i) {
        cout << c[i] << "\n";
    }*/

    vct.pb(c);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (compId[i] == compId[j] || !g[i][j]) {
                continue;
            }
            h[compId[i]][compId[j]] = 1;
        }
    }

    vector<int> ptr(n);

    for (int i = 0; i < cc; ++i) {
        for (int j = i + 1; j < cc; ++j) {
            if (!h[i][j]) {
                continue;
            }
            vct.pb(occ);
            vct.pb(occ);
            int x1 = 2 * i, y1 = n * i + ptr[i];
            int x2 = 2 * j, y2 = n * j + ptr[j];
            for (int u = 1; u < sz(vct); ++u) {
                vct[u][x1][y1] = '.';
            }

            for (int z = x1; z <= x2; ++z) {
                vct.back()[z][y1] = '.';
            }

            for (int z = y1; z <= y2; ++z) {
                vct.back()[x2][z] = '.';
            }

            for (int u = 1; u < sz(vct); ++u) {
                vct[u][x2][y2] = '.';
            }

            ++ptr[i], ++ptr[j];
        }
    }

    cout << n * cc << " " << sz(vct) << " " << 2 * cc - 1 << "\n";
    for (int i = 0; i < 2 * cc - 1; ++i) {
        for (int u = 0; u < sz(vct); ++u) {
            for (int j = 0; j < n * cc; ++j) {
                cout << vct[u][i][j];
            }
            cout << "\n";
        }
        cout << "\n";
        if (i != 2 * cc - 2) {
            cout << "\n";
        }
    }

}
