#include <bits/stdc++.h>

using namespace std;

const int maxn = 512;
int n;
vector<int> graph[maxn];

int dist[maxn][maxn];

void floyd() {
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (i != j)
                dist[i][j] = 1179;
    for (int i = 0; i < n; i++)
        for (int v : graph[i])
            dist[i][v] = 1;
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++)
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
        }
    }
}

struct edge {
    int by_edge;
    int v;
};

int get(bitset<maxn> b) {
    for (int i = 0; i < n; i++)
        if (b[i])
            return i;
}

int root;
vector<edge> tree[maxn];
bitset<maxn> enabled[maxn];

void build(bitset<maxn> en, int& rt) {
    if (en.count() == 1) {
        rt = get(en);
        enabled[rt] = en;
        return;
    }
    int brt = -1, rtv = 1179;
    for (int v = 0; v < n; v++) {
        if (!en[v])
            continue;
        int vv = 0;
        for (int u : graph[v]) {
            if (!en[u])
                continue;
            int cnt = 0;
            for (int w  = 0; w < n; w++) {
                if (!en[w])
                    continue;
                if (dist[u][w] < dist[v][w])
                cnt++;
            }
            vv = max(vv, cnt);
        }
        if (vv < rtv) {
            rtv = vv;
            brt = v;    
        }
    }
    
    rt = brt;
    enabled[rt] = en;

    for (int u : graph[brt]) {
        if (!en[u])
            continue;
        bitset<maxn> b;
        for (int w = 0; w < n; w++) {
            if (!en[w])
                continue;
            if (dist[u][w] < dist[brt][w])
                b[w] = true;
        }
        int nrt;
        build(b, nrt);
        tree[brt].push_back(edge { u, nrt });
    }
}

void build() {
    bitset<maxn> b;
    b.set();
    build(b, root);     
}

int main() {
    int m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        int v;
        cin >> v;
        v--;
        for (int j = 1; j < k; j++) {
            int u;
            cin >> u;
            u--;
            graph[v].push_back(u);
            graph[u].push_back(v);
            v = u;
        }
    }

    floyd();
    build();

    for (int i = 0; i < n; i++) {
        int cur = root;
        bool f = false;
        while (enabled[cur].count() > 1) {
            cout << cur + 1 << endl;
            string s; int u;
            cin >> s;
            if (s == "FOUND") {
                f = true;
                break;
            }
            cin >> u;
            u--;
            int w = -1;
            for (auto e : tree[cur])
                if (e.by_edge == u)
                    w = e.v;
            cur = w;
        }
        if (!f) {
            cout << cur + 1 << endl;
            string s;
            cin >> s;
        }
    }

    return 0;
}