#define _CRT_SECURE_NO_WARNINGS
#define sz(x) ((int)((x).size()))
#define pb push_back
#define mp make_pair
#define eb emplace_back
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

template<typename T>
istream& operator>>(istream& fin, vector<T>& v)
{
	int n = sz(v);
	for (int i = 0; i < n; ++i)
		fin >> v[i];
	return fin;
}

void dfs(const int& v, const vvi& gr, vb& nv, vi& st, const int& n)
{
	nv[v] = false;
	for (int i = 0; i < n; ++i)
		if (nv[i] && (gr[v][i]))
		{
			dfs(i, gr, nv, st, n);
		}
	st.pb(v);
}

void dfs1(const int& v, const vvi& gr, vb& nv, vi& st, const int& n)
{
	nv[v] = false;
	for (int i = 0; i < n; ++i)
		if (nv[i] && (gr[i][v]))
		{
			dfs(i, gr, nv, st, n);
		}
	st.pb(v);
}

void fill_lay(vvvc& minec, const int& my_x, const int& my_y, const int& my_z, const int& h)
{
	for (int i = 0; i < my_x; ++i)
		for (int j = 0; j < my_y; ++j)
			minec[i][j][h] = '#';
}

void put_person(vvvc& minec, const int& my_x, const int& my_y, const int& my_z, const int& per, const int& lay)
{
	minec[per][3][lay * 2 + 1] = per + '1';
}

void fill_column(vvvc& minec, const int& my_x, const int& my_y, const int& my_z, const int& x, const int& y, const int& z1, const int& z2)
{
	for (int k = z1; k <= z2; ++k)
		minec[x][y][k] = '#';
}

void unfill_column(vvvc& minec, const int& my_x, const int& my_y, const int& my_z, const int& x, const int& y, const int& z1, const int& z2)
{
	for (int k = z1; k <= z2; ++k)
		minec[x][y][k] = '.';
}

void draw_edge(vvvc& minec, const int& my_x, const int& my_y, const int& my_z, const int& e, const int& p, const int& q)
{
	fill_column(minec, my_x, my_y, my_z, 2 * e, 0, 2 * q + 1, 2 * p - 1);
	fill_column(minec, my_x, my_y, my_z, 2 * e + 1, 0, 2 * q + 1, 2 * p - 1);
	fill_column(minec, my_x, my_y, my_z, 2 * e + 2, 0, 2 * q + 1, 2 * p - 1);
	fill_column(minec, my_x, my_y, my_z, 2 * e + 2, 1, 2 * q + 1, 2 * p - 1);
	fill_column(minec, my_x, my_y, my_z, 2 * e + 2, 2, 2 * q + 1, 2 * p - 1);
	fill_column(minec, my_x, my_y, my_z, 2 * e + 1, 2, 2 * q + 2, 2 * p - 1);
	fill_column(minec, my_x, my_y, my_z, 2 * e, 2, 2 * q + 1, 2 * p - 1);
	fill_column(minec, my_x, my_y, my_z, 2 * e, 1, 2 * q + 1, 2 * p - 1);
	unfill_column(minec, my_x, my_y, my_z, 2 * e + 1, 1, 2 * q + 1, 2 * p);
}
int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
#endif
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); cerr.tie(0);
	int n;
	cin >> n;
	vvi gr(n, vi(n));
	cin >> gr;
	vi st;
	vb nv(n, true);
	for (int i = 0; i < n; ++i)
		if (nv[i])
			dfs(i, gr, nv, st, n);
	//reverse(st.begin(), st.end());
	vb nv1(n, true);
	vvi css;
	vi colors(n);
	for (int i = 0; i < n; ++i)
	{
		int v = st[i];
		if (nv1[v])
		{
			css.eb();
			dfs1(v, gr, nv1, css.back(), n);
			for (int j = 0; j < sz(css.back()); ++j)
				colors[css.back()[j]] = sz(css) - 1;
		}
	}
	int vrc = sz(css);
	vvi gr1(vrc, vi(vrc));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			if (gr[i][j])
			{
				int c1 = colors[i];
				int c2 = colors[j];
				if (c1 != c2)
					gr1[c1][c2] = 1;
			}
	int edgs = 0;
	for (int i = 0; i < vrc; ++i)
		for (int j = 0; j < vrc; ++j)
			if (gr1[i][j])
				++edgs;
	int my_x = max(2 * edgs + 1, n);
	int my_y = 4;
	int my_z = 2 * vrc;
	vvvc minec(my_x, vvc(my_y, vc(my_z, '.')));
	for (int i = 0; i < vrc; ++i)
		fill_lay(minec, my_x, my_y, my_z, 2 * i);
	for (int i = 0; i < n; ++i)
		put_person(minec, my_x, my_y, my_z, i, colors[i]);
	int e = 0;
	for (int i = 0; i < vrc; ++i)
		for (int j = 0; j < vrc; ++j)
			if (gr1[i][j])
			{
				draw_edge(minec, my_x, my_y, my_z, e, i, j);
				++e;
			}
	cout << my_x << ' ' << my_y << ' ' << my_z << '\n';
	for (int i = my_z - 1; i >= 0; --i)
	{
		for (int j = 0; j < my_y; ++j)
		{
			for (int k = 0; k < my_x; ++k)
				cout << minec[k][j][i];
			cout << '\n';
		}
		cout << '\n';
	}
	return 0;
}
