#include <bits/stdc++.h>

using namespace std;

double workTime() {
    return clock() / CLOCKS_PER_SEC;
}

void myReturn(int _code = 0) {
#ifdef LOCAL
    printf("\n\nTime = %.3lf\n", workTime());
#endif
    exit(_code);
}

int n;
vector <vector <int> > G, Gr;
vector <bool> used;
vector <int> order, component, id;
void dfs1(int v) {
    used[v] = true;
    for (auto to: G[v]) if (!used[to]) dfs1(to);
    order.push_back(v);
}
void dfs2(int v) {
    used[v] = true;
    component.push_back(v);
    for (auto to: Gr[v]) if (!used[to]) dfs2(to);
}
int solve() {
    used.assign(n + 1, false);
    for (int i = 1; i <= n; ++i) if (!used[i]) dfs1(i);
    used.assign(n + 1, false);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        int v = order[n - 1 - i];
        if (!used[v]) {
            dfs2(v);
            ++cnt;
            for (auto it: component) id[it] = cnt;
            component.clear();
        }
    }
    return cnt;
}

int k;
vector <vector <bool> > trans;
vector <string> conn;
vector <int> ool;
void orderLevels(int v) {
    used[v] = true;
    for (int i = 0; i <= k; ++i) if (!used[i]) orderLevels(i);
    ool.push_back(v);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n;
    G.resize(n + 1); Gr.resize(n + 1);
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            int x;
            cin >> x;
            if (x == 1) {
                G[i].push_back(j);
                Gr[j].push_back(i);
            }
        }
    }
    used.resize(n + 1);
    id.resize(n + 1);
    k = solve();

    trans = vector <vector <bool> >(k + 1, vector <bool>(k + 1, false));
    for (int i = 1; i <= n; ++i) {
        for (auto j: G[i]) {
            if (id[i] != id[j]) {
                trans[id[i]][id[j]] = true;
            }
        }
    }
    for (int i = 1; i <= k; ++i) {
        bool good = true;
        for (int j = 1; j <= k; ++j) {
            if (trans[j][i]) {
                good = false;
            }
        }
        if (good) trans[0][i] = true;
    }
    conn.resize(k + 1);
    for (int i = 1; i <= n; ++i) {
        conn[id[i]].push_back('0' + i);
    }
    used.assign(n + 1, false);
    orderLevels(0);
    reverse(ool.begin(), ool.end());

    vector <vector <bool> > tmpT(k + 1, vector <bool>(k + 1, false));
    for (int i = 0; i <= k; ++i) {
        for (int j = 0; j <= k; ++j) {
            tmpT[i][j] = trans[ool[i]][ool[j]];
        }
    }
    trans = tmpT;
    vector <string> tmpC(k + 1, "");
    for (int i = 0; i <= k; ++i) {
        tmpC[i] = conn[ool[i]];
    }
    conn = tmpC;

    vector <int> xx(k + 1), yy(k + 1);
    for (int i = 1; i <= k; ++i) {
        xx[i] = i;
        if (i == 1) {
            yy[i] = 1;
        }
        else {
            yy[i] = yy[i - 1] + conn[i - 1].length() + 1;
        }
    }

    int h = k + 2, w = yy[k] + conn[k].length() + 1, numOfLayers = 3*k;
    cout << w << " " << h << " " << numOfLayers << endl;
    for (int i = 1; i <= k; ++i) {
        vector <string> s(h, string(w, '.'));
        for (int y = yy[i] - 1; y < w; ++y) {
            s[xx[i] - 1][y] = '#';
        }
        s[xx[i]][yy[i] - 1] = '#';
        for (int y = yy[i] - 1; y < w; ++y) {
            s[xx[i] + 1][y] = '#';
        }
        for (int id = i + 1; id <= k; ++id) {
            if (trans[i][id]) {
                for (int j = 0; j < conn[id].length(); ++j) {
                    s[xx[i] + 1][yy[id] + j] = '.';
                }
                for (int x = xx[i] + 1; x < xx[id]; ++x) {
                    s[x][yy[id] - 1] = '#';
                    s[x][yy[id] + conn[id].length()] = '#';
                }
            }
        }
        for (auto it: s) {
            cout << it << endl;
        }
        cout << endl;

        for (int j = 0; j < conn[i].length(); ++j) {
            s[xx[i]][yy[i] + j] = conn[i][j];
        }
        for (auto it: s) {
            cout << it << endl;
        }
        cout << endl;

        for (int x = 0; x < h; ++x) {
            for (int y = 0; y < w; ++y) {
                s[x][y] = '#';
            }
        }
        for (int id = i + 1; id <= k; ++id) {
            if (trans[i][id]) {
                for (int j = 0; j < conn[id].length(); ++j) {
                    s[xx[id]][yy[id] + j] = '.';
                }
            }
        }
        for (auto it: s) {
            cout << it << endl;
        }
        cout << endl;
    }

    myReturn();
}