#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<cstdio>
#include<cstring>
#include<ctime>
#include<deque>
#include<functional>
#include<iomanip>
#include<iostream>
#include<map>
#include<queue>
#include<random>
#include<stack>
#include<set>
#include<string>
#include<unordered_map>
#include<unordered_set>
#include<vector>

using namespace std;

typedef long long lint;

#define For(i, n) for (int (i)= 0; (i) < (int)(n); (i)++)
#define sz(x) (int)(x).size()
#define all(v) (v).begin(), (v).end()

//#pragma comment(linker, "/STACK:16777216")

const int maxsize = 207;

pair<int, int> par[maxsize][maxsize][4][4];

bool check(int a, int b, int c, int d) {
	return a < maxsize && b < maxsize && c <= 3 && d <= 3;
}

void precalc() {
	For(i, maxsize) {
		For(j, maxsize) {
			For(c, 4) {
				fill(par[i][j][c], par[i][j][c] + 4, make_pair(-1, -1));
			}
		}
	}

	par[0][0][0][0] = { -2, -2 };

	For(i, maxsize) {
		For(j, maxsize) {
			For(f, 4) {
				For(s, 4) {
					if (par[i][j][f][s].first == -1)
						continue;

					For(w, 2) {
						int add_a = 25;
						for (int add_b = 0; add_b <= 23; add_b++) {
							if (w == 0) {
								if (check(i + add_a, j + add_b, f + 1, s))
									par[i + add_a][j + add_b][f + 1][s] = { i, j };
							}
							else {
								if (check(i + add_b, j + add_a, f, s + 1))
									par[i + add_b][j + add_a][f][s + 1] = { i, j };
							}
						}

						for (int x = 26; x <= 200; x++) {
							if (w == 0) {
								if (check(i + x, j + x - 2, f + 1, s))
									par[i + x][j + x - 2][f + 1][s] = { i, j };
							}
							else {
								if (check(i + x - 2, j + x, f, s + 1))
									par[i + x - 2][j + x][f][s + 1] = { i, j };
							}
						}
					}
				}
			}
		}
	}
}

vector<pair<int, int>> recover(int a, int b, int f, int s) {
	if (par[a][b][f][s].first == -1)
		throw;

	vector<pair<int, int>> path;
	while (a != 0 || b != 0) {
		auto prev = par[a][b][f][s];
		path.emplace_back(a - prev.first, b - prev.second);
		a = prev.first;
		b = prev.second;
		if (path.back().first > path.back().second)
			f -= 1;
		else
			s -= 1;
	}
	return path;
}

void print_ans(int a, int b) {
	int max_val = -4;
	pair<int, int> best = { -1, -1 };
	for (int f = 0; f < 4; f++) {
		for (int s = 0; s < 4; s++) {
			if (f != 3 && s != 3)
				continue;
			if (f == 3 && s == 3)
				continue;
			if (par[a][b][f][s].first != -1) {
				if (max_val < f - s) {
					max_val = f - s;
					best = { f, s };
				}
			}
		}
	}

	if (max_val == -4) {
		cout << "Impossible\n";
		return;
	}

	cout << best.first << ':' << best.second << '\n';
	auto path = recover(a, b, best.first, best.second);
	for (auto e : path) {
		cout << e.first << ':' << e.second << ' ';
	}
	cout << '\n';
}

void solve() {
	int m;
	cin >> m;
	precalc();
	For(i, m) {
		int a, b;
		cin >> a >> b;
		print_ans(a, b);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	solve();
#ifdef LOCAL
	printf("\n\n%.3lf\n", (double)clock() / CLOCKS_PER_SEC);
#endif
}
