#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<cstdio>
#include<cstring>
#include<ctime>
#include<deque>
#include<functional>
#include<iomanip>
#include<iostream>
#include<map>
#include<queue>
#include<random>
#include<stack>
#include<set>
#include<string>
#include<unordered_map>
#include<unordered_set>
#include<vector>

using namespace std;

typedef long long lint;

#define For(i, n) for (int (i)= 0; (i) < (int)(n); (i)++)
#define sz(x) (int)(x).size()
#define all(v) (v).begin(), (v).end()

//#pragma comment(linker, "/STACK:16777216")

vector<set<string> > gar;
vector<vector<string> > trav;

vector<string> get_ans(const set<string> &gr, const vector<string> &trv, int target) {
	int alr = sz(gr);
	vector<string> ans;
	for (auto c : trv) {
		if (gr.count(c)) {
			ans.push_back(c);
		}
		else {
			if (alr < target) {
				ans.push_back(c);
				alr++;
			}
		}
	}
	return ans;
}

string get_cell(char col, char row) {
	string x = "";
	x += col;
	x += row;
	return x;
}

void init() {
	gar.resize(3);
	trav.resize(3);
	
	gar[0].insert("h1");
	gar[0].insert("h8");

	for (char c = 'b'; c <= 'h'; c++)
		trav[0].push_back(get_cell(c, '1'));
	for (char c = '2'; c <= '8'; c++)
		trav[0].push_back(get_cell('h', c));

	//----------
	for (char c = '1'; c <= '8'; c++) {
		gar[1].insert(get_cell('a', c));
		gar[1].insert(get_cell('h', c));
	}
	gar[1].erase("a1");
	gar[1].erase("a8");

	for (int i = 1; i <= 7; i++) {
		if (i % 2 == 1) {
			for (char c = 'a'; c <= 'h'; c++) {
				trav[1].push_back(get_cell(c, '0' + i));
			}
		}
		else {
			for (char c = 'h'; c >= 'a'; c--) {
				trav[1].push_back(get_cell(c, '0' + i));
			}
		}
	}
	trav[1].push_back("h8");
	trav[1].erase(trav[1].begin());
	//-----------

	for (char c = '1'; c <= '8'; c++) {
		gar[2].insert(get_cell('a', c));
		gar[2].insert(get_cell('h', c));
	}

	for (char c = 'a'; c <= 'h'; c++) {
		gar[2].insert(get_cell(c, '7'));
		gar[2].insert(get_cell(c, '8'));
	}
	gar[2].erase("a1");

	trav[2] = trav[1];
	For(i, 9)
		trav[2].pop_back();

	for (char c = 'a'; c <= 'h'; c++) {
		if ((c - 'a') % 2 == 0) {
			trav[2].push_back(get_cell(c, '8'));
			trav[2].push_back(get_cell(c, '7'));
		}
		else {
			trav[2].push_back(get_cell(c, '7'));
			trav[2].push_back(get_cell(c, '8'));
		}
	}
/*
#ifdef LOCAL
	For(i, 3) {
		cout << "gar:\n";
		cout << sz(gar[i]) << endl;
		for (auto c : gar[i])
			cout << c << " ";
		cout << "\n\n";
		cout << "trav:\n";
		cout << sz(trav[i]) << endl;
		for (auto c : trav[i])
			cout << c << " ";
		cout << endl;
		cout << endl;
	}
#endif*/
}

void solve() {
	init();
	int n;
	cin >> n;
	vector<string> ans;
	if (2 <= n && n <= 14) {
		ans = get_ans(gar[0], trav[0], n);
	}
	else if (n <= 56) {
		ans = get_ans(gar[1], trav[1], n);
	}
	else {
		ans = get_ans(gar[2], trav[2], n);
	}
	cout << "a1";
	for (auto c : ans)
		cout << ' ' << c;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	solve();
#ifdef LOCAL
	printf("\n\n%.3lf\n", (double)clock() / CLOCKS_PER_SEC);
#endif
}
