#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<cstdio>
#include<cstring>
#include<ctime>
#include<deque>
#include<functional>
#include<iomanip>
#include<iostream>
#include<map>
#include<queue>
#include<random>
#include<stack>
#include<set>
#include<string>
#include<unordered_map>
#include<unordered_set>
#include<vector>

using namespace std;

typedef long long lint;

#define For(i, n) for (int (i)= 0; (i) < (int)(n); (i)++)
#define sz(x) (int)(x).size()
#define all(v) (v).begin(), (v).end()

//#pragma comment(linker, "/STACK:16777216")

const int MAXN = 9;
const int HEIGHT = 100;
const int MAXX = MAXN * 3 + 10;
const int MAXZ = 200;
#if HEIGHT * MAXX * MAXZ > 100000
#error
#endif
const char EMPTY = '.';
const char WALL = '#';
const char START = '1';
char field[HEIGHT][MAXX][MAXZ];

void dfs(int h, int x, int z, char color)
{
	field[h][x][z] = color;
	if (h && field[h - 1][x][z] != WALL)
	{
		if (field[h - 1][x][z] == EMPTY)
			dfs(h - 1, x, z, color);
		return;
	}
	if (x && field[h][x - 1][z] == EMPTY)
		dfs(h, x - 1, z, color);
	if (x && field[h][x - 1][z] == WALL && field[h + 1][x - 1][z] != WALL && field[h + 1][x][z] != WALL)
		dfs(h + 1, x - 1, z, color);
	if (z && field[h][x][z - 1] == EMPTY)
		dfs(h, x, z - 1, color);
	if (z && field[h][x][z - 1] == WALL && field[h + 1][x][z - 1] != WALL && field[h + 1][x][z] != WALL)
		dfs(h + 1, x, z - 1, color);
	if (x < MAXX - 1 && field[h][x + 1][z] == EMPTY)
		dfs(h, x + 1, z, color);
	if (x < MAXX - 1 && field[h][x + 1][z] == WALL && field[h + 1][x + 1][z] != WALL && field[h + 1][x][z] != WALL)
		dfs(h + 1, x + 1, z, color);
	if (z < MAXZ - 1 && field[h][x][z + 1] == EMPTY)
		dfs(h, x, z + 1, color);
	if (z < MAXZ - 1 && field[h][x][z + 1] == WALL && field[h + 1][x][z + 1] != WALL && field[h + 1][x][z] != WALL)
		dfs(h + 1, x, z + 1, color);
}

void solve() {
	int n;
	cin >> n;
	memset(field, EMPTY, sizeof(field));
	For(i, MAXN)
	{
		if (i < n)
			field[0][i * 3][i * 3] = START + i;
		For(j, MAXN * MAXN + 5)
			field[j][i * 3][i * 3 + j + 1] = WALL;
		For(h, 100) For(z, MAXZ)
			field[h][i * 3 + 2][z] = WALL;
	}
	vector<vector<int>> ar(n, vector<int>(n));
	int index = 3;
	For(i, n) For(j, n)
	{
		cin >> ar[i][j];
		if (ar[i][j] == 0)
			continue;
		index++;
		int h = index, x = i * 3, z = i * 3 + index, target_x = j * 3 + 1;
		if (x < target_x)
		{
			for (x++; x < target_x; x++)
			{
				field[h][x][z] = EMPTY;
				field[h + 1][x][z] = WALL;
				field[h - 1][x][z] = WALL;
				field[h][x][z + 1] = WALL;
				field[h][x][z - 1] = WALL;
			}
		}
		else
		{
			for (x--; x > target_x; x--)
			{
				field[h][x][z] = EMPTY;
				field[h + 1][x][z] = WALL;
				field[h - 1][x][z] = WALL;
				field[h][x][z + 1] = WALL;
				field[h][x][z - 1] = WALL;
			}
		}
		field[h + 1][x][z] = WALL;
		field[h][x][z + 1] = WALL;
		field[h][x][z - 1] = WALL;
	}
	cout << MAXZ << ' ' << MAXX << ' ' << HEIGHT << '\n';
	For(h, HEIGHT)
	{
		For(i, MAXX)
		{
			For(j, MAXZ)
				cout << field[HEIGHT - 1 - h][i][j];
			cout << '\n';
		}
		cout << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	solve();
#ifdef LOCAL
	printf("\n\n%.3lf\n", (double)clock() / CLOCKS_PER_SEC);
#endif
}
