#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:167772160000")
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <climits>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <list>
#include <stack>
#include <set>
#include <bitset>
#include <queue>
#include <map>
#include <sstream>
#include <functional>
#include <unordered_map>
#include <unordered_set>
#include <complex>
#include <random>
#include <chrono>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
template <typename T> using min_heap = priority_queue<T, vector<T>, greater<T>>;
template <typename T> using max_heap = priority_queue<T, vector<T>, less<T>>;
// prints
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(NULL)
#define TESTS(t) int NUMBER_OF_TESTS; cin >> NUMBER_OF_TESTS; for(int t = 1; t <= NUMBER_OF_TESTS; t++)
#define FOR(i, begin, end) for(int i = (begin)-((begin)>(end));i!=(end)-((begin)>(end));i+=1-2*((begin)>(end)))
#define rnd(a, b) (uniform_int_distribution<int>((a),(b))(rng))
#define pb push_back
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const int oo = 2e9;

void solveEq(ll a, ll b, ll& x, ll& y, ll& g) {
	if (b == 0) {
		x = 1;
		y = 0;
		g = a;
		return;
	}
	ll xx, yy;
	solveEq(b, a%b, xx, yy, g);
	x = yy;
	y = xx - yy*(a / b);
}

bool solveEq(ll a, ll b, ll c, ll& x, ll& y, ll&g) {
	solveEq(a, b, x, y, g);
	if (c%g != 0) return false;
	x *= c / g;
	y *= c / g;
	return true;
}

bool solveEqNonNeg(ll a, ll b, ll c, ll& x, ll&y, ll&g) {
	if (!solveEq(a, b, c, x, y, g)) return false;
	ll k = x*g / b;
	x = x - k*b / g;
	y = y + k*a / g;
	if (x < 0) {
		x += b / g;
		y -= a / g;
	}
	return true;
}

void solveEqStupid(vector<int> b, vector<int> a, vector<int>& ans, int curr, int need, int k) {
	if (k == a.size()) {
		if (curr == need) {
			ans = a;
		}
		return;
	}
	if (curr > need) return;
	if (!ans.empty()) return;
	int n = need + 1;
	FOR(i, 0, n / b[k]) {
	a[k] = i;
	solveEqStupid(b, a, ans, curr + i*b[k], need, k + 1);
	a[k] = 0;
	}
}
void solveEqSmart(vector<int> b, vector<int> a, vector<int>& ans, int curr, int need, int k) {
	if (k == a.size()) {
		if (curr == need) {
			ans = a;
		}
		return;
	}
	if (curr > need) return;
	if (!ans.empty()) return;
	int n = need + 1;
	/*FOR(i, 0, n / b[k]) {
	a[k] = i;
	solveEq(b, a, ans, curr + i*b[k], need, k + 1);
	a[k] = 0;
	}*/
	vector<int> vals = { 0, 1, (need - curr) / b[k] };
	for (auto x : vals) {
		a[k] = x;
		solveEqSmart(b, a, ans, curr + x*b[k], need, k + 1);
		a[k] = 0;
	}
}

bool solveStupid(int n) {
	set<int> divs;
	for (int i = 2; i*i <= n; i++) {
		if (n%i == 0) {
			divs.insert(i);
			divs.insert(n / i);
		}
	}
	vector<int> divsV;
	for (auto x : divs) divsV.pb(x);
	sort(divsV.begin(), divsV.end(), [](auto a, auto b) -> bool {
		return a > b;
	});
	vector<int> a(divsV.size());
	vector<int> ans;
	solveEqStupid(divsV, a, ans, 0, n - 1, 0);
	//cout << n << ". ";
	if (ans.empty()) {
		//cout << "NO" << endl;
		return false;
	}
	else {
		/*cout << "YES: ";
		FOR(i, 0, (int)divsV.size()) {
			if (ans[i] > 0) cout << ans[i] << "/" << n / divsV[i] << " + ";
		}
		cout << endl;*/
		return true;
	}
}

bool isPowOf(int x, int y) {
	int d = 1;
	while (d <= x) {
		if (d == x) return true;
		d = d * y;
	}
	return false;
}

bool solveMaybeSmart(int n) {
	if (isPowOf(n, 2) || isPowOf(n, 3)) {
		cout << "NO" << endl;
		return false;
	}
	set<int> divs;
	for (int i = 2; i*i <= n; i++) {
		if (n%i == 0) {
			divs.insert(i);
			divs.insert(n / i);
		}
	}
	vector<int> divsV;
	for (auto x : divs) divsV.pb(x);
	sort(divsV.begin(), divsV.end(), [](auto a, auto b) -> bool {
		return a > b;
	});
	vector<int> a(divsV.size());
	vector<int> ans;
	solveEqSmart(divsV, a, ans, 0, n - 1, 0);
	//cout << n << ". ";
	if (ans.empty()) {
		//cout << "NO" << endl;
		if (divsV.size() == 2) {
			ll x, y, g;
			if (solveEqNonNeg(divsV[0], divsV[1], n-1, x, y, g)) {
				int a1 = y;
				int a2 = x;
				ll k = -y*g / divsV[0];
				FOR(i, k - 2, k + 2) {
					int yy = y + k*divsV[0] / g;
					if (yy >= 0) {
						a1 = yy;
						a2 = x - k*divsV[1] / g;
						break;
					}
				}
				if (a1 < 0 || a1 >= divsV[0] || a2 < 0 || a2 >= divsV[1] ) {
					cout << "NO" << endl;
					return false;
				}
				cout << "YES" << endl;
				cout << 2 << endl;
				cout << a1 << " " << divsV[0] << endl;
				cout << a2 << " " << divsV[1] << endl;
				return true;
			}
			else {
				cout << "NO" << endl;
				return false;
			}
		}
		cout << "NO" << endl;
		return false;
	}
	else {
		cout << "YES" << endl;
		vector<pii> res;
		FOR(i, 0, (int)divsV.size()) {
			if (ans[i] > 0) res.pb({ ans[i], n / divsV[i] });
		}
		cout << res.size() << endl;
		for (auto x : res) cout << x.first << " " << x.second << endl;
		cout << endl;
		return true;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	/*FOR(_, 0, 1000) {
		int n = rnd(1, 1000000000);
		cout << n << endl;
		solveMaybeSmart(n);
	}*/

	int n;
	cin >> n;
	if (isPowOf(n, 2) || isPowOf(n, 3)) {
		cout << "NO" << endl;
		return 0;
	}
	solveMaybeSmart(n);

	return 0;
}