#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:167772160000")
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <climits>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <list>
#include <stack>
#include <set>
#include <bitset>
#include <queue>
#include <map>
#include <sstream>
#include <functional>
#include <unordered_map>
#include <unordered_set>
#include <complex>
#include <random>
#include <chrono>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
template <typename T> using min_heap = priority_queue<T, vector<T>, greater<T>>;
template <typename T> using max_heap = priority_queue<T, vector<T>, less<T>>;
template <typename A, typename B>ostream& operator<<(ostream& out, pair<A, B>& p) { return out << "(" << p.first << ", " << p.second << ")"; }
template <typename T>ostream& operator<<(ostream& out, vector<T>& p) { out << "["; for (auto x : p) out << x << ", "; out << "]"; return out; }
template <typename T>ostream& operator<<(ostream& out, set<T>& p) { out << "{"; for (auto x : p) out << x << ", "; out << "}"; return out; }
template <typename K, typename V> ostream& operator<<(ostream& out, map<K, V>& p) { out << "{"; for (auto x : p) out << x.first << " -> " << x.second << ", "; out << "}"; return out; }
// prints
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(NULL)
#define TESTS(t) int NUMBER_OF_TESTS; cin >> NUMBER_OF_TESTS; for(int t = 1; t <= NUMBER_OF_TESTS; t++)
#define FOR(i, begin, end) for(int i = (begin)-((begin)>(end));i!=(end)-((begin)>(end));i+=1-2*((begin)>(end)))
#define rnd(a, b) (uniform_int_distribution<int>((a),(b))(rng))
#define pb push_back
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const int oo = 2e9;

vector<int> g[9], gr[9];
vector<bool> used;
vector<int> order, component;
vector<vector<int>> components;
int componentNum[9];
set<int> sccg[100], sccgr[100];
int floorType[100];
int n;
vector<vector<string>> floors;
int maxCompSize;

void dfs1(int v) {
	used[v] = true;
	FOR(i, 0, (int)g[v].size()) {
		if (!used[g[v][i]]) dfs1(g[v][i]);
	}
	order.pb(v);
}
void dfs2(int v) {
	used[v] = true;
	component.pb(v);
	FOR(i, 0, (int)gr[v].size()) {
		if (!used[gr[v][i]]) dfs2(gr[v][i]);
	}
}

void findSCC() {
	used.assign(n, false);
	FOR(i, 0, n) if (!used[i]) dfs1(i);
	used.assign(n, false);
	FOR(i, 0, n) {
		int v = order[n - 1 - i];
		if (!used[v]) {
			dfs2(v);
			vector<int> tmp;
			for (auto x : component) {
				tmp.pb(x);
				componentNum[x] = components.size();
			}
			components.pb(tmp);
			maxCompSize = max(maxCompSize, (int)components.size());
			component.clear();
		}
	}
	for (auto comp : components) {
		for (auto v : comp) {
			for (auto u : g[v]) {
				if (componentNum[u] == componentNum[v]) continue;
				sccg[componentNum[v]].insert(componentNum[u]);
			}
			for (auto u : gr[v]) {
				if (componentNum[u] == componentNum[v]) continue;
				sccgr[componentNum[v]].insert(componentNum[u]);
			}
		}
	}
}

vector<vector<string>> join(vector<vector<string>> a, vector<vector<string>> b) {
	if (a.empty()) return b;
	if (b.empty()) return a;
	vector<vector<string>> res;
	
	int sz = max(a.size(), b.size());
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	for (int i = 0; i < sz; i++) {
		vector<string> currLayer(6, "");
		if (i < a.size()) {
			FOR(j, 0, 6) currLayer[j] += a[i][j];
		}
		else {
			FOR(j, 0, 6) currLayer[j] += "######";
		}
		if (i < b.size()) {
			FOR(j, 0, 6) currLayer[j] += b[i][j];
		}
		else {
			FOR(j, 0, 6) currLayer[j] += "######";
		}
		res.pb(currLayer);
	}
	reverse(res.begin(), res.end());
	return res;
}

vector<vector<string>> dfsSCC(int v, int t) {
	vector<vector<string>> res;
	used[v] = true;
	if (sccgr[v].empty()) {
		res.assign(2, vector<string>(6, "######"));
		for (int i = 1; i < 5; i++) {
			for (int j = 1; j < 5; j++) {
				res[0][i][j] = '.';
			}
		}
		int id = 0;
		if (t == 0) {
			res[1][4][4] = '.';
			for (int i = 1; i < 5; i++) {
				for (int j = 1; j < 5; j++) {
					if (id >= components[v].size()) break;
					res[0][i][j] = (components[v][id++] + 1) + '0';
				}
			}
		}
		else {
			res[1][1][1] = '.';
			for (int i = 4; i >= 1; i--) {
				for (int j = 4; j >= 1; j--) {
					if (id >= components[v].size()) break;
					res[0][i][j] = (components[v][id++] + 1) + '0';
				}
			}
		}
		return res;
	}
	for (auto x : sccgr[v]) {
		if (!used[x]) {
			auto R = dfsSCC(x, t ^ 1);
			res = join(res, R);
		}
	}
	int h = 6;
	int w = res[0][0].size();
	vector<string> floor(6, string(w, '.'));
	vector<string> floor2(6, string(w, '#'));
	FOR(i, 0, h) floor[i][0] = floor[i][w-1] = '#';
	FOR(j, 0, w) floor[0][j] = floor[h - 1][j] = '#';
	if (t == 0) {
		floor2[4][w - 2] = '.';
		int id = 0;
		FOR(i, 1, h - 1) {
			FOR(j, 1, w - 1) {
				if (id >= components[v].size()) break;
				floor[i][j] = (components[v][id] + 1) + '0';
				id++;
			}
		}
	}
	else {
		floor2[1][1] = '.';
		int id = 0;
		for (int i = h - 2; i >= 1; i--) {
			for (int j = w - 2; j >= 1; j--) {
				if (id >= components[v].size()) break;
				floor[i][j] = (components[v][id] + 1) + '0';
				id++;
			}
		}
	}
	res.pb(floor);
	res.pb(floor2);

	return res;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n;
	FOR(i, 0, n) {
		FOR(j, 0, n) {
			int t;
			cin >> t;
			if (t == 1) {
				g[i].pb(j);
				gr[j].pb(i);
			}
		}
	}

	findSCC();
	//reverse(components.begin(), components.end());
	used.assign(components.size(), false);
	for (int i = (int)components.size() - 1; i >= 0; i--) {
		if (!used[i]) {
			auto r = dfsSCC(i, 0);
			floors = join(floors, r);
		}
	}
	floors.pop_back();
	int z = floors.size();
	int y = floors[0].size();
	int x = floors[0][0].size();
	cout << x << " " << y << " " << z << endl;
	for (auto f : floors) {
		for (auto r : f) {
			cout << r << endl;
		}
		cout << endl;
	}

	return 0;
}