#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef __int128 ell;

struct Match {
    int len;
    int winner[5];
    int res[5][2];
};

bool solveNicely(int a, int b, Match& res) {
    int aUp = 0, bUp = 0;
    for (int i = 0; i < res.len; ++i) {
        if (res.winner[i] == 0) {
            bUp += res.res[i][0] - 2;
        } else {
            aUp += res.res[i][1] - 2;
        }
    }
    if (aUp < a || bUp < b) {
        return false;
    }
    for (int i = 0; i < res.len; ++i) {
        if (res.winner[i] == 0) {
            int toAdd = min(b, res.res[i][0] - 2);
            b -= toAdd;
            res.res[i][1] += toAdd;
        } else {
            int toAdd = min(a, res.res[i][1] - 2);
            a -= toAdd;
            res.res[i][0] += toAdd;
        }
    }
    return true;
}

bool solveRougly(int s, int a, int b, Match& res) {
    if (res.winner[s] == 0) {
        res.res[s][1] += res.res[s][0] - 2;
        b -= res.res[s][0] - 2;
    } else {
        res.res[s][0] += res.res[s][1] - 2;
        a -= res.res[s][1] - 2;
    }
    if (a < 0 || b < 0) {
        return false;
    }
    int com = min(a, b);
    a -= com;
    b -= com;
    res.res[s][0] += com;
    res.res[s][1] += com;
    for (int i = 0; i < res.len; ++i) {
        if (i == s) {
            continue;
        }
        if (res.winner[i] == 0) {
            int toAdd = min(b, res.res[i][0] - 2);
            b -= toAdd;
            res.res[i][1] += toAdd;
        } else {
            int toAdd = min(a, res.res[i][1] - 2);
            a -= toAdd;
            res.res[i][0] += toAdd;
        }
    }
    return a == 0 && b == 0;
}

bool backtrack2(int a, int b, Match& res) {
    for (int i = 0; i < res.len; ++i) {
        int howMuch = 25;
        if (i == 4) {
            howMuch = 15;
        }
        if (res.winner[i] == 0) {
            a -= howMuch;
        } else {
            b -= howMuch;
        }
        res.res[i][res.winner[i]] += howMuch;
    }
    if (a < 0 || b < 0) {
        return false;
    }
    if (solveNicely(a, b, res)) {
        return true;
    }
    for (int i = 0; i < res.len; ++i) {
        Match orig = res;
        if (solveRougly(i, a, b, res)) {
            return true;
        }
        res = orig;
    }
    return false;
}

bool backtrack1(int a, int b, int x, int y, Match& res) {
    res.len = x + y;
    if (x + y == 5) {
        if (x == 3) {
            res.winner[4] = 0;
            --x;
        } else {
            res.winner[4] = 1;
            --y;
        }
    }
    while (x || y) {
        if (x) {
            --x;
            res.winner[x + y] = 0;
        } else {
            --y;
            res.winner[x + y] = 1;
        }
    }
    memset(res.res, 0, sizeof res.res);
    return backtrack2(a, b, res);
}

void solveTest() {
    int a, b;
    cin >> a >> b;
    for (int x = 3; x >= 0; --x) {
        for (int y = 0; y <= 3; ++y) {
            if (x < 3 && y < 3 || x + y > 5) {
                continue;
            }
            Match res;
            if (backtrack1(a, b, x, y, res)) {
                cout << x << ":" << y << "\n";
                for (int i = 0; i < x + y; ++i) {
                    cout << res.res[i][0] << ":" << res.res[i][1] << " ";
                }
                cout << "\n";
                return;
            }
        }
    }
    cout << "Impossible\n";
}

int main() {
#ifdef ONLY_HERE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // ONLY_HERE
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int tests;
    cin >> tests;

    while(tests--) {
        solveTest();
    }

    return 0;
}
