#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef __int128 ell;

int n, m;
vector <int> g[504];

void read() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int k, last;
        cin >> k >> last;
        for (int j = 1; j < k; ++j) {
            int to;
            cin >> to;
            g[last].push_back(to);
            g[to].push_back(last);
            last = to;
        }
    }
}

int way0[504], way1[504], way2[504];
bool death[504];

void clearArr() {
    for (int i = 1; i <= n; ++i) {
        way0[i] = way1[i] = way2[i] = -1;
    }
}

int bfs0true(int v) {
    memset(way0, -1, sizeof(way0));
    way0[v] = 0;
    queue <int> que;
    que.push(v);
    int maxDist = 0;
    while(!que.empty()) {
        int p = que.front();
        que.pop();
        for (int to : g[p]) {
            if (way0[to] == -1) {
                way0[to] = way0[p] + 1;
                maxDist = max(maxDist, way0[to]);
                que.push(to);
            }
        }
    }
    return maxDist;
}

int bfs0() {
    int vertex = 1, globalMn = 1e7;
    for (int i = 1; i <= n; ++i) {
        if (death[i] == true) {
            continue;
        }
        int mn = bfs0true(i);
        if (mn < globalMn) {
            globalMn = mn;
            vertex = i;
        }
    }
    return vertex;
}

void bfs1(int v) {
    way1[v] = 0;
    queue <int> que;
    que.push(v);
    while(!que.empty()) {
        int p = que.front();
        que.pop();
        for (int to : g[p]) {
            if (way1[to] == -1) {
                way1[to] = way1[p] + 1;
                que.push(to);
            }
        }
    }
}

void bfs2(int v) {
    way2[v] = 0;
    queue <int> que;
    que.push(v);
    int maxDist = 0;
    while(!que.empty()) {
        int p = que.front();
        que.pop();
        for (int to : g[p]) {
            if (way2[to] == -1) {
                way2[to] = way2[p] + 1;
                maxDist = max(maxDist, way2[to]);
                que.push(to);
            }
        }
    }
    return;
}

void solveTest() {
    read();
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            death[j] = false;
        }
        int z = 0;
        while (true) {

            if(++z > 10)
                exit(-1);

            clearArr();
            int v = bfs0();
            cout << v << endl;
            string s;
            cin >> s;
            if (s == "FOUND") {
                break;
            }
            int w;
            cin >> w;
            bfs1(v);
            bfs2(w);
            for (int j = 1; j <= n; ++j) {
                if (way1[j] <= way2[j]) {
                    death[j] = true;
                }
            }
        }
    }
}

int main() {
#ifdef ONLY_HERE
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // ONLY_HERE

    int tests = 1;

    while(tests--) {
        solveTest();
    }

    return 0;
}
