#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef __int128 ell;

void brute() {
    for (int i = 50; i < 100; ++i) {
        cout << "-> " << i << ":" << endl;
        for (int a = 2; a < i; ++a) {
            int b = i - a - 1;
            int da = __gcd(i, a);
            int db = __gcd(i, b);
            if (da == 1 || db == 1 || b < 2 || b >= i) continue;
            cout << a/da << "/" << i/da << endl;
            cout << b/db << "/" << i/db << endl << endl;
        }
    }
}

bool notPrime[33004];
vector <int> dels, alldels;
int m = 0;

ll euclid(ll a, ll b, ll &x, ll &y) {
    if (!b) {
        x = 1;
        y = 0;
        return a;
    }

    ll g = euclid(b, a%b, x, y);
    ll xl = x;
    ll yl = y;

    x = yl;
    y = xl - (a/b)*y;

    return g;
}

ll up(ll a, ll b, bool prec) {
    ll res = a / b;
    if (a >= 0) {
        if (a % b || prec) {
            ++res;
        }
    } else {
        if (a % b == 0 && prec) {
            ++res;
        }
    }
    return res;
}

ll down(ll a, ll b, bool prec) {
    ll res = a / b;
    if (a >= 0) {
        if (prec && a % b == 0) {
            --res;
        }
    } else {
        if (a % b || prec) {
            --res;
        }
    }
    return res;
}

void solve(ll alp, ll bet, ll c, ll &x, ll &y, ll b1, ll b2) {
    ll g = euclid(alp, bet, x, y);

    ll l1 = up((g - x*c), bet, false);
    ll l2 = down((g*b1 - x*c), bet, true);
    ll r1 = up((y*c - b2*g), alp, true);
    ll r2 = down((y*c - g), alp, false);

    if (l1 <= l2 && r1 <= r2 && min(l2, r2) - max(l1, r1) >= 0) {
        ll k = max(l1, r1);
        x = x*c/g + k*bet/g;
        y = y*c/g - k*alp/g;

        if (x*alp + y*bet != c) return;

        cout << "YES\n";
        cout << 2 << endl;
        cout << x << " " << b1 << endl;
        cout << y << " " << b2 << endl;

        exit(0);
    }
}

void solveTest() {
    int n;
    cin >> n;
    for (ll i = 2; i <= 33000; ++i) {
        if (notPrime[i]) continue;
        for (ll j = i*i; j <= 33000; j += i) {
            notPrime[j] = 1;
        }
    }
    for (int j = 2; j <= 33000; ++j) {
        if (notPrime[j]) continue;
        if (n%j == 0) {
            dels.push_back(j);
        }
    }

    int ntmp = n;

    while (m < dels.size()) {
        while (ntmp%dels[m] == 0) {
            ntmp /= dels[m];
        }
        ++m;
    }

    if (ntmp > 1) {
        dels.push_back(ntmp);
        alldels.push_back(ntmp);
    }

    for (int i = 2; i <= 1e7; ++i) {
        if (n%i == 0) {
            alldels.push_back(i);
        }
    }

    if (dels.size() < 2) {
        cout << "NO";
        return;
    }

    ll a1, a2;
    m = alldels.size();
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < i; ++j) {
        solve(n/alldels[i], n/alldels[j], n - 1, a1, a2, alldels[i], alldels[j]);
        }
    }
    cout << "NO";
}

int main() {
#ifdef ONLY_HERE
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // ONLY_HERE
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int tests = 1;

    while(tests--) {
        solveTest();
    }

    return 0;
}
