#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef __int128 ell;

const int N = 10;

int n;
bool g[N][N];
char table[4 * N + 10][4 * N + 10][4 * N + 10];
int x, y, z;

void read() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            int a;
            cin >> a;
            g[i][j] = a;
        }
    }
}

void buildFloors() {
    for (int k = 0; k < z; k++) {
        for (int i = 0; i < x; ++i) {
            for (int j = 0; j < y; ++j) {
                if (k % 4 != 3) {
                    table[i][j][k] = '.';
                } else {
                    table[i][j][k] = '#';
                }
            }
        }
    }
}

void markBox(int ii, int jj, int kk) {
    for (int i = ii - 2; i <= ii + 1; ++i) {
        for (int j = jj - 1; j <= jj + 1; ++j) {
            table[i][j][kk] = '#';
        }
    }
    table[ii][jj][kk] = '.';
    table[ii - 1][jj][kk] = '.';
}

void markSmallBox(int ii, int jj, int kk) {
    for (int i = ii - 1; i <= ii; ++i) {
        for (int j = jj - 1; j <= jj + 1; ++j) {
            table[i][j][kk] = '#';
        }
    }
    table[ii][jj][kk] = '.';
}

void buildStairs() {
    for (int u = 1; u <= n; ++u) {
        int i = x - 2;
        int j = (u - 1) * 4 + 1;
        for (int k = 0; k < z; ++k) {
            markBox(i, j, k);
            if (k % 4 == 2) {
                int v = k / 4;
                if (g[u][v]) {
                    table[i - 1][j + 1][k] = '.';
                    table[i - 1][j + 1][k - 1] = '.';
                }
            }
            --i;
        }
        table[x - 1][(u - 1) * 4 + 1][0] = '0' + u;
    }
}

void buildColumns() {
    for (int v = 1; v <= n; ++v) {
        int i = x - 1;
        int j = (v - 1) * 4 + 1;
        for (int k = 1; k < z; ++k) {
            markSmallBox(i, j, k);
            if (k % 4 == 0) {
                int u = k / 4;
                if (u == v) {
                    table[i - 1][j][k] = '.';
                }
            }
        }
    }
}

void build() {
    x = 4 * n + 8;
    y = 4 * n;
    z = 4 * n + 4;
    buildFloors();
    buildStairs();
    buildColumns();
}

void write() {
    cout << x << ' ' << y << ' ' << z << '\n';
    for (int k = z - 1; k >= 0; --k) {
        for (int j = 0; j < y; ++j) {
            for (int i = 0; i < x; ++i) {
                cout << table[i][j][k];
            }
            cout << '\n';
        }
        cout << '\n';
    }
}

void solveTest() {
    read();
    build();
    write();
}

int main() {
#ifdef ONLY_HERE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // ONLY_HERE
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int tests = 1;

    while(tests--) {
        solveTest();
    }

    return 0;
}
