#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

int my_rand() {
	return abs((rand() << 15) ^ rand());
}

struct node {
	int t, d, mint, sumd, posd, y, l, r, endt;
	node() {
		t = 0;
		d = 0;
		mint = 0;
		sumd = 0;
		posd = 0;
		y = my_rand();
		l = -1;
		r = -1;
		endt = 0;
	}
};

const int nmax = 1000 * 1000;
int t;

node a[nmax];
int hey[nmax];

void update(int root) {
	if (root == -1) return;
	a[root].mint = a[root].t;
	a[root].sumd = a[root].d;
	a[root].posd = 0;
	if (a[root].l != -1) {
		a[root].mint = min(a[a[root].l].mint, a[root].mint);
		a[root].sumd += a[a[root].l].sumd;
		a[root].posd = a[a[root].l].posd + max(0, a[root].t - a[a[root].l].endt);
		if (a[a[root].l].endt >= a[root].t) {
			a[root].endt = a[a[root].l].endt + a[root].d;
		}
		else {
			a[root].endt = a[root].t + a[root].d;
		}
	}
	else {
		a[root].endt = a[root].t + a[root].d;
	}
	if (a[root].r != -1) {
		if (a[a[root].r].posd > a[root].endt - a[a[root].r].mint) {
			if (a[root].endt < a[a[root].r].mint) {
				a[root].posd += a[a[root].r].posd + a[a[root].r].mint - a[root].endt;
			} else {
				a[root].posd += a[a[root].r].posd - max(0, a[root].endt - a[a[root].r].mint);	
			}
			a[root].endt = a[a[root].r].endt;
		}
		else {
			a[root].endt += a[a[root].r].sumd;
		}
		a[root].mint = min(a[root].mint, a[a[root].r].mint);
		a[root].sumd += a[a[root].r].sumd;
	}
}

void split(int root, int &l, int &r, int t) {
	if (root == -1) {
		l = r = -1;
		return;
	}
	if (a[root].t <= t) {
		l = root;
		split(a[root].r, a[l].r, r, t);
	}
	else {
		r = root;
		split(a[root].l, l, a[r].l, t);
	}
	update(l);
	update(r);
}

int merge(int l, int r) {
	if (l == -1) return r;
	else if (r == -1) return l;
	if (a[l].y < a[r].y) {
		a[l].r = merge(a[l].r, r);
		update(l);
		return l;
	}
	else {
		a[r].l = merge(l, a[r].l);
		update(r);
		return r;
	}
}


int main()
{
	//freopen("in.txt", "r", stdin);
	ios_base::sync_with_stdio(false);
	cin >> t;
	int top = 0;
	int root = -1;
	int l1, r1, l2, r2;
	char c;
	int x, d;
	for (int i = 0; i < t; i++) {
		cin >> c;
		if (c == '?') {
			cin >> x;
			split(root, l1, r1, x);
			cout << max(0, a[l1].endt - x) << endl;
			root = merge(l1, r1);
		}
		else if (c == '+') {
			cin >> x >> d;
			hey[i] = top;
			a[top].t = x;
			a[top].d = d;
			update(top);
			split(root, l1, r1, x);
			root = merge(l1, top);
			root = merge(root, r1);
			top++;
		}
		else {
			cin >> x;
			x--;
			x = hey[x];
			split(root, l1, r1, a[x].t);
			split(l1, l2, r2, a[x].t - 1);
			root = merge(l2, r1);
		}
	}

}
