#include <bits/stdc++.h>

#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

const int MAXN = 13;

int n;
int arr[MAXN][MAXN];
bool used[MAXN];
vector<int> order;
vector<int> layers[MAXN];
int lay_edges[MAXN][MAXN];
int to_lay[MAXN];
int sz_lay;
char ans[MAXN][MAXN][MAXN];

void dfs(int v)
{
	used[v] = true;
	for (int to = 0; to < n; to++)
	{
		if (arr[v][to] && !used[to])
		{
			dfs(to);
		}
	}
	order.push_back(v);
}

void inv_dfs(int v, int lay)
{
	used[v] = true;
	to_lay[v] = lay;
	layers[lay].push_back(v);

	for (int to = 0; to < n; to++)
	{
		if (arr[to][v] && !used[to])
		{
			inv_dfs(to, lay);
		}
	}
}

int main()
{
    ios_base::sync_with_stdio(false);	
                    	
    cin >> n;

    for (int i = 0; i < n; i++)
    {
    	for (int j = 0; j < n; j++)
    	{
    		cin >> arr[i][j];
    	}
    }

    for (int i = 0; i < n; i++)
    {
    	if (!used[i])
    	{
    		dfs(i);
    	}
    }

    reverse(order.begin(), order.end());
    for (int i = 0; i < n; i++)
    {
    	used[i] = 0;
    }


    for (int v: order)
    {
    	if (!used[v])
    	{
    		inv_dfs(v, sz_lay);
    		sz_lay++;	
    	}
    }

    for (int i = 0; i < n; i++)
    {
    	for(int j = 0; j < n; j++)
    	{
    		if (arr[i][j] && to_lay[i] != to_lay[j])
    		{
    			lay_edges[to_lay[i]][to_lay[j]] = 1;    			
    		}
    	}
    }
                 /*
    for (int i = 0; i < n; i++)
    {
    	for (int j = 0; j < n; j++)
    	{
    		cout << lay_edges[i][j] << ' ';
    	}
    	cout << '\n';
    }

    for (int i = 0; i < n; i++)
    {
    	cout << i << ": ";
    	for (int v: layers[i])
    	cout << v << ' ';
    	cout << '\n';
    }
    */

    int x, y, z;
    z = 2 * sz_lay;
    y = 2 * n;
    x = 2 * n + 1;

    for (int i = 0; i < x; i++)
    {
    	for (int j = 0; j < y; j++)
    	{
    		for (int k = 0; k < z; k++)
    		{
    			ans[i][j][k] = (k % 2 == 0 ? '.' : '#');
    		}
    	}
    }

    for (int lay = 0; lay < sz_lay; lay++)
    {
    	for (int ind = 0; ind < (int)layers[lay].size(); ind++)
    	{
    		ans[x - 1][ind][lay * 2] = '1' + layers[lay][ind];
       	}
    }
         
    for (int i = 0; i < sz_lay; i++)
    {
    	for (int j = 0; j < sz_lay; j++)
    	{
    		if (lay_edges[i][j])
    		{
    			assert(i < j);
    			for (int zz = 2 * i + 1; zz < 2 * j + 1; zz += 2)
    			{
    				ans[2 * i][2 * j][zz] = '.';
    			}
    		}
    	}
    }

    cout << x << ' ' << y << ' ' << z << '\n';

	for (int zz = 0; zz < z; zz++)
	{
		for (int yy = 0; yy < y; yy++)
		{
			for (int xx = 0; xx < x; xx++)
			{
			 	cout << ans[xx][yy][zz];	
			}
			cout << '\n';
		}
		cout << '\n';
	}


    
}
