#include <algorithm>
#include <cmath>
#include <functional>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

using LL = long long;
using pii = pair<int, int>;

#define X first
#define Y second

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const map<U, T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const pair<U, T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const pair<U, T>& v) {
	return out << "(" << v.first << ", " << v.second << ")";
}

template<typename U, typename T>
ostream& operator<<(ostream& out, const map<U, T>& v) {
	out << "{";
	bool f = false;
	for (const auto& p : v) {
		out << (!f ? "" : ", ") << p;
		f = true;
	}
	return out << "}";
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	out << "{";
	for (int i = 0; i < int(v.size()); ++i) {
		out << (i == 0 ? "" : ", ") << v[i];
	}
	return out << "}";
}

void cerr_printer(bool start) {}
template<typename T, typename ... Args>
void cerr_printer(bool start, const T& x, const Args& ... args) {
	if (!start) cerr << ", ";
	cerr << x;
	cerr_printer(false, args...);
}

template<typename ... Args>
void dbg(const char * name, int line, const Args& ... args) {
	cerr << "[" << line << "] (" << name << ") = (";
	cerr_printer(true, args...);
	cerr << ")" << endl;
}

#define DBG(...) {dbg(#__VA_ARGS__, __LINE__, __VA_ARGS__); }

struct Solver {
	LL solve(LL k, vector<int> b) {
		LL sum = 0;
		for (int x : b) sum += x;

		LL l = 0;
		LL r = 1e10;
		while (r - l > 1) {
			LL mid = (l + r) / 2;

			LL rs = mid % 7;
			LL tt = mid / 7;
			LL cur = sum * tt;
			for (int i = 0; i < rs; ++i) cur += b[i];
			if (cur >= k) r = mid;
			else l = mid;
		}

		return r;
	}

	void solve(istream& cin, ostream& cout) {
		int n;
		cin >> n;

		vector<string> path;
		if (n <= 14) {
			for (char c = 'a'; c <= 'h'; ++c) {
				path.push_back(string(1, c) + "1");
			}
			for (int i = 2; i <= 8; ++i) {
				path.push_back(string("h") + char('0' + i));
			}
		} else if (n <= 17) {
			for (char c = 'a'; c <= 'h'; ++c) {
				path.push_back(string(1, c) + "1");
			}
			for (char c = 'h'; c >= 'a'; --c) {
				path.push_back(string(1, c) + "2");
			}
			path.push_back(string("a") + '8');
			path.push_back(string("h") + '8');
		} else {
			for (int i = 1; i <= 6; ++i) {
				if (i % 2 == 1) {
					for (char c = 'a'; c <= 'h'; ++c) {
						path.push_back(string(1, c) + char('0' + i));
					}
				} else {
					for (char c = 'h'; c >= 'a'; --c) {
						path.push_back(string(1, c) + char('0' + i));
					}
				}
			}
			for (char c = 'a'; c <= 'h'; ++c) {
				if (c != 'b') {
					path.push_back(string(1, c) + '7');
				}
			}
			path.push_back(string("b") + '7');
			path.push_back(string("b") + '8');
			for (char c = 'a'; c <= 'h'; ++c) {
				if (c != 'b') {
					path.push_back(string(1, c) + '8');
				}
			}
		}

		for (int i = path.size() - 2; i > 0 && path.size() - 1 > n; i--) {
			if (path[i][0] == path[i + 1][0] && path[i][0] == path[i - 1][0]) {
				path.erase(path.begin() + i);
			} else if (path[i][1] == path[i + 1][1] && path[i][1] == path[i - 1][1]) {
				path.erase(path.begin() + i);
			}
		}

		for (auto it : path) {
			cout << it << " ";
		}
		cout << endl;
	}
};

struct Brute {
	void solve(istream& cin, ostream& cout) {
	}
};

int main() {
	Solver().solve(cin, cout);
}