#include <algorithm>
#include <cmath>
#include <functional>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

using LL = long long;
using pii = pair<int, int>;

#define X first
#define Y second

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const map<U, T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const pair<U, T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const pair<U, T>& v) {
	return out << "(" << v.first << ", " << v.second << ")";
}

template<typename U, typename T>
ostream& operator<<(ostream& out, const map<U, T>& v) {
	out << "{";
	bool f = false;
	for (const auto& p : v) {
		out << (!f ? "" : ", ") << p;
		f = true;
	}
	return out << "}";
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	out << "{";
	for (int i = 0; i < int(v.size()); ++i) {
		out << (i == 0 ? "" : ", ") << v[i];
	}
	return out << "}";
}

void cerr_printer(bool start) {}
template<typename T, typename ... Args>
void cerr_printer(bool start, const T& x, const Args& ... args) {
	if (!start) cerr << ", ";
	cerr << x;
	cerr_printer(false, args...);
}

template<typename ... Args>
void dbg(const char * name, int line, const Args& ... args) {
	cerr << "[" << line << "] (" << name << ") = (";
	cerr_printer(true, args...);
	cerr << ")" << endl;
}

#define DBG(...) {dbg(#__VA_ARGS__, __LINE__, __VA_ARGS__); }

struct Solver {
	LL solve(LL k, vector<int> b) {
		LL sum = 0;
		for (int x : b) sum += x;

		LL l = 0;
		LL r = 1e10;
		while (r - l > 1) {
			LL mid = (l + r) / 2;

			LL rs = mid % 7;
			LL tt = mid / 7;
			LL cur = sum * tt;
			for (int i = 0; i < rs; ++i) cur += b[i];
			if (cur >= k) r = mid;
			else l = mid;
		}

		return r;
	}

	void solve(istream& cin, ostream& cout) {
		LL k;
		cin >> k;
		vector<int> a(7);
		for (int& x : a) cin >> x;

		LL res = 1e9;
		for (int i = 0; i < 7; ++i) {
			vector<int> b(7);
			for (int j = 0; j < 7; ++j) {
				b[j] = a[(i + j) % 7];
			}

			res = min(res, solve(k, b));
		}

		cout << res << endl;
	}
};

struct Brute {
	void solve(istream& cin, ostream& cout) {
	}
};

int main() {
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		Solver().solve(cin, cout);
	}
}