#include <algorithm>
#include <cmath>
#include <functional>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

using LL = long long;
using pii = pair<int, int>;

#define X first
#define Y second

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const map<U, T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const pair<U, T>& v);

template<typename U, typename T>
ostream& operator<<(ostream& out, const map<U, T>& v) {
	return out << "(" << v.first << ", " << v.second << ")";
}

//template<typename U, typename T>
//ostream& operator<<(ostream& out, const map<U, T>& v) {
//	out << "{";
//	bool f = false;
//	for (const auto& p : v) {
//		out << (!f ? "" : ", ") << p;
//		f = true;
//	}
//	return out << "}";
//}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	out << "{";
	for (int i = 0; i < int(v.size()); ++i) {
		out << (i == 0 ? "" : ", ") << v[i];
	}
	return out << "}";
}

void cerr_printer(bool start) {}
template<typename T, typename ... Args>
void cerr_printer(bool start, const T& x, const Args& ... args) {
	if (!start) cerr << ", ";
	cerr << x;
	cerr_printer(false, args...);
}

template<typename ... Args>
void dbg(const char * name, int line, const Args& ... args) {
	cerr << "[" << line << "] (" << name << ") = (";
	cerr_printer(true, args...);
	cerr << ")" << endl;
}

#define DBG(...) {dbg(#__VA_ARGS__, __LINE__, __VA_ARGS__); }

struct Solver {
	void solve(istream& cin, ostream& cout) {
		int a, b;
		cin >> a >> b;
		cout << a + b << endl;
	}
};

int main() {
	int n, k;
	cin >> n >> k;

	vector<pair<int,int>> a(n);
	for (auto & it : a)
		cin >> it.second;
	for (auto & it : a)
		cin >> it.first;

	set<int> was;
	vector<int> cnt(k + 1, 0);
	for (auto it : a) {
		was.insert(it.second);
		cnt[it.second]++;
	}

	int res = was.size();

	sort(a.begin(), a.end());

	LL ans = 0;
	for (int i = 0; i < n && res < k; ++i) {
		if (cnt[a[i].second] > 1) {
			res++;
			cnt[a[i].second]--;
			ans += a[i].first;
		}
	}

	cout << ans << endl;
}