#include <bits/stdc++.h>

using namespace std;

const int N = 30;
int g[N][N];
int where[N];
bool comp_graph[N][N];
bool visited[N];

int n;
vector<int> order;
vector<vector<int>> comps;

void dfs1(int v) {
    visited[v] = true;
    for (int to = 0; to < n; ++to) {
        if (!g[v][to])
            continue;
        if (!visited[to]) {
            dfs1(to);
        }
    }
    order.push_back(v);
}

void dfs2(int v) {
    comps.back().push_back(v);
    where[v] = comps.size() - 1;
    visited[v] = true;
    for (int to = 0; to < n; ++to) {
        if (!g[to][v])
            continue;
        if (!visited[to]) {
            dfs2(to);
        }
    }
}

const int F = 100;
char field[N][F][F];
const int BEGIN = 20;
const int DELTA = 5;

int to_layer(int idx) {
    return BEGIN - 2 * idx;
}

void make_tunnel(int from, int to) {
    int x = DELTA * from + 2;
    int y = DELTA * to + 2;

    from = to_layer(from);
    to = to_layer(to);
//    cout << from << ' '  << to << endl;

    for (int h = from - 1; h >= to + 1; --h) {
        for (int dx = -1; dx <= 1; ++dx) {
            for (int dy = -1; dy <= 1; ++dy) {
                field[h][x + dx][y + dy] = '#';
            }
        }
//        cout << "H " << h << ' ' << x << ' ' << y << endl;
        field[h][x][y] = '.';
    }
}

int main()
{
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> g[i][j];
        }
    }


    for (int i = 0; i < n; ++i) {
        if (!visited[i]) {
            dfs1(i);
        }
    }
//    cout << "HERE" << endl;

    reverse(order.begin(), order.end());
    fill(visited, visited + N, false);

    for (int i = 0; i < n; ++i) {
        if (!visited[i]) {
            comps.emplace_back();
            dfs2(i);
        }
    }

//    for (auto c : comps) {
//        cout << "Comp" << endl;
//        for (int i : c) {
//            cout << i << ' ';
//        }
//        cout << endl;
//    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (!g[i][j] || where[i] == where[j])
                continue;
            comp_graph[where[i]][where[j]] = true;
        }
    }




    for (int i = BEGIN; i >= 0; --i) {
        char f = i % 2 == 0 ? '.' : '#';
        for (int j = 0; j < F; ++j) {
            for (int k = 0; k < F; ++k) {
//                cout << i << ' ' << j << ' ' << k << endl;
                field[i][j][k] = f;
            }
        }
    }




    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (comp_graph[i][j]) {
                if (i > j) {
                    cout << "WTFFFFFFFFFFFF";
                    return 1;
                }
//                cout << "Tunnel " << i << ' ' << j << endl;
                make_tunnel(i, j);
            }
        }
    }



//    return 0;

    cout << F << ' '  << F << ' ' << BEGIN << '\n';
    for (int h = BEGIN; h >= 0; --h) {
        for (int i = 0; i < F; ++i) {
            for (int j = 0; j < F; ++j) {
                cout << field[h][i][j];
            }
            cout << '\n';
        }

        cout << '\n';
    }

    return 0;
}
