#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cassert>

using namespace std;

const int N = 201;

bool dp[N][N][4][4];
pair <int, int> pr[N][N][4][4];
pair <int, int> ans[N][N];

void relax(int a, int b, int wina, int winb, pair <int, int> score) {
    if (a >= N || b >= N || wina > 3 || winb > 3) {
        return;
    }
    dp[a][b][wina][winb] = 1;
    pr[a][b][wina][winb] = score;
}

int main() {
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    dp[0][0][0][0] = true;
    for (int games = 0; games < 5; ++games) {
        for (int wina = 0; wina <= games && wina < 3; ++wina) {
            int winb = games - wina;
            if (winb >= 3)
                continue;
            for (int a = 0; a < N; ++a) {
                for (int b = 0; b < N; ++b) {
                    if (!dp[a][b][wina][winb]) {
                        continue;
                    }
                    if (games == 4) {
                        //a wins
                        //[15 : x]
                        for (int x = 0; x <= 13; ++x) {
                            relax(a + 15, b + x, wina + 1, winb, { 15, x });
                        }
                        //[n + 2 : n]
                        for (int ascore = 16; ascore + a < N; ++ascore) {
                            relax(a + ascore, b + ascore - 2, wina + 1, winb, { ascore, ascore - 2 });
                        }

                        for (int x = 0; x <= 13; ++x) {
                            relax(a + x, b + 15, wina, winb + 1, { x, 15 });
                        }
                        //[n + 2 : n]
                        for (int bscore = 16; b + bscore < N; ++bscore) {
                            relax(a + bscore - 2, b + bscore, wina, winb + 1, { bscore - 2, bscore });
                        }
                    } else {
                        //a wins
                        //[25 : x]
                        for (int x = 0; x <= 23; ++x) {
                            relax(a + 25, b + x, wina + 1, winb, { 25, x });
                        }
                        //[n + 2 : n]
                        for (int ascore = 26; ascore + a < N; ++ascore) {
                            relax(a + ascore, b + ascore - 2, wina + 1, winb, { ascore, ascore - 2 });
                        }

                        for (int x = 0; x <= 23; ++x) {
                            relax(a + x, b + 25, wina, winb + 1, { x, 25 });
                        }
                        //[n + 2 : n]
                        for (int bscore = 26; b + bscore < N; ++bscore) {
                            relax(a + bscore - 2, b + bscore, wina, winb + 1, { bscore - 2, bscore });
                        }
                    }

                }
            }
        }
    }
    for (int a = 0; a < N; ++a) {
        for (int b = 0; b < N; ++b) {
            pair <int, int> mx = { -1, -1 };
            if (a == 75 && b == 0) {
                a = a;
            }
            for (int wina = 0; wina <= 3; ++wina) {
                for (int winb = 0; winb <= 3; ++winb) {
                    if (wina == 3 || winb == 3) {
                        if (dp[a][b][wina][winb]) {
                            mx = max(mx, { wina, winb });
                        }
                    }
                }
            }
            ans[a][b] = mx;
        }
    }
    int T;
    cin >> T;
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    while (T--) {
        int a, b;
        cin >> a >> b;
        if (ans[a][b].first == -1) {
            cout << "IMPOSSIBLE\n";
        } else {
            cout << ans[a][b].first << ":" << ans[a][b].second << endl;
            pair <int, int> cur = { a, b };
            vector <pair<int, int>> scores;
            int wina = ans[a][b].first;
            int winb = ans[a][b].second;
            while (cur != pair<int,int>(0,0)) {
                pair <int,int> score = pr[a][b][wina][winb];
                a -= score.first;
                b -= score.second;
                if (score.first > score.second)
                    wina--;
                else
                    winb--;
                scores.push_back(score);
                cur = { a, b };
            }
            reverse(scores.begin(), scores.end());
            for (auto x : scores) {
                cout << x.first << ":" << x.second << " ";
            }
            cout << endl;
        }
    }
    return 0;
}