#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cassert>
#include <bitset>

using namespace std;

const int N = 501;
int a[N][N];
vector <int> g[N];
bool shot[N];
bitset<N> bestxx[N][N];
int keep = 0;

int main() {
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int m;
    cin >> m;
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            a[k][i] = -1;
        }
    }
    for (int k = 0; k < n; ++k) {
        a[k][k] = 0;
    }
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        int s;
        cin >> s;
        --s;
        for (int i = 0; i + 1 < k; ++i) {
            int t;
            cin >> t;
            --t;
            a[t][s] = a[s][t] = 1;
            g[s].push_back(t);
            g[t].push_back(s);
            s = t;
        }
    }

    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            if (a[i][k] == -1)
                continue;
            for (int j = 0; j < n; ++j) {
                if (a[k][j] == -1)
                    continue;
                if (a[i][j] == -1 || (a[i][j] > a[i][k] + a[k][j])) {
                    a[i][j] = a[i][k] + a[k][j];
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto x : g[i]) {
            for (int j = 0; j < n; ++j) {
                if (1 + a[x][j] == a[i][j]) {
                    bestxx[i][x][j] = 1;
                }
            }
        }
    }
    int T = n;
    while (T--) { //O(T)
        set <int> candidates;
        fill(shot, shot + n, false);
        for (int i = 0; i < n; ++i)
            candidates.insert(i);
        bool found = false;
        while (candidates.size() > 1) {
            bitset<N> possiblecands;
            for (auto x : candidates) {
                possiblecands[x] = 1;
            }
            int bestshoot = -1;
            int willbeleft = candidates.size();
            for (int root = 0; root < n; ++root) {
                if (shot[root])
                    continue;
                if (candidates.count(root) == 0) continue;
                int keep = 0;
                for (int adjacent : g[root]) { //O(N)
                    bitset<N> there = bestxx[root][adjacent];
                    int cnt = (there & possiblecands).count();
                    keep = max(keep, cnt);
                }
                if (keep < willbeleft) {
                    bestshoot = root;
                    willbeleft = keep;
                }
            }
            cout << bestshoot + 1 << endl;
            shot[bestshoot] = 1;
            string s;
            cin >> s;
            if (s == "FOUND") {
                found = true;
                candidates = { bestshoot };
            } else {
                int go;
                cin >> go;
                --go;
                int root = bestshoot;
                set <int> newcands;
                for (int c : candidates) {
                    if (a[root][c] == 1 + a[go][c]) {
                        newcands.insert(c);
                    }
                }
                newcands.swap(candidates);
            }
        }
        if (!found) {
            cout << (*candidates.begin()) + 1 << endl;
            string res;
            cin >> res;
        }
    }
    return 0;
}