#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cassert>

using namespace std;

const int N = 1e5;
const long long INF = 1LL<<30;

int main() {
    int n, k;
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int k;
        cin >> k;
        int a[7];
        int summer = 0;
        for (int i = 0; i < 7; ++i) {
            cin >> a[i];
            summer += a[i];
        }
        auto getsum = [&](long long l, long long r) {
            int keeper = 0;
            if (r - l < 21) {
                for (; l != r; ++l) {
                    keeper += a[l % 7];
                }
                return keeper;
            }
            int l2 = l;
            int r2 = r;
            long long lef[7];
            long long rig[7];
            for (int i = 0; i < 7; ++i) {
                lef[l % 7] = l;
                ++l;
            }
            for (int j = 0; j < 7; ++j) {
                --r;
                rig[r % 7] = r;
            }
            for (int val = 0; val < 7; ++val) {
                if (a[val]) 
                    keeper += (rig[val] - lef[val] + 7) / 7;
            }                        
            return keeper;
        };
        long long answer = INF;
        for (int start = 0; start < 7; ++start) {
            long long l = start;
            long long r = start + INF;
            while (l < r - 1) {
                long long mid = (l + r) / 2;
                if (getsum(start, mid) < k) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            answer = min(answer, r - start);
        }
        cout << answer << endl;
    }
    return 0;
}