#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cassert>

using namespace std;

const int N = 10;
vector <int> g[N];
vector <int> gr[N];

vector <int> ans;
vector <vector <int>> components;
int compid[N];
bool used[N];

bool mark[N][N];

void dfs(int i) {
    if (used[i])
        return;
    used[i] = true;
    for (auto x : g[i]) {
        dfs(x);
    }
    ans.push_back(i);
}

void dfs2(int i) {
    if (used[i])
        return;
    used[i] = true;
    for (auto x : gr[i]) {
        dfs2(x);
    }
    compid[i] = components.size() - 1;
    components.back().push_back(i);
}

bool a[N][N];

int main() {
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                a[i][j] = max(a[i][j], a[i][k] && a[k][j]);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int k = a[i][j];
            if (k) {
                g[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
    for (int a = 0; a < n; ++a) {
        dfs(a);
    }
    fill(used, used + n, false);
//  reverse(ans.begin(), ans.end());
    for (int i = n - 1; i >= 0; --i) {
        int v = ans[i];
        if (!used[v]) {
            components.push_back({});
            dfs2(v);
        }
    }
    //reverse(components.begin(), components.end());
    for (auto comp : components) {
        for (auto from : comp) {
            for (auto to : g[from]) {
                mark[compid[from]][compid[to]] = 1;
            }
        }
    }
    for (int i = 0; i < N; ++i) {
        mark[i][i] = true;
    }
    const int KEEP = components.size() * 2;
    vector <vector <string>> field;
    int cnt = components.size();
    int compnumber = 0;
    for (auto comp : components) {
        vector <string> levelTop(3, string(KEEP, '.'));
        vector <string> levelBot(3, string(KEEP, '.'));
        levelBot[1] = levelBot[2] = string(KEEP, '#');
        for (int i = 0; i < components.size(); ++i) {
            levelTop[0][i * 2 + 1] = '#';
        }
        for (int i = 0; i <= compnumber; ++i) {
            levelBot[0][i * 2] = '#';
        }
        for (int i = 0; i < cnt; ++i) {
            if (!mark[compnumber][i]) {
                levelTop[1][i * 2] = '#';
            }
        }

        int id = 0;
        for (auto x : comp) {
            levelTop[2][id] = x + '1';
            levelBot[2][id] = '#';
            id++;
        }
        field.push_back(levelTop);
        field.push_back(levelBot);
        ++compnumber;
    }
    {
        vector <string> levelTop(3, string(KEEP, '.'));
        vector <string> levelBot(3, string(KEEP, '.'));
        field.push_back(levelTop);
        field.push_back(levelTop);
        field.push_back(levelTop);
        field.push_back(levelTop);
        field.push_back(levelTop);
        field.push_back(levelTop);
    }
    cout << KEEP << " " << 3 << " " << field.size() << endl;
    for (const auto& x : field) {
        for (const auto& y : x) {
            cout << y << endl;
        }
        cout << endl;
    }
    return 0;
}