#pragma comment(linker, "/STACK:134217728")
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <functional>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

typedef long long ll;

int gcd(int a, int b, int &x, int &y) {
	if (a == 0) {
		x = 0;
		y = 1;
		return b;
	}
	int x1, y1;
	int d = gcd(b%a, a, x1, y1);
	x = y1 - (b / a)*x1;
	y = x1;
	return d;
}

int division(int n, int d) {
	while (n % d == 0)
		n /= d;
	return n;
}

int separate(int n) {
	int b = 1;
	if (n % 2 == 0) {
		b = division(n, 2);
	}
	for (int i = 3; i*i < n; i += 2) {
		if (n % i == 0) {
			b = division(n, i);
			break;
		}
	}
	return b;
}

int solve()
{
	int n;
	cin >> n;
	int b1, b2;
	b2 = separate(n);
	b1 = n / b2;
	if (min(b1, b2) == 1) {
		cout << "NO\n";
		return 0;
	}
	int a1, a2;
	gcd(b1, b2, a2, a1);
	if (a2 < 0) {
		a2 = -a2;
		a1 = n / b2 - a1;
	}
	else {
		a1 = -a1;
		a2 = n / b1 - a2;
	}
	cout << "YES\n";
	cout << 2 << '\n';
	cout << a1 << " " << b1 << '\n';
	cout << a2 << " " << b2;
	return 0;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	solve();
	return 0;
}