#pragma comment(linker, "/STACK:134217728")
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <functional>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

typedef long long ll;

ll GetSum(int l, int r, const vector<int>& sum)
{
	if (l == 0)
		return sum[r];
	return sum[r] - sum[l - 1];
}

void Solve()
{
	int k;
	vector<int> schedule(7);
	vector<int> sum(7);
	cin >> k;
	for (int i = 0; i < 7; i++)
	{
		cin >> schedule[i];
		sum[i] = (i == 0 ? 0 : sum[i - 1]) + schedule[i];
	}
	auto total = sum[6];
	ll ans = (ll)1e9;
	for (int i = 0; i < 7; i++)
	{
		for (int j = 0; j < 7; j++)
		{
			ll tails = GetSum(i, 6, sum) + GetSum(0, j, sum);
			ll weeks = (k - tails + total - 1) / total;
			ll total_days = weeks * 7 + (7 - i) + (j + 1);
			if (total_days < ans)
			{
				ans = total_days;
			}
		}
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		Solve();
	}
	return 0;
}