import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class Main {
    FastInput in;
    PrintWriter out;

    class Solver {
        void solve() {
            int n = in.readInt();
            if (n <= 14) {
                solve14Minus(n);
                return;
            }
            if (n == 15) {
                solve15();
                return;
            }
            solve16Plus(n);
        }

        void solve14Minus(int n) {
            n -= 2;
            for (int x = 2; x < 8; x++) {
                if (n > 0) {
                    n--;
                    print(x, 1);
                }
            }
            print(8, 1);
            for (int y = 2; y < 8; y++) {
                if (n > 0) {
                    n--;
                    print(8, y);
                }
            }
            print(8, 8);
        }

        void solve15() {
            for (int r = 2; r <= 8; r++) print(r, 1);
            print(8, 2);
            print(7, 2);
            print(7, 3);
            print(7, 4);
            print(7, 5);
            print(7, 6);
            print(7, 8);
            print(8, 8);
        }

        void solve16Plus(int n) {
            List<Pair> order = new ArrayList<>();
            for (int i = 0; i < 3; i++) {
                int c0 = 1 + i * 2;
                for (int r = 1; r <= 8; r++) {
                    order.add(new Pair(r, c0));
                }
                for (int r = 8; r >= 1; r--) {
                    order.add(new Pair(r, c0 + 1));
                }
            }
            order.add(new Pair(1, 7));
            for (int r = 8; r >= 2; r--) order.add(new Pair(r, 7));
            order.add(new Pair(2, 8));
            order.add(new Pair(1, 8));
            for (int r = 3; r <= 8; r++) {
                order.add(new Pair(r, 8));
            }
            n -= 16;
            for (int i = 1; i < order.size(); i++) {
                Pair p = order.get(i);
                boolean strictlyNeed = p.first == 1 || p.first == 8 ||
                        (p.first == 2 && (p.second == 7 || p.second == 8));
                if (p.first == 1 && p.second == 8) strictlyNeed = false;
                boolean need = strictlyNeed;
                if (!need && n > 0) {
                    n--;
                    need = true;
                }
                if (need) print(p.first, p.second);
            }
        }

        String get(int r, int c) {
            char x = (char) (r + '0');
            char y = (char) (c + 'a' - 1);
            return y + "" + x;
        }

        boolean any = false;
        void print(int r, int c) {
            if (!any) {
                out.print("a1");
                any = true;
            }
            out.print(" " + get(r, c));
        }
    }

    class Pair implements Comparable<Pair> {
        int first, second;

        Pair(int first, int second) {
            this.first = first;
            this.second = second;
        }

        @Override
        public int compareTo(Pair o) {
            int c = Integer.compare(first, o.first);
            if (c == 0) c = Integer.compare(second, o.second);
            return c;
        }
    }

    void run() {
        in = new FastInput();
        out = new PrintWriter(System.out);
        new Solver().solve();
        out.close();
    }

    public static void main(String[] args) {
        new Main().run();
    }

    class FastInput {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer("");

        String next() {
            try {
                while (!st.hasMoreTokens()) {
                    st = new StringTokenizer(br.readLine());
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            return st.nextToken();
        }

        int readInt() {
            return Integer.parseInt(next());
        }
    }
}
