// ConsoleApplication1.cpp : Defines the entry point for the console application.
//
#define USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <set>
#include<map>
#define for0(i, n) for(int i = 0; i < n; i++)
using namespace std;

vector<bool>was;
vector<bool>was_sets;
vector<int>parent;
vector<vector<int>>g;
map<int, set<int>>groups;
vector<vector<bool>>reachable;
vector<int>topsorted_sets;
int n;
void dfs(int v) {
	was[v] = true;
	for (int j = 0; j < n; j++) {
		if (!was[j] && g[v][j] == 1) {
dfs(j);
		}
	}
}

int find_set(int v) {
	if (v == parent[v]) return v;
	return parent[v] = find_set(parent[v]);
}

void union_sets(int a, int b) {
	a = find_set(a);
	b = find_set(b);
	if (a != b) {
		parent[b] = a;
	}
}


void dfs_on_sets(int v) {
	was_sets[v] = true;
	for (set<int>::iterator it = groups[v].begin(); it != groups[v].end(); ++it) {
		for (map<int, set<int>>::iterator it2 = groups.begin(); it2 != groups.end(); ++it2) {
			if (it2->first != v) {
				if (!was_sets[it2->first]) {
					for (set<int>::iterator it3 = it2->second.begin(); it3 != it2->second.end(); ++it3) {
						if (g[*it][*it3]) {
							dfs_on_sets(it2->first);
							//topsorted_sets.push_back(v);
						}
					}
				}
			}
		}
	}
	topsorted_sets.push_back(v);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	/*int m;
	cin >> m;
	while (m--) {
		int a, b;
		cin >> a >> b;
		if (a < 65 && b < 65) {
			cout << "Impossible\n";
			continue;
		}

		if (a )
	}*/

	//int n;
	cin >> n;
	was.resize(n, false);
	was_sets.resize(n, false);
	parent.resize(n);
	g.resize(n, vector<int>(n));
	//vector<vector<bool>>reachable(n, vector<bool>(n, false));
	reachable.resize(n, vector<bool>(n, false));
	for (int i = 0; i < n; i++) {
		parent[i] = i;
		for (int j = 0; j < n; j++) {
			cin >> g[i][j];
		}
	}
	for (int i = 0; i < n; i++) {
		dfs(i);
		for (int j = 0; j < n; j++) {
			if (was[j] && i != j) {
				reachable[i][j] = true;
			}
		}
		for (int j = 0; j < n; j++) {
			was[j] = false;
		}
	}


	//for (int f = 0; f < n; f++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i != j) {
					if (reachable[i][j] && reachable[j][i]) {
						union_sets(i, j);
					}
				}
			}
		}
	//}

	for (int i = 0; i < n; i++) {
		//cout << find_set(i) << " ";
		groups[find_set(i)].insert(i);
	}

	for (map<int, set<int>>::iterator it = groups.begin(); it != groups.end(); ++it) {
		if (!was_sets[it->first]) {
			dfs_on_sets(it->first);
		}
	}
	//dfs_on_sets(groups.begin()->first);
	reverse(topsorted_sets.begin(), topsorted_sets.end());
	/*for (int i = 0; i < topsorted_sets.size(); i++) {
		cout << topsorted_sets[i] << ": ";
		for (set<int>::iterator it = groups[topsorted_sets[i]].begin(); it != groups[topsorted_sets[i]].end(); ++it) {
			cout << *it << " ";
		}
		cout << '\n';
	}*/

	cout << n << " " << 1 << " " << 2 * groups.size()<<'\n';

	int leftt = 0;
	for (map<int, set<int>>::iterator it = groups.begin(); it != groups.end(); ++it) {
		for (int i = 0; i < leftt; i++) {
			cout << ".";
		}
		for (set<int>::iterator it2 = it->second.begin(); it2 != it->second.end(); ++it2) {
			cout << *it2+1;
		}
		for (int i = 0; i < n - leftt - it->second.size(); i++) {
			cout << ".";
		}
		cout << "\n\n";
		for (int i = 0; i < leftt; i++) {
			cout << ".";
		}
		for (set<int>::iterator it2 = it->second.begin(); it2 != it->second.end(); ++it2) {
			cout << "#";
		}
		for (int i = 0; i < n - leftt - it->second.size(); i++) {
			cout << ".";
		}
		cout << "\n\n";
		leftt += it->second.size();

	}

	return 0;
}

