#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ldb;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define mp make_pair
#define pii pair<int, int>

int read() {
	int x; cin >> x; return x;
}

void normalize(vector<pair<int, int>> &res) {
	vector<pair<int, int>> fst;
	vector<pair<int, int>> snd;

	for (int i = 0; i < res.size(); i++) {
		if (res[i].first > res[i].second) fst.push_back(res[i]);
		else snd.push_back(res[i]);
	}

	res.clear();
	if (fst.size() < snd.size()) swap(fst, snd);
	for (int i = 0; i < snd.size(); i++) {
		res.push_back(fst[i]);
		res.push_back(snd[i]);
	}
	for (int i = snd.size(); i < fst.size(); i++) {
		res.push_back(fst[i]);
	}
}

bool possible_match(int a, int b, int wa, int wb, vector<pair<int, int>> &res, bool ignore_5 = false) {
	res.clear();
	for (int i = 0; i < wa; i++) res.push_back(make_pair(25, 0));
	for (int i = 0; i < wb; i++) res.push_back(make_pair(0, 25));

	if (wa + wb == 5 && !ignore_5) {
		// 15 : x
		/*
		for (int pts = 0; pts <= 13; pts++) {
			if (possible_match(a - pts, b - 15, wa, wb - 1, res)) {
				res.push_back(make_pair(pts, 15));
				return true;
			}
			if (possible_match(a - 15, b - pts, wa - 1, wb, res)) {
				res.push_back(make_pair(15, pts));
				return true;
			}
		}
		*/
		// x + 2 : x

		if (possible_match(a + 10, b + 10, wa, wb, res, true)) {
			vector<pair<int, int>> nres;
			bool good = false;
			int sacred;

			if (wa > wb) {
				for (int i = 0; i < wa + wb; i++) {
					if ((res[i].first == 25 && res[i].second >= 10 && res[i].second < res[i].first)
						|| (res[i].first - res[i].second == 2)) {
						res[i].first -= 10;
						res[i].second -= 10;
						good = true;
						sacred = i;
						break;
					}
				}
			}
			else {
				for (int i = 0; i < wa + wb; i++) {
					if ((res[i].second == 25 && res[i].first >= 10 && res[i].first < res[i].second)
						|| (res[i].second - res[i].first == 2)) {
						res[i].first -= 10;
						res[i].second -= 10;
						good = true;
						sacred = i;
						break;
					}
				}
			}

			if (!good) return false;

			for (int i = 0; i < wa + wb; i++) {
				if (i != sacred) nres.push_back(res[i]);
			}
		
			nres.push_back(res[sacred]);

			res = nres;
			normalize(res);
			return true;
		}

		return false;
	}
	else {
		int ta = a - 25 * wa;
		int tb = b - 25 * wb;
		if (ta < 0 || tb < 0) return false;
		if (ta >= 23 || tb >= 23) {
			int mn = min(max(max(ta - 23 * wa, tb - 23 * wb), 0), min(min(ta, tb), max(ta - 23, tb - 23)));
			ta -= mn;
			tb -= mn;
			for (int i = 0; i < wa + wb; i++) {
				if (res[i].first == 0) {
					res[i].first = min(23, ta);
					ta -= res[i].first;
				}
				else {
					res[i].second = min(23, tb);
					tb -= res[i].second;
				}
			}
			for (int i = 0; i < wa + wb; i++) {
				if (abs(res[i].first - res[i].second) == 2) {
					res[i].first += mn;
					res[i].second += mn;
					mn = 0;
				}
			}
		}
		else {
			for (int i = 0; i < wa + wb; i++) {
				if (res[i].first == 0) {
					res[i].first = min(23, ta);
					ta -= res[i].first;
				}
				else {
					res[i].second = min(23, tb);
					tb -= res[i].second;
				}
			}
		}
		normalize(res);
		if (ta != 0 || tb != 0) return false;
		else return true;
	}
}

void solve() {
	//int tests = read();
	//for (int T = 0; T < tests; T++) {
		int a, b;
		cin >> a >> b;

		vector<pair<int, int>> res;
		if (possible_match(a, b, 3, 0, res)) {
			cout << "3:0" << endl;
			for (int i = 0; i < res.size(); i++) cout << res[i].first << ":" << res[i].second << " ";
			cout << endl;
		}
		else if (possible_match(a, b, 3, 1, res)) {
			cout << "3:1" << endl;
			for (int i = 0; i < res.size(); i++) cout << res[i].first << ":" << res[i].second << " ";
			cout << endl;
		}
		else if (possible_match(a, b, 3, 2, res)) {
			cout << "3:2" << endl;
			for (int i = 0; i < res.size(); i++) cout << res[i].first << ":" << res[i].second << " ";
			cout << endl;
		}
		else if (possible_match(a, b, 2, 3, res)) {
			cout << "2:3" << endl;
			for (int i = 0; i < res.size(); i++) cout << res[i].first << ":" << res[i].second << " ";
			cout << endl;
		}
		else if (possible_match(a, b, 1, 3, res)) {
			cout << "1:3" << endl;
			for (int i = 0; i < res.size(); i++) cout << res[i].first << ":" << res[i].second << " ";
			cout << endl;
		}
		else if (possible_match(a, b, 0, 3, res)) {
			cout << "0:3" << endl;
			for (int i = 0; i < res.size(); i++) cout << res[i].first << ":" << res[i].second << " ";
			cout << endl;
		}
		else cout << "Impossible" << endl;

		cout.flush();
	//}
}

signed main() {
	int t = read();
	while (t--) {
		clock_t t = clock();
		solve();
		fprintf(stderr, "Time : %.3f\n", (double)(clock() - t) / CLOCKS_PER_SEC);
	}
}