#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ldb;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define mp make_pair
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define endl '\n'

int read() {
	int x; cin >> x; return x;
}

const int N = 505;
vector<int> g[N];

int dfs(int u, int e = -1) {
	int s = 1;
	for (auto v : g[u])
		if (v != e)
			s += dfs(v, u);
	return s;
}

int cdc(int u, int s, int& p, int e = -1) {
	int sz = 1;
	for (auto v : g[u])
		if (v != e) {
			sz += cdc(v, s, p, u);
		}
	if (p == -1 && ((2 * sz >= s) || e == -1))
		p = u;
	return sz;
}

bool used[N];
int p[N];

vector<int> ccl[N];
int ccl_num = 0;
set<pii> restr;

map<pii, int> wh;

void find_cycles(int u, int e) {
	used[u] = true;
	p[u] = e;

	for (auto v : g[u])
		if (used[v] && v != e && !restr.count(minmax(u, v))) {
			int x = u;
			ccl[ccl_num].push_back(u);
			while (p[x] != v) {
				restr.insert(minmax(p[x], x));
				wh[minmax(p[x], x)] = ccl_num;
				ccl[ccl_num].push_back(p[x]);
				x = p[x];
			}
			ccl[ccl_num].push_back(v);
			restr.insert(minmax(u, v));
			wh[minmax(u, v)] = ccl_num;
			restr.insert(minmax(x, v));
			wh[minmax(x, v)] = ccl_num;
			ccl_num++;
		}
		else if (!used[v])
			find_cycles(v, u);
}

bool used2[N];
int dfs2(int v, int cyc) {
	if (used2[v]) return 0;
	used2[v] = true;
	int ans = 1;
	for (auto u : g[v]) {
		if (!restr.count(minmax(v, u)) || wh[minmax(v, u)] != cyc) ans += dfs2(u, cyc);
	}
	return ans;
}

vector<int> gc[N];
int n;

void start() {
	n = read();
	int m = read();
	forn(i, m) {
		int k = read();
		int last = -1;
		forn(j, k) {
			int u = read();
			if (last != -1) {
				gc[last].push_back(u);
				gc[u].push_back(last);
			}
			last = u;
		}
	}
}

void solve() {
	for (int i = 1; i <= n; i++)
		g[i] = gc[i];

	vector<bool> in_graph(n + 1, true);

	while (true) {
		restr.clear();
		wh.clear();
		forn(i, ccl_num) ccl[i].clear();
		ccl_num = 0;
		fill_n(used, N, 0);

		int cycv = 1;
		while (!in_graph[cycv]) cycv++;
		find_cycles(cycv, -1);

		/*forn(i, ccl_num) {
			for (auto v : ccl[i]) {
				cout << v << " ";
			}
			cout << endl;
		}*/

		int bew = N, bev = 0;
		for (int i = 1; i <= n; i++) {
			if (!in_graph[i]) continue;
			int maxedgew = 0;
			for (auto v : g[i]) {
				int edgew = 0;
				if (restr.count(minmax(i, v))) {
					int cyc = wh[minmax(i, v)];
					int pos;
					bool dir = true;
					int mod = ccl[cyc].size();
					for (int it = 0; it < mod; it++) {
						if (ccl[cyc][it] == v) {
							pos = it;
							if (ccl[cyc][(it + 1) % mod] == i) dir = false;
						}
					}
					fill_n(used2, N, 0);
					for (int it = pos; abs(it - pos) < mod / 2; dir ? it++ : it--) {
						edgew += dfs2(ccl[cyc][(it + mod) % mod], cyc);
					}
				}
				else {
					fill_n(used2, N, 0);
					used2[i] = true;
					edgew = dfs2(v, -1);
				}
				maxedgew = max(maxedgew, edgew);
			}
			if (maxedgew < bew) {
				bev = i;
				bew = maxedgew;
			}
		}

		cout << bev << endl;
		cout.flush();
		string s;
		cin >> s;
		if (s == "FOUND") return;
		else {
			int v;
			cin >> v;
			int i = bev;

			if (restr.count(minmax(i, v))) {
				int cyc = wh[minmax(i, v)];
				int pos;
				bool dir = true;
				int mod = ccl[cyc].size();
				for (int it = 0; it < mod; it++) {
					if (ccl[cyc][it] == v) {
						pos = it;
						if (ccl[cyc][(it + 1) % mod] == i) dir = false;
					}
				}
				fill_n(used2, N, 0);
				for (int it = pos; abs(it - pos) < mod / 2; dir ? it++ : it--) {
					dfs2(ccl[cyc][(it + mod) % mod], cyc);
				}
			}
			else {
				fill_n(used2, N, 0);
				used2[i] = true;
				dfs2(v, -1);
				used2[i] = false;
			}

			for (int it = 1; it <= n; it++) in_graph[it] = used2[it];
			for (int it = 1; it <= n; it++) {
				if (!in_graph[it]) g[it].clear();
				else {
					vector<int> tmp;
					for (auto u : g[it]) if (in_graph[u]) tmp.push_back(u);
					g[it] = tmp;
				}
			}
		}
	}
}

signed main() {
	int t = 1;
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	while (t--) {
		clock_t t = clock();
		start();
		forn(i, n) {
			solve();
		}
		fprintf(stderr, "Time : %.3f\n", (double)(clock() - t) / CLOCKS_PER_SEC);
	}
}