#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ldb;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define mp make_pair
#define pii pair<int, int>

ll gcdex(ll a, ll b, ll &x, ll &y) {
	if (a == 0) {
		x = 0, y = 1;
		return b;
	}
	ll xo, yo;
	ll d = gcdex(b % a, a, xo, yo);
	x = yo - (b / a) * xo, y = xo;
	return d;
}

void solve() {
	int n;
	cin >> n;

	int m = n;
	int p = 1, q;
	for (int i = 2; i * i <= n; i++) {
		if (n % i == 0) {
			while (m % i == 0) {
				m /= i;
				p *= i;
			}
			break;
		}
	}

	q = n / p;

	if (p == 1 || q == 1) cout << "NO" << endl;
	else {
		ll a, b;
		gcdex(p, q, a, b);
		a = -a, b = -b;
		a += q;

		ll shft = a / q;
		a -= shft * q, b += shft * p;

		if (a < 0) a += q, b -= p;
		if (a >= q) a -= q, b += p;

		cout << "YES" << endl;
		cout << "2" << endl;
		cout << b << ' ' << p << endl;
		cout << a << ' ' << q << endl;
	}
}

signed main() {
	int t = 1;
	while (t--) {
		clock_t t = clock();
		solve();
		fprintf(stderr, "Time : %.3f\n", (double)(clock() - t) / CLOCKS_PER_SEC);
	}
}