#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ldb;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define mp make_pair
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define endl '\n'

int read() {
	int x; cin >> x; return x;
}

struct node {
	ll min_time = -1, sum = 0, time = 0;
	node() {}
	node(ll min_time, ll sum, ll time) : min_time(min_time), sum(sum), time(time) {}
};

const int N = 1e6 + 5;
node t[4 * N];

node merge(node left, node right) {
	if (left.min_time == -1) return right;
	if (right.min_time == -1) return left;

	node ans;
	ans.min_time = min(left.min_time, right.min_time);
	ans.sum = left.sum + right.sum;
	ans.time = right.time + right.min_time - left.min_time
		+ max(0ll, left.min_time + left.time - right.min_time - (right.time - right.sum));
	return ans;
}

node get(int u, int l, int r, int L, int R) {
	if (l == L && r == R) {
		return t[u];
	}
	int m = (l + r) / 2;
	if (L < m && R <= m)
		return get(u * 2, l, m, L, R);
	if (L >= m && R > m) {
		return get(u * 2 + 1, m, r, L, R);
	}
	return merge(get(u * 2, l, m, L, min(m, R)), get(u * 2 + 1, m, r, max(L, m), R));
}

void update(int u, int l, int r, int i, int nt) {
	if (l == r - 1) {
		t[u] = { i, nt, nt };
		return;
	}
	int m = (l + r) / 2;
	if (i < m) {
		update(2 * u, l, m, i, nt);
	}
	else {
		update(2 * u + 1, m, r, i, nt);
	}

	t[u] = merge(t[2 * u], t[2 * u + 1]);
}

void build(int u, int l, int r) {
	if (l == r - 1) {
		t[u] = { l, 0, 0 };
		return;
	}
	int m = (l + r) / 2;
	build(u * 2, l, m);
	build(u * 2 + 1, m, r);
	t[u] = merge(t[u * 2], t[u * 2 + 1]);
}

vector<int> ev;

const int MAX_TIME = 1e6 + 5;

void solve() {
	int q; cin >> q;
	build(1, 0, MAX_TIME);
	forn(i, q) {
		char c; cin >> c;
		if (c == '?') {
			int t; cin >> t;
			auto nd = get(1, 0, MAX_TIME, 0, t + 1);
			cout << nd.time - t << endl;
			ev.push_back(-1488);
		}
		else if (c == '+') {
			int t, d; cin >> t >> d;
			update(1, 0, MAX_TIME, t, d);
			ev.push_back(t);
		}
		else {
			int x; cin >> x;
			update(1, 0, MAX_TIME, ev[x - 1], 0);
			ev.push_back(-1488);
		}
	}
}

signed main() {
	int t = 1;
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	while (t--) {
		clock_t t = clock();
		solve();
		fprintf(stderr, "Time : %.3f\n", (double)(clock() - t) / CLOCKS_PER_SEC);
	}
}