#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ldb;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define mp make_pair
#define pii pair<int, int>
#define all(x) x.begin(), x.end()

int read() {
	int x; cin >> x; return x;
}

const int N = 1e3;

int mt[N][N];
int used[N], n;

vector<int> order;

void dfs(int u) {
	if (used[u]) return;
	used[u] = true;
	forn(i, n)
		if (mt[u][i])
			dfs(i);
	order.push_back(u);
}

int col[N];

void dfs2(int u, int cl) {
	if (col[u] != -1) return;
	col[u] = cl;
	forn(i, n)
		if (mt[i][u])
			dfs2(i, cl);
}

int mn[N][N], cl = 0;

void dfs3(int u) {
	if (used[u]) return;
	used[u] = true;
	forn(i, cl)
		if (mn[u][i])
			dfs3(i);
	order.push_back(u);
}

void solve() {
	n = read();
	forn(i, n)
		forn(j, n)
			mt[i][j] = read();

	forn(i, n) dfs(i);
	reverse(all(order));

	//int cl = 0;

	fill_n(col, N, -1);

	for (auto v : order) 
		if (col[v] == -1)
			dfs2(v, cl++);

	fill_n(used, N, 0);

	forn(i, n)
		forn(j, n)
			if (mt[i][j]) 
				mn[col[i]][col[j]] = 1;

	order.clear();

	forn(i, cl) dfs3(i);

	reverse(all(order));

	for (auto v : order) cerr << v << " ";
	cerr << endl;

	int MINESIZE = 100; // min 10

	//  
	vector<vector<string>> minefield(MINESIZE, vector<string>(MINESIZE, string(MINESIZE, '.')));
	
	// Layers
	for (int i = 0; i < order.size(); i++) {
		for (int j = 0; j < MINESIZE; j++) {
			for (int k = 0; k < MINESIZE; k++) {
				minefield[2 * i + 1][j][k] = '#';
				if (j == 0 && k < n && order[i] == col[k]) minefield[2 * i][j][k] = (char)(k + '1');
			}
		}
	}

	vector<int> rev_order(n, -1);
	for (int i = 0; i < order.size(); i++) rev_order[order[i]] = i;

	// Shafts
	for (int i = 0; i < order.size(); i++) {
		for (int j = i + 1; j < order.size(); j++) {
			if (mn[order[i]][order[j]] == 1) {
				// 4x+3 4y+2
				minefield[2 * i + 1][4 * i + 3][4 * j + 2] = '.';
				for (int h = 2 * i + 2; h <= 2 * j; h++) {
					minefield[h][4 * i + 2][4 * j + 2] = '#';
					minefield[h][4 * i + 4][4 * j + 2] = '#';
					minefield[h][4 * i + 3][4 * j + 1] = '#';
					minefield[h][4 * i + 3][4 * j + 3] = '#';
					minefield[h][4 * i + 3][4 * j + 2] = '.';
				}
				minefield[2 * j][4 * i + 2][4 * j + 2] = '.';
			}
		}
	}

	cout << MINESIZE << ' ' << MINESIZE << ' ' << MINESIZE << endl;

	for (int i = 0; i < MINESIZE; i++) {
		for (int j = 0; j < MINESIZE; j++) {
			cout << minefield[i][j] << endl;
		}
		cout << endl;
	}
}

signed main() {
	int t = 1;
	while (t--) {
		clock_t t = clock();
		solve();
		fprintf(stderr, "Time : %.3f\n", (double)(clock() - t) / CLOCKS_PER_SEC);
	}
}