#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cmath>

using namespace std;

using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()

const int maxn = sqrt(1e9)+ 10;
vector<vector<int>> dp(300, vector<int>(maxn, -1));
vector<vector<int>> par(300, vector<int>(maxn, -1));

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	ll n;
	cin >> n;

	vll frct;
	frct.push_back(0);

	for (ll j = 2; j * j <= n; ++j) {
		if (n % j == 0) {
			ll sd = n / j;
			frct.push_back(j);
			frct.push_back(sd);
		}
	}

	sort(all(frct));
	frct.resize(unique(all(frct)) - frct.begin());
	frct[0] = maxn;
	dp[0].assign(maxn, n - 1);

	for (int i = 1; i < frct.size(); ++i)
	{
		for (int a = 0; a < frct[i - 1]; ++a)
		{
			if (dp[i - 1][a] == -1)continue;
			ll left = dp[i - 1][a];
			ll b = n / frct[i];
			for (int a2 = 1; a2 < frct[i]; ++a2)
			{
				if (a2 * b > left)
					break;
				dp[i][a2] = left - a2*b;
				par[i][a2] = a;
			}
			dp[i][0] = left;
			par[i][0] = a;
		}
	}

	for (int i = 1; i < frct.size(); ++i)
	{
		for (int a = 0; a < frct[i]; ++a)
		{
			if (dp[i][a] == 0)
			{
				vector<pair<int, int>> ans;
				int icur = i, acur = a;
				while (par[icur][acur] != -1)
				{
					if (acur != 0)
						ans.emplace_back(acur, frct[icur]);
					acur = par[icur][acur];
					icur--;
				}
				cout << "YES\n";
				cout << ans.size() << '\n';
				sort(all(ans));
				for (auto & x : ans)
					cout << x.first << ' ' << x.second << '\n';
				return 0;
			}
		}
	}

	cout << "NO";

	return 0;
}
