#include <bits/stdc++.h>
#include <random>
using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int N = 300228;

mt19937_64 mt{ 228 };

struct Node {
	using Ptr = Node*;
	Node* l;
	Node* r;
	ull y;
	ll t;
	ll d;
	ll sd;
	ll fin;
	ll beg;

	Node() = default;

	Node(ll t, ll d)
		: l(nullptr)
		, r(nullptr)
		, y(mt())
		, t(t)
		, d(d)
		, sd(d)
		, fin(t + d)
		, beg(t)
	{
	}
};

const ll INF = (1ll << 60);

using Ptr = Node::Ptr;

ll gsd(Ptr p) {
	return p ? p->sd : 0;
}

ll gfin(Ptr p) {
	return p ? p->fin : -INF;
}

ll gbeg(Ptr p) {
	return p ? p->beg : -INF;
}

using Pair = pair<Ptr, Ptr>;

void upd(Ptr p) {
	p->sd = gsd(p->l) + gsd(p->r) + p->d;
	ll ld = gsd(p->l);
	ll rd = gsd(p->r);
	p->fin = max({ gfin(p->l) + p->d + rd, p->t + p->d + rd, gfin(p->r) });
	p->beg = min({ gbeg(p->l), p->t - ld, gbeg(p->r) - p->d - ld });
}

Ptr merge(Ptr l, Ptr r) {
	if (!l) {
		return r;
	}

	if (!r) {
		return l;
	}

	Ptr t;
	if (l->y > r->y) {
		t = l;
		t->r = merge(l->r, r);
	}
	else {
		t = r;
		t->l = merge(l, r->l);
	}

	upd(t);
	return t;
}

Pair split(Ptr t, ll x) {
	if (!t) {
		return { {}, {} };
	}

	if (t->t <= x) {
		auto c = split(t->r, x);
		t->r = c.first;
		upd(t);
		c.first = t;
		return c;
	}
	else {
		auto c = split(t->l, x);
		t->l = c.second;
		upd(t);
		c.second = t;
		return c;
	}
}

Node nodes[N];

Ptr root = new Node(INF, 1);

ll entry[N];

int main() {
#ifdef BZ
	freopen("k.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(nullptr); cout.tie(nullptr); cout.setf(ios::fixed); cout.precision(20);
	int q;
	cin >> q;
	for (int i = 1; i <= q; ++i) {
		char tp;
		cin >> tp;
		if (tp == '+') {
			ll t, d;
			cin >> t >> d;
			entry[i] = t;
			nodes[i] = Node(t, d);
			auto spl = split(root, t);
			root = merge(spl.first, merge(nodes + i, spl.second));
		} else if (tp == '-') {
			int idx;
			cin >> idx;
			ll t = entry[idx];
			auto a = split(root, t - 1);
			auto b = split(a.second, t);
			root = merge(a.first, b.second);
		}
		else {
			ll t;
			cin >> t;
			auto a = split(root, t);
			
			Ptr l = a.first;
			Ptr r = a.second;
			ll x = max(t, gfin(l));

			cout << x - t << "\n";
			root = merge(l, r);
		}
	}

	return 0;
}