#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define F first
#define S second
#define eb emplace_back
#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef long double ld;
typedef pair<int, int> pii;

const int INF = int(1e9);
const ll INFll = ll(1e18);
const int MOD = INF + 7;

struct trie {
    map<char, int> nxt;
    bool leaf = 0;
};

vector<trie> t(1);

void add(const string& s) {
    int v = 0;
    for (char c : s) {
        if (!t[v].nxt.count(c)) {
            t[v].nxt[c] = t.size();
            t.pb(trie{});
        }
        v = t[v].nxt[c];
    }
    t[v].leaf = true;
}

bool parseNumber(const string& s, int l, int r, string& res) {
    if (s[l] >= '0' && s[l] <= '9') {
        res += s[l];
        for (int i = l + 1; i < r; ++i)
            if (s[i] >= '0' && s[i] <= '9') {
                res += s[i];
            } else {
                break;
            }
        return true;
    }
    return false;
}

bool allowed[256];
void initAllowed() {
    for (char c = 'a'; c <= 'z'; ++c)
        allowed[c] = true;
    for (char c = 'A'; c <= 'Z'; ++c)
        allowed[c] = true;
    for (char c = '0'; c <= '9'; ++c)
        allowed[c] = true;
    allowed['_'] = true;
    allowed['$'] = true;
}

bool parseWord(const string& s, int l, int r, string& res) {
    if (allowed[s[l]] && (s[l] < '0' || s[l] > '9')) {
        res += s[l];
        for (int i = l + 1; i < r; ++i)
            if (allowed[s[i]])
                res += s[i];
            else
                break;
        return true;
    }
    return false;
}

bool parseSpecial(const string& s, int l, int r, string& res) {
    int v = 0;
    int lst = -1;
    if (t[v].nxt.count(s[l])) {
        v = t[v].nxt[s[l]];
        if (t[v].leaf)
            lst = l;
        for (int i = l + 1; i < r; ++i) {
            if (t[v].nxt.count(s[i])) {
                v = t[v].nxt[s[i]];
                if (t[v].leaf)
                    lst = i;
            } else {
                break;
            }
        }
        if (lst == -1)
            return false;
        for (int i = l; i <= lst; ++i)
            res += s[i];
        return true;
    }
    return false;
}

vector<string> newtoks;
set<string> stoks;

void initNewtoks() {
    for (char x = 'a'; x <= 'z'; ++x) {
        string tmp;
        tmp += x;
        newtoks.pb(tmp);
    }
    for (char x = 'a'; x <= 'z'; ++x)
        for (char y = 'a'; y <= 'z'; ++y) {
            string tmp;
            tmp += x;
            tmp += y;
            newtoks.pb(tmp);
        }
    for (char x = 'a'; x <= 'z'; ++x)
        for (char y = 'a'; y <= 'z'; ++y)
            for (char z = 'a'; z <= 'z'; ++z) {
                string tmp;
                tmp += x;
                tmp += y;
                tmp += z;
                newtoks.pb(tmp);
            }
}

vector<string> parse(const string& s, int l, int r) {
    vector<string> ans;
    map<string, string> toks;
    int cur = 0;
    for (int i = l; i < r; ++i) {
        int v = 0;
        if (s[i] == ' ')
            continue;
        string num, word, special;
        parseNumber(s, i, r, num);
        parseWord(s, i, r, word);
        parseSpecial(s, i, r, special);
        if (num.empty() && word.empty() && special.empty()) {
            return vector<string>{};
        }
        string res;
        bool isword = false;
        if (special.size() >= word.size() && special.size() >= num.size()) {
            res = special;
        } else if (word.size() >= num.size()) {
            res = word;
            isword = true;
        } else
            res = num;
        i += res.size() - 1;
        if (isword) {
            if (!toks.count(res)) {
                while (stoks.count(newtoks[cur]))
                    cur++;
                toks[res] = newtoks[cur++];
            }
            res = toks[res];
        }
        ans.pb(res);
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    initAllowed();
    initNewtoks();
    int k;
    cin >> k;
    string s;
    for (int i = 0; i < k; ++i) {
        cin >> s;
        add(s);
        stoks.insert(s);
    }
    int n;
    cin >> n;
    getline(cin, s);
    string a;
    for (int i = 0; i < n; ++i) {
        getline(cin, s);
        for (char c : s) {
            if (c == '#')
                break;
            a += c;
        }
        a += ' ';
    }

    auto res = parse(a, 0, a.size());
    string ans;
    for (auto s : res) {
        string s1 = ans + s;
        string s2 = ans + " " + s;
        if (parse(s1, 0, s1.size()) != parse(s2, 0, s2.size()))
            ans += " " + s;
        else
            ans += s;
    }
    cout << ans << endl;
    return 0;
}
