#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define F first
#define S second
#define eb emplace_back
#define all(x) x.begin(), x.end()

using namespace std;

#define left sdfsd
#define right fsdghfdhj

typedef long long ll;
typedef vector<int> vi;
typedef long double ld;
typedef pair<int, int> pii;


const int INF = int(1e9);
const ll INFll = ll(1e18);
const int MOD = INF + 7;

const int maxn = 300500;

int left[maxn];
int right[maxn];
int t[maxn], d[maxn];

vector <int> indexes[4 * maxn];

void add(int v, int l, int r, int x, int tl, int tr) {
    if (l <= tl && tr <= r) {
        indexes[v].push_back(x);
        return;
    }
    int tm = (tl + tr) / 2;
    if (l <= tm){
        add(v + v, l, r, x, tl, tm);
    }
    if (r > tm) {
        add(v + v + 1, l, r, x, tm + 1, tr);
    }
}

vector <pair<int*, int> > rollbacks;

const int maxv = 2000500;

int tree[4 * maxv];
int zeroes[4 * maxv];
int pu[4 * maxv];

void apply(int v, int x) {
    rollbacks.eb(&tree[v], tree[v]);
    rollbacks.eb(&pu[v], pu[v]);
    tree[v] = x;
    pu[v] = x;
    if (zeroes[v] != 0) {
        rollbacks.eb(&zeroes[v], zeroes[v]);
        zeroes[v] = 0;
    }
}

void push(int v) {
    if (pu[v] == -1) return;
    apply(v + v, pu[v]);
    apply(v + v + 1, pu[v]);
    rollbacks.eb(&pu[v], pu[v]);
    pu[v] = -1;
}

void paint(int v, int l, int r, int x, int tl, int tr){
    if (l <= tl && tr <= r) {
        apply(v, x);
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    if (l <= tm) {
        paint(v + v, l, r, x, tl, tm);
    }
    if (r > tm) {
        paint(v + v + 1, l, r, x, tm + 1, tr);
    }
    rollbacks.eb(&zeroes[v], zeroes[v]);
    zeroes[v] = zeroes[v + v] + zeroes[v + v + 1];
}

int getZeroes(int v, int l, int r, int tl, int tr) {
    if (l <= tl && tr <= r) {
        return zeroes[v];
    }
    push(v);
    int tm = (tl + tr) / 2;
    if (r <= tm) {
        return getZeroes(v + v, l, r, tl, tm);
    }
    if (l > tm) {
        return getZeroes(v + v + 1, l, r, tm + 1, tr);
    }
    return getZeroes(v + v, l, r, tl, tm) + getZeroes(v + v + 1, l, r, tm + 1, tr);
}

int findKth(int v, int k, int tl, int tr) {
    if (tl == tr) {
        return tl;
    }
    push(v);
    int tm = (tl + tr) / 2;
    if (zeroes[v + v] >= k) {
        return findKth(v + v, k, tl, tm);
    }
    return findKth(v + v + 1, k - zeroes[v + v], tm + 1, tr);
}


int findKth(int k, int pos) {
//    cout << "kth CC" << k << ' ' << pos << ' ';
    int cnt = (pos == 1 ? 0 : getZeroes(1, 1, pos - 1, 1, maxv - 1));
    k += cnt;
//    cout << k << ' ';
    if (zeroes[1] < k) return -1;
    int ans = findKth(1, k, 1, maxv - 1);
//    cout << ans << endl;
    return ans;
}

int go(int v, int index, int tl, int tr) {
    if (tl == tr) {
        return tree[v];
    }
    push(v);
    int tm = (tl + tr) / 2;
    if (index <= tm) {
        return go(v + v, index, tl, tm);
    }
    return go(v + v + 1, index, tm + 1, tr);
}

void append(int x) {
    int color = go(1, t[x], 1, maxv - 1);
    if (color == 0) color = x;
    int pos = findKth(d[x], t[x]);
    if (pos == -1) return;
//    cout << "append " << t[x] << ' ' << pos << ' ' << color << endl;
    paint(1, t[x], pos, color, 1, maxv - 1);
}

ll fenw[maxv];

void addFenw(int x, int value) {
    for (; x < maxv; x |= x + 1) {
        fenw[x] += value;
    }
}

ll getFenw(int x) {
    ll ret = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1) {
        ret += fenw[x];
    }
    return ret;
}

ll getFenw(int l, int r) {
    return getFenw(r) - getFenw(l - 1);
}

long long calc(int t) {
    int color = go(1, t, 1, maxv - 1);
//    cout << "calc " << t << 'C ' << color << endl;
    if (color == 0) return 0;
    int l = ::t[color];
    int r = t;
    return ::t[color] - t + getFenw(l, r);
}

int query[maxn];

void dfs(int v, int l, int r) {
    int k = (int)rollbacks.size();
//    cout << v << ' ' << l << ' ' << r << ' ' << k << endl;
    for (auto x: indexes[v]) {
        addFenw(t[x], d[x]);
        append(x);
    }
    if (l != r) {
        int m = (l + r) / 2;
        dfs(v + v, l, m);
        dfs(v + v + 1, m + 1, r);
    } else if (query[l] != -1) {
        cout << calc(query[l]) << '\n';
    }
    while(rollbacks.size() > k) {
        *rollbacks.back().first = rollbacks.back().second;
        rollbacks.pop_back();
    }
    for (auto x: indexes[v]) {
        addFenw(t[x], -d[x]);
    }
}

void initZeroes(int v, int tl, int tr) {
    zeroes[v] = tr - tl + 1;
    if (tl == tr) return;
    int tm = (tl + tr) / 2;
    initZeroes(v + v, tl, tm);
    initZeroes(v + v + 1, tm + 1, tr);
}

int main() {
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    memset(left, -1, sizeof left);
    memset(pu, -1, sizeof pu);
    memset(right, -1, sizeof right);
    memset(query, -1, sizeof query);

    initZeroes(1, 1, maxv - 1);

    int q;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        char c;
        cin >> c;
        if (c == '+') {
            cin >> t[i] >> d[i];
            left[i] = i;
        }
        if (c == '-') {
            int index;
            cin >> index;
            right[index] = i - 1;
        }
        if (c == '?') {
            cin >> query[i];
        }
    }
    for (int i = 1; i <= q; ++i) {
        if (left[i] == -1) continue;
        if (right[i] != -1) continue;
        right[i] = q;
    }

    for (int i = 1; i <= q; ++i) {
        if (left[i] == -1) continue;
        add(1, left[i], right[i], i, 1, q);
    }
    dfs(1, 1, q);
    return 0;
}
