#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define F first
#define S second
#define eb emplace_back
#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef long double ld;
typedef pair<int, int> pii;

const int INF = int(1e9);
const ll INFll = ll(1e18);
const int MOD = INF + 7;

vi p;
int used[10];

int get(int v) {
    return p[v] == v ? v : p[v] = get(p[v]);
}

void unite(int x, int y) {
    x = get(x);
    y = get(y);
    p[y] = x;
}

vi b;

void dfs(int v, const vector<set<int>>& g) {
    if (used[v])
        return;
    used[v] = 1;
    for (int to : g[v]) {
        dfs(to, g);
    }
    b.pb(v);
}

int main() {
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    vector<vi> g(n, vi(n));
    vector<vi> e(n, vi(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> g[i][j];
            e[i][j] = g[i][j];
        }
    }
    for (int iter = 0; iter < n; ++iter)
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j)
            for (int k = 0; k < n; ++k)
                if (e[i][k] && e[k][j])
                    e[i][j] = 1;
    }
    p.resize(n);
    for (int i = 0; i < n; ++i)
        p[i] = i;
    for (int iter = 0; iter < n; ++iter) {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j)
                if (e[i][j] && e[j][i])
                    unite(i, j);
    }
    for (int i = 0; i < n; ++i)
        p[i] = get(p[i]);
    vector<vi> comps(n);
    for (int i = 0; i < n; ++i)
        comps[p[i]].pb(i);
    vector<set<int>> ng(n);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            if (g[i][j] && p[i] != p[j])
                ng[p[i]].insert(p[j]);
    for (int i = 0; i < n; ++i)
        if (!comps[i].empty())
            dfs(i, ng);
    reverse(b.begin(), b.end());
    vi dx = {1, 0, -1, 0};
    vi dy = {0, 1, 0, -1};
    {
        int h = 2 * b.size();
        int mx = 0;
        for (int i = 0; i < n; ++i)
            mx = max<int>(mx, comps[i].size());
        int n = mx + 8 + int(2.5 * b.size() * b.size());
        int m = mx + 8 + int(2.5 * b.size() * b.size());
        int cj = mx + 8;
        int ck = 2;
        vector<vector<vector<char>>> ans(h, vector<vector<char>>(n, vector<char>(m, '.')));
        for (int i = 1; i < h; i += 2) {
            for (int j = 0; j < n; ++j)
                for (int k = 0; k < m; ++k)
                    ans[i][j][k] = '#';
        }
        for (int i = 0; i < h; i += 2) {
            int z = 0;
            int v = b[i / 2];
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k < m; ++k) {
                    if (z < comps[v].size()) {
                        ans[i][j][k] = '1' + comps[v][z++];
                    }
                }
            }
            for (int to : ng[v]) {
//                cerr << v << " " << to << endl;
                for (int z = i + 1; ; ++z) {
                    ans[z][cj][ck] = '.';
                    if (b[z / 2] == to)
                        break;
                    for (int d = 0; d < 4; ++d) {
                        int nx = cj + dx[d];
                        int ny = ck + dy[d];
                        if (nx >= 0 && nx < n && ny >= 0 && ny < m) {
                            ans[z][nx][ny] = '#';
                        }
                    }
                }
                ck += 4;
                if (ck >= m) {
                    ck = 2;
                    cj += 4;
                }
            }
        }
        cout << m << " " << n << " " << h << endl;
        for (int i = 0; i < h; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k < m; ++k)
                    cout << ans[i][j][k];
                cout << endl;
            }
            cout << endl;
        }
    }
    return 0;
}
