#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int> > g;
vector<vector<int> > rg;
vector<vector<int> > cg;
vector<int> used;
vector<int> topsort;
vector<int> colored_topsort;
vector<int> color;
int c;

void topsort_dfs(int v) {
	used[v] = 1;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (!used[to]) {
			topsort_dfs(to);
		}
	}
	topsort.push_back(v);
}


void rdfs(int v) {
	used[v] = 1;
	color[v] = c;
	for (int i = 0; i < rg[v].size(); ++i) {
		int to = rg[v][i];
		if (!used[to]) {
			rdfs(to);
		}
	}
}

void cdfs_topsort(int v) {
	used[v] = 1;
	for (int i = 0; i < cg[v].size(); ++i) {
		int to = cg[v][i];
		if (!used[to]) {
			cdfs_topsort(to);
		}
	}
	colored_topsort.push_back(v);
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;

	g.resize(n);
	rg.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			int a;
			cin >> a;
			if (a) {
				g[i].push_back(j);
				rg[j].push_back(i);
			}
		}
	}
	used.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			topsort_dfs(i);
		}
	}
	color.assign(n, -1);
	reverse(topsort.begin(), topsort.end());
	used.assign(n, 0);
	for (int i = 0; i < topsort.size(); ++i) {
		int v = topsort[i];
		if (!used[v]) {
			rdfs(v);
			c++;
		}
	}
	cg.resize(c);
	vector<vector<int>> map_(c, vector<int>(c, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < g[i].size(); ++j) {
			int to = g[i][j];
			if (color[i] != color[to]) {
				cg[color[i]].push_back(color[to]);
				map_[color[i]][color[to]] = 1;
			}
		}
	}
	used.assign(c, 0);
	for (int i = 0; i < c; ++i) {
		if (!used[i]) {
			cdfs_topsort(i);
		}
	}
	cout << 1 << " " << "3 " << "20 " << endl;
	for (int i = 0; i < 10; ++i) {
		for (int j = 0; j < 10 - i ; j++) {			
			cout << ".#";
		}
		for (int j = 10 - i; j < 10; ++j) {
			cout << "##";
		}
		cout << endl;
		for (int j = 0; j < 10; ++j) {
			bool f = true;
			for (int k = j; k < c && i < c; ++k)
				if (map_[i][k]) {
					cout << "..";
					f = false;
					break;
				}
			if (f) {
				cout << "..";
			}
		}
		cout << endl;
		int k = 0;
		for (int j = 0; j < n; ++j) {
			if (color[j] == i) {
				k++;
				cout << j + 1;
			}
		}
		for (int j = k; j < 20; j++) {
			cout << ".";
		}
		cout << endl;
		cout << endl;
		for (int j = 0; j < 10 - i - 1; j++) {
			cout << ".#";
		}
		for (int j = 10 - i - 1; j < 10 ; ++j) {
			cout << "##";
		}
		cout << endl;
		for (int j = 0; j < 2; ++j) {
			for (int k = 0; k < 10; k++)
				cout << "##";
			cout << endl;
		}
		cout << endl;
	}
}

