#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <set>
#include <algorithm>
#include <vector>
#include <map>
#include <cstdio>

using namespace std;

set<string> reserved;

string last_w("a");

void upd_last_w()
{
	int j(last_w.size() - 1);
	while (j >= 0 && last_w[j] == 'z')
		--j;
	if (j == -1)
	{
		int t = last_w.size() + 1;
		last_w.clear();
		last_w.assign(t, 'a');
	}
	else
	{
		++last_w[j];
		for (j += 1; j < last_w.size(); ++j)
			last_w[j] = 'a';
	}
	if (reserved.count(last_w))
		upd_last_w();
}

int get_reserved(const string& s)
{
	string t;
	int best(0);
	for (int i(0); i < 20 && i < s.size(); ++i)
	{
		t += s[i];
		if (reserved.count(t))
			best = i + 1;
	}
	return best;
}

int get_number(const string& s)
{
	int best(0);
	for (int i(0); i < s.size(); ++i)
	{
		if (!isdigit(s[i]))
			break;
		best = i + 1;
	}
	return best;
}

int get_word(const string& s)
{
	int best(0);
	if (isdigit(s[0]))
		return 0;
	for (int i(0); i < s.size(); ++i)
	{
		if (!(isalpha(s[i]) || isdigit(s[i]) || s[i] == '_' || s[i] == '$'))
			break;
		best = i + 1;
	}
	return best;
}

int get_token(const string& s)
{
	return max({get_number(s), get_word(s), get_reserved(s) });
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	int R; cin >> R;
	for (int i(0); i < R; ++i)
	{
		string s; cin >> s;
		reserved.insert(s);
	}
	int L; cin >> L;
	vector<string> tokens;
	map<string, string> rename;
	string s__;
	getline(cin, s__);
	while (L--)
	{
		string line;
		getline(cin, line);
		while (!line.empty())
		{
			if (line[0] == ' ')
			{
				line = line.substr(1, line.size() - 1);
				continue;
			}
			if (line[0] == '#')
				break;
			int best(get_token(line));
			tokens.push_back(line.substr(0, best));
			line = line.substr(best, line.size() - best);
		}
	}
	for (string& w : tokens)
	{
		if (!reserved.count(w) && !isdigit(w[0]))
		{
			if (!rename.count(w))
			{
				rename[w] = last_w;
				upd_last_w();
			}
			w = rename[w];
		}
	}
	int next_space(tokens.size());
	for (int i(0); i < tokens.size(); ++i)
	{
		string s(tokens[i]);
		for (int j(i + 1); j < tokens.size() && s.size() <= 20; ++j)
		{
			if (get_token(s + tokens[j]) != tokens[i].size()) {
				next_space = min(next_space, j - 1);
				break;
			}
			s += tokens[j];
		}
		cout << tokens[i];
		if (next_space == i)
		{
			cout << ' ';
			next_space = tokens.size();
		}
	}
}