#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <set>
#include <algorithm>
#include <vector>
#include <map>
#include <cstdio>
#include <cstring>

using namespace std;

#define MX 15

vector<int> g[MX];
vector<int> bg[MX];

bool used[MX];

vector<int> topsort;

void topsort1(int v)
{
	used[v] = true;
	for (int u : g[v])
		if (!used[u])
			topsort1(u);
	topsort.push_back(v);
}

vector<int> comps[MX];
int color[MX];

void dfs(int v, int cur_col)
{
	color[v] = cur_col;
	comps[cur_col].push_back(v);
	used[v] = true;
	for (int u : bg[v])
		if (!used[u])
			dfs(u, cur_col);
}

vector<int> G[MX];

void topsort2(int v)
{
	used[v] = true;
	for (int u : G[v])
		if (!used[u])
			topsort2(u);
	topsort.push_back(v);
}

char ans[20][3][30];

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	for (int i(1); i <= n; ++i)
		for (int j(1); j <= n; ++j)
		{
			int t; cin >> t;
			if (t) {
				g[i].push_back(j);
				bg[j].push_back(i);
			}
		}
	topsort1(1);
	reverse(begin(topsort), end(topsort));
	memset(used, 0, sizeof used);
	int sz(1);
	for (int v : topsort)
		if (!used[v])
		{
			dfs(v, sz++);
		}
	--sz;
	//cout << sz << endl;
	for (int v(1); v <= sz; ++v)
		for (int u : comps[v])
			for (int w : g[u])
				if (color[u] != color[w])
					G[v].push_back(color[w]);
	/*for (int i(1); i <= sz; ++i)
	{
		cout << i << ": ";
		for (int j : G[i])
			cout << ' ' << j;
		cout << '\n';
	}
	return 0;*/
	topsort.clear();
	memset(used, 0, sizeof used);
	topsort2(1);
	memset(ans, '.', sizeof ans);
	//reverse(begin(topsort), end(topsort));
	int hole[MX];
	for (int i(0); i < topsort.size(); ++i)
	{
		hole[topsort[i]] = i * 2 + 2;
		int s = 29 - i * 2;
		--s;
		set<int> can_go(begin(G[topsort[i]]), end(G[topsort[i]]));
		for (int j(0); j < i; ++j)
			if (!can_go.count(j))
			{
				int h = hole[topsort[j]];
				ans[h - 1][0][s] = ans[h - 1][1][s] = ans[h][1][s] = ans[h + 1][0][s] = ans[h + 1][1][s] = '#';
			}
		int cnt(0);
		for (int p(0); p < 20; ++p)
			for (int q(0); q < 3; ++q)
				ans[p][q][s + 1] = '#';
		for (int j(0); j < i; ++j)
			ans[j * 2 + 2][0][s + 1] = '.';
		for (int v : comps[topsort[i]])
			ans[cnt++][2][s] = v + '0';
	}
	cout << "20 3 30\n";
	for (int i(0); i < 30; ++i)
	{
		for (int j(0); j <= 2; ++j)
		{
			for (int k(0); k < 20; ++k)
				cout << ans[k][j][i];
			cout << '\n';
		}
		cout << '\n';
	}
}