#include <bits/stdc++.h>


#define db(x) cout << #x << " = " << x << endl;

using namespace std;

typedef long long ll;

const int N = 500;

struct Component {
    vector <int> ids;
    vector <int> tos;
    int j = 0;
};

char d[N][N][N];
int n, size;
int g[N][N];

vector <Component> constructComponents() {
    vector <Component> res;

    for( int k=0; k < n; ++k )
        for( int i=0; i < n; ++i )
            for( int j=0; j < n; ++j )
                g[i][j] |= (g[i][k] & g[k][j]);

    vector <int> compId(n, -1);
    int C = -1;

    for( int i=0; i < n; ++i ) {
        if( compId[i] != -1 )
            continue;
        ++C;
        Component c;
        for( int j=0; j < n; ++j )
            if( g[i][j] && g[j][i] ) {
                compId[j] = C;
                c.ids.push_back(j);
            }
        res.push_back(c);
    }

    vector <bool> used(res.size(), false);
    for( int i=0; i < res.size(); ++i ) {
        set <int> tos;
        for( int v: res[i].ids )
            for( int to =0; to < n; ++to )
                if( g[v][to] && compId[to] != i ) {
                    tos.insert(compId[to]);
                }

        for( int to : tos )
            res[i].tos.push_back(to);
    }
    return res;
}

void dfs( int v, vector <int> &res, vector <bool>& used, const vector <Component>& comps) {
    if( used[v] )
        return;
    used[v] = true;
    for( int to : comps[v].tos )
        if( !used[to] )
            dfs( to, res, used, comps);

    res.push_back(v);
}
vector <Component> topSort(const vector <Component>& comps) {
    vector <Component> res;
    vector <int> ids;
    vector <bool> used(comps.size(), false);

    for( int i=0; i < comps.size(); ++i )
        if( !used[i] )
            dfs( i, ids, used, comps );

    for( int i : ids )
        res.push_back(comps[i]);

    for( int i=0; i < res.size(); ++i )
        for( int j=0; j < res[i].tos.size(); ++j )
            res[i].tos[j] = ids[res[i].tos[j]];
    return res;
}


void printGrid() {
    printf( "%d %d %d\n", size, size, size );
    for( int i=0; i < size; ++i, printf( "\n") )
        for( int j=0; j < size; ++j, printf( "\n") )
            for( int l=0; l < size; ++l)
                printf( "%c", d[i][j][l]);
}

void construct(const vector <Component>& comps) {
    for( int i=0; i < comps.size(); ++i ) {
        Component c = comps[i];
        c.j = 2 * i;

        for( int l=0; l < size; ++l )
            d[2*i][l][c.j] = '.';

        for( int l=0; l < c.ids.size(); ++l )
            d[2*i][0][c.j + l + 1] = '0' + c.ids[l] + 1;

        for (int to : c.tos) {
            int j = comps[to].j;

            for( int k=2*to+1; k <= 2*i; ++ k )
                d[k][2*i][j] = '.';
        }
    }
}

int main() {
    scanf( "%d", &n );
    for( int i=0; i < n; ++i )
        for( int j=0; j < n; ++j )
            scanf( "%d", &g[i][j]);
    for( int i=0; i < n; ++i )
        g[i][i] = 1;


    vector <Component> comps = constructComponents();
    /// debug
//    for( int i=0; i < comps.size(); ++i ) {
//        printf( "\n%d: ", i );
//        printf( "(" );      for( int id: comps[i].ids ) printf( "%d ", id );    printf( ")");
//        printf( " -> " );   for( int to: comps[i].tos ) printf( "%d ", to );
//    }
//    printf( "\n" );
    /// debug

    comps = topSort(comps);
    /// debug
//    for( int i=0; i < comps.size(); ++i ) {
//        printf( "\n%d: ", i );
//        printf( "(" );      for( int id: comps[i].ids ) printf( "%d ", id );    printf( ")");
//        printf( " -> " );   for( int to: comps[i].tos ) printf( "%d ", to );
//    }
//    printf( "\n" );
    /// debug

    int biggestCompSize = 0;
    for( const auto& c : comps )
        biggestCompSize = max( biggestCompSize, (int) c.ids.size() );

    size = biggestCompSize + 1 + (int) comps.size() * 2;
    for( int i=0; i < size; ++i )
        for( int j=0; j < size; ++j )
            for( int l=0; l < size; ++l) {
                d[i][j][l] = '#';
                if( i % 2 == 0 )
                    d[i][0][l] = '.';
            }

    construct(comps);
    printGrid();
    return 0;
}

/*
4
0 1 0 1
0 0 1 0
0 1 0 0
1 0 0 0


7
0 1 0 0 0 0 0
1 0 0 0 0 0 0
1 0 0 1 0 0 0
0 0 1 0 0 0 0
0 1 0 0 0 1 0
0 0 0 0 1 0 0
0 0 0 0 0 0 0
*/

