#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int i=0; i<(b); i++)
#define trav(a, x) for (auto& a: x)
#define all(x) x.begin(), x.end()
#define DIST 85

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long LL;
typedef unsigned long long ULL;

bool can_go(int a, int b, vector<vector<int> > &nodes, vector<vector<int> > &vec) {
    return vec[nodes[a][0]][nodes[b][0]] < DIST;
}

void print_ans(vector<vector<int> > &nodes, vector<vector<int> > &ns, vector<int> &tmp) {
    int n = nodes.size();
    vector<vector<vector<char> > > vec(2 * n, vector<vector<char> >(3, vector<char>(3 * n * n + 3, '.')));
    for (int i=1; i<2 * n; i+=2) {
        for (int j=0; j<3; j++) {
            for (int k=0; k<3 * n * n + 3; k++) {
                vec[i][j][k] = '#';
            }
        }
    }
    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) {
            for (int k=i; k<j; k++) {
                vec[2 * k + 1][2][(n * i + j) * 3 + 1] = '.';
            }
        }
    }
    for (int i=0; i<n; i++) {
        for (int k=0; k<n * n; k++) {
            if (k / n != i) {
                vec[2 * i][1][k * 3] = '#';
                vec[2 * i][1][k * 3 + 1] = '#';
                vec[2 * i][1][k * 3 + 2] = '#';
                vec[2 * i][2][k * 3] = '#';
                vec[2 * i][2][k * 3 + 2] = '#';
            }
        }
    }
    for (int i=0; i<n; i++) {
        for (int k=0; k<n * n; k++) {
            int curj, curi;
            if (k % n == i) {
                curj = i;
                curi = k / n;
            } else {
                continue;
            }
            if (ns[curi][curj]) {
                vec[2 * i][1][k * 3] = '.';
                vec[2 * i][1][k * 3 + 1] = '.';
                vec[2 * i][1][k * 3 + 2] = '.';
                vec[2 * i][2][k * 3] = '.';
                vec[2 * i][2][k * 3 + 2] = '.';
            }
        }
    }
    for (int i=0; i<n; i++) {
        for (int j=0; j<nodes[i].size(); j++) {
            int cur = nodes[i][j];
            vec[2 * i][cur / 3][3 * n * n + cur % 3] = cur + 1 + '0';
        }
    }
    cout << 3 * n * n + 3 << " " << 3 << " " << 2 * n << endl;
    for (int i=0; i<2 * n; i++) {
        for (int j=0; j<3; j++) {
            for (int k=0; k<3 * n * n + 3; k++) {
                cout << vec[i][j][k];
            }
            cout << endl;
        }
        cout << endl;
    }
}

int main() {
    int n;
    cin >> n;
    vector<vector<int> > vec(n, vector<int>(n));
    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) {
            cin >> vec[i][j];
            if (vec[i][j] == 0) {
                vec[i][j] = 1000;
            }
        }
    }
    for (int k=0; k<n; k++) {
        for (int i=0; i<n; i++) {
            for (int j=0; j<n; j++) {
                vec[i][j] = min(vec[i][k] + vec[k][j], vec[i][j]);
            }
        }
    }
    vector<vector<int> > nodes;
    vector<bool> used(n, false);
    for (int i=0; i<n; i++) {
        if (used[i]) continue;
        used[i] = true;
        vector<int> tmp;
        nodes.push_back(tmp);
        nodes[nodes.size() - 1].push_back(i);
        for (int j=i+1; j<n; j++) {
            if (used[j]) continue;
            if (vec[i][j] < DIST && vec[j][i] < DIST) {
                nodes[nodes.size() - 1].push_back(j);
                used[j] = true;
            }
        }
    }
    vector<vector<int> > ns(nodes.size(), vector<int>(nodes.size(), 0));
    for (int i=0; i<nodes.size(); i++) {
        for (int j=0; j<nodes.size(); j++) {
            if (i == j) {
                ns[i][j] = 0;
                continue;
            }
            if (can_go(i, j, nodes, vec)) {
                ns[i][j] = 1;
                continue;
            }
        }
    }
    vector<int> incs(ns.size(), 0);
    queue<int> q;
    for (int i=0; i<ns.size(); i++) {
        for (int j=0; j<ns.size(); j++) {
            if (ns[i][j] == 1) {
                incs[j]++;
            }
        }
    }
    for (int i=0; i<ns.size(); i++) {
        if (incs[i] == 0){
            q.push(i);
        }
    }
    vector<int> tmp;
    while (q.size()) {
        int cur = q.front();
        q.pop();
        tmp.push_back(cur);
        for (int i=0; i<ns[cur].size(); i++) {
            if (ns[cur][i] == 1) {
                incs[i]--;
                if (incs[i] == 0) {
                    q.push(i);
                }
            }
        }
    }
    vector<vector<int> > new_nodes(nodes.size());
    for (int i=0; i<tmp.size(); i++) {
        new_nodes[i] = nodes[tmp[i]];
    }
    vector<vector<int> > new_ns(nodes.size());
    for (int i=0; i<tmp.size(); i++) {
        new_ns[i] = ns[tmp[i]];
    }
    print_ans(new_nodes, new_ns, tmp);
}
