#include <iostream>
#include <vector>
#include <stack>
#include <string>

using namespace std;


struct A {
	vector<int> v;
};

vector<A> nodes; // nodes
int n, a[10][10];
bool visited[11];
int conn[11][11]; // nodes connections

vector<int> order; // nodes order


void dfs(int current, int v) {
	visited[v] = 1;
	a[current][v] = 1;

	for (int j = 0; j < n; j++) {
		if (a[v][j] && !visited[j])
			dfs(current, j);
	}
}

void construct() {
	memset(visited, 0, n);

	for (int i = 0; i < n; i++) {
		if (!visited[i]) {
			visited[i] = true;
			vector<int> current = { i };
			for (int j = 0; j < n; j++)
				if (!visited[j]) {
					bool from = false, to = false;
					for (int k = 0; k < current.size(); k++)
						if (current[k] != j) {
							if (a[current[k]][j])
								from = true;
							if (a[j][current[k]])
								to = true;
						}
					if (to && from) {
						current.push_back(j);
						visited[j] = true;
					}
				}

			nodes.push_back({ current });
		}
	}

	for (int i = 0; i < nodes.size(); i++)
		for (int j = 0; j < nodes.size(); j++)
			if (i != j && a[nodes[i].v[0]][nodes[j].v[0]])
				conn[i][j] = 1;
}

void dfs_topo(int v) {
	visited[v] = true;
	for (int i = 0; i < nodes.size(); i++)
		if (!visited[i] && conn[v][i])
			dfs_topo(i);
	order.push_back(v);
}

bool canstart(int v) {
	for (int i = 0; i < nodes.size(); i++)
		if (i != v && conn[i][v])
			return false;
	return true;
}

void topological_sort() {
	memset(visited, 0, n);
	for (int i = 0; i < nodes.size(); i++)
		if (canstart(i) && !visited[i])
			dfs_topo(i);

	reverse(order.begin(), order.end());
}


//int conn[10][10] // nodes
//vector<int> order;
//vector<A> nodes;
//vector<int> A.v;

vector<vector<string>> pre_ans;
void verjacra() {
	int m = nodes.size();
	for (size_t i = 0; i < m; i++)
	{
		vector<string> layer1;
		for (size_t j = 0; j < m * 2 - 1; j++)
		{
			string s = "";
			for (size_t k = 0; k < 2 * m - 1; k++)
			{
				s += "#";
			}
			layer1.push_back(s);
		}
		vector<string> layer2;
		for (size_t j = 0; j < m * 2 - 1; j++)
		{
			string s = "";
			for (size_t k = 0; k < 2 * m - 1; k++)
			{
				s += '#';
			}
			layer2.push_back(s);
		}
		layer1[i * 2][i * 2] = to_string(int(i))[0];
		for (size_t j = 0; j < layer1[i * 2].size(); j++)
		{
			layer1[i * 2][j] = '.';
		}
		pre_ans.push_back(layer1);
		pre_ans.push_back(layer2);
	}
	for (size_t i = 0; i < 2 * m; i++)
	{
		for (size_t j = (i + 1) / 2; j < m; j++)
		{
			pre_ans[i][j * 2][j * 2] = '.';
		}
	}
	for (size_t i = 0; i < m; i++)
	{
		for (size_t j = 0; j < m; j++)
		{
			if (conn[order[i]][order[j]]) {
				for (size_t k = 0; k < j * 2; k++)
				{
					pre_ans[2 * i][k][j * 2] = '.';
				}
			}
		}
	}
	for (size_t i = 0; i < m; i++)
	{
		pre_ans[i * 2][i * 2][i * 2] = 'a';
	}
}

/*
4
0 1 0 1
0 0 1 0
0 1 0 0
1 0 0 0
*/
/*
4
0 1 1 0
0 0 0 1
0 0 0 1
0 0 0 0
*/
/*
4
0 1 0 1
0 0 1 0
0 0 0 0
0 0 1 0
*/


int main() {
	cin >> n;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			cin >> a[i][j];

	for (int i = 0; i < n; i++) {
		dfs(i, i);
		memset(visited, 0, 10);
	}
	construct();
	topological_sort();
	verjacra();
	vector<int> copies;
	for (size_t i = 0; i < order.size(); i++)
	{
		for (size_t j = 1; j < nodes[order[i]].v.size(); j++)
		{
			copies.push_back(i * 2);
		}
	}
	reverse(copies.begin(), copies.end());
	for (size_t i = 0; i < copies.size(); i++)
	{
		for (size_t j = 0; j < pre_ans.size(); j++)
		{
			for (size_t k = 0; k < pre_ans[j].size(); k++)
			{
				string x;
				x += pre_ans[j][k][copies[i]];
				pre_ans[j][k].insert(copies[i], x);
			}
		}
	}
	vector<int> allll;
	for (size_t i = 0; i < order.size(); i++)
	{
		for (size_t j = 0; j < nodes[order[i]].v.size(); j++)
		{
			allll.push_back(nodes[order[i]].v[j]);
		}
	}
	int q = 0;
	for (size_t i = 0; i < pre_ans.size(); i++)
	{
		for (size_t j = 0; j < pre_ans[i].size(); j++)
		{
			for (size_t k = 0; k < pre_ans[i][j].size(); k++)
			{
				if (pre_ans[i][j][k] == 'a') {
					pre_ans[i][j][k] = 49 + allll[q];
					q++;
				}
			}
		}
	}
	cout << pre_ans[0][0].size() << " " << pre_ans[0].size() << " " << pre_ans.size() << endl;
	for (size_t i = 0; i < pre_ans.size(); i++)
	{
		for (size_t j = 0; j < pre_ans[i].size(); j++)
		{
			cout << pre_ans[i][j] << endl;
		}
		cout << endl;
	}
	return 0;
}