#include <bits/stdc++.h>

#define F first
#define S second
#define MP make_pair
#define PB push_back

using namespace std;

typedef long long ll;
typedef long double ld;

const int max_n = 300111, max_x = 1000111, inf = 1000111222;

struct node {
    long long l, r, cnt;

    node(): l(-1), r(-1), cnt(0) {
    }

    node(long long l, long long r, long long cnt): l(l), r(r), cnt(cnt) {
    }
};

node merge(const node &a, const node &b) {
    node res;
    if (a.l == -1) {
        return b;
    }
    if (b.l == -1) {
        return a;
    }
    if (a.r <= b.l) {
        res.l = a.l;
        res.r = b.r;
        res.cnt = a.cnt + b.cnt + b.l - a.r;
    } else {
        long long need = a.r - b.l;
        res.l = a.l;
        long long cnt_left = b.cnt - need;
        res.r = b.r;
        if (cnt_left < 0) {
            res.r -= cnt_left;
            cnt_left = 0;
        }
        res.cnt = res.r - res.l + a.cnt + cnt_left;
    }
    return res;
}

struct tree {
    node a[4 * max_x];

    void update(int v, int tl, int tr, int l, int r) {
        if (tl == tr) {
            if (r == -1) {
                a[v] = node();
            } else {
                a[v].l = l;
                a[v].r = r;
                a[v].cnt = 0;
            }
            return;
        }
        int mid = (tl + tr) / 2;
        if (l <= mid) {
            update(2 * v, tl, mid, l, r);
        } else if (l > mid) {
            update(2 * v + 1, mid + 1, tr, l, r);
        }
        a[v] = merge(a[2 * v], a[2 * v + 1]);
    }

    node get(int v, int tl, int tr, int l, int r) {
        if (tl == l && tr == r) {
            return a[v];
        }
        int mid = (tl + tr) / 2;
        if (r <= mid) {
            return get(2 * v, tl, mid, l, r);
        } else if (l > mid) {
            exit(1);
        } else {
            return merge(get(2 * v, tl, mid, l, mid), get(2 * v + 1, mid + 1, tr, mid + 1, r));
        }
    }
};

tree tr;
int q, t[max_n], d[max_n];
char tp[max_n];

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    scanf("%d", &q);
    for (int i = 0; i < q; ++i) {
        scanf("\n%c", &tp[i]);
        if (tp[i] == '?') {
            scanf("%d", &t[i]);
            const node &res = tr.get(1, 0, max_x - 1, 0, t[i]);
            if (res.r <= t[i]) {
                printf("0\n");
            } else {
                printf("%lld\n", res.r - t[i]);
            }
        } else if (tp[i] == '+') {
            scanf("%d%d", &t[i], &d[i]);
            tr.update(1, 0, max_x - 1, t[i], t[i] + d[i]);
        } else {
            scanf("%d", &t[i]);
            --t[i];
            tr.update(1, 0, max_x - 1, t[t[i]], -1);
        }
    }
    return 0;
}
