#include <bits/stdc++.h>

#define F first
#define S second
#define MP make_pair
#define PB push_back

using namespace std;

typedef long long ll;
typedef long double ld;

const int max_n = 300111, max_x = 1000111, inf = 1000111222; // !!!

struct node {
    long long l, r, cnt;

    node(): l(-1), r(-1), cnt(0) {
    }

    node(long long l, long long r, long long cnt): l(l), r(r), cnt(cnt) {
    }
};

ostream& operator << (ostream &os, const node &nd) {
    os << "([" << nd.l << " " << nd.r << "], c = " << nd.cnt << ")";
    return os;
}

node merge(const node &a, const node &b) {
    node res;
    if (a.l == -1) {
        return b;
    }
    if (b.l == -1) {
        return a;
    }
    if (a.r <= b.l) {
        res.l = a.l;
        res.r = b.r;
        res.cnt = a.cnt + b.cnt + b.l - a.r;
    } else {
        long long need = a.r - b.l;
        res.l = a.l;
        long long cnt_left = b.cnt - need;
        res.r = b.r;
        if (cnt_left < 0) {
            res.r -= cnt_left;
            cnt_left = 0;
        }
        res.cnt = a.cnt + cnt_left;
    }
    //cout << a << " + " << b << " = " << res << endl;
    return res;
}

struct tree {
    node a[4 * max_x];

    void clr() {
        for (int i = 0; i < 4 * max_x; ++i) {
            a[i] = node();
        }
    }

    void update(int v, int tl, int tr, int l, int r) {
        if (tl == tr) {
            if (r == -1) {
                a[v] = node();
            } else {
                a[v].l = l;
                a[v].r = r;
                a[v].cnt = 0;
            }
            return;
        }
        int mid = (tl + tr) / 2;
        if (l <= mid) {
            update(2 * v, tl, mid, l, r);
        } else if (l > mid) {
            update(2 * v + 1, mid + 1, tr, l, r);
        }
        a[v] = merge(a[2 * v], a[2 * v + 1]);
    }

    node get(int v, int tl, int tr, int l, int r) {
        if (tl == l && tr == r) {
            return a[v];
        }
        int mid = (tl + tr) / 2;
        if (r <= mid) {
            return get(2 * v, tl, mid, l, r);
        } else if (l > mid) {
            exit(1);
        } else {
            return merge(get(2 * v, tl, mid, l, mid), get(2 * v + 1, mid + 1, tr, mid + 1, r));
        }
    }
};

tree tr;
int q, t[max_n], d[max_n];
char tp[max_n];

namespace triv {
    set<pair<int, int>> all;

    void clr() {
        all.clear();
    }

    void add(int l, int d) {
        all.insert({l, d});
    }

    void del(int l, int d) {
        all.erase(all.find({l, d}));
    }

    long long get(int t) {
        set<pair<int, int>>::iterator it = all.begin();
        long long cur = 0;
        while (it != all.end() && it->first <= t) {
            cur = max(cur, (long long) it->first);
            cur += it->second;
            ++it;
        }
        if (cur < t) {
            return 0;
        }
        return cur - t;
    }
}

const bool debug = false;

int main() {
    //freopen("kings-reception1.in", "r", stdin);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    while (scanf("%d", &q) == 1) {
        tr.clr();
        if (debug) {
            triv::clr();
        }
        for (int i = 0; i < q; ++i) {
            scanf("\n%c", &tp[i]);
            if (tp[i] == '?') {
                scanf("%d", &t[i]);
                const node &res = tr.get(1, 0, max_x - 1, 0, t[i]);
                long long ans = 0;
                if (res.r > t[i]) {
                    ans = res.r - t[i];
                }
                if (debug) {
                    long long ans_triv = triv::get(t[i]);
                    if (ans != ans_triv) {
                        cout << "WA, i = " << i << endl;
                        cout << "ok: " << ans_triv << endl;
                        cout << "wa: " << ans << endl;
                        cout << q << endl;
                        for (int i = 0; i < q; ++i) {
                            cout << tp[i] << " ";
                            if (tp[i] == '+') {
                                cout << t[i] << " " << d[i] << endl;
                            } else if (tp[i] == '?') {
                                cout << t[i] << endl;
                            } else {
                                cout << t[i] + 1 << endl;
                            }
                        }
                        exit(1);
                    }
                } else {
                    printf("%lld\n", ans);
                }
            } else if (tp[i] == '+') {
                scanf("%d%d", &t[i], &d[i]);
                tr.update(1, 0, max_x - 1, t[i], t[i] + d[i]);
                if (debug) {
                    triv::add(t[i], d[i]);
                }
            } else {
                scanf("%d", &t[i]);
                --t[i];
                tr.update(1, 0, max_x - 1, t[t[i]], -1);
                if (debug) {
                    triv::del(t[t[i]], d[t[i]]);
                }
            }
        }
        return 0;
        if (debug) {
            cout << "+";
        }
    }
    //cout << "!!!" << max_x << endl;
    return 0;
}
