#include <bits/stdc++.h>

#define F first
#define S second
#define MP make_pair
#define PB push_back

using namespace std;

typedef long long ll;
typedef long double ld;

const int max_n = 10, inf = 1000111222;

int n, matr[max_n][max_n], top_sort[max_n], t, comp[max_n], c, used[max_n], sz[max_n];
int x, y, z, a[5000][4][50], rev_top_sort[max_n];
vector<int> v[max_n], cc[max_n];
int matr_bad[4][4] = {{-2, -2, -2, -1},
                      {-2, -2, -2, -1},
                      {-2, -2, -2, -1},
                      {-1, -1, -1, -1}};
int matr_worst[4][4] = {{-2, -2, -2, -2},
                        {-2, -2, -2, -2},
                        {-2, -2, -2, -2},
                        {-2, -2, -2, -2}};
int matr_good[4][4] = {{-1, -1, -1, -1},
                       {-1, -1, -1, -1},
                       {-1, -1, -1, -1},
                       {-1, -1, -1, -1}};

void dfs_top_sort(int x) {
    used[x] = 1;
    for (int i = 0; i < n; ++i) {
        if (matr[x][i] && !used[i]) {
            dfs_top_sort(i);
        }
    }
    top_sort[t++] = x;
}

void dfs_top_sort2(int x) {
    used[x] = 1;
    for (int i = 0; i < v[x].size(); ++i) {
        if (!used[v[x][i]]) {
            dfs_top_sort2(v[x][i]);
        }
    }
    rev_top_sort[x] = c - t - 1;
    top_sort[t++] = x;
}

void dfs_comp(int x, int c) {
    comp[x] = c;
    used[x] = 1;
    cc[c].push_back(x);
    ++sz[c];
    for (int i = 0; i < n; ++i) {
        if (matr[i][x] && !used[i]) {
            dfs_comp(i, c);
        }
    }
}

bool debug = 0;

void make_condence() {
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs_top_sort(i);
        }
    }
    reverse(top_sort, top_sort + n);
    memset(used, 0, sizeof(used));
    for (int i = 0; i < n; ++i) {
        if (!used[top_sort[i]]) {
            dfs_comp(top_sort[i], c++);
        }
    }
    if (debug) {
        cout << endl << endl;
        for (int i = 0; i < n; ++i) {
            cout << comp[i] << " ";
        }
        cout << endl;
    }
    for (int i = 0; i < n; ++i) {
        for (int q = 0; q < n; ++q) {
            if (matr[i][q] && comp[q] != comp[i]) {
                v[comp[i]].push_back(comp[q]);
            }
        }
    }
    for (int i = 0; i < c; ++i) {
        sort(v[i].begin(), v[i].end());
        v[i].erase(unique(v[i].begin(), v[i].end()), v[i].end());
    }
    if (debug) {
        for (int i = 0; i < c; ++i) {
            cout << i << ":  ";
            for (int q : v[i]) {
                cout << q << " ";
            }
            cout << endl;
        }
        cout << endl;
    }
}

void make_field() {
    z = c * 2 - 1;
    y = 4;
    x = 9;
    for (int i = 0; i < c; ++i) {
        for (int q = 0; q < y; ++q) {
            for (int w = 0; w < x; ++w) {
                a[w][q][i * 2 + 1] = -2;
                a[w][q][i * 2] = -1;
            }
        }
    }
    for (int i = 0; i < c; ++i) {
        for (int q = 0; q < cc[i].size(); ++q) {
            a[q][0][z - i * 2 - 1] = cc[top_sort[i]][q];
        }
    }
}

void make_cell(int fr, int to) {
    for (int w = 0; w < z; ++w) {
        for (int q = 0; q < y; ++q) {
            for (int i = x; i < x + 4; ++i) {
                if (w == fr || w == to) {
                    a[i][q][w] = matr_good[i - x][q];
                } else {
                    a[i][q][w] = matr_bad[i - x][q];
                }
                if (w % 2) {
                    a[i][q][w] = matr_worst[i - x][q];
                }
            }
        }
    }
    // cout << "make cell " << fr << " " << to << " " << endl;
    for (int i = fr; i <= to; ++i) {
        a[x + 1][1][i] = -1;
    }
    x += 4;
}

char to_c(int a) {
    if (a == -2) {
        return '#';
    }
    if (a == -1) {
        return '.';
    }
    return a + '1';
}

int main() {
    //freopen("input_m.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n;
    for (int i = 0; i < 100; ++i) {
        for (int q = 0; q < 100; ++q) {
            for (int w = 0; w < 100; ++w) {
                a[i][q][w] = -2;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int q = 0; q < n; ++q) {
            cin >> matr[i][q];
        }
    }
    make_condence();
    memset(used, 0, sizeof(used));
    t = 0;
    for (int i = 0; i < c; ++i) {
        if (!used[i]) {
            dfs_top_sort2(i);
        }
    }
    reverse(top_sort, top_sort + c);
    if (debug) {
        for (int i = 0; i < c; ++i) {
            cout << top_sort[i] << " ";
        } cout << endl;
    }
    make_field();
    for (int i = 0; i < c; ++i) {
        int g = top_sort[i];
        for (int q = 0; q < v[g].size(); ++q) {
            make_cell(z - 1 - 2 * rev_top_sort[v[g][q]], z - 1 - 2 * i);
        }
    }
    cout << x << " " << y << " " << z << endl;
    for (int i = z - 1; i >= 0; --i) {
        for (int q = 0; q < y; ++q) {
            for (int w = 0; w < x; ++w) {
                printf("%c", to_c(a[w][q][i]));
            }
            printf("\n");
        }
        printf("\n");
    }

    return 0;
}
/*

4
0 1 0 1
0 0 1 0
0 1 0 0
1 0 0 0

*/
