#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <cassert>
using namespace std;

int n;
vector<int> d;

int gcd(int a, int b, int & x, int &y) {
	if (a == 0) {
		x = 0;
		y = 1;
		return b;
	}
	int x1, y1;
	int g = gcd(b%a, a, x1, y1);
	x = y1 - (b / a)*x1;
	y = x1;
	return g;
}

void findPair(int a, int b, int & x, int & y, int val) {
	// a*x+b*y == 1
	// a*x+b*y == val
	long long X = (long long)x*val;
	long long Y = (long long)y*val;
	//a*(x+b)+b*(y-a)
	if (X < 0) {
		//X + b*k >= 0
		long long k = ((-X)+(b-1)) / b;
		X += (long long)b*k;
		Y -= (long long)a*k;
	}

	if (Y < 0) {
		//Y+a*k >= 0
		long long k = ((-Y) + (a - 1)) / a;
		X -= (long long)b*k;
		Y += (long long)a*k;
	}
	x = (int)X;
	y = (int)Y;
}
void solve() {
	scanf("%d", &n);
	
	for (int i = 2; (long long)i*i <= n; ++i) {
		if (n%i == 0) {
			d.push_back(i);
			d.push_back(n / i);
		}
	}
	sort(d.begin(), d.end());
	int x = n;
	vector<int> pr;
	for (auto D : d) {
		if (x%D == 0) {
			pr.push_back(D);
			while (x%D == 0) {
				x /= D;
			}
		}
	}
	if (pr.size() < 2) {
		puts("NO");
		return;
	}
	int p1 = pr[0];
	int p2 = pr[1];
	// n >= p1*p2 - 1
	int a, b; // p1*a+p2*b==n
	gcd(p1, p2, a, b);
	findPair(p1, p2, a, b, n - 1);
	assert(a >= 0);
	assert(b >= 0);
	vector<pair<int, int>> res;
	if (a) {
		res.push_back(make_pair(a , (n / p1)));
	}
	if (b) {
		res.push_back(make_pair(b , (n / p2)));
	}
	puts("YES");
	printf("%d\n", res.size());
	for (auto r : res) {
		printf("%d %d\n", r.first, r.second);
	}
}

int main() {
//	freopen("input.txt", "r", stdin);
	solve();
	return 0;
}